<?php
/***************************************************************************
*   copyright            : (C) 2001,2002 Advanced Internet Designs Inc.
*   email                : forum@prohost.org
*
*   $Id: mvthread.php.t,v 1.3 2002/06/26 19:35:55 hackie Exp $
****************************************************************************
          
****************************************************************************
*
*	This program is free software; you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation; either version 2 of the License, or
*	(at your option) any later version.
*
***************************************************************************/

	define('plain_form', 1);
	
	include_once "GLOBALS.php";
	if ( !defined('__index_page_start__') ) exit('sorry, you can not access this page');define('_fileio_inc_', 1);


function register_fp($id)
{
	if( empty($GLOBALS['__MSG_FP__'][$id]) ) 
		$GLOBALS['__MSG_FP__'][$id] = fopen($GLOBALS["MSG_STORE_DIR"].'msg_'.$id, 'rb');
	
	return $GLOBALS['__MSG_FP__'][$id];
}

function un_register_fps()
{
	if( !@is_array($GLOBALS['__MSG_FP__']) ) return;
	
	reset($GLOBALS['__MSG_FP__']);
	while( list($k,$v) = each($GLOBALS['__MSG_FP__']) ) {
		if( @is_resource($v) ) fclose($v);
		$GLOBALS['__MSG_FP__'][$k] = NULL;
	}	
}

function read_msg_body($off, $len, $file_id)
{
	$fp = register_fp($file_id);
	fseek($fp, $off);
	return fread($fp, $len);
}function fetch_vars($pref, &$obj, $arr)
{
	reset($obj);
	while ( list($k, $v) = each($obj) ) {
		if ( isset($arr[$pref.$k]) ) $obj->{$k} = $arr[$pref.$k];
	}
}
	
function export_vars($pref, &$obj)
{
	reset($obj);
	while ( list($k, $v) = each($obj) ) {
		if ( isset($obj->{$k}) ) $GLOBALS[$pref.$k] = $v;
	}
}

function empty_object(&$obj)
{
	reset($obj);
	while ( list($k, $v) = each($obj) ) $obj->{$k} = NULL;
}class fud_user_reg extends fud_user
{
	function add_user()
	{	
		db_lock('fud21_users+');
		
		do {
			$this->conf_key = md5(get_random_value(128));
		} while ( bq("SELECT id FROM fud21_users WHERE conf_key='".$this->conf_key."'") );

		$ref_id = !empty($GLOBALS["HTTP_COOKIE_VARS"]["frm_referer_id"]) ? $GLOBALS["HTTP_COOKIE_VARS"]["frm_referer_id"] : 0;
		if( empty($this->avatar_loc) ) $this->avatar_loc = NULL;
		
		$md5pass = md5($this->plaintext_passwd);
		$tm = __request_timestamp__;
		
		if( $GLOBALS['USE_ALIASES'] != 'Y' || !$this->alias ) $this->alias = $this->login;
				
		$r = q("INSERT INTO 
			fud21_users (
				login,
				alias,
				passwd, 
				name, 
				email, 
				display_email, 
				notify, 
				notify_method, 
				ignore_admin, 
				email_messages, 
				gender, 
				icq, 
				aim,
				yahoo,
				msnm,
				jabber,
				append_sig, 
				posts_ppg, 
				time_zone, 
				bday, 
				invisible_mode, 
				last_visit, 
				conf_key, 
				user_image, 
				join_date, 
				location, 
				avatar, 
				theme, 
				coppa, 
				occupation, 
				interests,
				referer_id,
				show_sigs,
				show_avatars,
				last_read,
				avatar_loc,
				avatar_approved,
				sig,
				default_view,
				home_page,
				bio
			)
			VALUES (
				'".$this->login."',
				'".$this->alias."',
				'".$md5pass."',
				'".$this->name."',
				'".$this->email."',
				'".yn($this->display_email)."',
				'".yn($this->notify)."',
				'".$this->notify_method."',
				'".yn($this->ignore_admin)."',
				'".yn($this->email_messages)."',
				'".$this->gender."',
				".intnull($this->icq).",
				".strnull($this->aim).",
				".strnull($this->yahoo).",
				".strnull($this->msnm).",
				".strnull($this->jabber).",
				'".yn($this->append_sig)."',
				'".$this->posts_ppg."',
				'".$this->time_zone."',
				".intzero($this->bday).",
				'".yn($this->invisible_mode)."',
				".$tm.",
				'".$this->conf_key."',
				".strnull($this->user_image).",
				".$tm.",
				'".$this->location."',
				".intzero($this->avatar).",
				".intzero($this->theme).",
				'".yn($this->coppa)."',
				".strnull($this->occupation).",
				".strnull($this->interests).",
				".intzero($ref_id).",
				'".yn($this->show_sigs)."',
				'".yn($this->show_avatars)."',
				".$tm.",
				".strnull($this->avatar_loc).",
				'NO',
				".strnull($this->sig).",
				'".$this->default_view."',
				".strnull(addslashes($this->home_page)).",
				".strnull(addslashes($this->bio))."
			)
		");
		$this->id = db_lastid("fud21_users", $r);
		if( $GLOBALS['EMAIL_CONFIRMATION'] == 'N' ) $this->email_confirm();
		
		db_unlock();
		return $this->id;
	}
	
	function get_user_by_login($login)
	{
		qobj("SELECT * FROM fud21_users WHERE login='".$login."'", $this);
		if( empty($this->id) ) return;
		return $this;
	}
	
	function sync_user()
	{
		if ( $plaintext_passwd ) $passwd = "'".md5($plaintext_passwd)."',";
		$alias = ( $GLOBALS['USE_ALIASES'] == 'Y' && $this->alias ) ? "alias='".$this->alias."'," : "alias=login,";
		
		q("UPDATE 
				fud21_users 
			SET 
				$passwd name='".$this->name."',
				".$alias."
				email='".$this->email."',
				display_email='".yn($this->display_email)."',
				notify='".yn($this->notify)."',
				notify_method='".$this->notify_method."',
				ignore_admin='".yn($this->ignore_admin)."',
				email_messages='".yn($this->email_messages)."',
				gender='".$this->gender."',
				icq=".intnull($this->icq).",
				aim=".strnull($this->aim).",
				yahoo=".strnull($this->yahoo).",
				msnm=".strnull($this->msnm).",
				jabber=".strnull($this->jabber).",
				append_sig='".yn($this->append_sig)."',
				show_sigs='".yn($this->show_sigs)."',
				show_avatars='".yn($this->show_avatars)."',
				posts_ppg='".$this->posts_ppg."',
				time_zone='".$this->time_zone."',
				invisible_mode='".yn($this->invisible_mode)."',
				bday=".intzero($this->bday).",
				user_image=".strnull($this->user_image).",
				location='".$this->location."',
				occupation='".$this->occupation."',
				interests='".$this->interests."',
				avatar=".intzero($this->avatar).",
				theme=".intzero($this->theme).",
				avatar_loc=".strnull($this->avatar_loc).",
				avatar_approved='".$this->avatar_approved."',
				sig=".strnull($this->sig).",
				default_view='".$this->default_view."',
				home_page=".strnull(addslashes($this->home_page)).",
				bio=".strnull(addslashes($this->bio))."
			WHERE id=".$this->id
		);
	}
	
	function ch_passwd($pass)
	{
		q("UPDATE fud21_users SET passwd='".md5($pass)."' WHERE id=".$this->id);
	}

	function reset_passwd()
	{
		$randval = dechex(get_random_value(32));
		q("UPDATE fud21_users SET passwd='".md5($randval)."', reset_key='0' WHERE id=".$this->id);
		return $randval;
	}
	
	function reset_key()
	{
		db_lock('fud21_users+');
		do {
			$reset_key = md5(get_random_value(128));
		} while ( bq("SELECT id FROM fud21_users WHERE reset_key='".$reset_key."'") );
		q("UPDATE fud21_users SET reset_key='".$reset_key."' WHERE id=".$this->id);
		db_unlock();
		return $reset_key;
	}

	function email_confirm()
	{
		q("UPDATE fud21_users SET email_conf='Y', conf_key='0' WHERE id=".$this->id);
	}
	
	function email_unconfirm()
	{
		db_lock('fud21_users+');
		do {
			$this->conf_key = md5(get_random_value(128));
		} while ( bq("SELECT id FROM fud21_users WHERE conf_key='".$this->conf_key."'") );
	
		q("UPDATE fud21_users SET email_conf='N', conf_key='".$this->conf_key."' WHERE id=".$this->id);
		db_unlock();
		
		return $this->conf_key;
	}
}

function get_id_by_email($email)
{
	return q_singleval("SELECT id FROM fud21_users WHERE LOWER(email)='".strtolower($email)."'");
}

function get_id_by_login($login)
{
	return q_singleval("SELECT id FROM fud21_users WHERE LOWER(login)='".strtolower($login)."'");
}

function get_id_by_alias($alias)
{
	return q_singleval("SELECT id FROM fud21_users WHERE alias='".$alias."'");
}

function get_id_by_radius($login, $passwd)
{
	return q_singleval("SELECT id FROM fud21_users WHERE LOWER(login)='".strtolower($login)."' AND passwd='".md5($passwd)."'");
}

function check_user($id)
{
	return q_singleval("SELECT login FROM fud21_users WHERE id=".$id);
}

function check_passwd($id, $passwd)
{
	return q_singleval("SELECT login FROM fud21_users WHERE id=".$id." AND passwd='".md5($passwd)."'");
}

function reset_user_passwd_by_key($key)
{
	if ( empty($key) ) return;
	db_lock('fud21_users+');
	$pass=NULL;
	$id = q_singleval("SELECT id FROM fud21_users WHERE reset_key='".$key."'");
	if ( $id ) {
		$u = new fud_user_reg;
		$u->get_user_by_id($id);
		$pass['passwd'] = $u->reset_passwd();
		$pass['usr'] = $u;
		
	}
	db_unlock();
	
	return $pass;
}

function fud_user_to_reg($obj)
{
	if ( !$obj ) return;
	$u = new fud_user_reg;
	user_copy_object($obj, $u);
	return $u;
}function get_mime_by_ext($ext)
{
	return q_singleval("SELECT id FROM fud21_mime WHERE fl_ext='".$ext."'");
}class fud_attach
{
	var $id=NULL;
	var $proto=NULL;
	var $location=NULL;
	var $original_name=NULL;
	var $owner=NULL;
	var $private=NULL;
	var $message_id=NULL;
	var $dlcount=NULL;
	var $mime_type=NULL;
	
	var $a_list;
	
	function add($owner, $message_id, $original_name, $cur_location, $private='')
	{
		$proto = proto($cur_location);
		
		$ext = substr($original_name, strrpos($original_name, '.')+1);
		if( !($mime_id = get_mime_by_ext($ext)) ) $mime_id = 0;
		
		$r=q("INSERT INTO fud21_attach (proto, location, original_name, message_id, owner, private, mime_type) VALUES('".$proto."', 'none://unset', '".$original_name."', ".intzero($message_id).", ".intzero($owner).", '".yn($private)."', ".$mime_id.")");
		$id = db_lastid("fud21_attach", $r);
		$this->message_id=$message_id;
		if ( $proto == 'LOCAL' ) {
			$loc = safe_attachment_copy($cur_location, $id);
		}
		else $loc = $cur_location;
		
		if ( $private == 'Y' ) 
			$tbl = 'fud21_pmsg';
		else
			$tbl = 'fud21_msg';
		
		q("UPDATE fud21_attach SET location='".addslashes($loc)."' WHERE id=".$id);
		if ( $message_id ) {
			qobj("SELECT count(*) AS a_count FROM fud21_attach WHERE message_id=".$message_id, $cObj);
			q("UPDATE ".$tbl." SET attach_cnt=".$cObj->a_count." WHERE id=".$this->message_id);
		}
		
		return $id;
	}
		
	function get($id,$private='')
	{
		$obj = qobj("SELECT * FROM fud21_attach WHERE id=".$id." AND private='".yn($private)."'", $this);
	}
	
	function replace($original_name, $cur_location)
	{
		$proto = proto($cur_location);
		$ext = substr($original_name, strrpos($original_name, '.')+1);
		if( !($mime_id = get_mime_by_ext($ext)) ) $mime_id = 0;
		
		q("UPDATE fud21_attach SET mime_type=".$mime_id.", proto='".$proto."', original_name='".$original_name."', location='".$cur_location."' WHERE id=".$this->id);
		if ( $proto == 'LOCAL' ) {
			$loc = $GLOBALS['FILE_STORE'].$this->id.'.atch';
			if ( file_exists($loc) ) unlink($loc);
			safe_attachment_copy($cur_location, $id);
		}
	}
	
	function delete()
	{
		if( !db_locked() ) {
			$ll = 1;
			db_lock('fud21_attach+');
		}	
		$r = q("SELECT location FROM fud21_attach WHERE id=".$this->id);
		if( db_count($r) ) {
			list($loc) = db_rowarr($r);
			if( file_exists($loc) ) 
				unlink($loc);
		}
		qf($r);
		q("DELETE FROM fud21_attach WHERE id=".$this->id);
		if( $ll ) db_unlock();
	}
	
	function inc_dl_count()
	{
		q("UPDATE fud21_attach SET dlcount=dlcount+1 WHERE id=".$this->id);
	}
	
}

function proto($file)
{
	if ( start_match($file, 'http://') ) 	return "REMOTE";
	if ( start_match($file, 'ftp://') ) 	return "REMOTE";
	
	return "LOCAL";
}

function start_match($haystack, $needle)
{
	if ( strtolower(substr($haystack, 0, strlen($needle))) == strtolower($needle) ) return strlen($needle);
	return 0;
}

function safe_attachment_copy($source, $id)
{
	$loc = $GLOBALS['FILE_STORE'].$id.'.atch';	
	if ( file_exists($loc) ) {
		unlink($loc);
		std_out('"'.$loc.'" already exists, but shouldn\'t (old file unlinked), check security', 'ERR');
	}
	
	if( !@copy($source, $loc) ) {
		std_out('unable to create source file ('.$loc.') check permissions on ('.$GLOBALS['FILE_STORE'].'), we suggest 1777', 'ERR');
	}
	@chmod($loc, 0600);
	
	return $loc;
}function get_host($ip)
{
	if( empty($ip) ) return;

	$name = gethostbyaddr($ip);
	if( $name != $ip ) {
		if ( count(explode('.', $name)) > 2 ) 
			$name = substr($name, strpos($name, '.'));
	}		
	else
		$name = NULL;		

	return $name;
}class fud_pmsg
{
	var $id='';
	var $to_list='';
	var $ouser_id='';
	var $duser_id='';
	var $pdest='';
	var $ip_addr='';
	var $host_name='';
	var $post_stamp='';
	
	var $icon='';
	var $mailed='';

	var $folder_id='';

	var $subject='';
	var $attach_cnt='';
	var $smiley_disabled='';
	var $show_sig='';
	var $track='';
	var $length='';
	var $foff='';
	var $login='';
	var $ref_msg_id='';	
	var $body;
	
	function add($track='')
	{
		if ( !db_locked() ) {
			$ll = 1;
			db_lock("fud21_pmsg+");
		}
	
		$this->post_stamp = __request_timestamp__;
		$this->ip_addr = $GLOBALS['HTTP_SERVER_VARS']['REMOTE_ADDR'];
	
		if ( $GLOBALS['PUBLIC_RESOLVE_HOST'] == 'Y' ) $this->host_name = get_host($this->ip_addr);
		
		if( empty($this->mailed) ) $this->mailed = ( $this->folder_id=='SENT' ) ? 'Y' : 'N';
		
		$r = q("INSERT INTO fud21_pmsg (
			ouser_id,
			duser_id,
			pdest,
			to_list,
			ip_addr,
			host_name,
			post_stamp,
			icon,
			mailed,
			folder_id,
			subject,
			attach_cnt,
			smiley_disabled,
			show_sig,
			track,
			read_stamp,
			ref_msg_id
			)
			VALUES(
				".$this->ouser_id.",
				".$this->ouser_id.",
				".INTZERO($GLOBALS['recv_user_id'][0]).",
				".strnull($this->to_list).",
				".ifnull($this->ip_addr, "'0.0.0.0'").",
				".strnull($this->host_name).",
				".$this->post_stamp.",
				".strnull($this->icon).",
				'".yn($this->mailed)."',
				'DRAFT',
				'".$this->subject."',
				".intzero($this->attach_cnt).",
				'".yn($this->smiley_disabled)."',
				'".yn($this->show_sig)."',
				'".yn($this->track)."',
				".$this->post_stamp.",
				".strnull($this->ref_msg_id)."
			)");
			
		$this->id = db_lastid("fud21_pmsg", $r);
			
		list($this->foff, $this->length) = write_pmsg_body($this->body);
		
		q("UPDATE fud21_pmsg SET foff=".$this->foff.", length=".$this->length.", folder_id='".$this->folder_id."' WHERE id=".$this->id);
		
		if( $this->folder_id == 'SENT' && empty($track) ) $this->send_pmsg();
		if ( $ll ) db_unlock();
	}
	
	function send_pmsg()
	{
		while( list(, $v) = each($GLOBALS['recv_user_id']) ) {
			$r = q("INSERT INTO 
			fud21_pmsg 
			(
				to_list,
				ouser_id,
				ip_addr,
				host_name,
				post_stamp,
				icon,
				mailed,
				folder_id,
				subject,
				attach_cnt,
				show_sig,
				smiley_disabled,
				track,
				foff,
				length,
				duser_id,
				ref_msg_id
			)
			VALUES
			(
				".strnull($this->to_list).",
				".$this->ouser_id.",
				".ifnull($this->ip_addr, "'0.0.0.0'").",
				".strnull($this->host_name).",
				".$this->post_stamp.",
				".strnull($this->icon).",
				'Y',
				'INBOX',
				'".$this->subject."',
				".intzero($this->attach_cnt).",
				'".yn($this->show_sig)."',
				'".yn($this->smiley_disabled)."',
				'".yn($this->track)."',
				".$this->foff.",
				".$this->length.",
				".$v.",
				".strnull($this->ref_msg_id)."
			)
			");
			$GLOBALS["send_to_array"][] = array($v, db_lastid("fud21_pmsg", $r));
		}	
	}
	
	function move_folder($folder_id)
	{
		if( empty($folder_id) ) return;
		q("UPDATE fud21_pmsg SET folder_id='".$folder_id."' WHERE duser_id="._uid." AND id=".$this->id);
		$this->mark_read();
	}
	
	function sync()
	{
		list($this->foff, $this->length) = write_pmsg_body($this->body);
		
		$this->post_stamp = __request_timestamp__;
		$this->ip_addr = $GLOBALS['HTTP_SERVER_VARS']['REMOTE_ADDR'];
		
		if ( $GLOBALS['PUBLIC_RESOLVE_HOST'] == 'Y' ) $this->host_name = get_host($this->ip_addr);
		
		$this->mailed = ( $this->folder_id=='SENT' ) ? 'Y' : 'N';
		
		q("UPDATE fud21_pmsg 
			SET
				to_list=".strnull($this->to_list).",
				icon=".strnull($this->icon).",
				ouser_id=".$this->ouser_id.",
				duser_id=".$this->ouser_id.",
				post_stamp=".$this->post_stamp.",
				subject='".$this->subject."',
				ip_addr='".$this->ip_addr."',
				host_name='".$this->host_name."',
				mailed='".yn($this->mailed)."',
				attach_cnt=".intzero($this->attach_cnt).",
				show_sig='".yn($this->show_sig)."',
				smiley_disabled='".yn($this->smiley_disabled)."',
				track='".yn($this->track)."',
				folder_id='".$this->folder_id."',
				foff=".$this->foff.",
				length=".$this->length."
			WHERE
				id=".$this->id);
				
		if( $this->folder_id == 'SENT' ) $this->send_pmsg();		
	}
	
	function del_pmsg($fldr_id='')
	{
		if( empty($fldr_id) ) {
			$fldr_id = q_singleval("SELECT folder_id FROM fud21_pmsg WHERE duser_id="._uid." AND id=".$this->id);
			$this->mark_read();
		}	
		if( empty($fldr_id) ) return;
			
		if( $fldr_id != 'TRASH' ) 
			$this->move_folder('TRASH');				
		else {
			$this->get($this->id, 1);
			
			q("DELETE FROM fud21_pmsg WHERE duser_id="._uid." AND id=".$this->id);
			if ( $this->attach_cnt ) {
				$res = q("SELECT location FROM fud21_attach WHERE message_id=".$this->id." AND private='Y'");
				if( db_count($res) ) {
					while ( list($loc) = db_rowarr($res) ) {
						if( file_exists($loc) ) unlink($loc);				
					}
				}
				qf($res);
				q("DELETE FROM fud21_attach WHERE message_id=".$this->id." AND private='Y'");
			}
		}	
	}
	
	function get($id, $re='')
	{
		qobj("SELECT fud21_pmsg.*,fud21_users.alias AS login FROM fud21_pmsg LEFT JOIN fud21_users ON fud21_pmsg.ouser_id=fud21_users.id WHERE fud21_pmsg.duser_id="._uid." AND fud21_pmsg.id=".$id, $this);
		if( !empty($this->id) && empty($re) ) 
			$this->body = read_pmsg_body($this->foff, $this->length);
	}
	
	function send_notify_msg()
	{
		$track_msg = new fud_pmsg;
		$track_msg->ouser_id = $track_msg->duser_id = $this->ouser_id;
		$track_msg->ip_addr = $track_msg->host_name = NULL;
		$track_msg->post_stamp = __request_timestamp__;
		$track_msg->mailed='Y';
		$track_msg->folder_id='INBOX';
		$track_msg->track='N';
		$this->subject = addslashes($this->subject);
		$track_msg->subject = 'Read Notification For: '.$this->subject;
		$track_msg->body = 'Hello,<br>'.$GLOBALS["usr"]->login.' has read your private message, "'.$this->subject.'", on '.strftime("%a, %d %B %Y %H:%M", $track_msg->post_stamp).'<br>';
		$track_msg->add(1);
		$this->mark_notify();	
	}

	function mark_read()
	{
		q("UPDATE fud21_pmsg SET read_stamp=".__request_timestamp__." WHERE id=".$this->id);
	}
	
	function mark_notify()
	{
		q("UPDATE fud21_pmsg SET track='SENT' WHERE id=".$this->id);
	}
}

function set_nrf($nrf, $id)
{
	q("UPDATE fud21_pmsg SET nrf_status='".$nrf."' WHERE id=".$id);		
}	

function write_pmsg_body($text)
{
	$fp = fopen($GLOBALS['MSG_STORE_DIR'].'private', 'ab');
	
	if( !($s = ftell($fp)) ) $s = __ffilesize($fp);

	fwrite($fp, $text);
	fflush($fp);
	$len = (ftell($fp)-$s);
	fclose($fp);
	
	if( !$s ) chmod($GLOBALS['MSG_STORE_DIR'].'private', 0600);
	
	return array($s,$len);
}

function read_pmsg_body($offset, $length)
{
	if( empty($length) ) return;
	
	$fp = fopen($GLOBALS['MSG_STORE_DIR'].'private', 'rb');
	
	fseek($fp, $offset, SEEK_SET);
	$str = fread($fp, $length);
	
	fclose($fp);
	
	return $str;
}class fud_custom_tag
{
	var $id;
	var $name;
	var $user_id;
	
	function delete()
	{
		q("DELETE FROM fud21_custom_tags WHERE id=".$this->id);
		$this->sync();
	}
	
	function delete_user($user_id)
	{
		q("DELETE FROM fud21_custom_tags WHERE user_id=".$user_id);
	}
	
	function add()
	{
		$r=q("INSERT INTO fud21_custom_tags(name, user_id) VALUES('".$this->name."', ".$this->user_id.")");
		$this->sync();
		$this->id = db_lastid("fud21_custom_tags", $r);
		return $this->id;
	}
	
	function export_vars($prefix)
	{
		$GLOBALS[$prefix.'name'] 	= $this->name;
		$GLOBALS[$prefix.'user_id']	= $this->user_id;
	}
	
	function get($id)
	{
		$obj = db_singleobj(q("SELECT * FROM fud21_custom_tags WHERE id=".$id));
		if ( !$obj ) return;
		$this->id 	= $obj->id;
		$this->user_id 	= $obj->user_id;
		$this->name	= $obj->name;
	}
	
	function sync()
	{
		$ct='';
		$r = q("SELECT name FROM fud21_custom_tags WHERE user_id=".$this->user_id);
		
		if( db_count($r) ) {
			while ( list($name) = db_rowarr($r) ) {
				$ct .= addslashes($name).'<br>';
			}
			$ct = '<font class="LevelText">'.$ct.'</font>';
		}
		else $ct='';
		qf($r);
		q("UPDATE fud21_users SET custom_status='".$ct."' WHERE id=".$this->user_id);
	}
}$GLOBALS['__REVERSE_ARRAY__'] = array('&amp;'=>'&','&quot;'=>'"','&lt;'=>'<','&gt;'=>'>');

function reverse_FMT(&$data)
{
	$data = strtr($data, $GLOBALS['__REVERSE_ARRAY__']);
}

function FMT($val)
{
	return htmlspecialchars(stripslashes($val));
}function validate_email($email)
{
        return !preg_match('!([-_A-Za-z0-9\.]+)\@([-_A-Za-z0-9\.]+)\.([A-Za-z0-9]{2,4})$!', $email);
}
        
class fud_email_block
{
	var $id;
	var $type;
	var $string;
	
	var $e_list;
	
	function add($type, $string)
	{
		q("INSERT INTO fud21_email_block(type, string) VALUES('".$type."', '".$string."')");
	} 
	
	function sync($type, $string)
	{
		q("UPDATE fud21_email_block SET type='".$type."', string='".$string."' WHERE id=".$this->id);
	}
	
	function get($id)
	{
		$res = q("SELECT * FROM fud21_email_block WHERE id=".$id);
		if ( !is_result($res) ) exit("no such email block");
		
		$obj = db_singleobj($res);
		
		$this->id 	= $obj->id;
		$this->type	= $obj->type;
		$this->string	= $obj->string;
	}
	
	function delete()
	{
		q("DELETE FROM fud21_email_block WHERE id=".$this->id);
	}
	
	function getall()
	{
		$res = q("SELECT * FROM fud21_email_block ORDER BY id");
		
		unset($this->e_list);
		while ( $obj = db_rowobj($res) ) {
			$this->e_list[] = $obj;
		}
		if ( isset($this->e_list) ) reset($this->e_list);
		qf($res); 
	}
	
	function counte()
	{
		if ( !isset($this->e_list) ) return;
		return count($this->e_list);
	}
	
	function resete()
	{
		if ( !isset($this->e_list) ) return;
		reset($this->e_list);
	}
	
	function eache()
	{
		if ( !isset($this->e_list) ) return;
		$obj = current($this->e_list);
		if ( !isset($obj) ) return;
		next($this->e_list);
		
		return $obj;
	}
}

function is_email_blocked($addr)
{

	if ( bq("SELECT * FROM fud21_email_block WHERE string='".$addr."'") ) return 1;

	$r = q("SELECT * FROM fud21_email_block ORDER BY id");
	while ( $obj = db_rowobj($r) ) {
		if ( $obj->type == 'SIMPLE' ) {
			$reg = $obj->string;
			$reg = str_replace('.', '\.', $reg);
			$reg = str_replace('*', '.*?', $reg);			
			if ( preg_match("!".$reg."!i", $addr, $res) ) {
				return 1;
			}
		}
		else if ( $obj->type == 'REGEX' ) {
			$reg = $obj->string;
			if ( preg_match("!".$reg."!i", $addr, $res) ) {
				return 1;
			}	
		}
	}
	qf($r);
	
	return 0;
}

function send_email($from, $to, $subj, $body, $header='')
{
	if( empty($to) || !count($to) ) return;	
	$bcc='';
	
	if( is_array($to) ) {
		if( ($a = count($to)) > 1 ) {
			$bcc = "Bcc: ";
			for( $i=1; $i<$a; $i++ ) 
				$bcc .= $to[$i].', ';
				
			$bcc = substr($bcc,0,-2);	
		}		

		$to = $to[0];
	}
	
	mail($to, $subj, $body, "From: $from\r\nErrors-To: $from\r\nReturn-Path: $from\r\nX-Mailer: FUDforum v".$GLOBALS['FORUM_VERSION']."\r\n".$header.$bcc);
}

function send_notifications($to, $msg_id, $thr_subject, $poster_login, $id_type, $id, $frm_name='')
{
	$icq = str_replace("http://", "http'+'://'+'", $GLOBALS['WWW_ROOT']);
	$icq = str_replace("www.", "www'+'.", $icq);

	$goto_url['icq'] = "javascript:window.location='".$icq."index.php?t=rview&goto=".$msg_id."';";
	$goto_url['email'] = $GLOBALS['WWW_ROOT'].'index.php?t=rview&goto='.$msg_id;
	
	
	if ( $GLOBALS['NOTIFY_WITH_BODY'] == 'Y' ) {
		$r = q("SELECT 
			fud21_msg.*, 
			fud21_thread.locked,
			fud21_thread.forum_id,
			fud21_avatar.img AS avatar, 
			fud21_users.id AS user_id, 
			fud21_users.alias AS login, 
			fud21_users.display_email, 
			fud21_users.avatar_approved,
			fud21_users.avatar_loc,
			fud21_users.email, 
			fud21_users.posted_msg_count, 
			fud21_users.join_date, 
			fud21_users.location, 
			fud21_users.sig,
			fud21_users.icq,
			fud21_users.jabber,
			fud21_users.aim,
			fud21_users.msnm,
			fud21_users.invisible_mode,
			fud21_users.email_messages,
			fud21_users.last_visit AS time_sec,
			fud21_users.is_mod,
			fud21_users.yahoo,
			fud21_users.custom_status,
			fud21_level.name AS level_name,
			fud21_level.pri AS level_pri,
			fud21_level.img AS level_img
		FROM 
			fud21_msg 
			LEFT JOIN fud21_users 
				ON fud21_msg.poster_id=fud21_users.id 
			LEFT JOIN fud21_avatar 
				ON fud21_users.avatar=fud21_avatar.id 
			INNER JOIN fud21_thread
				ON fud21_msg.thread_id=fud21_thread.id	
			LEFT JOIN fud21_ses
				ON fud21_ses.user_id=fud21_msg.poster_id
			LEFT JOIN fud21_level
				ON fud21_users.level_id=fud21_level.id
		WHERE 
			fud21_msg.id=".$msg_id." AND fud21_msg.approved='Y'");
		
		$obj = db_singleobj($r);
		unset($obj->ip_addr);
		$headers  = "MIME-Version: 1.0\r\n";
		$split = get_random_value(128);
		$headers .= "Content-Type: multipart/alternative; boundary=\"------------$split\"\r\n";
		$boundry = "\r\n--------------$split\r\n";
		
		$plain_text = read_msg_body($obj->foff,$obj->length, $obj->file_id);
		$plain_text = $boundry."Content-Type: text/plain; charset=".$GLOBALS['CHARSET']."; format=flowed\r\nContent-Transfer-Encoding: 7bit\r\n\r\n".strip_tags($plain_text)."\r\n\r\nTo participate in the discussion, go here: ".$GLOBALS['WWW_ROOT'].'index.php?t=rview&th='.$id."&notify=1&opt=off\r\n";
		
		$mod = $GLOBALS['MOD'];
		$GLOBALS['MOD'] = 1;
		$GLOBALS['pl_view'] = $obj->poll_id;
		$body_email = tmpl_drawmsg($obj,NULL,NULL,'');
		$GLOBALS['MOD'] = $mod;
		
		$body_email = $boundry."Content-Type: text/html; charset=".$GLOBALS['CHARSET']."\r\nContent-Transfer-Encoding: 7bit\r\n\r\n".'<html>
<head>
<META HTTP-EQUIV="Content-Type" CONTENT="text/html; charset=ISO-8859-15">
<title>'.$GLOBALS['FORUM_TITLE'].$TITLE_EXTRA.'</title>
<BASE HREF="'.$GLOBALS['WWW_ROOT'].'">
<script language="JavaScript" src="lib.js"></script>
<link rel="StyleSheet" href="http://thelocust.org/bored/theme/default/forum.css" type="text/css">
</head>
<body topmargin="2" leftmargin="2" marginheight="2" marginwidth="2">
<table width="100%" border="0" cellspacing="3" cellpadding="5"><tr><td class="ForumBackground">
<table border="0" cellspacing="1" cellpadding="2" class="ContentTable">
<tr>
	<th width=1>Author</th>
	<th>Thread</th>
</tr>
'.$body_email.'
</table>
</td></tr></table></body></html>'."\r\n";
		$body_email = $plain_text.$body_email.substr($boundry, 0, -2)."--\r\n";
	}
	
	reverse_FMT($thr_subject);
	reverse_FMT($poster_login);
	
	if( $id_type == 'thr' ) {
		$subj = 'New reply to '.$thr_subject.' by '.$poster_login;
		
		if( !$body_email ) {
			$unsub_url['email'] = $GLOBALS['WWW_ROOT'].'index.php?t=rview&th='.$id.'&notify=1&opt=off';
			$body_email = 'To view unread replies goto '.$goto_url['email'].'

If you do not wish to receive further notifications about replies in this thread, please go here: '.$unsub_url['email'];
		}	
		
		$body_icq = 'To view unread replies goto
'.$goto_url['icq'].'

If you do not wish to receive further notifications about replies in this thread, please go here:
'.$unsub_url['icq'];
		$unsub_url['icq'] = "javascript:window.location='".$icq."index.php?t=rview&th=".$id."&notify=1&opt=off';";
	}
	else if ( $id_type == 'frm' ) {
		reverse_FMT($frm_name);
		
		$subj = 'New thread in forum '.$frm_name.' called '.$thr_subject.' by '.$poster_login;
		
		$unsub_url['icq'] = "javascript:window.location='".$icq."index.php?t=thread&unsub=1&frm_id=".$id."';";
		$body_icq = 'To view the thread goto:
'.$goto_url['icq'].'

To stop receiving notifications about new threads in this forum, please go here:
'.$unsub_url['icq'];
		
		if( !$body_email ) {
			$unsub_url['email'] = $GLOBALS['WWW_ROOT'].'index.php?t=thread&unsub=1&frm_id='.$id;
			$body_email = 'To view the thread goto:
'.$goto_url['email'].'

To stop receiving notifications about new threads in this forum, please go here: '.$unsub_url['email'];
		}	
	}	
	
	send_email($GLOBALS["FORUM_TITLE"].' <'.$GLOBALS['NOTIFY_FROM'].'>', $to['EMAIL'], $subj, $body_email, $headers);
	send_email($GLOBALS["FORUM_TITLE"].' <'.$GLOBALS['NOTIFY_FROM'].'>', $to['ICQ'], $subj, $body_icq);
}function send_status_update($dusr, $title, $msg)
{
	if( $GLOBALS['PM_ENABLED']=='Y' ) {
		if( defined('no_inline') ) fud_use('private.inc');
		$GLOBALS['recv_user_id'][] = $dusr->id;
		$pmsg = new fud_pmsg;
		$pmsg->to_list = addslashes($dusr->login);
		$pmsg->ouser_id = $GLOBALS['usr']->id;
		$pmsg->post_stamp = __request_timestamp__;
		$pmsg->subject = addslashes($title);
		list($pmsg->foff, $pmsg->length) = write_pmsg_body(nl2br($msg));
		$pmsg->send_pmsg();	
	}
	else {
		if( defined('no_inline') ) fud_use('iemail.inc');
		send_email($GLOBALS['NOTIFY_FROM'], $dusr->email, $title, $msg);
	}
}class fud_user_adm extends fud_user_reg
{
	var $custom_tags;

	function delete_user()
	{
		if ( !db_locked() ) { $ll=1; db_lock('fud21_forum+, fud21_poll_opt_track+, fud21_users+, fud21_pmsg+, fud21_attach+, fud21_mod+, fud21_custom_tags+, fud21_thread_notify+, fud21_forum_notify+, fud21_read+, fud21_forum_read+, fud21_thread_rate_track+, fud21_user_ignore+, fud21_buddy+'); }
		$this->de_moderate();
		$u_entry = $this->id."\n".addslashes(htmlspecialchars(trim_show_len($this->login,'LOGIN')));
		q("UPDATE fud21_forum SET moderators=TRIM(BOTH '\n\n' FROM REPLACE(moderators, '$u_entry', ''))");
		
		$tags = new fud_custom_tag;
		$tags->delete_user($this->id);
		
		q("DELETE FROM fud21_thread_notify WHERE user_id=".$this->id);
		q("DELETE FROM fud21_forum_notify WHERE user_id=".$this->id);
		q("DELETE FROM fud21_read WHERE user_id=".$this->id);
		q("DELETE FROM fud21_forum_read WHERE user_id=".$this->id);
		q("DELETE FROM fud21_thread_rate_track WHERE user_id=".$this->id);
		q("DELETE FROM fud21_user_ignore WHERE user_id=".$this->id);
		q("DELETE FROM fud21_user_ignore WHERE ignore_id=".$this->id);
		q("DELETE FROM fud21_buddy WHERE user_id=".$this->id);
		q("DELETE FROM fud21_buddy WHERE bud_id=".$this->id);
		q("DELETE FROM fud21_poll_opt_track WHERE user_id=".$this->id);
		
		/* Delete the private messages of this user */
		
		$r = q("SELECT id FROM fud21_pmsg WHERE duser_id=".$this->id);
		while( list($pid) = db_rowarr($r) ) {
			$pmsg = new fud_pmsg;
			$pmsg->get($pid);
			$pmsg->del_pmsg('TRASH');
		}
		
		q("DELETE FROM fud21_users WHERE id=".$this->id);

		if ( $ll ) db_unlock();
	}

	function block_user()
	{
		q("UPDATE fud21_users SET blocked='Y' WHERE id=".$this->id);
	}
	
	function unblock_user()
	{
		q("UPDATE fud21_users SET blocked='N' WHERE id=".$this->id);
	}
	
	function start_mod()
	{
		db_lock('fud21_forum+, fud21_mod+');
	}
	
	function end_mod()
	{
		db_unlock();
	}
	
	function mk_moderator($forum_id)
	{	
		if ( !bq("SELECT id FROM fud21_forum WHERE id=".$forum_id) ) {
			exit("no such forum to moderate\n");
		}
		
		q("INSERT INTO fud21_mod(user_id, forum_id) VALUES(".$this->id.", ".$forum_id.")");
	}
	
	function rm_moderator($forum_id)
	{
		q("DELETE FROM fud21_mod WHERE user_id=".$this->id." AND forum_id=".$forum_id);
	}
	
	function de_moderate()
	{
		q("DELETE FROM fud21_mod WHERE user_id=".$this->id);
	}
	
	function mk_admin()
	{
		q("UPDATE fud21_users SET is_mod='A' WHERE id=".$this->id);
	}
	
	function de_admin()
	{
		$is_mod = ( bq("SELECT id FROM fud21_mod WHERE user_id=".$this->id." LIMIT 1") ) ? 'Y' : 'N';
		q("UPDATE fud21_users SET is_mod='".$is_mod."' WHERE id=".$this->id);
	}
	
	function getmod()
	{
		$result = q("SELECT fud21_mod.id AS id, fud21_mod.user_id AS user_id, fud21_forum.id AS forum_id, fud21_forum.name AS name FROM fud21_mod, fud21_forum WHERE fud21_mod.forum_id=fud21_forum.id AND fud21_mod.user_id=".$this->id);
		
		unset($this->mod_list);
		$this->mod_cur = 0;
		
		while ( $obj=db_rowobj($result) ) {
			$this->mod_list[$this->mod_cur++] = $obj;
		}
		qf($result);
		
		return $this->mod_cur;
	}
	
	function countmod()
	{
		if ( !isset($this->mod_list) ) return;
		return @count($this->mod_list); 
	}
	
	function resetmod()
	{
		$this->mod_cur = 0;
	}
	
	function nextmod()
	{
		if ( !isset($this->mod_list[$this->mod_cur]) ) return;
		
		return $this->mod_list[$this->mod_cur++];
	}
	
	function get_custom_tags()
	{
		$r = q("SELECT * FROM fud21_custom_tags WHERE user_id=".$this->id);
		
		unset($this->custom_tags);
		$z = 0;
		while ( $obj = db_rowobj($r) ) {
			$this->custom_tags[$z++] = $obj;
		}
		qf($r);
		
		return $this->custom_tags;
	}
	
	function approve_avatar()
	{
		q("UPDATE fud21_users SET avatar_approved='Y' WHERE id=".$this->id);
		send_status_update($this, 'Your custom avatar was approved.', 'Your avatar was approved by the administrator. It should now appear as your avatar on all your messages. If you do not see it, or see your old avatar, it is because your browser has cached the page. Try refreshing it once or twice, this, in most cases will solve the caching problem.');
	}
	
	function unapprove_avatar()
	{
		q("UPDATE fud21_users SET avatar_approved='NO', avatar_loc=NULL WHERE id=".$this->id);
		send_status_update($this, 'Your custom avatar was declined.', 'The administrator did not approve your avatar. Most common reasons are that your avatar was too big (size and/or dimensions) or it had contained inappropriate subject matter. If you would like more information about why your avatar was rejected, contact the administrator.');
	}
}

function fud_user_to_adm($obj)
{
	if ( !$obj ) return;
	$u = new fud_user_adm;
	user_copy_object($obj, $u);
	return $u;
}class fud_thread
{
	var $id=NULL;
	var $forum_id=NULL;
	var $root_msg_id=NULL;
	var $last_post_date=NULL;
	var $replies=NULL;
	var $views=NULL;
	var $rating=NULL;
	var $last_post_id=NULL;
	var $locked=NULL;
	var $is_sticky=NULL;
	var $ordertype=NULL;
	var $orderexpiry=NULL;
	
	var $subject=NULL;
	var $db_thread=NULL;
	
	function add($root, $forum_id, $locked=NULL, $is_sticky=NULL, $ordertype=NULL, $orderexpiry=NULL) 
	{
		$r = q("INSERT INTO 
			fud21_thread(
				forum_id, 
				root_msg_id, 
				last_post_date, 
				replies, 
				views, 
				rating, 
				last_post_id,
				locked, 
				is_sticky,
				ordertype,
				orderexpiry
			)
			VALUES
			(
				".$forum_id.",
				".$root.",
				".__request_timestamp__.",
				0,
				0,
				0,
				".$root.",
				'".yn($locked)."',
				'".yn($is_sticky)."',
				".ifnull($ordertype, "'NONE'").",
				".intzero($orderexpiry)."
			)");
		
		$this->id = db_lastid("fud21_thread", $r);
		
		return $this->id;
	}
	
	function sync()
	{
		list($old_sticky,$forum_id) = db_singlearr(q("SELECT is_sticky,forum_id FROM fud21_thread WHERE id=".$this->id));
	
		q("UPDATE fud21_thread SET 
			is_sticky='".yn($this->is_sticky)."',
			ordertype=".ifnull($this->ordertype, "'NONE'").",
			orderexpiry=".intnull($this->orderexpiry).",
			locked='".yn($this->locked)."'
		WHERE id=".$this->id);
		
		if( $old_sticky != yn($this->is_sticky) ) rebuild_forum_view($forum_id);
	}
	
	function get_by_id($id)
	{
		$result = qobj("SELECT 
				fud21_thread.*,
				fud21_msg.subject
			FROM 
				fud21_thread 
				LEFT JOIN fud21_msg 
					ON fud21_thread.root_msg_id=fud21_msg.id 
				LEFT JOIN fud21_forum 
					ON fud21_thread.forum_id=fud21_forum.id 
				LEFT JOIN fud21_cat 
					ON fud21_forum.cat_id=fud21_cat.id 
			WHERE 
				fud21_thread.id=".$id, $this);
		if ( empty($this->id) ) error_dialog('Invalid thread ID','You\'ve followed an invalid link, the thread you are trying to view does not exist.','', 'FATAL');
	}

	function delete($rebuild_view=TRUE)
	{
		$msg = new fud_msg_edit;
		qobj("SELECT * FROM fud21_msg WHERE id=".$this->root_msg_id, $msg);
		if( !empty($msg->id) )
			$msg->delete(FALSE);
		else {
			q("DELETE FROM fud21_thread WHERE id=".$this->id);
			$tc = q_singleval("SELECT count(*) FROM fud21_thread INNER JOIN fud21_msg ON fud21_thread.root_msg_id=fud21_msg.id WHERE forum_id=".$this->forum_id." AND fud21_msg.approved='Y'");
			$mc = q_singleval("SELECT SUM(replies) FROM fud21_thread INNER JOIN fud21_msg ON fud21_thread.root_msg_id=fud21_msg.id WHERE forum_id=".$this->forum_id." AND fud21_msg.approved='Y'");
			$mc += $tc;
			$lpi = q_singleval("SELECT MAX(last_post_id) FROM fud21_thread INNER JOIN fud21_msg ON fud21_thread.root_msg_id=fud21_msg.id WHERE forum_id=".$this->forum_id." AND fud21_msg.approved='Y'");
			q("UPDATE fud21_forum SET post_count=".intzero($mc).", last_post_id=".intzero($lpi).", thread_count=".intzero($tc)." WHERE id=".$this->forum_id);
		}	
		
		if( $rebuild_view ) rebuild_forum_view($this->forum_id);
	}
	
	function lock()
	{
		q("UPDATE fud21_thread SET locked='Y' WHERE id=".$this->id);
	}
	
	function unlock()
	{
		q("UPDATE fud21_thread SET locked='N' WHERE id=".$this->id);
	}
	
	function move($to_forum)
	{
		if ( !db_locked() ) {
			db_lock('fud21_thread_view+, fud21_thread+, fud21_forum+, fud21_msg+');
			$local_lock = 1;
		}
		$msg_count = q_singleval("SELECT count(*) FROM fud21_thread LEFT JOIN fud21_msg ON fud21_msg.thread_id=fud21_thread.id WHERE fud21_msg.approved='Y' AND fud21_thread.id=".$this->id);
		
		q("UPDATE fud21_thread SET forum_id=".$to_forum." WHERE id=".$this->id);
		q("UPDATE fud21_forum SET post_count=post_count-".$msg_count." WHERE id=".$this->forum_id);
		q("UPDATE fud21_forum SET thread_count=thread_count+1,post_count=post_count+".$msg_count." WHERE id=".$to_forum);
		$r=q("DELETE FROM fud21_thread WHERE forum_id=".$to_forum." AND root_msg_id=".$this->root_msg_id." AND moved_to=".$this->forum_id);
		if( $aff_rows=db_affected($r) ) q("UPDATE fud21_forum SET thread_count=thread_count-".$aff_rows." WHERE id=".$to_forum);
		q("UPDATE fud21_thread SET moved_to=".$to_forum." WHERE id!=".$this->id." AND root_msg_id=".$this->root_msg_id);
		
		q("INSERT INTO fud21_thread(
			forum_id,
			root_msg_id,
			last_post_date,
			last_post_id,
			moved_to
		)
		VALUES(
			".$this->forum_id.",
			".$this->root_msg_id.",
			".$this->last_post_date.",
			".$this->last_post_id.",
			".$to_forum."
		)");
		
		rebuild_forum_view($this->forum_id);
		rebuild_forum_view($to_forum);
		
		if ( !empty($local_lock) ) db_unlock();
	}
	
	function inc_post_count($val)
	{
		q("UPDATE fud21_thread SET replies=replies+".$val." WHERE id=".$this->id);
	}
	
	function inc_view_count()
	{
		q("UPDATE fud21_thread SET views=views+1 WHERE id=".$this->id);
	}
	
	function dec_view_count($val)
	{
		q("UPDATE fud21_thread SET views=views-1 WHERE id=".$this->id);
	}
	
	function get_notify_list($user_id)
	{
		$ctm = __request_timestamp__;
		$tm = $ctm-604800;
	
		$r = q("SELECT 
				fud21_users.id AS user_id,
				fud21_users.email,
				fud21_users.icq,
				fud21_read.last_view,
				fud21_read.id,
				fud21_users.notify_method 
			FROM 
				fud21_thread_notify
				INNER JOIN fud21_users 
					ON fud21_thread_notify.user_id=fud21_users.id 
				LEFT JOIN fud21_read 
					ON fud21_read.user_id=fud21_thread_notify.user_id 
					AND fud21_read.thread_id=fud21_thread_notify.thread_id 
			WHERE 
				( fud21_read.msg_id=".$this->last_post_id." OR fud21_read.last_view < ".$tm." )
				AND fud21_thread_notify.thread_id=".$this->id." 
				AND fud21_thread_notify.user_id!=".intzero($user_id));
		
		$p = forum_perm_array($this->forum_id);
		$to=NULL;
		while ( $obj = db_rowobj($r) ) {
			if ( !is_allowed($obj->user_id, $p) ) continue;
			
			$to[$obj->notify_method][] = ( $obj->notify_method == 'EMAIL' ) ? $obj->email : $obj->icq.'@pager.icq.com';
			if( $obj->last_view < $tm ) q("UPDATE fud21_read SET last_view=".$ctm." WHERE id=".$obj->id);
		}
		qf($r);
		
		return $to;
	}
	
	function adm_set_rating($value)
	{
		q("UPDATE fud21_thread SET rating=".intnull($value)." WHERE id=".$this->id);
	}

	function has_thread_vote($user_id, $thread_id='')
	{
		if ( !$thread_id ) $thread_id = $this->id;
		
		if( ($rating=q_singleval("SELECT rating FROM fud21_thread_rate_track WHERE thread_id=".$thread_id." AND user_id=".$user_id)) ) {
			return $rating;	
		}
		return -1;
	}
	
	function update_vote_count()
	{
		$rating = q_singleval("SELECT ROUND(AVG(rating)) FROM fud21_thread_rate_track WHERE thread_id=".$this->id);
		q("UPDATE fud21_thread SET rating=".$rating." WHERE id=".$this->id);
	}
	
	function vote_count($thread_id='')
	{
		if ( !$thread_id ) $thread_id = $this->id;
		
		return q_singleval("SELECT COUNT(*) FROM fud21_thread_rate_track WHERE thread_id=".$thread_id);
	}
	
	function register_thread_vote($user_id, $rating, $thread_id='')
	{
		if ( !$thread_id ) $thread_id = $this->id;
		
		if( !db_locked() ) {
			db_lock('fud21_thread_rate_track+, fud21_thread+');
			$local_lock = 1;
		}
		
		if( $this->has_thread_vote($user_id, $thread_id) != -1 ) {
			if ( $local_lock ) db_unlock();
			return;
		}	
		
		q("INSERT INTO fud21_thread_rate_track (
			thread_id,
			user_id,
			stamp,
			rating
			)
		VALUES(
			".$thread_id.",
			".$user_id.",
			".__request_timestamp__.",
			".$rating."
		)");
		
		$rating = q_singleval("SELECT ROUND(AVG(rating)) FROM fud21_thread_rate_track WHERE thread_id=".$thread_id);
		
		q("UPDATE fud21_thread SET rating=".$rating." WHERE id=".$thread_id);
		
		if ( $local_lock ) db_unlock();
	}
}

function rebuild_forum_view($forum_id, $page=0)
{
	if( !db_locked() ) {
	        db_lock('fud21_thread_view+, fud21_thread+, fud21_msg+, fud21_forum+');
		$local_lock=1;
	}
	
	$tm = __request_timestamp__;
	
	/* Remove expired moved thread pointers */
	$r=q("DELETE FROM fud21_thread WHERE forum_id=".$forum_id." AND last_post_date<".($tm-86400*$GLOBALS['MOVED_THR_PTR_EXPIRY'])." AND moved_to!=0");
	if( $aff_rows = db_affected($r) ) {
		q("UPDATE fud21_forum SET thread_count=thread_count-".$aff_rows." WHERE id=".$forum_id);
		$page = 0;
	}
	
	/* De-announce expired announcments and sticky messages */
	$r = q("SELECT fud21_thread.id FROM fud21_thread INNER JOIN fud21_msg ON fud21_thread.root_msg_id=fud21_msg.thread_id WHERE fud21_thread.forum_id=".$forum_id." AND is_sticky='Y' AND (fud21_msg.post_stamp+fud21_thread.orderexpiry)<".$tm);
	while( list($tid) = db_rowarr($r) ) 
		q("UPDATE fud21_thread SET ordertype='NONE', is_sticky='N' WHERE id=".$tid);
	qf($r);

	if ( __dbtype__ == 'pgsql' ) {
		$tmp_tbl_name = "fud21_ftvt_".get_random_value();
		q("CREATE TEMP TABLE ".$tmp_tbl_name." ( forum_id INT NOT NULL, page INT8 NOT NULL, thread_id INT NOT NULL, pos SERIAL, tmp INT )");
		
		if( $page ) {
			q("DELETE FROM fud21_thread_view WHERE forum_id=".$forum_id." AND page<".($page+1));
			q("INSERT INTO ".$tmp_tbl_name." (thread_id,forum_id,page,tmp) SELECT fud21_thread.id, fud21_thread.forum_id, 4294967294, CASE WHEN is_sticky='Y' AND (fud21_msg.post_stamp+fud21_thread.orderexpiry>".$tm." OR fud21_thread.orderexpiry=0) THEN 4294967294 ELSE fud21_thread.last_post_date END AS sort_order_fld  FROM fud21_thread INNER JOIN fud21_msg ON fud21_thread.root_msg_id=fud21_msg.id WHERE forum_id=".$forum_id." AND fud21_msg.approved='Y' ORDER BY sort_order_fld DESC, fud21_thread.last_post_id DESC LIMIT ".($GLOBALS['THREADS_PER_PAGE']*$page).", 0");
		}
		else {
			q("DELETE FROM fud21_thread_view WHERE forum_id=".$forum_id);
			q("INSERT INTO ".$tmp_tbl_name." (thread_id,forum_id,page,tmp) SELECT fud21_thread.id, fud21_thread.forum_id, 2147483647, CASE WHEN is_sticky='Y' AND (fud21_msg.post_stamp+fud21_thread.orderexpiry>".$tm." OR fud21_thread.orderexpiry=0) THEN 2147483647 ELSE fud21_thread.last_post_date END AS sort_order_fld  FROM fud21_thread INNER JOIN fud21_msg ON fud21_thread.root_msg_id=fud21_msg.id WHERE forum_id=".$forum_id." AND fud21_msg.approved='Y' ORDER BY sort_order_fld DESC, fud21_thread.last_post_id DESC");
		}
		
		q("INSERT INTO fud21_thread_view (thread_id,forum_id,page,pos) SELECT thread_id,forum_id,CEIL(pos/40.0),(pos-(CEIL(pos/40)-1)*40) FROM ".$tmp_tbl_name);
		q("DROP SEQUENCE ".$tmp_tbl_name."_pos_seq");
		q("DROP TABLE ".$tmp_tbl_name);
		return;
	}
	else if ( __dbtype__ == 'mysql' ) {
		if( $page ) {
			q("DELETE FROM fud21_thread_view WHERE forum_id=".$forum_id." AND page<".($page+1));
			q("INSERT INTO fud21_thread_view (thread_id,forum_id,page,tmp) SELECT fud21_thread.id, fud21_thread.forum_id, 4294967294, CASE WHEN is_sticky='Y' AND (fud21_msg.post_stamp+fud21_thread.orderexpiry>".$tm." OR fud21_thread.orderexpiry=0) THEN 4294967294 ELSE fud21_thread.last_post_date END AS sort_order_fld  FROM fud21_thread INNER JOIN fud21_msg ON fud21_thread.root_msg_id=fud21_msg.id WHERE forum_id=".$forum_id." AND fud21_msg.approved='Y' ORDER BY sort_order_fld DESC, fud21_thread.last_post_id DESC LIMIT 0, ".($GLOBALS['THREADS_PER_PAGE']*$page));
			q("UPDATE fud21_thread_view SET page=CEILING(pos/".$GLOBALS['THREADS_PER_PAGE']."), pos=pos-(CEILING(pos/".$GLOBALS['THREADS_PER_PAGE'].")-1)*".$GLOBALS['THREADS_PER_PAGE']." WHERE forum_id=".$forum_id." AND page=4294967294");			
		}
		else {
			q("DELETE FROM fud21_thread_view WHERE forum_id=".$forum_id);
			q("INSERT INTO fud21_thread_view (thread_id,forum_id,page,tmp) SELECT fud21_thread.id, fud21_thread.forum_id, 4294967294, CASE WHEN is_sticky='Y' AND (fud21_msg.post_stamp+fud21_thread.orderexpiry>".$tm." OR fud21_thread.orderexpiry=0) THEN 4294967294 ELSE fud21_thread.last_post_date END AS sort_order_fld  FROM fud21_thread INNER JOIN fud21_msg ON fud21_thread.root_msg_id=fud21_msg.id WHERE forum_id=".$forum_id." AND fud21_msg.approved='Y' ORDER BY sort_order_fld DESC, fud21_thread.last_post_id DESC");
			q("UPDATE fud21_thread_view SET page=CEILING(pos/".$GLOBALS['THREADS_PER_PAGE']."), pos=pos-(CEILING(pos/".$GLOBALS['THREADS_PER_PAGE'].")-1)*".$GLOBALS['THREADS_PER_PAGE']." WHERE forum_id=".$forum_id);			
		}
	}
	if( $local_lock ) db_unlock();
}class fud_forum
{
	var $id=NULL;
	var $cat_id=NULL;
	var $name=NULL;
	var $descr=NULL;
	var $passwd_posting=NULL;
	var $post_passwd=NULL;
	var $anon_forum=NULL;
	var $forum_icon=NULL;
	var $tag_style=NULL;
	var $last_post_id=NULL;
	
	var $allow_polls=NULL;
	var $date_created=NULL;
	var $thread_count=NULL;
	var $view_order=NULL;
	var $message_threshold=NULL;
	
	var $moderated=NULL;
	var $max_attach_size=NULL;
	var $max_file_attachments=NULL;
	
	var $forums=NULL;
	var $cur_frm=NULL;
	
	var $locked=NULL;
	
	
	function get($id)
	{
		qobj("SELECT * FROM fud21_forum WHERE fud21_forum.id=".$id, $this);
		if( empty($this->id) ) invl_inp_err();
			
		return $id;		
	}
	
	function is_moderator($user_id)
	{
		return q_singleval("SELECT id FROM fud21_mod WHERE user_id=".$user_id." AND forum_id=".$this->id);
	}
	
	function inc_reply_count($val)
	{
		q("UPDATE fud21_forum SET post_count=post_count+".$val." WHERE id=".$this->id);
	}
	
	function dec_reply_count($val)
	{
		q("UPDATE fud21_forum SET post_count=post_count-".$val." WHERE id=".$this->id);
	}
	
	function inc_thread_count($val)
	{
		q("UPDATE fud21_forum SET thread_count=thread_count+".$val." WHERE id=".$this->id);
	}
	
	function dec_thread_count($val)
	{
		q("UPDATE fud21_forum SET thread_count=thread_count-".$val." WHERE id=".$this->id);
	}
	
	function get_notify_list($user_id)
	{
		$r = q("SELECT 
				fud21_users.email, 
				fud21_users.icq, 
				fud21_users.notify_method 
			FROM 
				fud21_forum_notify 
				INNER JOIN fud21_users 
					ON fud21_forum_notify.user_id=fud21_users.id 
			WHERE 
				fud21_forum_notify.forum_id=".$this->id." 
				AND fud21_forum_notify.user_id!=".$user_id);
		
		$p = forum_perm_array($this->id);
		$to=NULL;
		while ( $obj = db_rowobj($r) ) {
			if ( !is_allowed($obj->user_id, $p) ) continue;
			
			$to[$obj->notify_method][] = ( $obj->notify_method == 'EMAIL' ) ? $obj->email : $obj->icq.'@pager.icq.com';
		}

		qf($r);
				
		return $to;
	}
	
}

if ( defined('admin_form') && !defined("_forum_adm_inc_") ) fud_use('forum_adm.inc');class fud_msg
{
	var $id=NULL;
	var $thread_id=NULL;
	var $poster_id=NULL;
	var $reply_to=NULL;
	var $ip_addr=NULL;
	var $host_name=NULL;
	var $post_stamp=NULL;
	var $subject=NULL;
	var $attach_cnt=NULL;
	var $poll_id=NULL;
	var $update_stamp=NULL;
	var $icon=NULL;
	var $approved=NULL;
	var $show_sig=NULL;
	var $updated_by=NULL;
	var $smiley_disabled=NULL;
	var $login=NULL;
	var $length=NULL;
	var $foff=NULL;
	var $file_id=NULL;
	var $file_id_preview=NULL;
	var $length_preview=NULL;
	var $offset_preview=NULL;
	
	var $body;
		
	function get_by_id($id)
	{
		qobj("SELECT fud21_msg.*,fud21_users.alias AS login FROM fud21_msg LEFT JOIN fud21_users ON fud21_msg.poster_id=fud21_users.id WHERE fud21_msg.id=".$id, $this);
		if( empty($this->id) ) error_dialog('Invalid Message', 'The message you are trying to view does not exist.', '', 'FATAL');
		
		$this->body = read_msg_body($this->foff,$this->length, $this->file_id);
		un_register_fps();
	}
	
	function get_thread($th_id)
	{
		qobj("SELECT fud21_msg.* FROM fud21_msg INNER JOIN fud21_thread ON fud21_thread.root_msg_id=fud21_msg.id WHERE fud21_thread.id=".$th_id, $this);
		
		
		$this->body = read_msg_body($this->foff,$this->length, $this->file_id);
		un_register_fps();
	}
}

if ( defined('msg_edit') && !defined("_imsg_edit_inc_") ) fud_use('imsg_edt.inc');class fud_forum_adm extends fud_forum
{
	function get_max_view($cat_id)
	{
		$ret = q_singleval("SELECT MAX(view_order) FROM fud21_forum WHERE cat_id=".$cat_id);
		return ( empty($ret) ? 0 : $ret );
	}
	
	function add($pos)
	{
		if ( !db_locked() ) {
			$ll = 1;
			db_lock('
				fud21_forum+, 
				fud21_groups+, 
				fud21_group_resources+, 
				fud21_group_members+,
				fud21_group_cache+
			');
		}
		
		$max = $this->get_max_view($this->cat_id);
		if ( $max > 0 ) {
			$this->view_order = $max+1;
		}
		else $this->view_order = 1;
		
		if ( $pos == 'FIRST' ) {
			$this->move_up(1, $max, $this->cat_id);
			$this->view_order = 1;
		}
		
		$r = q("INSERT INTO fud21_forum (
			cat_id, 
			name, 
			descr, 
			passwd_posting, 
			post_passwd, 
			anon_forum, 
			date_created, 
			view_order, 
			forum_icon, 
			tag_style, 
			moderated, 
			max_attach_size,
			max_file_attachments,
			message_threshold
		) 
		VALUES(
			".$this->cat_id.",
			'".$this->name."',
			".strnull($this->descr).",
			'".$this->passwd_posting."',
			".strnull($this->post_passwd).",
			'".yn($this->anon_forum)."',
			".__request_timestamp__.",
			".$this->view_order.",
			".strnull($this->forum_icon).",
			'".$this->tag_style."',
			'".$this->moderated."',
			".intzero($this->max_attach_size).",
			".intzero($this->max_file_attachments).",
			".intzero($this->message_threshold)."
		)");
		
		$this->id = db_lastid("fud21_forum", $r);
		$grp = new fud_group;
		reset($GLOBALS['__GROUPS_INC']['permlist']);
		while ( list($k,$v) = each($GLOBALS['__GROUPS_INC']['permlist']) ) {
			$grp->{$k} = 'Y';
		}
		$grp->add('forum', $this->id, $this->name);
		$grp->add_resource('forum', $this->id);
		$grp->rebuild_cache();
		if ( $ll ) db_unlock();
		
		return $this->id;
	}
	
	function sync()
	{
		if ( !db_locked() ) { 
			$ll=1; 
			db_lock('
				fud21_forum+, 
				fud21_groups+
			'); 
		}
		
		q("UPDATE fud21_forum SET 
			cat_id=".$this->cat_id.",
			name='".$this->name."',
			descr=".strnull($this->descr).",
			passwd_posting='".$this->passwd_posting."',
			post_passwd=".strnull($this->post_passwd).",
			anon_forum='".yn($this->anon_forum)."',
			view_order=".$this->view_order.",
			forum_icon=".strnull($this->forum_icon).",
			tag_style='".$this->tag_style."',
			moderated='".$this->moderated."',
			max_attach_size=".$this->max_attach_size.", 
			max_file_attachments=".intzero($this->max_file_attachments).",
			message_threshold=".intzero($this->message_threshold)."
		WHERE id=".$this->id);
		
		q("UPDATE fud21_groups SET name='$this->name' WHERE res='forum' AND res_id=$this->id");
		
		if ( $ll ) db_unlock();
	}
	
	function change_pos($old, $new, $cat_id)
	{
		if ( !db_locked() ) {
			$ll = 1;
			db_lock('fud21_forum+');
		}
		
		q("UPDATE fud21_forum SET view_order=2147483647 WHERE cat_id=".$cat_id." AND view_order=".$old);
		
		if ( $old > $new ) 
			$this->move_up($new, $old, $cat_id);			
		else 
			$this->move_down($old, $new, $cat_id);
		
		q("UPDATE fud21_forum SET view_order=".$new." WHERE cat_id=".$cat_id." AND view_order=2147483647");
		if ( $ll ) db_unlock();
	}
	
	function move_up($start, $max, $cat_id)
	{
		q("UPDATE fud21_forum SET view_order=view_order+1 WHERE cat_id=".$cat_id." AND view_order>=".$start." AND view_order<=".$max);
	}
	
	function move_down($start, $max, $cat_id)
	{
		q("UPDATE fud21_forum SET view_order=view_order-1 WHERE cat_id=".$cat_id." AND view_order>=".$start." AND view_order<=".$max);
	}

	function get_cat_forums($cat_id)
	{
		$result = q("SELECT * FROM fud21_forum WHERE cat_id=".$cat_id." ORDER BY view_order");

		unset($this->forums);
		$this->cur_frm=0;
		if ( !is_result($result) ) return;
		
		while ( $obj=db_rowobj($result) ) {
			$this->forums[$this->cur_frm++] = $obj;
		}
		
		qf($result);
		
		$this->cur_frm = 0;
		return 1;
	}
	
	function get_all_forums()
	{
		$result = q("SELECT fud21_forum.* FROM fud21_forum INNER JOIN fud21_cat ON fud21_forum.cat_id=fud21_cat.id ORDER BY fud21_cat.view_order, fud21_forum.view_order");
		
		unset($this->forums);
		$this->cur_frm=0;
		if ( !is_result($result) ) return;
		
		while ( $obj=db_rowobj($result) ) {
			$this->forums[$this->cur_frm++] = $obj;
		}
		
		qf($result);
		
		$this->cur_frm = 0;
		return 1;
	}
	
	function resetfrm()
	{
		$this->cur_frm = 0;
	}
	
	function countfrm()
	{
		if ( !isset($this->forums) ) return;
		return count($this->forums);
	}
	
	function nextfrm()
	{
		if ( !isset($this->forums[$this->cur_frm]) ) return;

		$this->id = $this->forums[$this->cur_frm]->id;
		$this->cat_id = $this->forums[$this->cur_frm]->cat_id;
		$this->name = $this->forums[$this->cur_frm]->name;
		$this->descr = $this->forums[$this->cur_frm]->descr;
		$this->passwd_posting = $this->forums[$this->cur_frm]->passwd_posting;
		$this->post_passwd = $this->forums[$this->cur_frm]->post_passwd;
		$this->anon_forum = $this->forums[$this->cur_frm]->anon_forum;
		$this->date_created = $this->forums[$this->cur_frm]->date_created;
		$this->thread_count = $this->forums[$this->cur_frm]->thread_count;
		$this->post_count = $this->forums[$this->cur_frm]->post_count;
		$this->view_order = $this->forums[$this->cur_frm]->view_order;
		$this->forum_icon = $this->forums[$this->cur_frm]->forum_icon;
		$this->tag_style = $this->forums[$this->cur_frm]->tag_style;
		$this->moderated = $this->forums[$this->cur_frm]->moderated;
		$this->max_attach_size = $this->forums[$this->cur_frm]->max_attach_size;
		$this->max_file_attachments = $this->forums[$this->cur_frm]->max_file_attachments;
		$this->message_threshold = $this->forums[$this->cur_frm]->message_threshold;
		$this->cur_frm++;
		
		return 1;
	}
	
	function delete($id) {
		db_lock('fud21_forum+, 
			fud21_mod+, 
			fud21_thread+, 
			fud21_msg+, 
			fud21_ann_forums+, 
			fud21_forum_notify+, 
			fud21_thread_notify+, 
			fud21_read+, 
			fud21_cat+, 
			fud21_attach+, 
			fud21_poll+, 
			fud21_poll_opt+, 
			fud21_poll_opt_track+, 
			fud21_users+, 
			fud21_msg_report+, 
			fud21_level+,
			fud21_thread_view+,
			fud21_thread_rate_track+,
			fud21_groups+, 
			fud21_group_resources+, 
			fud21_group_members+,
			fud21_group_cache+
			');
			
		$result = q("SELECT cat_id, view_order FROM fud21_forum WHERE id=".$id);
		if ( !is_result($result) ) exit("no such forum\n");
		
		list($cat_id, $view_order) = db_singlearr($result);
		
		$max = $this->get_max_view($cat_id);
		
		$thr = q("SELECT root_msg_id FROM fud21_thread WHERE forum_id=".$id);
		while ( $obj = db_rowobj($thr) ) {
			$msg = new fud_msg_edit;
			$msg->get_by_id($obj->root_msg_id);
			$msg->delete();
			unset($msg);
		}
		qf($thr);
		
		
		q("DELETE FROM fud21_ann_forums WHERE forum_id=".$id);
		q("DELETE FROM fud21_thread WHERE forum_id=".$id);
		q("DELETE FROM fud21_mod WHERE forum_id=".$id);
		q("DELETE FROM fud21_forum_notify WHERE forum_id=".$id);
		if ( $group_id = q_singleval("SELECT id FROM fud21_groups WHERE res='forum' AND res_id=$id") ) {
			$grp = new fud_group;
			$grp->get($group_id);
			$grp->delete();
		}
		q("DELETE FROM fud21_forum WHERE id=".$id);
		$this->move_down($view_order, $max, $cat_id); 
		db_unlock();
	}
		
	function chcat($id, $new_cat)
	{
		db_lock('fud21_forum+');
		$result = q("SELECT cat_id, view_order FROM fud21_forum WHERE id=".$id);
		
		if ( !is_result($result) ) exit("no such forum");		
		
		list($old_cat_id, $view_order) = db_singlearr($result);
		$old_max = $this->get_max_view($old_cat_id);
		
		$new_n = $this->get_max_view($new_cat);
		if ( !$new_n ) {
			$new_n = 1;
		}
		else $new_n += 1;
		
		q("UPDATE fud21_forum SET cat_id=".$new_cat.", view_order=".$new_n." WHERE id=".$id);
		$this->move_down($view_order, $old_max, $old_cat_id); 
		db_unlock();
	}
}class fud_cat
{
	var $id=NULL;
	var $name=NULL;
	var $description=NULL;
	var $allow_collapse=NULL;
	var $default_view=NULL;
	var $view_order=NULL;
	
	var $cat_list;
	var $cur_cat;

	function get_cat($id)
	{
		qobj("SELECT * FROM fud21_cat WHERE id=".$id, $this);
		return $this->id;
	}
}

if ( defined('admin_form') && !defined("_cat_adm_inc_") ) fud_use('cat_adm.inc');class fud_cat_adm extends fud_cat
{
	function make_space($view_order, $max)
	{
		$result = q("SELECT id FROM fud21_cat WHERE view_order=".$view_order);
		
		if ( is_result($result) ) {
			qf($result);
			$max++;
			q("UPDATE fud21_cat SET view_order=view_order+1 WHERE view_order>=".$view_order." AND view_order<".$max);
		}
		return;
	}
	
	function get_max_view()
	{
		return q_singleval("SELECT max(view_order) FROM fud21_cat");
	}
	
	function add_cat($pos)
	{
		
		if( !db_locked() ) {
			db_lock('fud21_cat+');
			$local_lock = 1;
		}	

		$max = $this->get_max_view();
		if ( $pos == "FIRST" ) {
			$this->make_space(1, $max);
			$this->view_order = 1;
		}
		else if ( $max ) {
			$this->view_order = $max+1;
		}
		else $this->view_order = 1;
		
		$r = q("INSERT INTO fud21_cat (name, description, allow_collapse, default_view, view_order) VALUES('".$this->name."','".$this->description."','".$this->allow_collapse."','".$this->default_view."','".$this->view_order."')");
		
		$this->id = db_lastid("fud21_cat", $r);
		
		if ( $local_lock ) db_unlock();
		
		return $this->id;
	}
	
	function sync()
	{
		q("UPDATE fud21_cat SET name='".$this->name."',description='".$this->description."',allow_collapse='".$this->allow_collapse."',default_view='".$this->default_view."',view_order='".$this->view_order."' WHERE id=".$this->id);
	}
	
	function change_pos($cur, $new)
	{
		if( !db_locked() ) {
			db_lock('fud21_cat+');
			$local_lock = 1;
		}

		$max = $this->get_max_view();
		q("UPDATE fud21_cat SET view_order=2147483647 WHERE view_order=$cur");
		
		if ( $new < $cur ) {
			$this->make_space($new, $cur);			
		}
		else {
			$this->move_down($cur, $new);
		}
		
		q("UPDATE fud21_cat SET view_order=$new WHERE view_order=2147483647");		
		if ( $local_lock ) db_unlock();
	}
	
	function move_down($from, $max)
	{
		q("UPDATE fud21_cat SET view_order=view_order-1 WHERE view_order>=$from AND view_order<=$max");
	}
	
	function get_all_cat()
	{
		$result = q("SELECT * FROM fud21_cat ORDER BY view_order");
		unset($this->cat_list);
		
		$i=0;
		while ( $obj = db_rowobj($result) ) {
			$this->cat_list[$i++] = $obj;
		}
		
		qf($result);
		$this->cur_cat = 0;
	}
	
	function resetcat()
	{
		$this->cur_cat = 0;
	}
	
	function countcat()
	{
		return @count($this->cat_list);
	}
	
	function nextcat()
	{
		if ( !isset($this->cat_list[$this->cur_cat]) ) return;
	
		$this->id = $this->cat_list[$this->cur_cat]->id;
		$this->name = $this->cat_list[$this->cur_cat]->name;
		$this->description = $this->cat_list[$this->cur_cat]->description;
		$this->allow_collapse = $this->cat_list[$this->cur_cat]->allow_collapse;
		$this->default_view = $this->cat_list[$this->cur_cat]->default_view;
		$this->view_order = $this->cat_list[$this->cur_cat]->view_order;
		
		$this->cur_cat++;
		
		return 1;
	}
	
	function fetch_vars($array, $prefix)
	{
		$this->name = $array[$prefix.'name'];
		$this->description = $array[$prefix.'description'];
		$this->allow_collapse = $array[$prefix.'allow_collapse'];
		$this->default_view = $array[$prefix.'default_view'];
	}	
	
	function export_vars($prefix)
	{	
		$GLOBALS[$prefix.'name'] = $this->name;
		$GLOBALS[$prefix.'description'] = $this->description;
		$GLOBALS[$prefix.'allow_collapse'] = $this->allow_collapse;
		$GLOBALS[$prefix.'default_view'] = $this->default_view;
		$GLOBALS[$prefix.'view_order'] = $this->view_order;
	}

	function delete($id)
	{
		if ( !db_locked() ) {
			$ll = 1;
			db_lock('fud21_cat+, fud21_forum+');
		}
		
		$view_order = q_singleval("SELECT view_order FROM fud21_cat WHERE id=".$id);
		
		q("UPDATE fud21_forum SET cat_id=0 WHERE cat_id=".$id);
		$max = $this->get_max_view();
		
		$this->move_down($view_order+1, $max);
		
		q("DELETE FROM fud21_cat WHERE id=".$id);
		if ( $ll ) db_unlock();
	}

}

function create_cat_select($name, $def, $blocked)
{
	$result = q("SELECT id, name FROM fud21_cat WHERE id!='".$blocked."' ORDER BY view_order");

	if( !is_result($result) ) return;
	
	$sel = '<select name="'.$name.'">';
	
	while ( $obj = db_rowobj($result) ) {
		$selected = ( $obj->id == $def ) ? ' selected':'';
		$sel .= '<option value="'.$obj->id.'"'.$selected.'>'.$obj->name."\n";
	}
	qf($result);
	$sel .= '</select>';
	return $sel;
}

function draw_cat_select($name, $def)
{
	echo create_cat_select($name, $def, 0);
}function logaction($user_id, $res, $res_id=0, $action=NULL)
{
	q("INSERT INTO fud21_action_log(logtime, logaction, user_id, a_res, a_res_id)
		VALUES(".__request_timestamp__.", '$action', $user_id, '$res', $res_id)");
}

function clear_action_log()
{
	q("DELETE FROM fud21_action_log");
}
	$usr = fud_user_to_adm($usr);
	
	if( !empty($thx) ) {
		if( isset($reason_msg) ) {
			fud_use('thrx_adm.inc', TRUE);
			$thrx = new fud_thr_exchange;
			$thrx->reason_msg = nl2br(htmlspecialchars($HTTP_POST_VARS['reason_msg']));
			$thrx->th = $HTTP_POST_VARS['th'];
			$thrx->frm = $HTTP_POST_VARS['thx'];
			$thrx->req_by = $usr->id;
			$thrx->add();
			logaction($usr->id, 'THRXREQUEST', $thrx->th);
			exit('<html><script>window.close();</script></html>');
		}
		else {
			$thr = new fud_thread;
			$frm_dst = new fud_forum_adm;
		
			$thr->get_by_id($th);
			$frm_dst->get($thx);
			$table_data .= '<tr><td><font size="-1"><b>'.$frm_dst->name.'</b></font></td></tr>
<form action="http://thelocust.org/bored/index.php?t=mvthread" name="mvthread" method="post">
<tr><td><font size="-1">Why do you wish the thread to be moved?</font><br><textarea name="reason_msg" rows=7 cols=30></textarea><td></tr>
<tr><td align="right"><input type="submit" class="button" name="submit" value="Submit Request"></td></tr>
'._hs.'
<input type="hidden" name="th" value="'.$th.'">
<input type="hidden" name="thx" value="'.$thx.'">
</form>';		
		}
	}
	 
	if ( !empty($th) && !empty($to) ) {
		$frm_src = new fud_forum_adm;
		$frm_dst = new fud_forum_adm;
		$thr = new fud_thread;
		
		if ( !db_locked() ) { $ll=1; db_lock('fud21_mod+, fud21_cat+, fud21_thread_view+, fud21_thread+, fud21_forum+, fud21_msg+'); }
		
		$thr->get_by_id($th);
		$frm_src->get($thr->forum_id);
		$frm_dst->get($to);
		
		if ( !$frm_src->is_moderator($usr->id) && $usr->is_mod!='A' ) {
			db_unlock();
			std_error('access');
			exit();
		}
		
		if ( !$frm_dst->is_moderator($usr->id) && $usr->is_mod!='A' ) {
			db_unlock();
			std_error('access');
			exit();
		}
		
		$thr->move($to);
		
		if ( $frm_src->last_post_id == $thr->last_post_id ) {
			$mid = intzero(q_singleval("SELECT MAX(fud21_msg.id) FROM fud21_thread INNER JOIN fud21_msg ON fud21_thread.last_post_id=fud21_msg.id WHERE forum_id=".$frm_src->id." AND moved_to=0 AND approved='Y'"));
			q("UPDATE fud21_forum SET last_post_id=".$mid." WHERE id=".$frm_src->id);
		}
		
		if( $frm_dst->last_post_id < $thr->last_post_id ) q("UPDATE fud21_forum SET last_post_id=".$thr->last_post_id." WHERE id=".$frm_dst->id);
		
		if ( $ll ) db_unlock();
		
		logaction($usr->id, 'THRMOVE', $thr->id);
		
		exit("<html><script>window.opener.location='http://thelocust.org/bored/index.php?t=thread&"._rsid."&frm_id=".$frm_src->id."'; window.close();</script></html>");
	}

 	/* FILE START */

	if( empty($thx) ) {
		$thr = new fud_thread;
		$thr->get_by_id($th);

		$cat = new fud_cat;
	
		$prev_cat = NULL;
		$table_data = '';
	
		$r = q("SELECT 
				DISTINCT(fud21_forum.id),
				fud21_forum.*,
				fud21_mod.user_id AS mod_id 
			FROM 
				fud21_forum 
				LEFT JOIN fud21_mod 
					ON fud21_mod.user_id=".$usr->id." AND fud21_forum.id=fud21_mod.forum_id 
			WHERE 
				fud21_forum.cat_id!=0 
			ORDER BY 
				fud21_forum.cat_id, 
				fud21_forum.view_order");

		while( $obj = db_rowobj($r) ) {
			if( $obj->cat_id != $prev_cat ) {
				$cat->get_cat($obj->cat_id);
				$table_data .= '<tr><td bgcolor="#e5ffe7">'.$cat->name.'</td></tr>';
				$prev_cat = $obj->cat_id;
			}
		
			if( $obj->id != $thr->forum_id ) {
				if( $obj->mod_id == $usr->id || $usr->is_mod=='A' ) 
					$table_data .= '<tr><td><a href="http://thelocust.org/bored/index.php?t=mvthread&th='.$th.'&to='.$obj->id.'&'._rsid.'">'.$obj->name.'</a></td></tr>';
				else
					$table_data .= '<tr><td>'.$obj->name.' [<a href="http://thelocust.org/bored/index.php?t=mvthread&th='.$th.'&'._rsid.'&thx='.$obj->id.'">request a move</a>]</td></tr>';
			}
		}	
	}
	
?>
<html>
<head>
<META HTTP-EQUIV="Content-Type" CONTENT="text/html; charset=ISO-8859-15">
<title><?php echo $GLOBALS['FORUM_TITLE']; ?><?php echo $TITLE_EXTRA; ?></title>
<BASE HREF="<?php echo $GLOBALS['WWW_ROOT']; ?>">
<script language="JavaScript" src="lib.js"></script>
<link rel="StyleSheet" href="http://thelocust.org/bored/theme/default/forum.css" type="text/css">
</head>
<body topmargin="2" leftmargin="2" marginheight="2" marginwidth="2">
<table width="100%" border="0" cellspacing="3" cellpadding="5"><tr><td class="ForumBackground">
<table border=0 width="100%" cellspacing=0 cellpadding=3 class="dashed">
<tr><td><font size="-1">Move thread <b><?php echo $thr->subject; ?></b> to:</font></td></tr>
<?php echo $table_data; ?>
</table>
</td></tr></table></body></html>