<?php
/***************************************************************************
*   copyright            : (C) 2001,2002 Advanced Internet Designs Inc.
*   email                : forum@prohost.org
*
*   $Id: split_th.php.t,v 1.4 2002/07/08 23:15:19 hackie Exp $
****************************************************************************
          
****************************************************************************
*
*	This program is free software; you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation; either version 2 of the License, or
*	(at your option) any later version.
*
***************************************************************************/

	include_once "GLOBALS.php";

	if ( !defined('__index_page_start__') ) exit('sorry, you can not access this page');define('_fileio_inc_', 1);


function register_fp($id)
{
	if( empty($GLOBALS['__MSG_FP__'][$id]) ) 
		$GLOBALS['__MSG_FP__'][$id] = fopen($GLOBALS["MSG_STORE_DIR"].'msg_'.$id, 'rb');
	
	return $GLOBALS['__MSG_FP__'][$id];
}

function un_register_fps()
{
	if( !@is_array($GLOBALS['__MSG_FP__']) ) return;
	
	reset($GLOBALS['__MSG_FP__']);
	while( list($k,$v) = each($GLOBALS['__MSG_FP__']) ) {
		if( @is_resource($v) ) fclose($v);
		$GLOBALS['__MSG_FP__'][$k] = NULL;
	}	
}

function read_msg_body($off, $len, $file_id)
{
	$fp = register_fp($file_id);
	fseek($fp, $off);
	return fread($fp, $len);
}function fetch_vars($pref, &$obj, $arr)
{
	reset($obj);
	while ( list($k, $v) = each($obj) ) {
		if ( isset($arr[$pref.$k]) ) $obj->{$k} = $arr[$pref.$k];
	}
}
	
function export_vars($pref, &$obj)
{
	reset($obj);
	while ( list($k, $v) = each($obj) ) {
		if ( isset($obj->{$k}) ) $GLOBALS[$pref.$k] = $v;
	}
}

function empty_object(&$obj)
{
	reset($obj);
	while ( list($k, $v) = each($obj) ) $obj->{$k} = NULL;
}class fud_thread
{
	var $id=NULL;
	var $forum_id=NULL;
	var $root_msg_id=NULL;
	var $last_post_date=NULL;
	var $replies=NULL;
	var $views=NULL;
	var $rating=NULL;
	var $last_post_id=NULL;
	var $locked=NULL;
	var $is_sticky=NULL;
	var $ordertype=NULL;
	var $orderexpiry=NULL;
	
	var $subject=NULL;
	var $db_thread=NULL;
	
	function add($root, $forum_id, $locked=NULL, $is_sticky=NULL, $ordertype=NULL, $orderexpiry=NULL) 
	{
		$r = q("INSERT INTO 
			fud21_thread(
				forum_id, 
				root_msg_id, 
				last_post_date, 
				replies, 
				views, 
				rating, 
				last_post_id,
				locked, 
				is_sticky,
				ordertype,
				orderexpiry
			)
			VALUES
			(
				".$forum_id.",
				".$root.",
				".__request_timestamp__.",
				0,
				0,
				0,
				".$root.",
				'".yn($locked)."',
				'".yn($is_sticky)."',
				".ifnull($ordertype, "'NONE'").",
				".intzero($orderexpiry)."
			)");
		
		$this->id = db_lastid("fud21_thread", $r);
		
		return $this->id;
	}
	
	function sync()
	{
		list($old_sticky,$forum_id) = db_singlearr(q("SELECT is_sticky,forum_id FROM fud21_thread WHERE id=".$this->id));
	
		q("UPDATE fud21_thread SET 
			is_sticky='".yn($this->is_sticky)."',
			ordertype=".ifnull($this->ordertype, "'NONE'").",
			orderexpiry=".intnull($this->orderexpiry).",
			locked='".yn($this->locked)."'
		WHERE id=".$this->id);
		
		if( $old_sticky != yn($this->is_sticky) ) rebuild_forum_view($forum_id);
	}
	
	function get_by_id($id)
	{
		$result = qobj("SELECT 
				fud21_thread.*,
				fud21_msg.subject
			FROM 
				fud21_thread 
				LEFT JOIN fud21_msg 
					ON fud21_thread.root_msg_id=fud21_msg.id 
				LEFT JOIN fud21_forum 
					ON fud21_thread.forum_id=fud21_forum.id 
				LEFT JOIN fud21_cat 
					ON fud21_forum.cat_id=fud21_cat.id 
			WHERE 
				fud21_thread.id=".$id, $this);
		if ( empty($this->id) ) error_dialog('Invalid thread ID','You\'ve followed an invalid link, the thread you are trying to view does not exist.','', 'FATAL');
	}

	function delete($rebuild_view=TRUE)
	{
		$msg = new fud_msg_edit;
		qobj("SELECT * FROM fud21_msg WHERE id=".$this->root_msg_id, $msg);
		if( !empty($msg->id) )
			$msg->delete(FALSE);
		else {
			q("DELETE FROM fud21_thread WHERE id=".$this->id);
			$tc = q_singleval("SELECT count(*) FROM fud21_thread INNER JOIN fud21_msg ON fud21_thread.root_msg_id=fud21_msg.id WHERE forum_id=".$this->forum_id." AND fud21_msg.approved='Y'");
			$mc = q_singleval("SELECT SUM(replies) FROM fud21_thread INNER JOIN fud21_msg ON fud21_thread.root_msg_id=fud21_msg.id WHERE forum_id=".$this->forum_id." AND fud21_msg.approved='Y'");
			$mc += $tc;
			$lpi = q_singleval("SELECT MAX(last_post_id) FROM fud21_thread INNER JOIN fud21_msg ON fud21_thread.root_msg_id=fud21_msg.id WHERE forum_id=".$this->forum_id." AND fud21_msg.approved='Y'");
			q("UPDATE fud21_forum SET post_count=".intzero($mc).", last_post_id=".intzero($lpi).", thread_count=".intzero($tc)." WHERE id=".$this->forum_id);
		}	
		
		if( $rebuild_view ) rebuild_forum_view($this->forum_id);
	}
	
	function lock()
	{
		q("UPDATE fud21_thread SET locked='Y' WHERE id=".$this->id);
	}
	
	function unlock()
	{
		q("UPDATE fud21_thread SET locked='N' WHERE id=".$this->id);
	}
	
	function move($to_forum)
	{
		if ( !db_locked() ) {
			db_lock('fud21_thread_view+, fud21_thread+, fud21_forum+, fud21_msg+');
			$local_lock = 1;
		}
		$msg_count = q_singleval("SELECT count(*) FROM fud21_thread LEFT JOIN fud21_msg ON fud21_msg.thread_id=fud21_thread.id WHERE fud21_msg.approved='Y' AND fud21_thread.id=".$this->id);
		
		q("UPDATE fud21_thread SET forum_id=".$to_forum." WHERE id=".$this->id);
		q("UPDATE fud21_forum SET post_count=post_count-".$msg_count." WHERE id=".$this->forum_id);
		q("UPDATE fud21_forum SET thread_count=thread_count+1,post_count=post_count+".$msg_count." WHERE id=".$to_forum);
		$r=q("DELETE FROM fud21_thread WHERE forum_id=".$to_forum." AND root_msg_id=".$this->root_msg_id." AND moved_to=".$this->forum_id);
		if( $aff_rows=db_affected($r) ) q("UPDATE fud21_forum SET thread_count=thread_count-".$aff_rows." WHERE id=".$to_forum);
		q("UPDATE fud21_thread SET moved_to=".$to_forum." WHERE id!=".$this->id." AND root_msg_id=".$this->root_msg_id);
		
		q("INSERT INTO fud21_thread(
			forum_id,
			root_msg_id,
			last_post_date,
			last_post_id,
			moved_to
		)
		VALUES(
			".$this->forum_id.",
			".$this->root_msg_id.",
			".$this->last_post_date.",
			".$this->last_post_id.",
			".$to_forum."
		)");
		
		rebuild_forum_view($this->forum_id);
		rebuild_forum_view($to_forum);
		
		if ( !empty($local_lock) ) db_unlock();
	}
	
	function inc_post_count($val)
	{
		q("UPDATE fud21_thread SET replies=replies+".$val." WHERE id=".$this->id);
	}
	
	function inc_view_count()
	{
		q("UPDATE fud21_thread SET views=views+1 WHERE id=".$this->id);
	}
	
	function dec_view_count($val)
	{
		q("UPDATE fud21_thread SET views=views-1 WHERE id=".$this->id);
	}
	
	function get_notify_list($user_id)
	{
		$ctm = __request_timestamp__;
		$tm = $ctm-604800;
	
		$r = q("SELECT 
				fud21_users.id AS user_id,
				fud21_users.email,
				fud21_users.icq,
				fud21_read.last_view,
				fud21_read.id,
				fud21_users.notify_method 
			FROM 
				fud21_thread_notify
				INNER JOIN fud21_users 
					ON fud21_thread_notify.user_id=fud21_users.id 
				LEFT JOIN fud21_read 
					ON fud21_read.user_id=fud21_thread_notify.user_id 
					AND fud21_read.thread_id=fud21_thread_notify.thread_id 
			WHERE 
				( fud21_read.msg_id=".$this->last_post_id." OR fud21_read.last_view < ".$tm." )
				AND fud21_thread_notify.thread_id=".$this->id." 
				AND fud21_thread_notify.user_id!=".intzero($user_id));
		
		$p = forum_perm_array($this->forum_id);
		$to=NULL;
		while ( $obj = db_rowobj($r) ) {
			if ( !is_allowed($obj->user_id, $p) ) continue;
			
			$to[$obj->notify_method][] = ( $obj->notify_method == 'EMAIL' ) ? $obj->email : $obj->icq.'@pager.icq.com';
			if( $obj->last_view < $tm ) q("UPDATE fud21_read SET last_view=".$ctm." WHERE id=".$obj->id);
		}
		qf($r);
		
		return $to;
	}
	
	function adm_set_rating($value)
	{
		q("UPDATE fud21_thread SET rating=".intnull($value)." WHERE id=".$this->id);
	}

	function has_thread_vote($user_id, $thread_id='')
	{
		if ( !$thread_id ) $thread_id = $this->id;
		
		if( ($rating=q_singleval("SELECT rating FROM fud21_thread_rate_track WHERE thread_id=".$thread_id." AND user_id=".$user_id)) ) {
			return $rating;	
		}
		return -1;
	}
	
	function update_vote_count()
	{
		$rating = q_singleval("SELECT ROUND(AVG(rating)) FROM fud21_thread_rate_track WHERE thread_id=".$this->id);
		q("UPDATE fud21_thread SET rating=".$rating." WHERE id=".$this->id);
	}
	
	function vote_count($thread_id='')
	{
		if ( !$thread_id ) $thread_id = $this->id;
		
		return q_singleval("SELECT COUNT(*) FROM fud21_thread_rate_track WHERE thread_id=".$thread_id);
	}
	
	function register_thread_vote($user_id, $rating, $thread_id='')
	{
		if ( !$thread_id ) $thread_id = $this->id;
		
		if( !db_locked() ) {
			db_lock('fud21_thread_rate_track+, fud21_thread+');
			$local_lock = 1;
		}
		
		if( $this->has_thread_vote($user_id, $thread_id) != -1 ) {
			if ( $local_lock ) db_unlock();
			return;
		}	
		
		q("INSERT INTO fud21_thread_rate_track (
			thread_id,
			user_id,
			stamp,
			rating
			)
		VALUES(
			".$thread_id.",
			".$user_id.",
			".__request_timestamp__.",
			".$rating."
		)");
		
		$rating = q_singleval("SELECT ROUND(AVG(rating)) FROM fud21_thread_rate_track WHERE thread_id=".$thread_id);
		
		q("UPDATE fud21_thread SET rating=".$rating." WHERE id=".$thread_id);
		
		if ( $local_lock ) db_unlock();
	}
}

function rebuild_forum_view($forum_id, $page=0)
{
	if( !db_locked() ) {
	        db_lock('fud21_thread_view+, fud21_thread+, fud21_msg+, fud21_forum+');
		$local_lock=1;
	}
	
	$tm = __request_timestamp__;
	
	/* Remove expired moved thread pointers */
	$r=q("DELETE FROM fud21_thread WHERE forum_id=".$forum_id." AND last_post_date<".($tm-86400*$GLOBALS['MOVED_THR_PTR_EXPIRY'])." AND moved_to!=0");
	if( $aff_rows = db_affected($r) ) {
		q("UPDATE fud21_forum SET thread_count=thread_count-".$aff_rows." WHERE id=".$forum_id);
		$page = 0;
	}
	
	/* De-announce expired announcments and sticky messages */
	$r = q("SELECT fud21_thread.id FROM fud21_thread INNER JOIN fud21_msg ON fud21_thread.root_msg_id=fud21_msg.thread_id WHERE fud21_thread.forum_id=".$forum_id." AND is_sticky='Y' AND (fud21_msg.post_stamp+fud21_thread.orderexpiry)<".$tm);
	while( list($tid) = db_rowarr($r) ) 
		q("UPDATE fud21_thread SET ordertype='NONE', is_sticky='N' WHERE id=".$tid);
	qf($r);

	if ( __dbtype__ == 'pgsql' ) {
		$tmp_tbl_name = "fud21_ftvt_".get_random_value();
		q("CREATE TEMP TABLE ".$tmp_tbl_name." ( forum_id INT NOT NULL, page INT8 NOT NULL, thread_id INT NOT NULL, pos SERIAL, tmp INT )");
		
		if( $page ) {
			q("DELETE FROM fud21_thread_view WHERE forum_id=".$forum_id." AND page<".($page+1));
			q("INSERT INTO ".$tmp_tbl_name." (thread_id,forum_id,page,tmp) SELECT fud21_thread.id, fud21_thread.forum_id, 4294967294, CASE WHEN is_sticky='Y' AND (fud21_msg.post_stamp+fud21_thread.orderexpiry>".$tm." OR fud21_thread.orderexpiry=0) THEN 4294967294 ELSE fud21_thread.last_post_date END AS sort_order_fld  FROM fud21_thread INNER JOIN fud21_msg ON fud21_thread.root_msg_id=fud21_msg.id WHERE forum_id=".$forum_id." AND fud21_msg.approved='Y' ORDER BY sort_order_fld DESC, fud21_thread.last_post_id DESC LIMIT ".($GLOBALS['THREADS_PER_PAGE']*$page).", 0");
		}
		else {
			q("DELETE FROM fud21_thread_view WHERE forum_id=".$forum_id);
			q("INSERT INTO ".$tmp_tbl_name." (thread_id,forum_id,page,tmp) SELECT fud21_thread.id, fud21_thread.forum_id, 2147483647, CASE WHEN is_sticky='Y' AND (fud21_msg.post_stamp+fud21_thread.orderexpiry>".$tm." OR fud21_thread.orderexpiry=0) THEN 2147483647 ELSE fud21_thread.last_post_date END AS sort_order_fld  FROM fud21_thread INNER JOIN fud21_msg ON fud21_thread.root_msg_id=fud21_msg.id WHERE forum_id=".$forum_id." AND fud21_msg.approved='Y' ORDER BY sort_order_fld DESC, fud21_thread.last_post_id DESC");
		}
		
		q("INSERT INTO fud21_thread_view (thread_id,forum_id,page,pos) SELECT thread_id,forum_id,CEIL(pos/40.0),(pos-(CEIL(pos/40)-1)*40) FROM ".$tmp_tbl_name);
		q("DROP SEQUENCE ".$tmp_tbl_name."_pos_seq");
		q("DROP TABLE ".$tmp_tbl_name);
		return;
	}
	else if ( __dbtype__ == 'mysql' ) {
		if( $page ) {
			q("DELETE FROM fud21_thread_view WHERE forum_id=".$forum_id." AND page<".($page+1));
			q("INSERT INTO fud21_thread_view (thread_id,forum_id,page,tmp) SELECT fud21_thread.id, fud21_thread.forum_id, 4294967294, CASE WHEN is_sticky='Y' AND (fud21_msg.post_stamp+fud21_thread.orderexpiry>".$tm." OR fud21_thread.orderexpiry=0) THEN 4294967294 ELSE fud21_thread.last_post_date END AS sort_order_fld  FROM fud21_thread INNER JOIN fud21_msg ON fud21_thread.root_msg_id=fud21_msg.id WHERE forum_id=".$forum_id." AND fud21_msg.approved='Y' ORDER BY sort_order_fld DESC, fud21_thread.last_post_id DESC LIMIT 0, ".($GLOBALS['THREADS_PER_PAGE']*$page));
			q("UPDATE fud21_thread_view SET page=CEILING(pos/".$GLOBALS['THREADS_PER_PAGE']."), pos=pos-(CEILING(pos/".$GLOBALS['THREADS_PER_PAGE'].")-1)*".$GLOBALS['THREADS_PER_PAGE']." WHERE forum_id=".$forum_id." AND page=4294967294");			
		}
		else {
			q("DELETE FROM fud21_thread_view WHERE forum_id=".$forum_id);
			q("INSERT INTO fud21_thread_view (thread_id,forum_id,page,tmp) SELECT fud21_thread.id, fud21_thread.forum_id, 4294967294, CASE WHEN is_sticky='Y' AND (fud21_msg.post_stamp+fud21_thread.orderexpiry>".$tm." OR fud21_thread.orderexpiry=0) THEN 4294967294 ELSE fud21_thread.last_post_date END AS sort_order_fld  FROM fud21_thread INNER JOIN fud21_msg ON fud21_thread.root_msg_id=fud21_msg.id WHERE forum_id=".$forum_id." AND fud21_msg.approved='Y' ORDER BY sort_order_fld DESC, fud21_thread.last_post_id DESC");
			q("UPDATE fud21_thread_view SET page=CEILING(pos/".$GLOBALS['THREADS_PER_PAGE']."), pos=pos-(CEILING(pos/".$GLOBALS['THREADS_PER_PAGE'].")-1)*".$GLOBALS['THREADS_PER_PAGE']." WHERE forum_id=".$forum_id);			
		}
	}
	if( $local_lock ) db_unlock();
}class fud_forum
{
	var $id=NULL;
	var $cat_id=NULL;
	var $name=NULL;
	var $descr=NULL;
	var $passwd_posting=NULL;
	var $post_passwd=NULL;
	var $anon_forum=NULL;
	var $forum_icon=NULL;
	var $tag_style=NULL;
	var $last_post_id=NULL;
	
	var $allow_polls=NULL;
	var $date_created=NULL;
	var $thread_count=NULL;
	var $view_order=NULL;
	var $message_threshold=NULL;
	
	var $moderated=NULL;
	var $max_attach_size=NULL;
	var $max_file_attachments=NULL;
	
	var $forums=NULL;
	var $cur_frm=NULL;
	
	var $locked=NULL;
	
	
	function get($id)
	{
		qobj("SELECT * FROM fud21_forum WHERE fud21_forum.id=".$id, $this);
		if( empty($this->id) ) invl_inp_err();
			
		return $id;		
	}
	
	function is_moderator($user_id)
	{
		return q_singleval("SELECT id FROM fud21_mod WHERE user_id=".$user_id." AND forum_id=".$this->id);
	}
	
	function inc_reply_count($val)
	{
		q("UPDATE fud21_forum SET post_count=post_count+".$val." WHERE id=".$this->id);
	}
	
	function dec_reply_count($val)
	{
		q("UPDATE fud21_forum SET post_count=post_count-".$val." WHERE id=".$this->id);
	}
	
	function inc_thread_count($val)
	{
		q("UPDATE fud21_forum SET thread_count=thread_count+".$val." WHERE id=".$this->id);
	}
	
	function dec_thread_count($val)
	{
		q("UPDATE fud21_forum SET thread_count=thread_count-".$val." WHERE id=".$this->id);
	}
	
	function get_notify_list($user_id)
	{
		$r = q("SELECT 
				fud21_users.email, 
				fud21_users.icq, 
				fud21_users.notify_method 
			FROM 
				fud21_forum_notify 
				INNER JOIN fud21_users 
					ON fud21_forum_notify.user_id=fud21_users.id 
			WHERE 
				fud21_forum_notify.forum_id=".$this->id." 
				AND fud21_forum_notify.user_id!=".$user_id);
		
		$p = forum_perm_array($this->id);
		$to=NULL;
		while ( $obj = db_rowobj($r) ) {
			if ( !is_allowed($obj->user_id, $p) ) continue;
			
			$to[$obj->notify_method][] = ( $obj->notify_method == 'EMAIL' ) ? $obj->email : $obj->icq.'@pager.icq.com';
		}

		qf($r);
				
		return $to;
	}
	
}

if ( defined('admin_form') && !defined("_forum_adm_inc_") ) fud_use('forum_adm.inc');class fud_msg
{
	var $id=NULL;
	var $thread_id=NULL;
	var $poster_id=NULL;
	var $reply_to=NULL;
	var $ip_addr=NULL;
	var $host_name=NULL;
	var $post_stamp=NULL;
	var $subject=NULL;
	var $attach_cnt=NULL;
	var $poll_id=NULL;
	var $update_stamp=NULL;
	var $icon=NULL;
	var $approved=NULL;
	var $show_sig=NULL;
	var $updated_by=NULL;
	var $smiley_disabled=NULL;
	var $login=NULL;
	var $length=NULL;
	var $foff=NULL;
	var $file_id=NULL;
	var $file_id_preview=NULL;
	var $length_preview=NULL;
	var $offset_preview=NULL;
	
	var $body;
		
	function get_by_id($id)
	{
		qobj("SELECT fud21_msg.*,fud21_users.alias AS login FROM fud21_msg LEFT JOIN fud21_users ON fud21_msg.poster_id=fud21_users.id WHERE fud21_msg.id=".$id, $this);
		if( empty($this->id) ) error_dialog('Invalid Message', 'The message you are trying to view does not exist.', '', 'FATAL');
		
		$this->body = read_msg_body($this->foff,$this->length, $this->file_id);
		un_register_fps();
	}
	
	function get_thread($th_id)
	{
		qobj("SELECT fud21_msg.* FROM fud21_msg INNER JOIN fud21_thread ON fud21_thread.root_msg_id=fud21_msg.id WHERE fud21_thread.id=".$th_id, $this);
		
		
		$this->body = read_msg_body($this->foff,$this->length, $this->file_id);
		un_register_fps();
	}
}

if ( defined('msg_edit') && !defined("_imsg_edit_inc_") ) fud_use('imsg_edt.inc');class fud_poll
{
	var $id;
	var $name=NULL;
	var $owner=NULL;
	var $creation_date=NULL;
	var $expiry_date=NULL;
	var $max_votes=NULL;
	
	function add()
	{
		if ( !db_locked() ) {
			$ll = 1;
			db_lock("fud21_poll+");
		}
		$r = q("INSERT INTO fud21_poll (
			name, 
			owner, 
			creation_date, 
			expiry_date,
			max_votes
			) 
			VALUES(
			'".$this->name."',
			".$this->owner.",
			".__request_timestamp__.",
			".intzero($this->expiry_date).",
			0
			)");
		$this->id = db_lastid("fud21_poll", $r);
		if ( $ll ) db_unlock();
		return $this->id;
	}
	
	function sync()
	{
		q("UPDATE fud21_poll SET 
			name='".$this->name."',
			expiry_date=".intzero($this->expiry_date).",
			max_votes=".intzero($this->max_votes)."
		WHERE id=".$this->id);
	}
	
	function get($id) 
	{
		qobj("SELECT * FROM fud21_poll WHERE id=".$id, $this);
	}
	
	function delete()
	{
		q("UPDATE fud21_msg SET poll_id=0 WHERE poll_id=".$this->id);
		q("DELETE FROM fud21_poll_opt WHERE poll_id=".$this->id);
		q("DELETE FROM fud21_poll_opt_track WHERE poll_id=".$this->id);
		q("DELETE FROM fud21_poll WHERE id=".$this->id);
	}
	
	function regvote($user_id)
	{
		q("INSERT INTO fud21_poll_opt_track(poll_id, user_id) VALUES(".$this->id.", ".$user_id.")");
	}
	
	function voted($user_id)
	{
		return q_singleval("SELECT id FROM fud21_poll_opt_track WHERE poll_id=".$this->id." AND user_id=".$user_id);
	}
}

class fud_poll_opt
{
	var $id=NULL;
	var $poll_id=NULL;
	var $name=NULL;
	var $count=NULL;
	
	var $all=NULL;
	var $all_c=NULL;
	
	function add()
	{
		if ( !db_locked() ) {
			$ll = 1;
			db_lock("fud21_poll_opt+");
		}
		$r = q("INSERT INTO fud21_poll_opt (poll_id, name, count) VALUES (".$this->poll_id.",'".$this->name."',".intzero($this->count).")");
		$this->id = db_lastid("fud21_poll_opt", $r);
		if ( $ll ) db_unlock();
		return $this->id;
	}
	
	function sync()
	{
		q("UPDATE fud21_poll_opt SET name='".$this->name."' WHERE id=".$this->id);
	}
	
	function get($id)
	{
		qobj("SELECT * FROM fud21_poll_opt WHERE id=".$id, $this);
	}
	
	function delete()
	{
		q("DELETE FROM fud21_poll_opt WHERE id=".$this->id);
	}
	
	function fetch_vars($array, $prefix)
	{
		$this->name = $array[$prefix.'name'];
	}
	
	function increase()
	{
		q("UPDATE fud21_poll_opt SET count=count+1 WHERE id=".$this->id);
	}
	
	function get_poll($pl_id) 
	{
		$res = q("SELECT * FROM fud21_poll_opt WHERE poll_id=".$pl_id." ORDER BY id");
		if ( !is_result($res) ) return;
		
		unset($this->all);
		$this->all_c = 0;
		while ( $obj=db_rowobj($res) ) {
			$this->all[] = $obj;
		}
		
		qf($res);
	}
	
	function reset_opt()
	{
		if ( isset($this->all) ) reset($this->all);
	}
	
	function count_opt()
	{
		if ( isset($this->all) ) return count($this->all);
		return;
	}
	
	function next_opt()
	{
		if ( $this->all_c > count($this->all) ) return;
		return ( isset($this->all[$this->all_c])?$this->all[$this->all_c++]:'');
	}
}function get_mime_by_ext($ext)
{
	return q_singleval("SELECT id FROM fud21_mime WHERE fl_ext='".$ext."'");
}class fud_attach
{
	var $id=NULL;
	var $proto=NULL;
	var $location=NULL;
	var $original_name=NULL;
	var $owner=NULL;
	var $private=NULL;
	var $message_id=NULL;
	var $dlcount=NULL;
	var $mime_type=NULL;
	
	var $a_list;
	
	function add($owner, $message_id, $original_name, $cur_location, $private='')
	{
		$proto = proto($cur_location);
		
		$ext = substr($original_name, strrpos($original_name, '.')+1);
		if( !($mime_id = get_mime_by_ext($ext)) ) $mime_id = 0;
		
		$r=q("INSERT INTO fud21_attach (proto, location, original_name, message_id, owner, private, mime_type) VALUES('".$proto."', 'none://unset', '".$original_name."', ".intzero($message_id).", ".intzero($owner).", '".yn($private)."', ".$mime_id.")");
		$id = db_lastid("fud21_attach", $r);
		$this->message_id=$message_id;
		if ( $proto == 'LOCAL' ) {
			$loc = safe_attachment_copy($cur_location, $id);
		}
		else $loc = $cur_location;
		
		if ( $private == 'Y' ) 
			$tbl = 'fud21_pmsg';
		else
			$tbl = 'fud21_msg';
		
		q("UPDATE fud21_attach SET location='".addslashes($loc)."' WHERE id=".$id);
		if ( $message_id ) {
			qobj("SELECT count(*) AS a_count FROM fud21_attach WHERE message_id=".$message_id, $cObj);
			q("UPDATE ".$tbl." SET attach_cnt=".$cObj->a_count." WHERE id=".$this->message_id);
		}
		
		return $id;
	}
		
	function get($id,$private='')
	{
		$obj = qobj("SELECT * FROM fud21_attach WHERE id=".$id." AND private='".yn($private)."'", $this);
	}
	
	function replace($original_name, $cur_location)
	{
		$proto = proto($cur_location);
		$ext = substr($original_name, strrpos($original_name, '.')+1);
		if( !($mime_id = get_mime_by_ext($ext)) ) $mime_id = 0;
		
		q("UPDATE fud21_attach SET mime_type=".$mime_id.", proto='".$proto."', original_name='".$original_name."', location='".$cur_location."' WHERE id=".$this->id);
		if ( $proto == 'LOCAL' ) {
			$loc = $GLOBALS['FILE_STORE'].$this->id.'.atch';
			if ( file_exists($loc) ) unlink($loc);
			safe_attachment_copy($cur_location, $id);
		}
	}
	
	function delete()
	{
		if( !db_locked() ) {
			$ll = 1;
			db_lock('fud21_attach+');
		}	
		$r = q("SELECT location FROM fud21_attach WHERE id=".$this->id);
		if( db_count($r) ) {
			list($loc) = db_rowarr($r);
			if( file_exists($loc) ) 
				unlink($loc);
		}
		qf($r);
		q("DELETE FROM fud21_attach WHERE id=".$this->id);
		if( $ll ) db_unlock();
	}
	
	function inc_dl_count()
	{
		q("UPDATE fud21_attach SET dlcount=dlcount+1 WHERE id=".$this->id);
	}
	
}

function proto($file)
{
	if ( start_match($file, 'http://') ) 	return "REMOTE";
	if ( start_match($file, 'ftp://') ) 	return "REMOTE";
	
	return "LOCAL";
}

function start_match($haystack, $needle)
{
	if ( strtolower(substr($haystack, 0, strlen($needle))) == strtolower($needle) ) return strlen($needle);
	return 0;
}

function safe_attachment_copy($source, $id)
{
	$loc = $GLOBALS['FILE_STORE'].$id.'.atch';	
	if ( file_exists($loc) ) {
		unlink($loc);
		std_out('"'.$loc.'" already exists, but shouldn\'t (old file unlinked), check security', 'ERR');
	}
	
	if( !@copy($source, $loc) ) {
		std_out('unable to create source file ('.$loc.') check permissions on ('.$GLOBALS['FILE_STORE'].'), we suggest 1777', 'ERR');
	}
	@chmod($loc, 0600);
	
	return $loc;
}$GLOBALS['__REVERSE_ARRAY__'] = array('&amp;'=>'&','&quot;'=>'"','&lt;'=>'<','&gt;'=>'>');

function reverse_FMT(&$data)
{
	$data = strtr($data, $GLOBALS['__REVERSE_ARRAY__']);
}

function FMT($val)
{
	return htmlspecialchars(stripslashes($val));
}function validate_email($email)
{
        return !preg_match('!([-_A-Za-z0-9\.]+)\@([-_A-Za-z0-9\.]+)\.([A-Za-z0-9]{2,4})$!', $email);
}
        
class fud_email_block
{
	var $id;
	var $type;
	var $string;
	
	var $e_list;
	
	function add($type, $string)
	{
		q("INSERT INTO fud21_email_block(type, string) VALUES('".$type."', '".$string."')");
	} 
	
	function sync($type, $string)
	{
		q("UPDATE fud21_email_block SET type='".$type."', string='".$string."' WHERE id=".$this->id);
	}
	
	function get($id)
	{
		$res = q("SELECT * FROM fud21_email_block WHERE id=".$id);
		if ( !is_result($res) ) exit("no such email block");
		
		$obj = db_singleobj($res);
		
		$this->id 	= $obj->id;
		$this->type	= $obj->type;
		$this->string	= $obj->string;
	}
	
	function delete()
	{
		q("DELETE FROM fud21_email_block WHERE id=".$this->id);
	}
	
	function getall()
	{
		$res = q("SELECT * FROM fud21_email_block ORDER BY id");
		
		unset($this->e_list);
		while ( $obj = db_rowobj($res) ) {
			$this->e_list[] = $obj;
		}
		if ( isset($this->e_list) ) reset($this->e_list);
		qf($res); 
	}
	
	function counte()
	{
		if ( !isset($this->e_list) ) return;
		return count($this->e_list);
	}
	
	function resete()
	{
		if ( !isset($this->e_list) ) return;
		reset($this->e_list);
	}
	
	function eache()
	{
		if ( !isset($this->e_list) ) return;
		$obj = current($this->e_list);
		if ( !isset($obj) ) return;
		next($this->e_list);
		
		return $obj;
	}
}

function is_email_blocked($addr)
{

	if ( bq("SELECT * FROM fud21_email_block WHERE string='".$addr."'") ) return 1;

	$r = q("SELECT * FROM fud21_email_block ORDER BY id");
	while ( $obj = db_rowobj($r) ) {
		if ( $obj->type == 'SIMPLE' ) {
			$reg = $obj->string;
			$reg = str_replace('.', '\.', $reg);
			$reg = str_replace('*', '.*?', $reg);			
			if ( preg_match("!".$reg."!i", $addr, $res) ) {
				return 1;
			}
		}
		else if ( $obj->type == 'REGEX' ) {
			$reg = $obj->string;
			if ( preg_match("!".$reg."!i", $addr, $res) ) {
				return 1;
			}	
		}
	}
	qf($r);
	
	return 0;
}

function send_email($from, $to, $subj, $body, $header='')
{
	if( empty($to) || !count($to) ) return;	
	$bcc='';
	
	if( is_array($to) ) {
		if( ($a = count($to)) > 1 ) {
			$bcc = "Bcc: ";
			for( $i=1; $i<$a; $i++ ) 
				$bcc .= $to[$i].', ';
				
			$bcc = substr($bcc,0,-2);	
		}		

		$to = $to[0];
	}
	
	mail($to, $subj, $body, "From: $from\r\nErrors-To: $from\r\nReturn-Path: $from\r\nX-Mailer: FUDforum v".$GLOBALS['FORUM_VERSION']."\r\n".$header.$bcc);
}

function send_notifications($to, $msg_id, $thr_subject, $poster_login, $id_type, $id, $frm_name='')
{
	$icq = str_replace("http://", "http'+'://'+'", $GLOBALS['WWW_ROOT']);
	$icq = str_replace("www.", "www'+'.", $icq);

	$goto_url['icq'] = "javascript:window.location='".$icq."index.php?t=rview&goto=".$msg_id."';";
	$goto_url['email'] = $GLOBALS['WWW_ROOT'].'index.php?t=rview&goto='.$msg_id;
	
	
	if ( $GLOBALS['NOTIFY_WITH_BODY'] == 'Y' ) {
		$r = q("SELECT 
			fud21_msg.*, 
			fud21_thread.locked,
			fud21_thread.forum_id,
			fud21_avatar.img AS avatar, 
			fud21_users.id AS user_id, 
			fud21_users.alias AS login, 
			fud21_users.display_email, 
			fud21_users.avatar_approved,
			fud21_users.avatar_loc,
			fud21_users.email, 
			fud21_users.posted_msg_count, 
			fud21_users.join_date, 
			fud21_users.location, 
			fud21_users.sig,
			fud21_users.icq,
			fud21_users.jabber,
			fud21_users.aim,
			fud21_users.msnm,
			fud21_users.invisible_mode,
			fud21_users.email_messages,
			fud21_users.last_visit AS time_sec,
			fud21_users.is_mod,
			fud21_users.yahoo,
			fud21_users.custom_status,
			fud21_level.name AS level_name,
			fud21_level.pri AS level_pri,
			fud21_level.img AS level_img
		FROM 
			fud21_msg 
			LEFT JOIN fud21_users 
				ON fud21_msg.poster_id=fud21_users.id 
			LEFT JOIN fud21_avatar 
				ON fud21_users.avatar=fud21_avatar.id 
			INNER JOIN fud21_thread
				ON fud21_msg.thread_id=fud21_thread.id	
			LEFT JOIN fud21_ses
				ON fud21_ses.user_id=fud21_msg.poster_id
			LEFT JOIN fud21_level
				ON fud21_users.level_id=fud21_level.id
		WHERE 
			fud21_msg.id=".$msg_id." AND fud21_msg.approved='Y'");
		
		$obj = db_singleobj($r);
		unset($obj->ip_addr);
		$headers  = "MIME-Version: 1.0\r\n";
		$split = get_random_value(128);
		$headers .= "Content-Type: multipart/alternative; boundary=\"------------$split\"\r\n";
		$boundry = "\r\n--------------$split\r\n";
		
		$plain_text = read_msg_body($obj->foff,$obj->length, $obj->file_id);
		$plain_text = $boundry."Content-Type: text/plain; charset=".$GLOBALS['CHARSET']."; format=flowed\r\nContent-Transfer-Encoding: 7bit\r\n\r\n".strip_tags($plain_text)."\r\n\r\nTo participate in the discussion, go here: ".$GLOBALS['WWW_ROOT'].'index.php?t=rview&th='.$id."&notify=1&opt=off\r\n";
		
		$mod = $GLOBALS['MOD'];
		$GLOBALS['MOD'] = 1;
		$GLOBALS['pl_view'] = $obj->poll_id;
		$body_email = tmpl_drawmsg($obj,NULL,NULL,'');
		$GLOBALS['MOD'] = $mod;
		
		$body_email = $boundry."Content-Type: text/html; charset=".$GLOBALS['CHARSET']."\r\nContent-Transfer-Encoding: 7bit\r\n\r\n".'<html>
<head>
<META HTTP-EQUIV="Content-Type" CONTENT="text/html; charset=ISO-8859-15">
<title>'.$GLOBALS['FORUM_TITLE'].$TITLE_EXTRA.'</title>
<BASE HREF="'.$GLOBALS['WWW_ROOT'].'">
<script language="JavaScript" src="lib.js"></script>
<link rel="StyleSheet" href="http://thelocust.org/bored/theme/default/forum.css" type="text/css">
</head>
<body topmargin="2" leftmargin="2" marginheight="2" marginwidth="2">
<table width="100%" border="0" cellspacing="3" cellpadding="5"><tr><td class="ForumBackground">
<table border="0" cellspacing="1" cellpadding="2" class="ContentTable">
<tr>
	<th width=1>Author</th>
	<th>Thread</th>
</tr>
'.$body_email.'
</table>
</td></tr></table></body></html>'."\r\n";
		$body_email = $plain_text.$body_email.substr($boundry, 0, -2)."--\r\n";
	}
	
	reverse_FMT($thr_subject);
	reverse_FMT($poster_login);
	
	if( $id_type == 'thr' ) {
		$subj = 'New reply to '.$thr_subject.' by '.$poster_login;
		
		if( !$body_email ) {
			$unsub_url['email'] = $GLOBALS['WWW_ROOT'].'index.php?t=rview&th='.$id.'&notify=1&opt=off';
			$body_email = 'To view unread replies goto '.$goto_url['email'].'

If you do not wish to receive further notifications about replies in this thread, please go here: '.$unsub_url['email'];
		}	
		
		$body_icq = 'To view unread replies goto
'.$goto_url['icq'].'

If you do not wish to receive further notifications about replies in this thread, please go here:
'.$unsub_url['icq'];
		$unsub_url['icq'] = "javascript:window.location='".$icq."index.php?t=rview&th=".$id."&notify=1&opt=off';";
	}
	else if ( $id_type == 'frm' ) {
		reverse_FMT($frm_name);
		
		$subj = 'New thread in forum '.$frm_name.' called '.$thr_subject.' by '.$poster_login;
		
		$unsub_url['icq'] = "javascript:window.location='".$icq."index.php?t=thread&unsub=1&frm_id=".$id."';";
		$body_icq = 'To view the thread goto:
'.$goto_url['icq'].'

To stop receiving notifications about new threads in this forum, please go here:
'.$unsub_url['icq'];
		
		if( !$body_email ) {
			$unsub_url['email'] = $GLOBALS['WWW_ROOT'].'index.php?t=thread&unsub=1&frm_id='.$id;
			$body_email = 'To view the thread goto:
'.$goto_url['email'].'

To stop receiving notifications about new threads in this forum, please go here: '.$unsub_url['email'];
		}	
	}	
	
	send_email($GLOBALS["FORUM_TITLE"].' <'.$GLOBALS['NOTIFY_FROM'].'>', $to['EMAIL'], $subj, $body_email, $headers);
	send_email($GLOBALS["FORUM_TITLE"].' <'.$GLOBALS['NOTIFY_FROM'].'>', $to['ICQ'], $subj, $body_icq);
}function get_host($ip)
{
	if( empty($ip) ) return;

	$name = gethostbyaddr($ip);
	if( $name != $ip ) {
		if ( count(explode('.', $name)) > 2 ) 
			$name = substr($name, strpos($name, '.'));
	}		
	else
		$name = NULL;		

	return $name;
}function is_perms($user_id, $r_id, $perm, $r_type='forum')
{
	if( $GLOBALS['usr']->is_mod == 'A' ) return TRUE;
	if( __dbtype__ == 'pgsql' ) $perm = strtolower($perm);
	if( empty($user_id) ) $user_id = 0;

	if( @is_object($GLOBALS['__MEMPERM_CACHE'][$user_id][$r_id][$r_type]) ) 
		return ($GLOBALS['__MEMPERM_CACHE'][$user_id][$r_id][$r_type]->{'p_'.$perm}=='Y'?TRUE:FALSE);
	
	if ( empty($user_id) ) {
		$r = q("SELECT * FROM fud21_group_cache WHERE user_id=".$user_id." AND resource_type='".$r_type."' AND resource_id=".$r_id);
		if( !is_result($r) ) $r = q("SELECT * FROM fud21_groups WHERE id=1");
	}
	else {
		$r=q("SELECT * FROM fud21_group_cache WHERE user_id IN(".$user_id.",2147483647) AND resource_type='".$r_type."' AND resource_id=".$r_id." ORDER BY user_id LIMIT 1");
		if( !is_result($r) ) $r = q("SELECT * FROM fud21_groups WHERE id=2");
	}
	
	$GLOBALS['__MEMPERM_CACHE'][$user_id][$r_id][$r_type] = db_singleobj($r);
	return ($GLOBALS['__MEMPERM_CACHE'][$user_id][$r_id][$r_type]->{'p_'.$perm}=='Y'?TRUE:FALSE);
}function get_all_perms($usr_id)
{
	$fl = '';

	if( empty($usr_id) ) {
		$r = q("SELECT resource_id FROM fud21_group_cache WHERE user_id=0 AND resource_type='forum' AND p_READ='Y' AND p_VISIBLE='Y'");
		while( list($resource_id) = db_rowarr($r) ) $fl .= $resource_id.',';		
	}
	else {
		$tmp_arr = array();
		$r = q("SELECT user_id,resource_id,p_read,p_visible FROM fud21_group_cache WHERE user_id IN(".$usr_id.",2147483647) AND resource_type='forum' ORDER BY user_id");
		while( $obj = db_rowobj($r) ) {
			if( $obj->p_read == 'Y' && $obj->p_read == 'Y' && ($obj->user_id == $usr_id || !isset($tmp_arr[$obj->resource_id])) ) 
				$fl .= $obj->resource_id.',';

			$tmp_arr[$obj->resource_id] = 1;	
		}		
	}
	qf($r);
	
	if( !empty($fl) ) $fl = substr($fl, 0, -1);
	
	return $fl;
}

function forum_perm_array($forum_id)
{
 	$r = q("SELECT p_READ AS p_read, user_id FROM fud21_group_cache WHERE resource_type='forum' AND resource_id=$forum_id AND user_id>0");
	while ( $obj = db_rowobj($r) ) $p[$obj->user_id] = $obj->p_read;
	qf($r);
	
	return $p;
}

function is_allowed($user_id, $p)
{
	if ( isset($p[$user_id]) && $p[$user_id] != 'Y' ) 
		return 0;
	else if ( $p[$user_id] != 'Y' && $p['2147483647'] == 'N' ) 
		return 0;
	
	return 1;
}function delete_msg_index($msg_id)
{
	q("DELETE FROM fud21_index WHERE msg_id=".$msg_id);
	q("DELETE FROM fud21_title_index WHERE msg_id=".$msg_id);
}	
	
function index_text($subj, $body, $msg_id)
{
	
	/* Remove Stuff In Quotes */
	while ( preg_match('!<table border="0" align="center" width="90%" cellpadding="3" cellspacing="1"><tr><td class="SmallText"><b>(.*?)</b></td></tr><tr><td class="quote"><br>(.*?)<br></td></tr></table>!is', $body) ) 
		$body = preg_replace('!<table border="0" align="center" width="90%" cellpadding="3" cellspacing="1"><tr><td class="SmallText"><b>(.*?)</b></td></tr><tr><td class="quote"><br>(.*?)<br></td></tr></table>!is', '', $body);
		
	/* Remove HTML */
	reverse_FMT($body);
	$body = addslashes(strip_tags($body));

	reverse_FMT($subj);
	$subj = strtolower($subj);
	$subj = trim(preg_replace('!\s+!', ' ', $subj));
	
	$body = strtolower($body);
	$body = trim(preg_replace('!\s+!', ' ', $body));

	/* build full text index */
	$w = explode(' ', trim($subj.' '.$body));
	$a = count($w);
	
	if ( !db_locked() ) {
		$ll=1;
		db_lock('fud21_search+,
			 fud21_index+,
			 fud21_title_index+
			');
	}
	
	for ( $i=0; $i<$a; $i++ ) {
		if ( strlen($w[$i]) > 50 || strlen($w[$i])<3 ) continue;
		
		$r=q("SELECT id FROM fud21_search WHERE word='".$w[$i]."'");
		if ( !is_result($r) ) {
			$r = q("INSERT INTO fud21_search (word) VALUES('".$w[$i]."')");
			$id = db_lastid("fud21_search", $r);
		}
		else list($id) = db_singlearr($r);
		
		if ( !bq("SELECT id FROM fud21_index WHERE word_id=".$id." AND msg_id=".$msg_id) ) {
			q("INSERT INTO fud21_index(word_id, msg_id) VALUES(".$id.", ".$msg_id.")");
		}
	}
	
	/* build subject only index */
	$w = explode(' ', $subj);
	for ( $i=0; $i<count($w); $i++ ) {
		if ( strlen($w[$i]) > 50 || strlen($w[$i])<3 ) continue;
		$r=q("SELECT id FROM fud21_search WHERE word='".$w[$i]."'");
		if ( !is_result($r) ) {
			$r = q("INSERT INTO fud21_search (word) VALUES('".$w[$i]."')");
			$id = db_lastid("fud21_search", $r);
		}
		else list($id) = db_singlearr($r);
		
		if ( !bq("SELECT id FROM fud21_title_index WHERE word_id=$id AND msg_id=".$msg_id) ) {
			q("INSERT INTO fud21_title_index(word_id, msg_id) VALUES(".$id.", ".$msg_id.")");
		}
	}
	
	if ( $ll ) db_unlock();
}

function re_build_index()
{
	if ( !db_locked() ) { $ll=1; db_lock('fud21_search+, fud21_index+, fud21_title_index+, fud21_msg+'); }
	q("DELETE FROM fud21_search");
	q("DELETE FROM fud21_index");
	q("DELETE FROM fud21_title_index");
	$r = q("SELECT id,subject,thread_id,length,foff,file_id FROM fud21_msg ORDER BY thread_id,id ASC");
	if( !($cnt=db_count($r)) ) {
		qf($r);
		db_unlock();
		return;
	}

	$th_id=$i=0;
	$old_suject=$subj=NULL;
	while( $obj = db_rowobj($r) ) {
		if( $th_id != $obj->thread_id ) {
			
			$th_id = $obj->thread_id;
		}
		$body = read_msg_body($obj->foff, $obj->length, $obj->file_id);
		
		/* Remove Stuff In Quotes */
		while ( preg_match('!<table border="0" align="center" width="90%" cellpadding="3" cellspacing="1"><tr><td class="SmallText"><b>(.*?)</b></td></tr><tr><td class="quote"><br>(.*?)<br></td></tr></table>!is', $body) ) 
			$body = preg_replace('!<table border="0" align="center" width="90%" cellpadding="3" cellspacing="1"><tr><td class="SmallText"><b>(.*?)</b></td></tr><tr><td class="quote"><br>(.*?)<br></td></tr></table>!is', '', $body);
		
		/* Remove HTML */
		$body = addslashes(strip_tags($body));
		
		/* Do not store the same subjects twice */
		if( $old_suject!=$obj->subject ) {
			$subj = addslashes($obj->subject);
			$old_suject = $obj->subject;
		}
		else
			$subj = NULL;
			
		index_text($subj, $body, $obj->id);
	}
	un_register_fps();
	if ( $ll ) db_unlock();
}

function search($str, $fld, $start, $count, $forum_limiter='')
{
	$w = explode(" ", $str);
	$qr = '';
	$qry_uniq = array();
	
	while( list(,$v) = each($w) ) {
		if( !$v ) continue;
		$v = strtolower($v);
		if ( isset($qry_uniq[$v]) ) continue;
		
		$qr .= " '".$v."',";
		$qry_uniq[$v] = 1;
	}
	
	if( $qr )
		$qr = substr($qr, 0, -1);
	else
		return q("SELECT id FROM fud21_search WHERE id=0");	
	
	$field = ( $fld != 'subject' ) ? 'fud21_index' : 'fud21_title_index';
	
	$r = q("SELECT id FROM fud21_search WHERE word IN(".$qr.")");
	if( !db_count($r) ) return $r;
	$qr='';
	while( list($id) = DB_ROWARR($r) ) $qr .= $id.',';
	QF($r);
	$qr = substr($qr, 0, -1);
	
	if( $GLOBALS['usr']->is_mod != 'A' ) {
		if( is_numeric($forum_limiter) ) {
			if( !is_perms(_uid, $forum_limiter, 'READ') ) return q("SELECT id FROM fud21_index WHERE id=0");

			$forum_limiter_sql = " fud21_forum.id=".$forum_limiter." AND ";
		}
		else {
			if( !($fids = get_all_perms(_uid)) ) return q("SELECT id FROM fud21_index WHERE id=0");
		
			$forum_limiter_sql = 'fud21_forum.id IN ('.$fids.') AND ';
		
			if( $forum_limiter[0]=='c' && is_numeric(substr($forum_limiter,1)) ) 
				$forum_limiter_sql .= 'fud21_cat.id='.substr($forum_limiter,1).' AND ';
		}
	}	
	else
		$forum_limiter_sql = '';

	$r = q("SELECT 
		".$field.".msg_id AS msg_id,
		SUM(1) as rev_match
	FROM 
		".$field."
		INNER JOIN fud21_msg ON ".$field.".msg_id=fud21_msg.id
		INNER JOIN fud21_thread ON fud21_msg.thread_id=fud21_thread.id
		INNER JOIN fud21_forum ON fud21_thread.forum_id=fud21_forum.id
		INNER JOIN fud21_cat ON fud21_forum.cat_id=fud21_cat.id
	WHERE 
		".$field.".word_id IN ( ".$qr." ) AND
		".$forum_limiter_sql."
		fud21_msg.approved='Y'
	GROUP BY 
		".$field.".msg_id 
	ORDER BY rev_match DESC");
	
	if ( !db_count($r) ) return $r;
	
	$idlist = '';
	while ( $obj = db_rowobj($r) ) {
		$idlist .= $obj->msg_id.',';
	}
	
	$idlist = substr($idlist, 0, -1);
	qf($r);
	
	$r = q("SELECT
			fud21_users.alias AS login,
			fud21_forum.name AS forum_name, 
			fud21_forum.id AS forum_id,
			fud21_msg.poster_id,
			fud21_msg.id, 
			fud21_msg.thread_id,
			fud21_msg.subject,
			fud21_msg.poster_id,
			fud21_msg.foff,
			fud21_msg.length,
			fud21_msg.post_stamp,
			fud21_msg.file_id
		FROM 
			fud21_msg 
			INNER JOIN fud21_thread ON fud21_msg.thread_id=fud21_thread.id
			INNER JOIN fud21_forum ON fud21_thread.forum_id=fud21_forum.id
			INNER JOIN fud21_cat ON fud21_forum.cat_id=fud21_cat.id
			LEFT JOIN fud21_users ON fud21_msg.poster_id=fud21_users.id
		WHERE 
			fud21_msg.id IN ($idlist)
		");

	return $r;
}class fud_msg_edit extends fud_msg
{
	function add_thread($forum_id, $autoapprove=TRUE)
	{
		return $this->add($forum_id, $autoapprove);
	}
	
	function add_reply($reply_to, $th_id=NULL, $autoapprove=TRUE)
	{
		if( !empty($reply_to) ) {
			$this->reply_to=$reply_to;
			$forum_id = q_singleval("SELECT fud21_thread.forum_id FROM fud21_msg LEFT JOIN fud21_thread ON fud21_msg.thread_id=fud21_thread.id WHERE fud21_msg.id=".$reply_to);
		}
		else
			$forum_id = q_singleval("SELECT fud21_thread.forum_id FROM fud21_thread WHERE fud21_thread.id=".$th_id);
		
		return $this->add($forum_id, $autoapprove);
	}
	
	function add($forum_id, $autoapprove=TRUE)
	{
		if ( empty($this->attachment_id) ) $this->attachment_id = 0;
		if ( isset($GLOBALS['HTTP_SERVER_VARS']['REMOTE_ADDR']) ) $this->ip_addr = $GLOBALS['HTTP_SERVER_VARS']['REMOTE_ADDR'];
		
		$this->post_stamp = __request_timestamp__;
		if ( $GLOBALS['PUBLIC_RESOLVE_HOST'] == 'Y' ) $this->host_name = get_host($this->ip_addr);
		
		$this->thread_id = isset($this->thread_id) ? $this->thread_id : 0;
		$this->reply_to = isset($this->reply_to) ? $this->reply_to : 0;
		
		$frm = new fud_forum;
		$frm->get($forum_id);

		/* determine if preview needs building */
		if ( $frm->message_threshold && $frm->message_threshold < strlen($this->body) )
			$thres_body = trim_html($this->body, $frm->message_threshold);
		
		/* length+offset are returned by ref, thank php-devs for dumbass syntax */
		$file_id = write_body($this->body, $length, $offset);
		if ( $thres_body ) $file_id_preview = write_body($thres_body, $length_preview, $offset_preview);
		
		
		
		$r = q("INSERT INTO fud21_msg (
			thread_id, 
			poster_id, 
			reply_to, 
			ip_addr,
			host_name,
			post_stamp, 
			subject, 
			attach_cnt, 
			poll_id, 
			icon, 
			show_sig,
			smiley_disabled,
			file_id,
			foff,
			length,
			file_id_preview,
			offset_preview,
			length_preview
		) 
		VALUES(
			".$this->thread_id.",
			".$this->poster_id.",
			".intzero($this->reply_to).",
			".ifnull($this->ip_addr, "'0.0.0.0'").",
			".strnull($this->host_name).",
			".$this->post_stamp.",
			".strnull($this->subject).",
			".intzero($this->attach_cnt).",
			".intzero($this->poll_id).",
			".strnull($this->icon).",
			'".yn($this->show_sig)."',
			'".yn($this->smiley_disabled)."',
			".$file_id.",
			".intzero($offset).",
			".intzero($length).",
			".intzero($file_id_preview).",
			".intzero($offset_preview).",
			".intzero($length_preview)."
		)");

		$this->id = db_lastid("fud21_msg", $r);

		$thr = new fud_thread;
		if ( !$this->thread_id ) { /* new thread */
			$thr->last_post = $this->post_stamp;
			
			/* if moderator is creating a thread consider a number of other properties */
			if ( isset($GLOBALS['MOD']) ) {
				if ( $GLOBALS['HTTP_POST_VARS']['thr_ordertype'] != 'NONE' ) 
					$is_sticky = 'Y';
				else
					$is_sticky = 'N';
				$this->thread_id = $thr->add($this->id, $forum_id, $GLOBALS['HTTP_POST_VARS']['thr_locked'], $is_sticky, $GLOBALS['HTTP_POST_VARS']['thr_ordertype'], $GLOBALS['HTTP_POST_VARS']['thr_orderexpiry']);
			}
			else
				$this->thread_id = $thr->add($this->id, $forum_id);
	
			q("UPDATE fud21_msg SET thread_id=".$this->thread_id." WHERE id=".$this->id);
		}
		else {
			$thr->get_by_id($this->thread_id);
			if ( $GLOBALS['HTTP_POST_VARS']['thr_locked']=='Y' ) 
				$thr->lock(); 
			else
				$thr->unlock();
		}
		
		if ( $autoapprove && $frm->moderated != 'N' ) $this->approve(NULL, TRUE);

		return $this->id;
	}
	
	function sync($id)
	{
		if ( !db_locked() ) {
			db_lock('fud21_cat+, fud21_forum+, fud21_msg+, fud21_thread+, fud21_index+, fud21_title_index+, fud21_thread_view+');
			$ll=1;
		}
		$file_id = write_body($this->body, $length, $offset);
		/* determine if preview needs building */
		$frm = new fud_forum;
		$frm->get(q_singleval("SELECT forum_id FROM fud21_thread WHERE id=".$this->thread_id));
		
		if ( $frm->message_threshold && $frm->message_threshold < strlen($this->body) ) {
			$thres_body = trim_html($this->body, $frm->message_threshold);
			$file_id_preview = write_body($thres_body, $length_preview, $offset_preview);
		}
		q("UPDATE fud21_msg SET 
			file_id=".$file_id.", 
			foff=".intzero($offset).", 
			length=".intzero($length).", 
			file_id_preview=".intzero($file_id_preview).",
			offset_preview=".intzero($offset_preview).",
			length_preview=".intzero($length_preview).",
			smiley_disabled='".yn($this->smiley_disabled)."', 
			updated_by=".$id.", show_sig='".yn($this->show_sig)."', 
			subject='".$this->subject."', 
			attach_cnt=".intzero($this->attach_cnt).", 
			poll_id=".intzero($this->poll_id).", 
			update_stamp=".__request_timestamp__.", 
			icon=".strnull($this->icon)." 
		WHERE id=".$this->id);
		
		delete_msg_index($this->id);
		$root_msg_id = q_singleval("SELECT root_msg_id FROM fud21_thread WHERE id=".$this->thread_id);		
		if ( isset($GLOBALS['MOD']) ) {
			$thr = new fud_thread;
			$thr->id = $this->thread_id;
			if ( $root_msg_id==$this->id ) {
				if ( $GLOBALS['HTTP_POST_VARS']['thr_ordertype'] != 'NONE' ) 
					$thr->is_sticky = 'Y';
				else
					$thr->is_sticky = 'N';
				$thr->ordertype = $GLOBALS['HTTP_POST_VARS']['thr_ordertype'];
				$thr->orderexpiry = $GLOBALS['HTTP_POST_VARS']['thr_orderexpiry'];
				$thr->locked = yn($GLOBALS['HTTP_POST_VARS']['thr_locked']);
				$thr->sync();
			}
			else {
				if ( $GLOBALS['HTTP_POST_VARS']['thr_locked']=='Y' ) 
					$thr->lock();
				else
					$thr->unlock();
			}
		}
		if ( $ll ) db_unlock();
		$s_text = preg_match("!^Re: !i", $this->subject) ? '': $this->subject;
		if( $GLOBALS['FORUM_SEARCH'] == 'Y' ) index_text($s_text, $this->body, $this->id);
	}
	
	function fetch_vars($array, $prefix)
	{
		$this->subject = $array[$prefix.'subject'];
		$this->body = $array[$prefix.'body'];
		$this->icon = isset($array[$prefix.'icon'])?$array[$prefix.'icon']:'';
		$this->show_sig = isset($array[$prefix.'show_sig'])?$array[$prefix.'show_sig']:'';
	}
	
	function export_vars($prefix)
	{	
		$GLOBALS[$prefix.'subject'] = $this->subject;
		$GLOBALS[$prefix.'body'] = $this->body;
		$GLOBALS[$prefix.'icon'] = $this->icon;
		$GLOBALS[$prefix.'show_sig'] = $this->show_sig;
	}
	
	function delete($rebuild_view=TRUE)
	{
		if ( !db_locked() ) {
			db_lock('fud21_thread_view+, fud21_level+, fud21_forum+, fud21_forum_read+, fud21_thread+, fud21_msg+, fud21_attach+, fud21_poll+, fud21_poll_opt+, fud21_poll_opt_track+, fud21_users+, fud21_thread_notify+, fud21_msg_report+, fud21_thread_rate_track+');
			$local_lock = 1;
		}
		
		$res = q("SELECT 
				fud21_msg.*,
				fud21_thread.root_msg_id AS root_msg_id, 
				fud21_thread.last_post_id AS thread_lip,
				fud21_forum.last_post_id AS forum_lip,
				forum_id 
			FROM fud21_msg 
			LEFT JOIN fud21_thread 
				ON fud21_msg.thread_id=fud21_thread.id 
			LEFT JOIN fud21_forum 
				ON fud21_thread.forum_id=fud21_forum.id 
			WHERE 
				fud21_msg.id=".$this->id);
		if ( !is_result($res) ) exit("no such message");
		$del = db_singleobj($res);
		
		/* attachments */
		if ( $del->attach_cnt ) {
			$res = q("SELECT location FROM fud21_attach WHERE message_id=".$this->id." AND private='N'");
			if( db_count($res) ) {
				while ( list($loc) = db_rowarr($res) ) {
					if( file_exists($loc) ) unlink($loc);				
				}
			}
			qf($res);
			q("DELETE FROM fud21_attach WHERE message_id=".$this->id." AND private='N'");
		}
		
		q("DELETE FROM fud21_msg_report WHERE msg_id=".$this->id);
		
		if ( $del->poll_id ) {
			$poll = new fud_poll;
			$poll->get($del->poll_id);
			$poll->delete();
		}
		
		/* check if thread */
		if( $del->root_msg_id==$del->id ) {
			$rmsg = q("SELECT * FROM fud21_msg WHERE thread_id=".$del->thread_id." AND id!=".$del->id);
			$d_msg = new fud_msg_edit;
			while ( $obj = db_rowobj($rmsg) ) {
				qobj("SELECT * FROM fud21_msg WHERE id=".$obj->id, $d_msg);
				$d_msg->delete($rebuild_view);
			}
			qf($rmsg);
			q("DELETE FROM fud21_thread_notify WHERE thread_id=".$del->thread_id);
			$rthd=q("SELECT forum_id, root_msg_id FROM fud21_thread WHERE root_msg_id=".$del->root_msg_id);
			$i = 0;
			while ( list($th_forum_id, $th_root_msg_id) = db_rowarr($rthd) ) {
				q("UPDATE fud21_forum SET thread_count=thread_count-1 WHERE id=".$th_forum_id);
				$lip_update[$i]['forum_id'] = $th_forum_id;
				$lip_update[$i]['msg_id'] = $th_root_msg_id;
				++$i;
			}
			qf($rthd);
			
			q("DELETE FROM fud21_thread WHERE root_msg_id=".$del->root_msg_id);
			q("DELETE FROM fud21_thread_rate_track WHERE thread_id=".$del->thread_id);
			if( $del->approved!='N' && $del->forum_id ) q("UPDATE fud21_forum SET post_count=post_count-1 WHERE id=".$del->forum_id);
		}
		else {
			if( $del->approved!='N' ) {
				q("UPDATE fud21_thread SET replies=replies-1 WHERE id=".$del->thread_id);
				if( $del->forum_id ) {
					q("UPDATE fud21_forum SET post_count=post_count-1 WHERE id=".$del->forum_id);
					$lip_update[0]['forum_id'] = $del->forum_id;
					$lip_update[0]['msg_id'] = $del->id;
				}	
			}	
		}
		
		q("UPDATE fud21_msg SET reply_to=".$this->reply_to." WHERE thread_id=".$this->thread_id." AND reply_to=".$this->id);
		q("DELETE FROM fud21_msg WHERE id=".$this->id);
		
		if ( $this->poster_id && $del->approved!='N' ) {
			$u = new fud_user;
			$u->id = $this->poster_id;
			$u->set_post_count(-1);
		}
		
		if( $del->root_msg_id!=$this->id && $del->thread_lip == $this->id ) {
			$mid = q_singleval("SELECT id FROM fud21_msg WHERE thread_id=".$del->thread_id." AND approved='Y' ORDER BY post_stamp DESC LIMIT 1");
			q("UPDATE fud21_thread SET last_post_id=".$mid." WHERE id=".$del->thread_id);
		}
		
		if ( is_array($lip_update) ) {
			reset($lip_update);
			while ( list($k, $v) = each($lip_update) ) {
				if( $v['msg_id'] == $this->id ) {
					$mid = q_singleval("SELECT last_post_id FROM fud21_thread INNER JOIN fud21_msg ON fud21_thread.last_post_id=fud21_msg.id WHERE forum_id=".$v['forum_id']." AND fud21_msg.approved='Y' ORDER BY last_post_id DESC LIMIT 1");
					if( !$mid ) $mid = 0;
			
					q("UPDATE fud21_forum SET last_post_id=".$mid." WHERE id=".$v['forum_id']);
					if( $rebuild_view ) rebuild_forum_view($v['forum_id']);
				}
			}
		}
		if ( $local_lock ) db_unlock();
	}	
	
	function approve($id=NULL, $unlock_safe=FALSE)
	{	
		if( !db_locked() ) {
			db_lock('
				fud21_thread_view+, 
				fud21_level+, 
				fud21_cat+, 
				fud21_users+, 
				fud21_forum+, 
				fud21_thread+, 
				fud21_msg+
				');
			$ll = 1;
		}
		
		if( $id ) {
			$this->get_by_id($id);
			$this->subject = addslashes($this->subject);
			$this->body = addslashes($this->body);
		}	
		if( empty($this->approved) ) $this->approved = q_singleval("SELECT approved FROM fud21_msg WHERE id=".$this->id);
		
		if ( $this->approved!='Y' ) {
			$thr = new fud_thread;
			$frm = new fud_forum;
			
			$thr->get_by_id($this->thread_id);
			$frm->get($thr->forum_id);
			
			q("UPDATE fud21_msg SET approved='Y' WHERE id=".$this->id);
			
			if ( $this->poster_id ) {
				$u = new fud_user;
				$u->id = $this->poster_id;
				$u->set_post_count(1,$this->id);
			}
		
			if ( $thr->last_post_id <= $this->id ) { 
				q("UPDATE fud21_thread SET last_post_id=".$this->id.", last_post_date=".$this->post_stamp." WHERE id=".$this->thread_id);
				
				if( q_singleval("SELECT last_post_id FROM fud21_forum WHERE id=".$thr->forum_id) < $this->id ) 
					q("UPDATE fud21_forum SET last_post_id=".$this->id." WHERE id=".$thr->forum_id);
			}	

			if( $thr->root_msg_id == $this->id ) {/* new thread */
				q("UPDATE fud21_forum SET thread_count=thread_count+1 WHERE id=".$frm->id);
				rebuild_forum_view($thr->forum_id);
			}	
			else {/* reply to thread */
				$thr->inc_post_count(1);
				rebuild_forum_view($thr->forum_id, q_singleval("SELECT page FROM fud21_thread_view WHERE forum_id=".$thr->forum_id." AND thread_id=".$this->thread_id));
			}	
				
			$frm->inc_reply_count(1);
			if( db_locked() && ($unlock_safe || $ll) ) db_unlock();
			
			if( $GLOBALS['FORUM_SEARCH'] == 'Y' ) {
				$s_text = preg_match("!Re: !i", $this->subject) ? '': $this->subject;
				index_text($s_text, $this->body, $this->id);
			}

			if ( $thr->root_msg_id == $this->id ) 
				send_notifications($frm->get_notify_list(intzero($this->poster_id)), $this->id, $thr->subject, ($GLOBALS['usr']->login?$GLOBALS['usr']->login:$GLOBALS['ANON_NICK']), 'frm', $frm->id, $frm->name);
			else
				send_notifications($thr->get_notify_list(intzero($this->poster_id)), $this->id, $thr->subject, ($GLOBALS['usr']->login?$GLOBALS['usr']->login:$GLOBALS['ANON_NICK']), 'thr', $thr->id);
		}
		
		if( db_locked() && !empty($ll) ) db_unlock();
	}
	
	function unapprove()
	{
		q("UPDATE fud21_msg SET approved='N' WHERE id=".$this->id);
	}
	
}

function flood_check()
{
	$check_time = __request_timestamp__-$GLOBALS['FLOOD_CHECK_TIME'];
	
	if( ($v = q_singleval("SELECT post_stamp FROM fud21_msg WHERE ip_addr='".$GLOBALS['HTTP_SERVER_VARS']['REMOTE_ADDR']."' AND poster_id=".(($GLOBALS["usr"]->id)?$GLOBALS["usr"]->id:0)." AND post_stamp>".$check_time." ORDER BY post_stamp DESC LIMIT 1")) ) {
		$v += $GLOBALS['FLOOD_CHECK_TIME']-__request_timestamp__;
		if( $v<1 ) $v=1;
		return $v;
	}
	
	return;		
}

function write_body($data, &$len, &$offset)
{
	$MAX_FILE_SIZE = 2147483647;
	$curdir = getcwd();
	chdir($GLOBALS["MSG_STORE_DIR"]);

	$len = strlen($data);
	$i=1;
	while( $i<100 ) {
		$fp = fopen('msg_'.$i, 'ab');
		flock($fp, LOCK_EX);
		if( !($off = ftell($fp)) ) $off = __ffilesize($fp);
		if( !$off || sprintf("%u", $off+$len)<$MAX_FILE_SIZE ) break;
		fclose($fp);
		$i++;
	}
	
	$len = fwrite($fp, $data);
	fclose($fp);
	
	if( !$off ) @chmod('msg_'.$i, 0600);
	
	chdir($curdir);
	
	if( $len == -1 ) exit("FATAL ERROR: system has ran out of disk space<br>\n");
	$offset = $off;
	
	return $i;
}

function trim_html($str, $maxlen)
{
	$n = strlen($str);
	$ln = 0;
	for ( $i=0; $i<$n; $i++ ) {
		if ( $str[$i] != '<' ) {
			$ln++;
			if( $ln > $maxlen ) break;
			continue;
		}
		
		if( ($p = strpos($str, '>', $i)) === FALSE ) break;
		
		for ( $k=$i; $k<$p; $k++ ) {
			switch ( $str[$k] ) 
			{
				case ' ':
				case "\r":
				case "\n":
				case "\t":
				case ">":
					break 2;
			}
		}
		
		if ( $str[$i+1] == '/' ) {
			$tagname = strtolower(substr($str, $i+2, $k-$i-2));	
			if( @end($tagindex[$tagname]) ) {
				$k = key($tagindex[$tagname]);
				unset($tagindex[$tagname][$k]);
				unset($tree[$k]);
			}	
		}
		else {
			$tagname = strtolower(substr($str, $i+1, $k-$i-1));
			switch ( $tagname ) 
			{
				case "br":
				case "img":
				case "meta":
					break;
				default:
					$tree[] = $tagname;
					end($tree);
					$tagindex[$tagname][key($tree)] = 1;
			}
		}
		$i = $p;
	}
	
	$data = substr($str, 0, $i);
	if ( is_array($tree) ) {
		$tree = array_reverse($tree);
		reset($tree);	
		while( list(,$v) = each($tree) ) $data .= '</'.$v.'>';
	}

	return $data;
}function tmpl_draw_select_opt($values, $names, $selected, $normal_tmpl, $selected_tmpl)
{
	$vls = explode("\n", $values);
	$nms = explode("\n", $names);
	
	$a = count($vls);
	
	if( $a != count($nms) ) exit("FATAL ERROR: inconsistent number of values inside a select<br>\n");
	
	$options = '';
	for( $i=0; $i<$a; $i++ ) {
		if( $vls[$i]!=$selected ) 
			$options .= '<option value="'.$vls[$i].'" '.$normal_tmpl.'>'.$nms[$i].'</option>';
		else
			$options .= '<option value="'.$vls[$i].'" selected '.$selected_tmpl.'>'.$nms[$i].'</option>';
	}
	return $options;
}class fud_forum_adm extends fud_forum
{
	function get_max_view($cat_id)
	{
		$ret = q_singleval("SELECT MAX(view_order) FROM fud21_forum WHERE cat_id=".$cat_id);
		return ( empty($ret) ? 0 : $ret );
	}
	
	function add($pos)
	{
		if ( !db_locked() ) {
			$ll = 1;
			db_lock('
				fud21_forum+, 
				fud21_groups+, 
				fud21_group_resources+, 
				fud21_group_members+,
				fud21_group_cache+
			');
		}
		
		$max = $this->get_max_view($this->cat_id);
		if ( $max > 0 ) {
			$this->view_order = $max+1;
		}
		else $this->view_order = 1;
		
		if ( $pos == 'FIRST' ) {
			$this->move_up(1, $max, $this->cat_id);
			$this->view_order = 1;
		}
		
		$r = q("INSERT INTO fud21_forum (
			cat_id, 
			name, 
			descr, 
			passwd_posting, 
			post_passwd, 
			anon_forum, 
			date_created, 
			view_order, 
			forum_icon, 
			tag_style, 
			moderated, 
			max_attach_size,
			max_file_attachments,
			message_threshold
		) 
		VALUES(
			".$this->cat_id.",
			'".$this->name."',
			".strnull($this->descr).",
			'".$this->passwd_posting."',
			".strnull($this->post_passwd).",
			'".yn($this->anon_forum)."',
			".__request_timestamp__.",
			".$this->view_order.",
			".strnull($this->forum_icon).",
			'".$this->tag_style."',
			'".$this->moderated."',
			".intzero($this->max_attach_size).",
			".intzero($this->max_file_attachments).",
			".intzero($this->message_threshold)."
		)");
		
		$this->id = db_lastid("fud21_forum", $r);
		$grp = new fud_group;
		reset($GLOBALS['__GROUPS_INC']['permlist']);
		while ( list($k,$v) = each($GLOBALS['__GROUPS_INC']['permlist']) ) {
			$grp->{$k} = 'Y';
		}
		$grp->add('forum', $this->id, $this->name);
		$grp->add_resource('forum', $this->id);
		$grp->rebuild_cache();
		if ( $ll ) db_unlock();
		
		return $this->id;
	}
	
	function sync()
	{
		if ( !db_locked() ) { 
			$ll=1; 
			db_lock('
				fud21_forum+, 
				fud21_groups+
			'); 
		}
		
		q("UPDATE fud21_forum SET 
			cat_id=".$this->cat_id.",
			name='".$this->name."',
			descr=".strnull($this->descr).",
			passwd_posting='".$this->passwd_posting."',
			post_passwd=".strnull($this->post_passwd).",
			anon_forum='".yn($this->anon_forum)."',
			view_order=".$this->view_order.",
			forum_icon=".strnull($this->forum_icon).",
			tag_style='".$this->tag_style."',
			moderated='".$this->moderated."',
			max_attach_size=".$this->max_attach_size.", 
			max_file_attachments=".intzero($this->max_file_attachments).",
			message_threshold=".intzero($this->message_threshold)."
		WHERE id=".$this->id);
		
		q("UPDATE fud21_groups SET name='$this->name' WHERE res='forum' AND res_id=$this->id");
		
		if ( $ll ) db_unlock();
	}
	
	function change_pos($old, $new, $cat_id)
	{
		if ( !db_locked() ) {
			$ll = 1;
			db_lock('fud21_forum+');
		}
		
		q("UPDATE fud21_forum SET view_order=2147483647 WHERE cat_id=".$cat_id." AND view_order=".$old);
		
		if ( $old > $new ) 
			$this->move_up($new, $old, $cat_id);			
		else 
			$this->move_down($old, $new, $cat_id);
		
		q("UPDATE fud21_forum SET view_order=".$new." WHERE cat_id=".$cat_id." AND view_order=2147483647");
		if ( $ll ) db_unlock();
	}
	
	function move_up($start, $max, $cat_id)
	{
		q("UPDATE fud21_forum SET view_order=view_order+1 WHERE cat_id=".$cat_id." AND view_order>=".$start." AND view_order<=".$max);
	}
	
	function move_down($start, $max, $cat_id)
	{
		q("UPDATE fud21_forum SET view_order=view_order-1 WHERE cat_id=".$cat_id." AND view_order>=".$start." AND view_order<=".$max);
	}

	function get_cat_forums($cat_id)
	{
		$result = q("SELECT * FROM fud21_forum WHERE cat_id=".$cat_id." ORDER BY view_order");

		unset($this->forums);
		$this->cur_frm=0;
		if ( !is_result($result) ) return;
		
		while ( $obj=db_rowobj($result) ) {
			$this->forums[$this->cur_frm++] = $obj;
		}
		
		qf($result);
		
		$this->cur_frm = 0;
		return 1;
	}
	
	function get_all_forums()
	{
		$result = q("SELECT fud21_forum.* FROM fud21_forum INNER JOIN fud21_cat ON fud21_forum.cat_id=fud21_cat.id ORDER BY fud21_cat.view_order, fud21_forum.view_order");
		
		unset($this->forums);
		$this->cur_frm=0;
		if ( !is_result($result) ) return;
		
		while ( $obj=db_rowobj($result) ) {
			$this->forums[$this->cur_frm++] = $obj;
		}
		
		qf($result);
		
		$this->cur_frm = 0;
		return 1;
	}
	
	function resetfrm()
	{
		$this->cur_frm = 0;
	}
	
	function countfrm()
	{
		if ( !isset($this->forums) ) return;
		return count($this->forums);
	}
	
	function nextfrm()
	{
		if ( !isset($this->forums[$this->cur_frm]) ) return;

		$this->id = $this->forums[$this->cur_frm]->id;
		$this->cat_id = $this->forums[$this->cur_frm]->cat_id;
		$this->name = $this->forums[$this->cur_frm]->name;
		$this->descr = $this->forums[$this->cur_frm]->descr;
		$this->passwd_posting = $this->forums[$this->cur_frm]->passwd_posting;
		$this->post_passwd = $this->forums[$this->cur_frm]->post_passwd;
		$this->anon_forum = $this->forums[$this->cur_frm]->anon_forum;
		$this->date_created = $this->forums[$this->cur_frm]->date_created;
		$this->thread_count = $this->forums[$this->cur_frm]->thread_count;
		$this->post_count = $this->forums[$this->cur_frm]->post_count;
		$this->view_order = $this->forums[$this->cur_frm]->view_order;
		$this->forum_icon = $this->forums[$this->cur_frm]->forum_icon;
		$this->tag_style = $this->forums[$this->cur_frm]->tag_style;
		$this->moderated = $this->forums[$this->cur_frm]->moderated;
		$this->max_attach_size = $this->forums[$this->cur_frm]->max_attach_size;
		$this->max_file_attachments = $this->forums[$this->cur_frm]->max_file_attachments;
		$this->message_threshold = $this->forums[$this->cur_frm]->message_threshold;
		$this->cur_frm++;
		
		return 1;
	}
	
	function delete($id) {
		db_lock('fud21_forum+, 
			fud21_mod+, 
			fud21_thread+, 
			fud21_msg+, 
			fud21_ann_forums+, 
			fud21_forum_notify+, 
			fud21_thread_notify+, 
			fud21_read+, 
			fud21_cat+, 
			fud21_attach+, 
			fud21_poll+, 
			fud21_poll_opt+, 
			fud21_poll_opt_track+, 
			fud21_users+, 
			fud21_msg_report+, 
			fud21_level+,
			fud21_thread_view+,
			fud21_thread_rate_track+,
			fud21_groups+, 
			fud21_group_resources+, 
			fud21_group_members+,
			fud21_group_cache+
			');
			
		$result = q("SELECT cat_id, view_order FROM fud21_forum WHERE id=".$id);
		if ( !is_result($result) ) exit("no such forum\n");
		
		list($cat_id, $view_order) = db_singlearr($result);
		
		$max = $this->get_max_view($cat_id);
		
		$thr = q("SELECT root_msg_id FROM fud21_thread WHERE forum_id=".$id);
		while ( $obj = db_rowobj($thr) ) {
			$msg = new fud_msg_edit;
			$msg->get_by_id($obj->root_msg_id);
			$msg->delete();
			unset($msg);
		}
		qf($thr);
		
		
		q("DELETE FROM fud21_ann_forums WHERE forum_id=".$id);
		q("DELETE FROM fud21_thread WHERE forum_id=".$id);
		q("DELETE FROM fud21_mod WHERE forum_id=".$id);
		q("DELETE FROM fud21_forum_notify WHERE forum_id=".$id);
		if ( $group_id = q_singleval("SELECT id FROM fud21_groups WHERE res='forum' AND res_id=$id") ) {
			$grp = new fud_group;
			$grp->get($group_id);
			$grp->delete();
		}
		q("DELETE FROM fud21_forum WHERE id=".$id);
		$this->move_down($view_order, $max, $cat_id); 
		db_unlock();
	}
		
	function chcat($id, $new_cat)
	{
		db_lock('fud21_forum+');
		$result = q("SELECT cat_id, view_order FROM fud21_forum WHERE id=".$id);
		
		if ( !is_result($result) ) exit("no such forum");		
		
		list($old_cat_id, $view_order) = db_singlearr($result);
		$old_max = $this->get_max_view($old_cat_id);
		
		$new_n = $this->get_max_view($new_cat);
		if ( !$new_n ) {
			$new_n = 1;
		}
		else $new_n += 1;
		
		q("UPDATE fud21_forum SET cat_id=".$new_cat.", view_order=".$new_n." WHERE id=".$id);
		$this->move_down($view_order, $old_max, $old_cat_id); 
		db_unlock();
	}
}function logaction($user_id, $res, $res_id=0, $action=NULL)
{
	q("INSERT INTO fud21_action_log(logtime, logaction, user_id, a_res, a_res_id)
		VALUES(".__request_timestamp__.", '$action', $user_id, '$res', $res_id)");
}

function clear_action_log()
{
	q("DELETE FROM fud21_action_log");
}

	if( _uid ) {
	if( $usr->is_mod != 'N' && $usr->is_mod ) {
		if( $approve_count = q_singleval("SELECT count(*) FROM 
					fud21_msg 
					INNER JOIN fud21_thread 
						ON fud21_msg.thread_id=fud21_thread.id 
					INNER JOIN fud21_forum 
						ON fud21_thread.forum_id=fud21_forum.id 
					INNER JOIN fud21_mod 
						ON fud21_forum.id=fud21_mod.forum_id 
						".($GLOBALS["usr"]->is_mod != 'A' ? "AND fud21_mod.user_id="._uid : '')."  
					WHERE 
						fud21_msg.approved='N' 
						AND fud21_forum.moderated='Y'") ) 
			$mod_que = '<a class="GenLink" href="http://thelocust.org/bored/index.php?t=modque&'._rsid.'">Moderation Queue</a> <span class="GenText" style="color: #ff0000">('.$approve_count.')</span>';
		
		if( $GLOBALS["usr"]->is_mod == 'A' ) {
			if( $avatar_count = q_singleval("SELECT count(*) FROM fud21_users WHERE avatar_approved='N'") ) 
				$custom_avatar_queue = '| <a class="GenLink" href="adm/admapprove_avatar.php?'._rsid.'">Custom Avatar Queue</a> <span class="GenText" style="color: #ff0000">('.$avatar_count.')</span>';
	
			if( $report_count = q_singleval("SELECT count(*) FROM fud21_msg_report") ) 
				$reported_msgs = '| <a class="GenLink" href="http://thelocust.org/bored/index.php?t=reported&'._rsid.'">Reported Messages</a> <span class="GenText" style="color: #ff0000">('.$report_count.')</span>';
				
			if( $thr_exchc = q_singleval("SELECT count(*) FROM fud21_thr_exchange") )
				$thr_exch = '| <a class="GenLink" href="http://thelocust.org/bored/index.php?t=thr_exch&'._rsid.'">Thread Exchange </a> <span class="GenText" style="color: #ff0000">('.$thr_exchc.')</span>';
		}	
		else {
			if( $report_count = q_singleval("SELECT count(*) FROM fud21_msg_report INNER JOIN fud21_msg ON fud21_msg_report.msg_id=fud21_msg.id INNER JOIN fud21_thread ON fud21_msg.thread_id=fud21_thread.id INNER JOIN fud21_mod ON fud21_thread.forum_id=fud21_mod.forum_id AND fud21_mod.user_id=".$GLOBALS["usr"]->id) )
				$reported_msgs = '| <a class="GenLink" href="http://thelocust.org/bored/index.php?t=reported&'._rsid.'">Reported Messages</a> <span class="GenText" style="color: #ff0000">('.$report_count.')</span>';
			
			if( $thr_exchc = q_singleval("SELECT count(*) FROM fud21_thr_exchange INNER JOIN fud21_mod ON fud21_mod.user_id=".$usr->id." AND fud21_thr_exchange.frm=fud21_mod.forum_id") ) 
				$thr_exch = '| <a class="GenLink" href="http://thelocust.org/bored/index.php?t=thr_exch&'._rsid.'">Thread Exchange </a> <span class="GenText" style="color: #ff0000">('.$thr_exchc.')</span>';
		}
	}
	if( $usr->is_mod=='A' || bq("SELECT id FROM fud21_group_members WHERE user_id="._uid." AND group_leader='Y' LIMIT 1") )
		$group_mgr = '| <a class="GenLink" href="http://thelocust.org/bored/index.php?t=groupmgr&'._rsid.'">Group(s) Manager</a>';
	
	if( $thr_exch || $group_mgr || $reported_msgs || $custom_avatar_queue || $mod_que ) $admin_cp = '<br><font class="GenText"><b>Admin :</b></font> '.$mod_que.' '.$reported_msgs.' '.$thr_exch.' '.$custom_avatar_queue.' '.$group_mgr;
}$adm_str = $rid = $pm = '';
	$ret_to = '&returnto='.urlencode(!empty($GLOBALS['returnto'])?urldecode($GLOBALS['returnto']):$GLOBALS['HTTP_SERVER_VARS']['REQUEST_URI']);

	if ( empty($GLOBALS['usr']) ) {
		$login_n_logout = '<td valign="middle"><a class="UserControlPanel" href="http://thelocust.org/bored/index.php?t=login&'._rsid.$ret_to.'"><img src="http://thelocust.org/bored/theme/default/images/top_login.gif" border=0 alt="Login"></a></td>
<td valign="middle"><a class="UserControlPanel" href="http://thelocust.org/bored/index.php?t=login&'._rsid.$ret_to.'">Login</a></td>';
		$register_n_profile = '<td valign="middle"><a class="UserControlPanel" href="http://thelocust.org/bored/index.php?t=register&'._rsid.'"><img src="http://thelocust.org/bored/theme/default/images/top_register.gif" border=0 alt="Register"></a></td>
<td valign="middle"><a class="UserControlPanel" href="http://thelocust.org/bored/index.php?t=register&'._rsid.'">Register</a></td>';
	}
	else {
		if( $GLOBALS['usr']->is_mod == 'A' ) $admin_control_panel = '<td>&nbsp;&nbsp;</td><td valign="middle"><a class="UserControlPanel" href="adm/admglobal.php?'._rsid.'"><img src="http://thelocust.org/bored/theme/default/images/top_admin.gif" border=0 alt="Admin Control Panel"></a></td>
<td valign="middle"><a class="UserControlPanel" href="adm/admglobal.php?'._rsid.'">Admin Control Panel</a></td>';
		$user_login = htmlspecialchars($usr->alias);
		$login_n_logout = '<td valign="middle"><a class="UserControlPanel" href="http://thelocust.org/bored/index.php?t=login&'._rsid.$ret_to.'&logout=1"><img src="http://thelocust.org/bored/theme/default/images/top_logout.gif" border=0 alt="Logout"></a></td>
<td valign="middle"><a class="UserControlPanel" href="http://thelocust.org/bored/index.php?t=login&'._rsid.$ret_to.'&logout=1">Logout [ '.$user_login.' ]</a></td>';
		$register_n_profile = '<td valign="middle"><a class="UserControlPanel" href="http://thelocust.org/bored/index.php?t=register&'._rsid.'"><img src="http://thelocust.org/bored/theme/default/images/top_profile.gif" border=0 title="Click here to access user control panel" alt="Profile"></a></td>
<td valign="middle"><a class="UserControlPanel" href="http://thelocust.org/bored/index.php?t=register&'._rsid.'"><acronym title="Click here to access user control panel">Profile</acronym></a></td>';
		$rid = $GLOBALS["usr"]->id;
		
		if ( $GLOBALS['PM_ENABLED']=='Y' ) {
			$c = q_singleval("SELECT count(*) FROM fud21_pmsg WHERE duser_id=".$GLOBALS["usr"]->id." AND folder_id='INBOX' AND read_stamp=0");
			$private_msg = ( $c ) ? '<td>&nbsp;&nbsp;</td>
<td valign="middle"><a href="http://thelocust.org/bored/index.php?t=pmsg&'._rsid.'" class="UserControlPanel"><img src="http://thelocust.org/bored/theme/default/images/top_pm.gif" border=0 alt="Private Messaging"></a></td>
<td><a href="http://thelocust.org/bored/index.php?t=pmsg&'._rsid.'" class="UserControlPanel">You have <span class="GenText" style="color: #ff0000">('.$c.')</span> unread private message(s)</a></td>
<td>&nbsp;&nbsp;</td>' : '<td>&nbsp;&nbsp;</td>
<td valign="middle"><a href="http://thelocust.org/bored/index.php?t=pmsg&'._rsid.'" class="UserControlPanel"><img src="http://thelocust.org/bored/theme/default/images/top_pm.gif" border=0 alt="Private Messaging"></a></td>
<td><a href="http://thelocust.org/bored/index.php?t=pmsg&'._rsid.'" class="UserControlPanel">Private Messaging</a></td>
<td>&nbsp;&nbsp;</td>';
		}
	}/* FILE START */
	
	if( $usr->is_mod == 'A' || ($usr->is_mod == 'Y' && bq("SELECT fud21_mod.user_id FROM fud21_thread INNER JOIN fud21_mod ON fud21_thread.forum_id=fud21_mod.forum_id AND fud21_mod.user_id=".$usr->id)) ) 
		$MOD = 1;
	else {
		$GLOBALS['__RESOURCE_ID'] = q_singleval("SELECT forum_id FROM fud21_thread WHERE id=".$th);
		if( !is_perms(_uid, $GLOBALS['__RESOURCE_ID'], 'SPLIT') )
			error_dialog('Permission Denied!', 'Your user permissions do not allow you to perform the action you are attempting.', '');
	}
	
	if( !empty($HTTP_POST_VARS['new_title']) && ($mc=count($HTTP_POST_VARS['sel_th'])) ) {
		sort($HTTP_POST_VARS['sel_th']);
		reset($HTTP_POST_VARS['sel_th']);
		
		$mids = '';
		while( list(,$mid) = each($HTTP_POST_VARS['sel_th']) ) $mids .= $mid.',';
		$mids = substr($mids, 0, -1);	
		
		$src_frm = new fud_forum;
		$dst_frm = new fud_forum;
		$old_thr = new fud_thread;
		
		$old_thr->get_by_id($th);
		$src_frm->get($old_thr->forum_id);
		$dst_frm->get($forum);
		
		if( $mc != ($old_thr->replies+1) ) {
			if ( defined('db_locked') && constant('db_locked') ) {
				db_lock('fud21_thread_view+, fud21_thread+, fud21_forum+, fud21_msg+');
				$local_lock = 1;
			}
			
			$thr = new fud_thread;
			$thr->add($HTTP_POST_VARS['sel_th'][0], $dst_frm->id);
		
			/* Deal with the new thread */
			q("UPDATE fud21_msg SET thread_id=".$thr->id." WHERE id IN (".$mids.")");
			q("UPDATE fud21_msg SET reply_to=".$HTTP_POST_VARS['sel_th'][0]." WHERE thread_id=".$thr->id." AND reply_to NOT IN (".$mids.")");
			q("UPDATE fud21_msg SET reply_to=0, subject='".htmlspecialchars($HTTP_POST_VARS['new_title'])."' WHERE id=".$HTTP_POST_VARS['sel_th'][0]);
			list($lpi, $lpd) = db_singlearr(q("SELECT id,post_stamp FROM fud21_msg WHERE id=".$HTTP_POST_VARS['sel_th'][$mc-1]));
			q("UPDATE fud21_thread SET replies=".($mc-1).", last_post_date=".$lpd.", last_post_id=".$lpi." WHERE id=".$thr->id);
		
			/* Deal with the old thread */
			list($lpi, $lpd) = db_singlearr(q("SELECT id,post_stamp FROM fud21_msg WHERE thread_id=".$old_thr->id." AND approved='Y' ORDER BY post_stamp DESC LIMIT 1"));
			$old_root_msg_id = q_singleval("SELECT id FROM fud21_msg WHERE thread_id=".$old_thr->id." AND approved='Y' ORDER BY post_stamp ASC LIMIT 1");
			q("UPDATE fud21_msg SET reply_to=".$old_root_msg_id." WHERE thread_id=".$old_thr->id." AND reply_to IN(".$mids.")");
			q("UPDATE fud21_msg SET reply_to=0 WHERE id=".$old_root_msg_id);
			q("UPDATE fud21_thread SET root_msg_id=".$old_root_msg_id.", replies=replies-".$mc.", last_post_date=".$lpd.", last_post_id=".$lpi." WHERE id=".$old_thr->id);
		
			if( $src_frm->id != $dst_frm->id ) {
				$old_frm_lpi = q_singleval("SELECT last_post_id FROM fud21_thread WHERE forum_id=".$src_frm->id);
				$new_frm_lpi = q_singleval("SELECT last_post_id FROM fud21_thread WHERE forum_id=".$dst_frm->id);
		
				q("UPDATE fud21_forum SET last_post_id=".$old_frm_lpi.", post_count=post_count-".$mc.", thread_count=thread_count-1 WHERE id=".$src_frm->id);
				q("UPDATE fud21_forum SET last_post_id=".$new_frm_lpi.", post_count=post_count+".$mc.", thread_count=thread_count+1 WHERE id=".$dst_frm->id);
		
				rebuild_forum_view($src_frm->id, q_singleval("SELECT page FROM fud21_thread_view WHERE forum_id=".$src_frm->id." AND thread_id=".$th));
			}
			else {
				q("UPDATE fud21_forum SET thread_count=thread_count+1 WHERE id=".$src_frm->id);
			}
			rebuild_forum_view($dst_frm->id);
			
			if ( !empty($local_lock) ) db_unlock();
			$th_id = $thr->id;
			logaction($usr->id, 'THRSPLIT', $thr->id);
		}
		else {
			q("UPDATE fud21_msg SET subject='".htmlspecialchars($HTTP_POST_VARS['new_title'])."' WHERE id=".$old_thr->root_msg_id);
			if( $src_frm->id != $dst_frm->id ) { 			
				if ( $src_frm->last_post_id == $old_thr->last_post_id ) {
					$mid = q_singleval("SELECT last_post_id FROM fud21_thread WHERE forum_id=".$src_frm->id." AND last_post_date=".q_singleval("select MAX(last_post_date) FROM fud21_thread WHERE forum_id=".$src_frm->id));
					if( empty($mid) ) $mid = 0;
					q("UPDATE fud21_forum SET last_post_id=".$mid." WHERE id=".$src_frm->id);
				}
		
				$old_thr->move($forum);
		
				if( $dst_frm->last_post_id < $old_thr->last_post_id ) q("UPDATE fud21_forum SET last_post_id=".$old_thr->last_post_id." WHERE id=".$dst_frm->id);
			}
			
			$th_id = $old_thr->id;
		}
		header("Location: http://thelocust.org/bored/index.php?t=msg&th=".$th_id."&"._rsid);
		exit;
	}
	
	$r = q("SELECT 
			fud21_msg.*,
			fud21_users.alias AS login 
		FROM 
			fud21_msg 
		LEFT JOIN fud21_users
			ON fud21_msg.poster_id=fud21_users.id
		WHERE
			thread_id=".$th." AND approved='Y'
		ORDER BY 
			post_stamp ASC
		");
	
	if ( $usr->is_mod == 'A' ) {
		$fr = q("SELECT fud21_forum.id, fud21_forum.name FROM fud21_forum INNER JOIN fud21_cat ON fud21_forum.cat_id=fud21_cat.id ORDER BY fud21_cat.view_order, fud21_forum.view_order");
		while ( $obj = db_rowobj($fr) ) $fl[] = $obj;
	}
	else {
		$fr = q("SELECT fud21_forum.id, fud21_forum.name FROM fud21_group_cache INNER JOIN fud21_forum ON fud21_group_cache.resource_id=fud21_forum.id AND fud21_group_cache.resource_type='forum' WHERE user_id="._uid." AND p_SPLIT='Y'");
		while ( $obj = db_rowobj($fr) ) $fl[] = $obj;
		
		if( $usr->is_mod == 'Y' ) {
			$fr2 = q("SELECT fud21_forum.id, fud21_forum.name FROM fud21_mod INNER JOIN fud21_forum ON fud21_mod.forum_id=fud21_forum.id INNER JOIN fud21_cat ON fud21_forum.cat_id=fud21_cat.id WHERE fud21_mod.user_id=".$usr->id." ORDER BY fud21_cat.view_order, fud21_forum.view_order");
			while ( $obj = db_rowobj($fr2) ) $fl[] = $obj;
			qf($fr2);
		}		
	}
	qf($fr);	

	reset($fl);
	$vl = $kl = '';
	while( list(,$obj) = each($fl) ) {
		$vl .= $obj->id."\n";
		$kl .= $obj->name."\n";
	}
	
	$vl = substr($vl, 0, -1);
	$kl = substr($kl, 0, -1);
		
	if( empty($forum) ) 
		$forum = q_singleval("SELECT fud21_forum.id FROM fud21_thread INNER JOIN fud21_forum ON fud21_thread.forum_id=fud21_forum.id WHERE fud21_thread.id=".$th);
	
	$forum_sel = tmpl_draw_select_opt($vl, $kl, $forum, '', '');
	
	$msg_entry = '';
	
	while( $obj = db_rowobj($r) ) {
		$msg_body = read_msg_body($obj->foff,$obj->length, $obj->file_id);
		$msg_entry .= '<tr>
<td class="RowStyleC" valign="top" align="center"><input type="checkbox" name="sel_th[]" value="'.$obj->id.'"></td>
<td class="RowStyleA">
<table cellspacing=1 cellpadding=2 border=0 class="ContentTable">
<tr class="RowStyleB">
	<td><font size="-1">
	<b>Post By:</b> '.htmlspecialchars($obj->login).'<br>
	<b>Posted On:</b> '.strftime("%a, %d %B %Y %H:%M", $obj->post_stamp).'<br>
	<b>Subject:</b> '.$obj->subject.'
	</font></td>
</tr>
<tr class="RowStyleA">
	<td>'.$msg_body.'</td>
</tr>
</table>
</td>
</tr>';
	}
	un_register_fps();
	qf($r);	
	
	$page_gen_time = (db_getmicrotime() - $GLOBALS['PAGE_TIME']);
$q_time = query_count();
$ttl_time = total_time();

if ( isset($usr) && $usr->is_mod == 'A' )
	$page_stats = '<br><div align="left" class="SmallText">'.$q_time.' MySQL queries took '.$ttl_time.' seconds<br>Total time taken to generate the page: '.$page_gen_time.' seconds</div>';
else if ( $GLOBALS['PUBLIC_STATS'] == 'Y' ) 
	$page_stats = '<br><div align="left" class="SmallText">'.$q_time.' MySQL queries took '.$ttl_time.' seconds<br>Total time taken to generate the page: '.$page_gen_time.' seconds</div>';	
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<title><?php echo $GLOBALS['FORUM_TITLE']; ?><?php echo $TITLE_EXTRA; ?></title>
<META HTTP-EQUIV="Content-Type" CONTENT="text/html; charset=ISO-8859-15">
<script language="javascript" src="lib.js"></script>
<link rel="StyleSheet" href="http://thelocust.org/bored/theme/default/forum.css" type="text/css">
</head>
<body topmargin="2" leftmargin="2" marginheight="2" marginwidth="2">
<table width="100%" border="0" cellspacing="3" cellpadding="5"><tr><td class="ForumBackground">
<table border=0 cellspacing=0 cellpadding=0 width="100%"><tr><td align="right">
<table cellspacing=3 cellpadding=0 border=0>
	<tr>
		<td valign="middle"><a class="UserControlPanel" href="http://thelocust.org/bored/index.php?t=help_index&<?php echo _rsid; ?>"><img src="http://thelocust.org/bored/theme/default/images/top_help.gif" border=0 alt="F.A.Q."></a></td>
		<td valign="middle"><a class="UserControlPanel" href="http://thelocust.org/bored/index.php?t=help_index&<?php echo _rsid; ?>">F.A.Q.</a></td>
		<td>&nbsp;&nbsp;</td>
		<?php echo $register_n_profile; ?>
		<td>&nbsp;&nbsp;</td>
		<?php echo $login_n_logout; ?>
		<td>&nbsp;&nbsp;</td>
		<td valign="middle"><a class="UserControlPanel" href="http://thelocust.org/bored/index.php?t=index&<?php echo _rsid; ?>"><img src="http://thelocust.org/bored/theme/default/images/top_home.gif" border=0 alt="Home"></a></td>
		<td valign="middle"><a class="UserControlPanel" href="http://thelocust.org/bored/index.php?t=index&<?php echo _rsid; ?>">Home</a></td>
	</tr>
</table>
<table cellspacing=3 cellpadding=0 border=0>	
	<tr>	
		<?php echo $private_msg; ?>
		<td valign="middle"><a class="UserControlPanel" href="http://thelocust.org/bored/index.php?t=finduser&btn_submit=Find&<?php echo _rsid; ?>"><img src="http://thelocust.org/bored/theme/default/images/top_members.gif" border=0 alt="Members"></a></td>
		<td valign="middle"><a class="UserControlPanel" href="http://thelocust.org/bored/index.php?t=finduser&btn_submit=Find&<?php echo _rsid; ?>">Members</a></td>
		<td>&nbsp;&nbsp;</td>
		<td valign="middle"><a class="UserControlPanel" href="http://thelocust.org/bored/index.php?t=search&<?php echo _rsid; ?>"><img src="http://thelocust.org/bored/theme/default/images/top_search.gif" border=0 alt="Search"></a></td>
		<td valign="middle"><a class="UserControlPanel" href="http://thelocust.org/bored/index.php?t=search&<?php echo _rsid; ?>">Search</a></td>
		<?php echo $admin_control_panel; ?>
	</tr>
</table></td></tr></table>
<br><?php echo $admin_cp; ?>
<table border="0" cellspacing="1" cellpadding="2" class="ContentTable">
<form name="split_th" action="http://thelocust.org/bored/index.php?t=split_th" method="post">
<?php echo _hs; ?>
<input type="hidden" name="th" value="<?php echo $th; ?>">
<tr><th width="100%" colspan=2>Thread Split Control Panel</th></tr>
<tr class="RowStyleA">
	<td align="left"><b>New thread title:</b></td>
	<td ><input type="text" name="new_title" value="<?php echo $new_title; ?>" size=50></td>
</tr>
<tr class="RowStyleA">
	<td align="left"><b>Forum:</b></td>
	<td align="left"><select name="forum"><?php echo $forum_sel; ?></select></td>
</tr>
<tr class="RowStyleC">
	<td colspan=2 align="center">
		<input type="submit" class="button" name="btn_selected" value="Split selected messages">
		&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
		<input type="submit" class="button" name="btn_unselected" value="Split non-selected messages">
	</td>
</tr>
</table>
<br>
<table border="0" cellspacing="1" cellpadding="2" class="ContentTable">
<tr><th nowrap>Messages</th><th width="100%">Select</th></tr>
<?php echo $msg_entry; ?>
</table>
<br>
<table border="0" cellspacing="1" cellpadding="2" class="ContentTable">
<tr class="RowStyleC">
	<td colspan=2 align="center">
		<input type="submit" class="button" name="btn_selected" value="Split selected messages">
		&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
		<input type="submit" class="button" name="btn_unselected" value="Split non-selected messages">
	</td>
</tr>
</table>
</form>
<br><table bgcolor="#000000" border=0 cellspacing=1 cellpadding=1 align="center"><tr class="RowStyleA"><td class="SmallText"><b>Current Time:</b> 
<?php echo strftime("%a %b %e %H:%M:%S %Z %Y", __request_timestamp__); ?>
</td></tr></table>
<?php echo $page_stats; ?>
</td></tr></table>
<table width="100%" border="0" cellspacing="3" cellpadding="5"><tr><td class="ForumBackground" align="center">
<b>.::</b> <a href="mailto:<?php echo $GLOBALS['ADMIN_EMAIL']; ?>">Contact</a> <b>::</b> <a href="http://thelocust.org/bored/index.php?t=index&<?php echo _rsid; ?>">Home</a> <b>::.</b>
<p>
<span class="SmallText">Powered by: FUDforum <?php echo $GLOBALS['FORUM_VERSION']; ?><br>Copyright &copy;2001,2002 <a href="http://fud.prohost.org/" class="GenLink">Advanced Internet Designs Inc.</a></span>
</td></tr></table>
</body>
</html>