<?php
/***************************************************************************
*   copyright            : (C) 2001,2002 Advanced Internet Designs Inc.
*   email                : forum@prohost.org
*
*   $Id: thread.php.t,v 1.3 2002/07/08 23:15:19 hackie Exp $
****************************************************************************
          
****************************************************************************
*
*	This program is free software; you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation; either version 2 of the License, or
*	(at your option) any later version.
*
***************************************************************************/

	include_once "GLOBALS.php";
	if ( !defined('__index_page_start__') ) exit('sorry, you can not access this page');function pager_replace(&$str, $s, $c)
{
	$str = str_replace('%s', $s, $str);
	$str = str_replace('%c', $c, $str);
}

function tmpl_create_pager($start, $count, $total, $arg, $suf='', $append=1, $js_pager=FALSE)
{
	if ( $total <= $count ) return;
	if ( !$count ) $count = $GLOBALS["POSTS_PER_PAGE"];
	
	$cur_pg = ceil($start/$count);
	$ttl_pg = ceil($total/$count);
	
	$page_pager_data='';
	
	if ( $start-$count > -1 ) {
		$page_start = $start-$count;
		if ( $append ) {
			$page_first_url = $arg.'&start=0&count='.$count.$suf;
			$page_prev_url = $arg.'&start='.$page_start.'&count='.$count.$suf;
		}
		else {
			$page_first_url = $arg;
			$page_prev_url = $arg;
			pager_replace($page_first_url, 0, $count);
			pager_replace($page_prev_url, $page_start, $count);
		}
		
		$page_pager_data .= (!$js_pager)?'&nbsp;<a href="'.$page_first_url.'" class="PagerLink">&laquo</a>&nbsp;&nbsp;<a href="'.$page_prev_url.'" class="PagerLink">&lt;</a>&nbsp;&nbsp;':'&nbsp;<a href="javascript://" onClick="'.$page_first_url.'" class="PagerLink">&laquo</a>&nbsp;&nbsp;<a href="'.$page_prev_url.'" class="PagerLink">&lt;</a>&nbsp;&nbsp;';
	}	

	$mid = ceil($GLOBALS["GENERAL_PAGER_COUNT"]/2);
	
	if( $ttl_pg > $GLOBALS["GENERAL_PAGER_COUNT"] ) {
		if( ($mid+$cur_pg)>=$ttl_pg ) {
			$end = $ttl_pg;
			$mid += ($mid+$cur_pg)-$ttl_pg;
			$st = $cur_pg-$mid;
		}
		else if( ($cur_pg-$mid)<=0 ) {
			$st = 0;				
			$mid += $mid-$cur_pg;
			$end = $mid+$cur_pg;
		}
		else {
			$st = $cur_pg-$mid;
			$end = $mid+$cur_pg;
		}
		
		if( $st < 0 ) $start = 0;
		if( $end > $ttl_pg ) $end = $ttl_pg;
	}
	else {
		$end = $ttl_pg;
		$st = 0;
	}
	
	
	while ( $st<$end ) {
		if( $st != $cur_pg ) {
			$page_start = $st*$count;
			$st++;
			if ( $append ) {
				$page_page_url = $arg.'&start='.$page_start.'&count='.$count.$suf;
			}
			else {
				$page_page_url = $arg;
				pager_replace($page_page_url, $page_start, $count);
			}
			$page_pager_data .= (!$js_pager)?'<a href="'.$page_page_url.'" class="PagerLink">'.$st.'</a>&nbsp;&nbsp;':'<a href="javascript://" onClick="'.$page_page_url.'" class="PagerLink">'.$st.'</a>&nbsp;&nbsp;';
		}
		else {
			$st++;
			$page_pager_data .= (!$js_pager)?''.$st.'&nbsp;&nbsp;':''.$st.'&nbsp;&nbsp;';
		}	
	}
	
	if ( !$js_pager )
		$page_pager_data = substr($page_pager_data,0,strlen('&nbsp;&nbsp;')*-1);
	else 
		$page_pager_data = substr($page_pager_data,0,strlen('&nbsp;&nbsp;')*-1);
		
	if ( ($start+$count)<$total ) { 
		$page_start = $start+$count;
		$page_start_2 = ($st-1)*$count;
		if ( $append ) {
			$page_next_url = $arg.'&start='.$page_start.'&count='.$count.$suf;
			$page_last_url = $arg.'&start='.$page_start_2.'&count='.$count.$suf;
		}
		else {
			$page_next_url = $arg;
			$page_last_url = $arg;
			pager_replace($page_next_url, $page_start, $count);
			pager_replace($page_last_url, $page_start_2, $count);
		}
		$page_pager_data .= (!$js_pager)?'&nbsp;&nbsp;<a href="'.$page_next_url.'" class="PagerLink">&gt;</a>&nbsp&nbsp;<a href="'.$page_last_url.'" class="PagerLink">&raquo;</a>':'&nbsp;&nbsp;<a href="javascript://" onClick="'.$page_next_url.'" class="PagerLink">&gt;</a>&nbsp&nbsp;<a href="'.$page_last_url.'" class="PagerLink">&raquo;</a>';
	}
	
	return (!$js_pager)?'<font class="SmallText"><b>Pages ('.$ttl_pg.'): 
['.$page_pager_data.']
</b></font>':'<font class="SmallText"><b>Pages ('.$ttl_pg.'): 
['.$page_pager_data.']
</b></font>';
}function get_all_perms($usr_id)
{
	$fl = '';

	if( empty($usr_id) ) {
		$r = q("SELECT resource_id FROM fud21_group_cache WHERE user_id=0 AND resource_type='forum' AND p_READ='Y' AND p_VISIBLE='Y'");
		while( list($resource_id) = db_rowarr($r) ) $fl .= $resource_id.',';		
	}
	else {
		$tmp_arr = array();
		$r = q("SELECT user_id,resource_id,p_read,p_visible FROM fud21_group_cache WHERE user_id IN(".$usr_id.",2147483647) AND resource_type='forum' ORDER BY user_id");
		while( $obj = db_rowobj($r) ) {
			if( $obj->p_read == 'Y' && $obj->p_read == 'Y' && ($obj->user_id == $usr_id || !isset($tmp_arr[$obj->resource_id])) ) 
				$fl .= $obj->resource_id.',';

			$tmp_arr[$obj->resource_id] = 1;	
		}		
	}
	qf($r);
	
	if( !empty($fl) ) $fl = substr($fl, 0, -1);
	
	return $fl;
}

function forum_perm_array($forum_id)
{
 	$r = q("SELECT p_READ AS p_read, user_id FROM fud21_group_cache WHERE resource_type='forum' AND resource_id=$forum_id AND user_id>0");
	while ( $obj = db_rowobj($r) ) $p[$obj->user_id] = $obj->p_read;
	qf($r);
	
	return $p;
}

function is_allowed($user_id, $p)
{
	if ( isset($p[$user_id]) && $p[$user_id] != 'Y' ) 
		return 0;
	else if ( $p[$user_id] != 'Y' && $p['2147483647'] == 'N' ) 
		return 0;
	
	return 1;
}class fud_forum
{
	var $id=NULL;
	var $cat_id=NULL;
	var $name=NULL;
	var $descr=NULL;
	var $passwd_posting=NULL;
	var $post_passwd=NULL;
	var $anon_forum=NULL;
	var $forum_icon=NULL;
	var $tag_style=NULL;
	var $last_post_id=NULL;
	
	var $allow_polls=NULL;
	var $date_created=NULL;
	var $thread_count=NULL;
	var $view_order=NULL;
	var $message_threshold=NULL;
	
	var $moderated=NULL;
	var $max_attach_size=NULL;
	var $max_file_attachments=NULL;
	
	var $forums=NULL;
	var $cur_frm=NULL;
	
	var $locked=NULL;
	
	
	function get($id)
	{
		qobj("SELECT * FROM fud21_forum WHERE fud21_forum.id=".$id, $this);
		if( empty($this->id) ) invl_inp_err();
			
		return $id;		
	}
	
	function is_moderator($user_id)
	{
		return q_singleval("SELECT id FROM fud21_mod WHERE user_id=".$user_id." AND forum_id=".$this->id);
	}
	
	function inc_reply_count($val)
	{
		q("UPDATE fud21_forum SET post_count=post_count+".$val." WHERE id=".$this->id);
	}
	
	function dec_reply_count($val)
	{
		q("UPDATE fud21_forum SET post_count=post_count-".$val." WHERE id=".$this->id);
	}
	
	function inc_thread_count($val)
	{
		q("UPDATE fud21_forum SET thread_count=thread_count+".$val." WHERE id=".$this->id);
	}
	
	function dec_thread_count($val)
	{
		q("UPDATE fud21_forum SET thread_count=thread_count-".$val." WHERE id=".$this->id);
	}
	
	function get_notify_list($user_id)
	{
		$r = q("SELECT 
				fud21_users.email, 
				fud21_users.icq, 
				fud21_users.notify_method 
			FROM 
				fud21_forum_notify 
				INNER JOIN fud21_users 
					ON fud21_forum_notify.user_id=fud21_users.id 
			WHERE 
				fud21_forum_notify.forum_id=".$this->id." 
				AND fud21_forum_notify.user_id!=".$user_id);
		
		$p = forum_perm_array($this->id);
		$to=NULL;
		while ( $obj = db_rowobj($r) ) {
			if ( !is_allowed($obj->user_id, $p) ) continue;
			
			$to[$obj->notify_method][] = ( $obj->notify_method == 'EMAIL' ) ? $obj->email : $obj->icq.'@pager.icq.com';
		}

		qf($r);
				
		return $to;
	}
	
}

if ( defined('admin_form') && !defined("_forum_adm_inc_") ) fud_use('forum_adm.inc');function create_return()
{
	return '<input type="hidden" name="returnto" value="'.urldecode($GLOBALS['returnto']).'">';
}
        
function check_return()
{
        if ( empty($GLOBALS['returnto']) ) 
        	$GLOBALS['returnto']='index.php?'._rsid;
        else if ( !strstr($GLOBALS['returnto'], 'S=') ) {
        	if ( !strstr($GLOBALS['returnto'], '?') ) 
	         	$GLOBALS['returnto'] .= '?'._rsid;
	        else
	        	$GLOBALS['returnto'] .= '&'._rsid;
        }
        header("Location: ".$GLOBALS['returnto']);
	exit();
}class fud_cat
{
	var $id=NULL;
	var $name=NULL;
	var $description=NULL;
	var $allow_collapse=NULL;
	var $default_view=NULL;
	var $view_order=NULL;
	
	var $cat_list;
	var $cur_cat;

	function get_cat($id)
	{
		qobj("SELECT * FROM fud21_cat WHERE id=".$id, $this);
		return $this->id;
	}
}

if ( defined('admin_form') && !defined("_cat_adm_inc_") ) fud_use('cat_adm.inc');function fetch_vars($pref, &$obj, $arr)
{
	reset($obj);
	while ( list($k, $v) = each($obj) ) {
		if ( isset($arr[$pref.$k]) ) $obj->{$k} = $arr[$pref.$k];
	}
}
	
function export_vars($pref, &$obj)
{
	reset($obj);
	while ( list($k, $v) = each($obj) ) {
		if ( isset($obj->{$k}) ) $GLOBALS[$pref.$k] = $v;
	}
}

function empty_object(&$obj)
{
	reset($obj);
	while ( list($k, $v) = each($obj) ) $obj->{$k} = NULL;
}class fud_thread
{
	var $id=NULL;
	var $forum_id=NULL;
	var $root_msg_id=NULL;
	var $last_post_date=NULL;
	var $replies=NULL;
	var $views=NULL;
	var $rating=NULL;
	var $last_post_id=NULL;
	var $locked=NULL;
	var $is_sticky=NULL;
	var $ordertype=NULL;
	var $orderexpiry=NULL;
	
	var $subject=NULL;
	var $db_thread=NULL;
	
	function add($root, $forum_id, $locked=NULL, $is_sticky=NULL, $ordertype=NULL, $orderexpiry=NULL) 
	{
		$r = q("INSERT INTO 
			fud21_thread(
				forum_id, 
				root_msg_id, 
				last_post_date, 
				replies, 
				views, 
				rating, 
				last_post_id,
				locked, 
				is_sticky,
				ordertype,
				orderexpiry
			)
			VALUES
			(
				".$forum_id.",
				".$root.",
				".__request_timestamp__.",
				0,
				0,
				0,
				".$root.",
				'".yn($locked)."',
				'".yn($is_sticky)."',
				".ifnull($ordertype, "'NONE'").",
				".intzero($orderexpiry)."
			)");
		
		$this->id = db_lastid("fud21_thread", $r);
		
		return $this->id;
	}
	
	function sync()
	{
		list($old_sticky,$forum_id) = db_singlearr(q("SELECT is_sticky,forum_id FROM fud21_thread WHERE id=".$this->id));
	
		q("UPDATE fud21_thread SET 
			is_sticky='".yn($this->is_sticky)."',
			ordertype=".ifnull($this->ordertype, "'NONE'").",
			orderexpiry=".intnull($this->orderexpiry).",
			locked='".yn($this->locked)."'
		WHERE id=".$this->id);
		
		if( $old_sticky != yn($this->is_sticky) ) rebuild_forum_view($forum_id);
	}
	
	function get_by_id($id)
	{
		$result = qobj("SELECT 
				fud21_thread.*,
				fud21_msg.subject
			FROM 
				fud21_thread 
				LEFT JOIN fud21_msg 
					ON fud21_thread.root_msg_id=fud21_msg.id 
				LEFT JOIN fud21_forum 
					ON fud21_thread.forum_id=fud21_forum.id 
				LEFT JOIN fud21_cat 
					ON fud21_forum.cat_id=fud21_cat.id 
			WHERE 
				fud21_thread.id=".$id, $this);
		if ( empty($this->id) ) error_dialog('Invalid thread ID','You\'ve followed an invalid link, the thread you are trying to view does not exist.','', 'FATAL');
	}

	function delete($rebuild_view=TRUE)
	{
		$msg = new fud_msg_edit;
		qobj("SELECT * FROM fud21_msg WHERE id=".$this->root_msg_id, $msg);
		if( !empty($msg->id) )
			$msg->delete(FALSE);
		else {
			q("DELETE FROM fud21_thread WHERE id=".$this->id);
			$tc = q_singleval("SELECT count(*) FROM fud21_thread INNER JOIN fud21_msg ON fud21_thread.root_msg_id=fud21_msg.id WHERE forum_id=".$this->forum_id." AND fud21_msg.approved='Y'");
			$mc = q_singleval("SELECT SUM(replies) FROM fud21_thread INNER JOIN fud21_msg ON fud21_thread.root_msg_id=fud21_msg.id WHERE forum_id=".$this->forum_id." AND fud21_msg.approved='Y'");
			$mc += $tc;
			$lpi = q_singleval("SELECT MAX(last_post_id) FROM fud21_thread INNER JOIN fud21_msg ON fud21_thread.root_msg_id=fud21_msg.id WHERE forum_id=".$this->forum_id." AND fud21_msg.approved='Y'");
			q("UPDATE fud21_forum SET post_count=".intzero($mc).", last_post_id=".intzero($lpi).", thread_count=".intzero($tc)." WHERE id=".$this->forum_id);
		}	
		
		if( $rebuild_view ) rebuild_forum_view($this->forum_id);
	}
	
	function lock()
	{
		q("UPDATE fud21_thread SET locked='Y' WHERE id=".$this->id);
	}
	
	function unlock()
	{
		q("UPDATE fud21_thread SET locked='N' WHERE id=".$this->id);
	}
	
	function move($to_forum)
	{
		if ( !db_locked() ) {
			db_lock('fud21_thread_view+, fud21_thread+, fud21_forum+, fud21_msg+');
			$local_lock = 1;
		}
		$msg_count = q_singleval("SELECT count(*) FROM fud21_thread LEFT JOIN fud21_msg ON fud21_msg.thread_id=fud21_thread.id WHERE fud21_msg.approved='Y' AND fud21_thread.id=".$this->id);
		
		q("UPDATE fud21_thread SET forum_id=".$to_forum." WHERE id=".$this->id);
		q("UPDATE fud21_forum SET post_count=post_count-".$msg_count." WHERE id=".$this->forum_id);
		q("UPDATE fud21_forum SET thread_count=thread_count+1,post_count=post_count+".$msg_count." WHERE id=".$to_forum);
		$r=q("DELETE FROM fud21_thread WHERE forum_id=".$to_forum." AND root_msg_id=".$this->root_msg_id." AND moved_to=".$this->forum_id);
		if( $aff_rows=db_affected($r) ) q("UPDATE fud21_forum SET thread_count=thread_count-".$aff_rows." WHERE id=".$to_forum);
		q("UPDATE fud21_thread SET moved_to=".$to_forum." WHERE id!=".$this->id." AND root_msg_id=".$this->root_msg_id);
		
		q("INSERT INTO fud21_thread(
			forum_id,
			root_msg_id,
			last_post_date,
			last_post_id,
			moved_to
		)
		VALUES(
			".$this->forum_id.",
			".$this->root_msg_id.",
			".$this->last_post_date.",
			".$this->last_post_id.",
			".$to_forum."
		)");
		
		rebuild_forum_view($this->forum_id);
		rebuild_forum_view($to_forum);
		
		if ( !empty($local_lock) ) db_unlock();
	}
	
	function inc_post_count($val)
	{
		q("UPDATE fud21_thread SET replies=replies+".$val." WHERE id=".$this->id);
	}
	
	function inc_view_count()
	{
		q("UPDATE fud21_thread SET views=views+1 WHERE id=".$this->id);
	}
	
	function dec_view_count($val)
	{
		q("UPDATE fud21_thread SET views=views-1 WHERE id=".$this->id);
	}
	
	function get_notify_list($user_id)
	{
		$ctm = __request_timestamp__;
		$tm = $ctm-604800;
	
		$r = q("SELECT 
				fud21_users.id AS user_id,
				fud21_users.email,
				fud21_users.icq,
				fud21_read.last_view,
				fud21_read.id,
				fud21_users.notify_method 
			FROM 
				fud21_thread_notify
				INNER JOIN fud21_users 
					ON fud21_thread_notify.user_id=fud21_users.id 
				LEFT JOIN fud21_read 
					ON fud21_read.user_id=fud21_thread_notify.user_id 
					AND fud21_read.thread_id=fud21_thread_notify.thread_id 
			WHERE 
				( fud21_read.msg_id=".$this->last_post_id." OR fud21_read.last_view < ".$tm." )
				AND fud21_thread_notify.thread_id=".$this->id." 
				AND fud21_thread_notify.user_id!=".intzero($user_id));
		
		$p = forum_perm_array($this->forum_id);
		$to=NULL;
		while ( $obj = db_rowobj($r) ) {
			if ( !is_allowed($obj->user_id, $p) ) continue;
			
			$to[$obj->notify_method][] = ( $obj->notify_method == 'EMAIL' ) ? $obj->email : $obj->icq.'@pager.icq.com';
			if( $obj->last_view < $tm ) q("UPDATE fud21_read SET last_view=".$ctm." WHERE id=".$obj->id);
		}
		qf($r);
		
		return $to;
	}
	
	function adm_set_rating($value)
	{
		q("UPDATE fud21_thread SET rating=".intnull($value)." WHERE id=".$this->id);
	}

	function has_thread_vote($user_id, $thread_id='')
	{
		if ( !$thread_id ) $thread_id = $this->id;
		
		if( ($rating=q_singleval("SELECT rating FROM fud21_thread_rate_track WHERE thread_id=".$thread_id." AND user_id=".$user_id)) ) {
			return $rating;	
		}
		return -1;
	}
	
	function update_vote_count()
	{
		$rating = q_singleval("SELECT ROUND(AVG(rating)) FROM fud21_thread_rate_track WHERE thread_id=".$this->id);
		q("UPDATE fud21_thread SET rating=".$rating." WHERE id=".$this->id);
	}
	
	function vote_count($thread_id='')
	{
		if ( !$thread_id ) $thread_id = $this->id;
		
		return q_singleval("SELECT COUNT(*) FROM fud21_thread_rate_track WHERE thread_id=".$thread_id);
	}
	
	function register_thread_vote($user_id, $rating, $thread_id='')
	{
		if ( !$thread_id ) $thread_id = $this->id;
		
		if( !db_locked() ) {
			db_lock('fud21_thread_rate_track+, fud21_thread+');
			$local_lock = 1;
		}
		
		if( $this->has_thread_vote($user_id, $thread_id) != -1 ) {
			if ( $local_lock ) db_unlock();
			return;
		}	
		
		q("INSERT INTO fud21_thread_rate_track (
			thread_id,
			user_id,
			stamp,
			rating
			)
		VALUES(
			".$thread_id.",
			".$user_id.",
			".__request_timestamp__.",
			".$rating."
		)");
		
		$rating = q_singleval("SELECT ROUND(AVG(rating)) FROM fud21_thread_rate_track WHERE thread_id=".$thread_id);
		
		q("UPDATE fud21_thread SET rating=".$rating." WHERE id=".$thread_id);
		
		if ( $local_lock ) db_unlock();
	}
}

function rebuild_forum_view($forum_id, $page=0)
{
	if( !db_locked() ) {
	        db_lock('fud21_thread_view+, fud21_thread+, fud21_msg+, fud21_forum+');
		$local_lock=1;
	}
	
	$tm = __request_timestamp__;
	
	/* Remove expired moved thread pointers */
	$r=q("DELETE FROM fud21_thread WHERE forum_id=".$forum_id." AND last_post_date<".($tm-86400*$GLOBALS['MOVED_THR_PTR_EXPIRY'])." AND moved_to!=0");
	if( $aff_rows = db_affected($r) ) {
		q("UPDATE fud21_forum SET thread_count=thread_count-".$aff_rows." WHERE id=".$forum_id);
		$page = 0;
	}
	
	/* De-announce expired announcments and sticky messages */
	$r = q("SELECT fud21_thread.id FROM fud21_thread INNER JOIN fud21_msg ON fud21_thread.root_msg_id=fud21_msg.thread_id WHERE fud21_thread.forum_id=".$forum_id." AND is_sticky='Y' AND (fud21_msg.post_stamp+fud21_thread.orderexpiry)<".$tm);
	while( list($tid) = db_rowarr($r) ) 
		q("UPDATE fud21_thread SET ordertype='NONE', is_sticky='N' WHERE id=".$tid);
	qf($r);

	if ( __dbtype__ == 'pgsql' ) {
		$tmp_tbl_name = "fud21_ftvt_".get_random_value();
		q("CREATE TEMP TABLE ".$tmp_tbl_name." ( forum_id INT NOT NULL, page INT8 NOT NULL, thread_id INT NOT NULL, pos SERIAL, tmp INT )");
		
		if( $page ) {
			q("DELETE FROM fud21_thread_view WHERE forum_id=".$forum_id." AND page<".($page+1));
			q("INSERT INTO ".$tmp_tbl_name." (thread_id,forum_id,page,tmp) SELECT fud21_thread.id, fud21_thread.forum_id, 4294967294, CASE WHEN is_sticky='Y' AND (fud21_msg.post_stamp+fud21_thread.orderexpiry>".$tm." OR fud21_thread.orderexpiry=0) THEN 4294967294 ELSE fud21_thread.last_post_date END AS sort_order_fld  FROM fud21_thread INNER JOIN fud21_msg ON fud21_thread.root_msg_id=fud21_msg.id WHERE forum_id=".$forum_id." AND fud21_msg.approved='Y' ORDER BY sort_order_fld DESC, fud21_thread.last_post_id DESC LIMIT ".($GLOBALS['THREADS_PER_PAGE']*$page).", 0");
		}
		else {
			q("DELETE FROM fud21_thread_view WHERE forum_id=".$forum_id);
			q("INSERT INTO ".$tmp_tbl_name." (thread_id,forum_id,page,tmp) SELECT fud21_thread.id, fud21_thread.forum_id, 2147483647, CASE WHEN is_sticky='Y' AND (fud21_msg.post_stamp+fud21_thread.orderexpiry>".$tm." OR fud21_thread.orderexpiry=0) THEN 2147483647 ELSE fud21_thread.last_post_date END AS sort_order_fld  FROM fud21_thread INNER JOIN fud21_msg ON fud21_thread.root_msg_id=fud21_msg.id WHERE forum_id=".$forum_id." AND fud21_msg.approved='Y' ORDER BY sort_order_fld DESC, fud21_thread.last_post_id DESC");
		}
		
		q("INSERT INTO fud21_thread_view (thread_id,forum_id,page,pos) SELECT thread_id,forum_id,CEIL(pos/40.0),(pos-(CEIL(pos/40)-1)*40) FROM ".$tmp_tbl_name);
		q("DROP SEQUENCE ".$tmp_tbl_name."_pos_seq");
		q("DROP TABLE ".$tmp_tbl_name);
		return;
	}
	else if ( __dbtype__ == 'mysql' ) {
		if( $page ) {
			q("DELETE FROM fud21_thread_view WHERE forum_id=".$forum_id." AND page<".($page+1));
			q("INSERT INTO fud21_thread_view (thread_id,forum_id,page,tmp) SELECT fud21_thread.id, fud21_thread.forum_id, 4294967294, CASE WHEN is_sticky='Y' AND (fud21_msg.post_stamp+fud21_thread.orderexpiry>".$tm." OR fud21_thread.orderexpiry=0) THEN 4294967294 ELSE fud21_thread.last_post_date END AS sort_order_fld  FROM fud21_thread INNER JOIN fud21_msg ON fud21_thread.root_msg_id=fud21_msg.id WHERE forum_id=".$forum_id." AND fud21_msg.approved='Y' ORDER BY sort_order_fld DESC, fud21_thread.last_post_id DESC LIMIT 0, ".($GLOBALS['THREADS_PER_PAGE']*$page));
			q("UPDATE fud21_thread_view SET page=CEILING(pos/".$GLOBALS['THREADS_PER_PAGE']."), pos=pos-(CEILING(pos/".$GLOBALS['THREADS_PER_PAGE'].")-1)*".$GLOBALS['THREADS_PER_PAGE']." WHERE forum_id=".$forum_id." AND page=4294967294");			
		}
		else {
			q("DELETE FROM fud21_thread_view WHERE forum_id=".$forum_id);
			q("INSERT INTO fud21_thread_view (thread_id,forum_id,page,tmp) SELECT fud21_thread.id, fud21_thread.forum_id, 4294967294, CASE WHEN is_sticky='Y' AND (fud21_msg.post_stamp+fud21_thread.orderexpiry>".$tm." OR fud21_thread.orderexpiry=0) THEN 4294967294 ELSE fud21_thread.last_post_date END AS sort_order_fld  FROM fud21_thread INNER JOIN fud21_msg ON fud21_thread.root_msg_id=fud21_msg.id WHERE forum_id=".$forum_id." AND fud21_msg.approved='Y' ORDER BY sort_order_fld DESC, fud21_thread.last_post_id DESC");
			q("UPDATE fud21_thread_view SET page=CEILING(pos/".$GLOBALS['THREADS_PER_PAGE']."), pos=pos-(CEILING(pos/".$GLOBALS['THREADS_PER_PAGE'].")-1)*".$GLOBALS['THREADS_PER_PAGE']." WHERE forum_id=".$forum_id);			
		}
	}
	if( $local_lock ) db_unlock();
}function is_perms($user_id, $r_id, $perm, $r_type='forum')
{
	if( $GLOBALS['usr']->is_mod == 'A' ) return TRUE;
	if( __dbtype__ == 'pgsql' ) $perm = strtolower($perm);
	if( empty($user_id) ) $user_id = 0;

	if( @is_object($GLOBALS['__MEMPERM_CACHE'][$user_id][$r_id][$r_type]) ) 
		return ($GLOBALS['__MEMPERM_CACHE'][$user_id][$r_id][$r_type]->{'p_'.$perm}=='Y'?TRUE:FALSE);
	
	if ( empty($user_id) ) {
		$r = q("SELECT * FROM fud21_group_cache WHERE user_id=".$user_id." AND resource_type='".$r_type."' AND resource_id=".$r_id);
		if( !is_result($r) ) $r = q("SELECT * FROM fud21_groups WHERE id=1");
	}
	else {
		$r=q("SELECT * FROM fud21_group_cache WHERE user_id IN(".$user_id.",2147483647) AND resource_type='".$r_type."' AND resource_id=".$r_id." ORDER BY user_id LIMIT 1");
		if( !is_result($r) ) $r = q("SELECT * FROM fud21_groups WHERE id=2");
	}
	
	$GLOBALS['__MEMPERM_CACHE'][$user_id][$r_id][$r_type] = db_singleobj($r);
	return ($GLOBALS['__MEMPERM_CACHE'][$user_id][$r_id][$r_type]->{'p_'.$perm}=='Y'?TRUE:FALSE);
}
	
	if( empty($frm_id) || !is_numeric($frm_id) ) invl_inp_err();
	
	$frm = new fud_forum;
	$frm->get($frm_id);
	
	if( empty($frm->cat_id) ) invl_inp_err();
	
	$GLOBALS['__RESOURCE_ID'] = $frm->id;
	
	if( !is_perms(_uid, $GLOBALS['__RESOURCE_ID'], 'READ') )
		error_dialog('Permission Denied!', 'Your user permissions do not allow you to perform the action you are attempting.', '');	
	
	
	if ( isset($ses) ) $ses->update('Browsing forum <a class="GenLink" href="http://thelocust.org/bored/index.php?t=thread&frm_id='.$frm->id.'">'.$frm->name.'</a>');

	if ( isset($usr) ) {
		if ( $frm->is_moderator($usr->id) || $usr->is_mod == 'A' ) $MOD = 1;
		$ppg = $usr->posts_ppg;
		
		fud_use('forum_notify.inc');
		$frm_not = new fud_forum_notify;
		
		if ( isset($sub) && $sub ) 
			$frm_not->add($usr->id, $frm->id);
		else if ( isset($unsub) && $unsub ) 
			$frm_not->delete($usr->id, $frm->id);
	}
	
	if ( $MOD ) {
		fud_use('imsg.inc');
		fud_use('imsg_edt.inc');
	}
	
	if( _uid ) {
	if( $usr->is_mod != 'N' && $usr->is_mod ) {
		if( $approve_count = q_singleval("SELECT count(*) FROM 
					fud21_msg 
					INNER JOIN fud21_thread 
						ON fud21_msg.thread_id=fud21_thread.id 
					INNER JOIN fud21_forum 
						ON fud21_thread.forum_id=fud21_forum.id 
					INNER JOIN fud21_mod 
						ON fud21_forum.id=fud21_mod.forum_id 
						".($GLOBALS["usr"]->is_mod != 'A' ? "AND fud21_mod.user_id="._uid : '')."  
					WHERE 
						fud21_msg.approved='N' 
						AND fud21_forum.moderated='Y'") ) 
			$mod_que = '<a class="GenLink" href="http://thelocust.org/bored/index.php?t=modque&'._rsid.'">Moderation Queue</a> <span class="GenText" style="color: #ff0000">('.$approve_count.')</span>';
		
		if( $GLOBALS["usr"]->is_mod == 'A' ) {
			if( $avatar_count = q_singleval("SELECT count(*) FROM fud21_users WHERE avatar_approved='N'") ) 
				$custom_avatar_queue = '| <a class="GenLink" href="adm/admapprove_avatar.php?'._rsid.'">Custom Avatar Queue</a> <span class="GenText" style="color: #ff0000">('.$avatar_count.')</span>';
	
			if( $report_count = q_singleval("SELECT count(*) FROM fud21_msg_report") ) 
				$reported_msgs = '| <a class="GenLink" href="http://thelocust.org/bored/index.php?t=reported&'._rsid.'">Reported Messages</a> <span class="GenText" style="color: #ff0000">('.$report_count.')</span>';
				
			if( $thr_exchc = q_singleval("SELECT count(*) FROM fud21_thr_exchange") )
				$thr_exch = '| <a class="GenLink" href="http://thelocust.org/bored/index.php?t=thr_exch&'._rsid.'">Thread Exchange </a> <span class="GenText" style="color: #ff0000">('.$thr_exchc.')</span>';
		}	
		else {
			if( $report_count = q_singleval("SELECT count(*) FROM fud21_msg_report INNER JOIN fud21_msg ON fud21_msg_report.msg_id=fud21_msg.id INNER JOIN fud21_thread ON fud21_msg.thread_id=fud21_thread.id INNER JOIN fud21_mod ON fud21_thread.forum_id=fud21_mod.forum_id AND fud21_mod.user_id=".$GLOBALS["usr"]->id) )
				$reported_msgs = '| <a class="GenLink" href="http://thelocust.org/bored/index.php?t=reported&'._rsid.'">Reported Messages</a> <span class="GenText" style="color: #ff0000">('.$report_count.')</span>';
			
			if( $thr_exchc = q_singleval("SELECT count(*) FROM fud21_thr_exchange INNER JOIN fud21_mod ON fud21_mod.user_id=".$usr->id." AND fud21_thr_exchange.frm=fud21_mod.forum_id") ) 
				$thr_exch = '| <a class="GenLink" href="http://thelocust.org/bored/index.php?t=thr_exch&'._rsid.'">Thread Exchange </a> <span class="GenText" style="color: #ff0000">('.$thr_exchc.')</span>';
		}
	}
	if( $usr->is_mod=='A' || bq("SELECT id FROM fud21_group_members WHERE user_id="._uid." AND group_leader='Y' LIMIT 1") )
		$group_mgr = '| <a class="GenLink" href="http://thelocust.org/bored/index.php?t=groupmgr&'._rsid.'">Group(s) Manager</a>';
	
	if( $thr_exch || $group_mgr || $reported_msgs || $custom_avatar_queue || $mod_que ) $admin_cp = '<br><font class="GenText"><b>Admin :</b></font> '.$mod_que.' '.$reported_msgs.' '.$thr_exch.' '.$custom_avatar_queue.' '.$group_mgr;
}$adm_str = $rid = $pm = '';
	$ret_to = '&returnto='.urlencode(!empty($GLOBALS['returnto'])?urldecode($GLOBALS['returnto']):$GLOBALS['HTTP_SERVER_VARS']['REQUEST_URI']);

	if ( empty($GLOBALS['usr']) ) {
		$login_n_logout = '<td valign="middle"><a class="UserControlPanel" href="http://thelocust.org/bored/index.php?t=login&'._rsid.$ret_to.'"><img src="http://thelocust.org/bored/theme/default/images/top_login.gif" border=0 alt="Login"></a></td>
<td valign="middle"><a class="UserControlPanel" href="http://thelocust.org/bored/index.php?t=login&'._rsid.$ret_to.'">Login</a></td>';
		$register_n_profile = '<td valign="middle"><a class="UserControlPanel" href="http://thelocust.org/bored/index.php?t=register&'._rsid.'"><img src="http://thelocust.org/bored/theme/default/images/top_register.gif" border=0 alt="Register"></a></td>
<td valign="middle"><a class="UserControlPanel" href="http://thelocust.org/bored/index.php?t=register&'._rsid.'">Register</a></td>';
	}
	else {
		if( $GLOBALS['usr']->is_mod == 'A' ) $admin_control_panel = '<td>&nbsp;&nbsp;</td><td valign="middle"><a class="UserControlPanel" href="adm/admglobal.php?'._rsid.'"><img src="http://thelocust.org/bored/theme/default/images/top_admin.gif" border=0 alt="Admin Control Panel"></a></td>
<td valign="middle"><a class="UserControlPanel" href="adm/admglobal.php?'._rsid.'">Admin Control Panel</a></td>';
		$user_login = htmlspecialchars($usr->alias);
		$login_n_logout = '<td valign="middle"><a class="UserControlPanel" href="http://thelocust.org/bored/index.php?t=login&'._rsid.$ret_to.'&logout=1"><img src="http://thelocust.org/bored/theme/default/images/top_logout.gif" border=0 alt="Logout"></a></td>
<td valign="middle"><a class="UserControlPanel" href="http://thelocust.org/bored/index.php?t=login&'._rsid.$ret_to.'&logout=1">Logout [ '.$user_login.' ]</a></td>';
		$register_n_profile = '<td valign="middle"><a class="UserControlPanel" href="http://thelocust.org/bored/index.php?t=register&'._rsid.'"><img src="http://thelocust.org/bored/theme/default/images/top_profile.gif" border=0 title="Click here to access user control panel" alt="Profile"></a></td>
<td valign="middle"><a class="UserControlPanel" href="http://thelocust.org/bored/index.php?t=register&'._rsid.'"><acronym title="Click here to access user control panel">Profile</acronym></a></td>';
		$rid = $GLOBALS["usr"]->id;
		
		if ( $GLOBALS['PM_ENABLED']=='Y' ) {
			$c = q_singleval("SELECT count(*) FROM fud21_pmsg WHERE duser_id=".$GLOBALS["usr"]->id." AND folder_id='INBOX' AND read_stamp=0");
			$private_msg = ( $c ) ? '<td>&nbsp;&nbsp;</td>
<td valign="middle"><a href="http://thelocust.org/bored/index.php?t=pmsg&'._rsid.'" class="UserControlPanel"><img src="http://thelocust.org/bored/theme/default/images/top_pm.gif" border=0 alt="Private Messaging"></a></td>
<td><a href="http://thelocust.org/bored/index.php?t=pmsg&'._rsid.'" class="UserControlPanel">You have <span class="GenText" style="color: #ff0000">('.$c.')</span> unread private message(s)</a></td>
<td>&nbsp;&nbsp;</td>' : '<td>&nbsp;&nbsp;</td>
<td valign="middle"><a href="http://thelocust.org/bored/index.php?t=pmsg&'._rsid.'" class="UserControlPanel"><img src="http://thelocust.org/bored/theme/default/images/top_pm.gif" border=0 alt="Private Messaging"></a></td>
<td><a href="http://thelocust.org/bored/index.php?t=pmsg&'._rsid.'" class="UserControlPanel">Private Messaging</a></td>
<td>&nbsp;&nbsp;</td>';
		}
	}$today = gmdate("Ymd", __request_timestamp__);
	$res = q("SELECT fud21_announce.subject, fud21_announce.text FROM fud21_announce INNER JOIN fud21_ann_forums ON fud21_announce.id=fud21_ann_forums.ann_id AND fud21_ann_forums.forum_id=".$frm->id." WHERE fud21_announce.date_started<='".$today."' AND fud21_announce.date_ended>='".$today."'");
	if ( db_count($res) ) {
		$announcements_data='';
		while ( $data = db_rowobj($res) ) $announcements_data .= '<tr><td class="AnnText"><font class="AnnSubjText">'.$data->subject.'</font><br>'.$data->text.'</td></tr>';
		
		$announcements = '<table width="100%" class="AnnonTable" cellspacing=0 border=0 cellpadding=1>
<tr><th>Announcement</th></tr>
'.$announcements_data.'
</table><img src="blank.gif" height=1 width=1>';
	}
	qf($res);function tmpl_create_forum_select()
{
	global $frm_id;
	global $start;
	global $count;
	global $th_id;
	global $rid;
	global $th;

	if ( isset($GLOBALS['usr']) ) {
		$frm_sel = 'fud21_forum_read.last_view,';
		$frm_join = 'LEFT JOIN fud21_forum_read ON fud21_forum.id=fud21_forum_read.forum_id AND fud21_forum_read.user_id='.$GLOBALS['usr']->id;
	}
	else $frm_sel=$frm_join='';
		
	if( $GLOBALS['usr']->is_mod != 'A' ) {
		$lmt = get_all_perms(_uid);
		if( !$lmt ) $lmt = 0;
		$qry_limit = " WHERE fud21_forum.id IN (".$lmt.") ";
	}		
		
	$frmres = q("SELECT 
		fud21_forum.id,
		fud21_forum.name,
		".$frm_sel."
		fud21_cat.name AS cat_name,
		fud21_cat.id AS cat_id,
		fud21_msg.post_stamp AS msg_post_stamp
	FROM 
		fud21_cat
		INNER JOIN fud21_forum
			ON fud21_cat.id=fud21_forum.cat_id
		LEFT JOIN fud21_msg
			ON fud21_forum.last_post_id=fud21_msg.id	
		".$frm_join.$qry_limit."
	ORDER BY 
		fud21_cat.view_order, fud21_forum.view_order
	");
	
	$prev_cat_id = 0;
	if ( db_count($frmres) ) {
		$selection_options = '';
		
		while ( $obj = db_rowobj($frmres) ) {
			if ( $prev_cat_id != $obj->cat_id ) {
				$prev_cat_id = $obj->cat_id;
				$selection_options .= '<option value="0">'.$obj->cat_name.'</option>';
			}
			
			$selected = ( $frm_id == $obj->id ) ? ' selected' : '';
			$selection_options .= ( isset($GLOBALS['usr']) && $obj->last_view < $obj->msg_post_stamp ) ? '<option value="'.$obj->id.'"'.$selected.'>&nbsp;&nbsp;&nbsp;&nbsp;*(UNREAD) '.$obj->name.'</option>' : '<option value="'.$obj->id.'"'.$selected.'>&nbsp;&nbsp;&nbsp;&nbsp;'.$obj->name.'</option>';
		}
	}
	qf($frmres);

	return '<table border=0 cellspacing=0 cellpadding=1><form name="frmquicksel" method="post"><tr><td class="GenText" valign=bottom>
<font class="SmallText"><b>Goto Forum:</b><br></font>
<select class="SmallText" name="dst_frm_id" onChange="javascript: if ( this.value==0 ) return false; document.frmquicksel.submit();">
'.$selection_options.'
</select>
<input name="frm_id" type="hidden" value="'.$frm_id.'">
<input name="start" type="hidden" value="'.$start.'">
<input name="count" type="hidden" value="'.$count.'">
<input name="th_id" type="hidden" value="'.$th_id.'">
<input name="rid" type="hidden" value="'.$rid.'">
'._hs.'<input name="th" type="hidden" value="'.$th.'">
</td><td valign=bottom><input type="submit" class="button" name="frm_goto" value="Go"></td></tr></form></table>';
}

if ( !empty($dst_frm_id) ) {
	header("Location: http://thelocust.org/bored/index.php?t=thread&frm_id=".$dst_frm_id."&"._rsid);
	exit();
}

	$forum_select = tmpl_create_forum_select();if( isset($usr) ) $unread_posts = '<b>::</b> <a class="GenLink" href="http://thelocust.org/bored/index.php?t=selmsg&unread=1&'._rsid.'&frm_id='.$frm_id.'&th='.$th.'"><acronym title="Show all unread messages">Unread Posts</acronym></a>&nbsp;';
if( !$th ) $unanswered_posts = '<b>::</b> <a class="GenLink" href="http://thelocust.org/bored/index.php?t=selmsg&reply_count=0&'._rsid.'&frm_id='.$frm_id.'&th='.$th.'"><acronym title="Show all messages, which have no replies">Unanswered Posts</acronym></a>';/* FILE START */
	$TITLE_EXTRA = ': '.$frm->name.'';

	if ( !isset($cat) ) {
		$cat = new fud_cat;
		$cat->get_cat($frm->cat_id);
	}
	
	$returnto = 'returnto='.urlencode("http://thelocust.org/bored/index.php?t=thread&frm_id=".$frm_id.'&'._rsid);

	if ( isset($usr) ) {
		if( !isset($start) ) $start='';
		if( !isset($count) ) $count='';
		
		if ( is_forum_notified($usr->id, $frm->id) ) 
			$subscribe = '<a class="GenLink" href="http://thelocust.org/bored/index.php?t=thread&unsub=1&frm_id='.$frm_id.'&start='.$start.'&count='.$count.'&'._rsid.'"><acronym title="Stop receiving notifications about new threads in the forum">Unsubscribe</acronym></a>';
		else 
			$subscribe = '<a class="GenLink" href="http://thelocust.org/bored/index.php?t=thread&sub=1&frm_id='.$frm_id.'&start='.$start.'&count='.$count.'&'._rsid.'"><acronym title="Receive notifications when someone creates a new thread in this forum">Subscribe</acronym></a>';
	}

	if ( empty($start) ) $start = 0;
	if ( empty($ppg) ) $ppg = $THREADS_PER_PAGE;

	if( isset($usr) ) {
		$lread_s = ' fud21_read.last_view AS last_thread_view, ';
		$lread_f = ' LEFT JOIN fud21_read ON fud21_thread.id=fud21_read.thread_id AND fud21_read.user_id='.$usr->id.' ';
	}else $lread_s=$lread_f='';

	$result = q('SELECT fud21_thread.*, '.$lread_s.' fud21_msg.attach_cnt, fud21_msg.poll_id, fud21_msg.subject, fud21_users.alias AS login, fud21_users.id AS starter_id, fud21_msg.icon AS th_icon, fud_users_2.id AS last_poster_id, fud_users_2.alias AS last_poster_login, fud_msg_2.id AS last_post_id, fud_msg_2.post_stamp AS last_post_stamp, fud21_msg.post_stamp AS creation_date FROM fud21_thread_view INNER JOIN fud21_thread ON fud21_thread_view.thread_id=fud21_thread.id LEFT JOIN fud21_msg ON fud21_thread.root_msg_id=fud21_msg.id LEFT JOIN fud21_users ON fud21_users.id = fud21_msg.poster_id LEFT JOIN fud21_msg AS fud_msg_2 ON fud_msg_2.id=fud21_thread.last_post_id LEFT JOIN fud21_users AS fud_users_2 ON fud_users_2.id=fud_msg_2.poster_id '.$lread_f.' WHERE fud21_thread_view.forum_id='.$frm->id.' AND fud21_thread_view.page='.(floor($start/$ppg)+1).' ORDER BY fud21_thread_view.pos ASC');

	if ( !db_count($result) ) {
		$no_messages = '<font class="GenText">There are no messages in this forum.</font>';
	}
	else {
		if ( $MOD || is_perms(_uid, $GLOBALS['__RESOURCE_ID'], 'MOVE') || is_perms(_uid, $GLOBALS['__RESOURCE_ID'], 'DEL') ) $admin_heading_row = '<th nowrap>Moderator Options</th>';
	
	$POSTS_PER_PAGE = ($usr->posts_ppg)?$usr->posts_ppg:$GLOBALS['POSTS_PER_PAGE'];
	
	$thread_list_table_data='';
	while ( $obj = db_rowobj($result) ) {
		if ( $obj->moved_to ) {
			list($name, $d_frm_id) = db_singlearr(q("SELECT name, id FROM fud21_forum WHERE id=".$obj->moved_to));
			$thread_list_table_data .= '<tr>
<td width=1 class="RowStyleB"><img src="http://thelocust.org/bored/theme/default/images/moved.gif" border=0 title="This thread has been moved to another forum"></td>
<td class="RowStyleB" colspan=10 align="center" class="GenText"><a href="http://thelocust.org/bored/index.php?t='.d_thread_view.'&goto='.$obj->root_msg_id.'&'._rsid.'" class="GenLink">'.$obj->subject.'</a> has been moved to <a href="http://thelocust.org/bored/index.php?t=thread&frm_id='.$d_frm_id.'&'._rsid.'" class="GenLink">'.$name.'</a> by the moderator</td>
</tr>';
			continue;
		}
		
		$mini_pager_data=$mini_thread_pager=$thread_poll_indicator=$thread_attach_indicator=$first_unread_msg_link=$thread_read_status='';
		
		$msg_count = $obj->replies+1;
		
		if ( $msg_count > $POSTS_PER_PAGE && d_thread_view=='msg' ) {
			$pgcount = ceil($msg_count/$POSTS_PER_PAGE);
			$i = ( $THREAD_MSG_PAGER < $pgcount ) ? $pgcount-$THREAD_MSG_PAGER : 0;
			if( $i ) $mini_pager_data = '&nbsp;...';

			for( $i; $i<$pgcount; $i++ ) {
				$st_pos = $i*$POSTS_PER_PAGE;
				$pg_num = $i+1;
				$mini_pager_data .= '&nbsp;<a class="GenLink" href="http://thelocust.org/bored/index.php?t='.d_thread_view.'&th='.$obj->id.'&start='.$st_pos.'&'._rsid.'">'.$pg_num.'</a>';
			}
		
			if ( $mini_pager_data ) $mini_thread_pager = '<font class="SmallText">(<img src="http://thelocust.org/bored/theme/default/images/pager.gif" border=0>'.$mini_pager_data.')</font>';
		}
		
		if( $obj->poll_id ) 
			$thread_poll_indicator = 'Poll:&nbsp;';		
		
		if( $obj->attach_cnt ) 
			$thread_attach_indicator = '<img src="http://thelocust.org/bored/theme/default/images/attachment.gif" border=0>';

		if ( isset($usr) ) {
			if( $usr->last_read < $obj->last_post_stamp && $obj->last_post_stamp>$obj->last_thread_view ) {
				if ( $obj->locked == 'Y' ) 
					$thread_read_status = '<img src="http://thelocust.org/bored/theme/default/images/unreadlocked.gif" border=0 title="Locked thread with unread messages">';
				else 
					$thread_read_status = '<img src="http://thelocust.org/bored/theme/default/images/unread.gif" border=0 title="This thread contains messages you have not yet read">';
	
				$first_unread_msg_link = '<a href="http://thelocust.org/bored/index.php?t='.d_thread_view.'&th='.$obj->id.'&unread=1&'._rsid.'"><img src="http://thelocust.org/bored/theme/default/images/newposts.gif" border=0 title="Click here to go the first unread message in this thread"></a>&nbsp;';
			}
		}

		if( !$thread_read_status ) {
			if ( $obj->locked == 'Y' ) 
				$thread_read_status = '<img src="http://thelocust.org/bored/theme/default/images/readlocked.gif" border=0 title="This thread has been locked">';
			else if ( !isset($usr) )
				$thread_read_status = '<img src="http://thelocust.org/bored/theme/default/images/read.gif" border=0 title="The read & unread messages are only tracked for registered users">';
			else
				$thread_read_status = '<img src="http://thelocust.org/bored/theme/default/images/read.gif" border=0 title="This thread has no unread messages">';	 
		}
		
		
		if ( $obj->th_icon )
			$thread_icon = '<img src="images/message_icons/'.$obj->th_icon.'" border=0>';
		else 
		 	$thread_icon = '&nbsp;';
		
		if ( $obj->rating )
			$rating = '<img src="http://thelocust.org/bored/theme/default/images/'.$obj->rating.'stars.gif" border=0>';
		else 
			$rating = '&nbsp;';
		
		if ( $obj->is_sticky == 'Y' ) 
			$stick_status = $obj->ordertype=='STICKY' ? '<font class="SmallText"><b>sticky:</b>&nbsp;</font>' : '<font class="SmallText"><b>announcement:</b>&nbsp;</font>';
		else
			$stick_status = '';	
			
		if( $obj->last_poster_id ) {
			$reg_user_link = htmlspecialchars(trim_show_len($obj->last_poster_login,'LOGIN'));
			$user_link = '<a href="http://thelocust.org/bored/index.php?t=usrinfo&id='.$obj->last_poster_id.'&'._rsid.'">'.$reg_user_link.'</a>';
		}
		else {
			$unreg_user_link = htmlspecialchars(trim_show_len($GLOBALS["ANON_NICK"],'LOGIN'));
			$user_link = ''.$unreg_user_link.''; 
		}	

		if( $obj->starter_id ) {
			$first_post_login = htmlspecialchars(trim_show_len($obj->login,'LOGIN'));
			$first_post_login = '<a href="http://thelocust.org/bored/index.php?t=usrinfo&id='.$obj->starter_id.'&'._rsid.'">'.$first_post_login.'</a>';
		}	
		else {
			$first_post_login = htmlspecialchars(trim_show_len($GLOBALS["ANON_NICK"],'LOGIN'));
			$first_post_login = ''.$first_post_login.'';
		}	

		$thread_first_post = '<font class="DateText">'.strftime("%a, %d %B %Y", $obj->creation_date).'</font>';
		
		if( $MOD || (is_perms(_uid, $GLOBALS['__RESOURCE_ID'], 'DEL') && is_perms(_uid, $GLOBALS['__RESOURCE_ID'], 'MOVE')) ) 
			$admin_control_row = '<td align=center class="RowStyleA"><a href="javascript://" onClick="javascript: window_open(\'http://thelocust.org/bored/index.php?t=mvthread&'._rsid.'&th='.$obj->id.'\', \'th_move\', 300, 400);">Move</a> | <a href="http://thelocust.org/bored/index.php?t=mmod&'._rsid.'&th='.$obj->id.'&del='.$obj->root_msg_id.'&'.$returnto.'">Delete</a></td>';
		else if ( is_perms(_uid, $GLOBALS['__RESOURCE_ID'], 'MOVE') ) 
			$admin_control_row = '<td align=center class="RowStyleA"><a href="javascript://" onClick="javascript: window_open(\'http://thelocust.org/bored/index.php?t=mvthread&'._rsid.'&th='.$obj->id.'\', \'th_move\', 300, 400);">Move</a></td>';
		else if ( is_perms(_uid, $GLOBALS['__RESOURCE_ID'], 'DEL') ) 
			$admin_control_row = '<td align=center class="RowStyleA"><a href="http://thelocust.org/bored/index.php?t=mmod&'._rsid.'&th='.$obj->id.'&del='.$obj->root_msg_id.'&'.$returnto.'">Delete</a></td>';	

		$thread_list_table_data .= '<tr>		
<td width=1 class="RowStyleB">'.$thread_read_status.'</td>
<td class="RowStyleB" width=1 align="center">'.$thread_icon.'</td>
<td class="RowStyleA">'.$stick_status.''.$first_unread_msg_link.''.$thread_poll_indicator.''.$thread_attach_indicator.'<a class="GenLink" href="http://thelocust.org/bored/index.php?t='.d_thread_view.'&th='.$obj->id.'&start=0&'._rsid.'">'.$obj->subject.'</a>&nbsp;'.$mini_thread_pager.'</td>
<td class="RowStyleB" align="center">'.$obj->replies.'</td>
<td class="RowStyleB" align="center">'.$obj->views.'</td>
<td class="RowStyleA" align="center">'.$rating.'</td>
<td class="RowStyleB" nowrap><font class="DateText">'.strftime("%a, %d %B %Y %H:%M", $obj->last_post_stamp).'</font><br>By: '.$user_link.' <a href="http://thelocust.org/bored/index.php?t='.d_thread_view.'&goto='.$obj->last_post_id.'&'._rsid.'" class="GenLink"><img src="http://thelocust.org/bored/theme/default/images/goto.gif" border=0 title="Go to the last message in this thread"></a></td>
<td class="RowStyleB" nowrap><font class="DateText">'.strftime("%a, %d %B %Y", $obj->creation_date).'</font><br>By: '.$first_post_login.'</td>
'.$admin_control_row.'
</tr>';
	}
	
	qf($result); 	
}

	$page_pager = tmpl_create_pager($start, $ppg, $frm->thread_count, 'http://thelocust.org/bored/index.php?t=thread&frm_id='.$frm_id.'&'._rsid);

	$page_gen_time = (db_getmicrotime() - $GLOBALS['PAGE_TIME']);
$q_time = query_count();
$ttl_time = total_time();

if ( isset($usr) && $usr->is_mod == 'A' )
	$page_stats = '<br><div align="left" class="SmallText">'.$q_time.' MySQL queries took '.$ttl_time.' seconds<br>Total time taken to generate the page: '.$page_gen_time.' seconds</div>';
else if ( $GLOBALS['PUBLIC_STATS'] == 'Y' ) 
	$page_stats = '<br><div align="left" class="SmallText">'.$q_time.' MySQL queries took '.$ttl_time.' seconds<br>Total time taken to generate the page: '.$page_gen_time.' seconds</div>';
?>	
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<title><?php echo $GLOBALS['FORUM_TITLE']; ?><?php echo $TITLE_EXTRA; ?></title>
<META HTTP-EQUIV="Content-Type" CONTENT="text/html; charset=ISO-8859-15">
<script language="javascript" src="lib.js"></script>
<link rel="StyleSheet" href="http://thelocust.org/bored/theme/default/forum.css" type="text/css">
</head>
<body topmargin="2" leftmargin="2" marginheight="2" marginwidth="2">
<table width="100%" border="0" cellspacing="3" cellpadding="5"><tr><td class="ForumBackground">
<table border=0 cellspacing=0 cellpadding=0 width="100%"><tr><td align="right">
<table cellspacing=3 cellpadding=0 border=0>
	<tr>
		<td valign="middle"><a class="UserControlPanel" href="http://thelocust.org/bored/index.php?t=help_index&<?php echo _rsid; ?>"><img src="http://thelocust.org/bored/theme/default/images/top_help.gif" border=0 alt="F.A.Q."></a></td>
		<td valign="middle"><a class="UserControlPanel" href="http://thelocust.org/bored/index.php?t=help_index&<?php echo _rsid; ?>">F.A.Q.</a></td>
		<td>&nbsp;&nbsp;</td>
		<?php echo $register_n_profile; ?>
		<td>&nbsp;&nbsp;</td>
		<?php echo $login_n_logout; ?>
		<td>&nbsp;&nbsp;</td>
		<td valign="middle"><a class="UserControlPanel" href="http://thelocust.org/bored/index.php?t=index&<?php echo _rsid; ?>"><img src="http://thelocust.org/bored/theme/default/images/top_home.gif" border=0 alt="Home"></a></td>
		<td valign="middle"><a class="UserControlPanel" href="http://thelocust.org/bored/index.php?t=index&<?php echo _rsid; ?>">Home</a></td>
	</tr>
</table>
<table cellspacing=3 cellpadding=0 border=0>	
	<tr>	
		<?php echo $private_msg; ?>
		<td valign="middle"><a class="UserControlPanel" href="http://thelocust.org/bored/index.php?t=finduser&btn_submit=Find&<?php echo _rsid; ?>"><img src="http://thelocust.org/bored/theme/default/images/top_members.gif" border=0 alt="Members"></a></td>
		<td valign="middle"><a class="UserControlPanel" href="http://thelocust.org/bored/index.php?t=finduser&btn_submit=Find&<?php echo _rsid; ?>">Members</a></td>
		<td>&nbsp;&nbsp;</td>
		<td valign="middle"><a class="UserControlPanel" href="http://thelocust.org/bored/index.php?t=search&<?php echo _rsid; ?>"><img src="http://thelocust.org/bored/theme/default/images/top_search.gif" border=0 alt="Search"></a></td>
		<td valign="middle"><a class="UserControlPanel" href="http://thelocust.org/bored/index.php?t=search&<?php echo _rsid; ?>">Search</a></td>
		<?php echo $admin_control_panel; ?>
	</tr>
</table></td></tr></table>
<table width="100%" border=0 cellspacing=0 cellpadding=0><tr>
<td valign="bottom" align="left" width="100%"><a class="GenLink" href="http://thelocust.org/bored/index.php?t=index&<?php echo _rsid; ?>"><?php echo $cat->name; ?></a><font class="GenText"> &raquo; <b><?php echo $frm->name; ?></b></font><br><font class="GenText"><b>Show:</b></font> <a class="GenLink" href="http://thelocust.org/bored/index.php?t=selmsg&date=today&<?php echo _rsid; ?>&frm_id=<?php echo $frm_id; ?>&th=<?php echo $th; ?>"><acronym title="Show all messages that were posted today">Today's Posts</acronym></a>&nbsp;<?php echo $unread_posts; ?><?php echo $unanswered_posts; ?><br><img src="blank.gif" height=2 border=0><br><?php echo $subscribe; ?><?php echo $admin_cp; ?></td>
<td valign="bottom" align="right" class="GenText"><a class="GenLink" href="http://thelocust.org/bored/index.php?t=post&<?php echo $returnto; ?>&frm_id=<?php echo $frm_id; ?>&<?php echo _rsid; ?>"><img src="http://thelocust.org/bored/theme/default/images/new_thread.gif" alt="Create a new thread" border=0></a></td>
</tr></table><img src="blank.gif" height=2 border=0>
<?php echo $announcements; ?>
<table border="0" cellspacing="1" cellpadding="2" class="ContentTable">
<tr>
	<th>&nbsp;</th>
	<th>&nbsp;</th>
	<th width="100%">Thread</th>
	<th width=1>Replies</th>
	<th width=1>Views</th>
	<th align="center">Rating</th>
	<th nowrap>Last Post</th>
	<th nowrap>Started On</th>
	<?php echo $admin_heading_row; ?>
</tr>
<?php echo $thread_list_table_data; ?>
</table>
<img src="blank.gif" width=1 height=2><br>
<table border=0 cellspacing=0 cellpadding=0 width="100%">
<tr>
<td valign="top"><?php echo $page_pager; ?>&nbsp;</td>
<td align="right" class="GenText" valign="bottom" nowrap><a class="GenLink" href="http://thelocust.org/bored/index.php?t=post&<?php echo $returnto; ?>&frm_id=<?php echo $frm_id; ?>&<?php echo _rsid; ?>"><img src="http://thelocust.org/bored/theme/default/images/new_thread.gif" alt="Create a new thread" border=0></a></td>
</tr>
</table>
<?php echo $forum_select; ?>
<br>
<table border="0" cellspacing="1" cellpadding="2" class="ContentTable">
	<tr><td class="RowStyleB"><font class="SmallText"><b>Legend:</b></font><br></td></tr>
	<tr><td align=left class="RowStyleB">
		<table border=0 cellspacing=0 cellpadding=0 align=left>
			<tr>
				<td>
				<table border=0 cellspacing=0 cellpadding=2>
					<tr><td><img src="http://thelocust.org/bored/theme/default/images/unread.gif" border=0></td><td class="SmallText">New Posts</td></tr>
				</table>
				</td>
				
				<td>
				<table border=0 cellspacing=0 cellpadding=2>
					<tr><td><img src="http://thelocust.org/bored/theme/default/images/read.gif" border=0></td><td class="SmallText">No New posts</td></tr>
				</table>
				</td>
				
				<td>
				<table border=0 cellspacing=0 cellpadding=2>
					<tr><td><img src="http://thelocust.org/bored/theme/default/images/unreadlocked.gif" border=0></td><td class="SmallText">Locked (w/ unread posts)</td></tr>
				</table>
				</td>
				
				<td>
				<table border=0 cellspacing=0 cellpadding=2>
					<tr><td><img src="http://thelocust.org/bored/theme/default/images/readlocked.gif" border=0></td><td class="SmallText">Locked</td></tr>
				</table>
				</td>
				
				<td>
				<table border=0 cellspacing=0 cellpadding=2>
					<tr><td><img src="http://thelocust.org/bored/theme/default/images/moved.gif" border=0></td><td class="SmallText">Moved to another forum</td></tr>
				</table>
				</td>
			</tr>
		</table>
	</td></tr>
</table>
<br><table bgcolor="#000000" border=0 cellspacing=1 cellpadding=1 align="center"><tr class="RowStyleA"><td class="SmallText"><b>Current Time:</b> 
<?php echo strftime("%a %b %e %H:%M:%S %Z %Y", __request_timestamp__); ?>
</td></tr></table>
<?php echo $page_stats; ?>
</td></tr></table>
<table width="100%" border="0" cellspacing="3" cellpadding="5"><tr><td class="ForumBackground" align="center">
<b>.::</b> <a href="mailto:<?php echo $GLOBALS['ADMIN_EMAIL']; ?>">Contact</a> <b>::</b> <a href="http://thelocust.org/bored/index.php?t=index&<?php echo _rsid; ?>">Home</a> <b>::.</b>
<p>
<span class="SmallText">Powered by: FUDforum <?php echo $GLOBALS['FORUM_VERSION']; ?><br>Copyright &copy;2001,2002 <a href="http://fud.prohost.org/" class="GenLink">Advanced Internet Designs Inc.</a></span>
</td></tr></table>
</body>
</html>	
<?php	
	if ( isset($usr) ) $usr->register_forum_view($frm->id);
?>