<?php
/***************************************************************************
*   copyright            : (C) 2001,2002 Advanced Internet Designs Inc.
*   email                : forum@prohost.org
*
*   $Id: finduser.php.t,v 1.7 2002/07/09 14:47:29 hackie Exp $
****************************************************************************
          
****************************************************************************
*
*	This program is free software; you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation; either version 2 of the License, or
*	(at your option) any later version.
*
***************************************************************************/
/*#? User Locator Page */

	include_once "GLOBALS.php";
	if ( !defined('__index_page_start__') ) exit('sorry, you can not access this page');function pager_replace(&$str, $s, $c)
{
	$str = str_replace('%s', $s, $str);
	$str = str_replace('%c', $c, $str);
}

function tmpl_create_pager($start, $count, $total, $arg, $suf='', $append=1, $js_pager=FALSE)
{
	if ( $total <= $count ) return;
	if ( !$count ) $count = $GLOBALS["POSTS_PER_PAGE"];
	
	$cur_pg = ceil($start/$count);
	$ttl_pg = ceil($total/$count);
	
	$page_pager_data='';
	
	if ( $start-$count > -1 ) {
		$page_start = $start-$count;
		if ( $append ) {
			$page_first_url = $arg.'&start=0&count='.$count.$suf;
			$page_prev_url = $arg.'&start='.$page_start.'&count='.$count.$suf;
		}
		else {
			$page_first_url = $arg;
			$page_prev_url = $arg;
			pager_replace($page_first_url, 0, $count);
			pager_replace($page_prev_url, $page_start, $count);
		}
		
		$page_pager_data .= (!$js_pager)?'&nbsp;<a href="'.$page_first_url.'" class="PagerLink">&laquo</a>&nbsp;&nbsp;<a href="'.$page_prev_url.'" class="PagerLink">&lt;</a>&nbsp;&nbsp;':'&nbsp;<a href="javascript://" onClick="'.$page_first_url.'" class="PagerLink">&laquo</a>&nbsp;&nbsp;<a href="'.$page_prev_url.'" class="PagerLink">&lt;</a>&nbsp;&nbsp;';
	}	

	$mid = ceil($GLOBALS["GENERAL_PAGER_COUNT"]/2);
	
	if( $ttl_pg > $GLOBALS["GENERAL_PAGER_COUNT"] ) {
		if( ($mid+$cur_pg)>=$ttl_pg ) {
			$end = $ttl_pg;
			$mid += ($mid+$cur_pg)-$ttl_pg;
			$st = $cur_pg-$mid;
		}
		else if( ($cur_pg-$mid)<=0 ) {
			$st = 0;				
			$mid += $mid-$cur_pg;
			$end = $mid+$cur_pg;
		}
		else {
			$st = $cur_pg-$mid;
			$end = $mid+$cur_pg;
		}
		
		if( $st < 0 ) $start = 0;
		if( $end > $ttl_pg ) $end = $ttl_pg;
	}
	else {
		$end = $ttl_pg;
		$st = 0;
	}
	
	
	while ( $st<$end ) {
		if( $st != $cur_pg ) {
			$page_start = $st*$count;
			$st++;
			if ( $append ) {
				$page_page_url = $arg.'&start='.$page_start.'&count='.$count.$suf;
			}
			else {
				$page_page_url = $arg;
				pager_replace($page_page_url, $page_start, $count);
			}
			$page_pager_data .= (!$js_pager)?'<a href="'.$page_page_url.'" class="PagerLink">'.$st.'</a>&nbsp;&nbsp;':'<a href="javascript://" onClick="'.$page_page_url.'" class="PagerLink">'.$st.'</a>&nbsp;&nbsp;';
		}
		else {
			$st++;
			$page_pager_data .= (!$js_pager)?''.$st.'&nbsp;&nbsp;':''.$st.'&nbsp;&nbsp;';
		}	
	}
	
	if ( !$js_pager )
		$page_pager_data = substr($page_pager_data,0,strlen('&nbsp;&nbsp;')*-1);
	else 
		$page_pager_data = substr($page_pager_data,0,strlen('&nbsp;&nbsp;')*-1);
		
	if ( ($start+$count)<$total ) { 
		$page_start = $start+$count;
		$page_start_2 = ($st-1)*$count;
		if ( $append ) {
			$page_next_url = $arg.'&start='.$page_start.'&count='.$count.$suf;
			$page_last_url = $arg.'&start='.$page_start_2.'&count='.$count.$suf;
		}
		else {
			$page_next_url = $arg;
			$page_last_url = $arg;
			pager_replace($page_next_url, $page_start, $count);
			pager_replace($page_last_url, $page_start_2, $count);
		}
		$page_pager_data .= (!$js_pager)?'&nbsp;&nbsp;<a href="'.$page_next_url.'" class="PagerLink">&gt;</a>&nbsp&nbsp;<a href="'.$page_last_url.'" class="PagerLink">&raquo;</a>':'&nbsp;&nbsp;<a href="javascript://" onClick="'.$page_next_url.'" class="PagerLink">&gt;</a>&nbsp&nbsp;<a href="'.$page_last_url.'" class="PagerLink">&raquo;</a>';
	}
	
	return (!$js_pager)?'<font class="SmallText"><b>Pages ('.$ttl_pg.'): 
['.$page_pager_data.']
</b></font>':'<font class="SmallText"><b>Pages ('.$ttl_pg.'): 
['.$page_pager_data.']
</b></font>';
}define('_fileio_inc_', 1);


function register_fp($id)
{
	if( empty($GLOBALS['__MSG_FP__'][$id]) ) 
		$GLOBALS['__MSG_FP__'][$id] = fopen($GLOBALS["MSG_STORE_DIR"].'msg_'.$id, 'rb');
	
	return $GLOBALS['__MSG_FP__'][$id];
}

function un_register_fps()
{
	if( !@is_array($GLOBALS['__MSG_FP__']) ) return;
	
	reset($GLOBALS['__MSG_FP__']);
	while( list($k,$v) = each($GLOBALS['__MSG_FP__']) ) {
		if( @is_resource($v) ) fclose($v);
		$GLOBALS['__MSG_FP__'][$k] = NULL;
	}	
}

function read_msg_body($off, $len, $file_id)
{
	$fp = register_fp($file_id);
	fseek($fp, $off);
	return fread($fp, $len);
}function fetch_vars($pref, &$obj, $arr)
{
	reset($obj);
	while ( list($k, $v) = each($obj) ) {
		if ( isset($arr[$pref.$k]) ) $obj->{$k} = $arr[$pref.$k];
	}
}
	
function export_vars($pref, &$obj)
{
	reset($obj);
	while ( list($k, $v) = each($obj) ) {
		if ( isset($obj->{$k}) ) $GLOBALS[$pref.$k] = $v;
	}
}

function empty_object(&$obj)
{
	reset($obj);
	while ( list($k, $v) = each($obj) ) $obj->{$k} = NULL;
}class fud_thread
{
	var $id=NULL;
	var $forum_id=NULL;
	var $root_msg_id=NULL;
	var $last_post_date=NULL;
	var $replies=NULL;
	var $views=NULL;
	var $rating=NULL;
	var $last_post_id=NULL;
	var $locked=NULL;
	var $is_sticky=NULL;
	var $ordertype=NULL;
	var $orderexpiry=NULL;
	
	var $subject=NULL;
	var $db_thread=NULL;
	
	function add($root, $forum_id, $locked=NULL, $is_sticky=NULL, $ordertype=NULL, $orderexpiry=NULL) 
	{
		$r = q("INSERT INTO 
			fud21_thread(
				forum_id, 
				root_msg_id, 
				last_post_date, 
				replies, 
				views, 
				rating, 
				last_post_id,
				locked, 
				is_sticky,
				ordertype,
				orderexpiry
			)
			VALUES
			(
				".$forum_id.",
				".$root.",
				".__request_timestamp__.",
				0,
				0,
				0,
				".$root.",
				'".yn($locked)."',
				'".yn($is_sticky)."',
				".ifnull($ordertype, "'NONE'").",
				".intzero($orderexpiry)."
			)");
		
		$this->id = db_lastid("fud21_thread", $r);
		
		return $this->id;
	}
	
	function sync()
	{
		list($old_sticky,$forum_id) = db_singlearr(q("SELECT is_sticky,forum_id FROM fud21_thread WHERE id=".$this->id));
	
		q("UPDATE fud21_thread SET 
			is_sticky='".yn($this->is_sticky)."',
			ordertype=".ifnull($this->ordertype, "'NONE'").",
			orderexpiry=".intnull($this->orderexpiry).",
			locked='".yn($this->locked)."'
		WHERE id=".$this->id);
		
		if( $old_sticky != yn($this->is_sticky) ) rebuild_forum_view($forum_id);
	}
	
	function get_by_id($id)
	{
		$result = qobj("SELECT 
				fud21_thread.*,
				fud21_msg.subject
			FROM 
				fud21_thread 
				LEFT JOIN fud21_msg 
					ON fud21_thread.root_msg_id=fud21_msg.id 
				LEFT JOIN fud21_forum 
					ON fud21_thread.forum_id=fud21_forum.id 
				LEFT JOIN fud21_cat 
					ON fud21_forum.cat_id=fud21_cat.id 
			WHERE 
				fud21_thread.id=".$id, $this);
		if ( empty($this->id) ) error_dialog('Invalid thread ID','You\'ve followed an invalid link, the thread you are trying to view does not exist.','', 'FATAL');
	}

	function delete($rebuild_view=TRUE)
	{
		$msg = new fud_msg_edit;
		qobj("SELECT * FROM fud21_msg WHERE id=".$this->root_msg_id, $msg);
		if( !empty($msg->id) )
			$msg->delete(FALSE);
		else {
			q("DELETE FROM fud21_thread WHERE id=".$this->id);
			$tc = q_singleval("SELECT count(*) FROM fud21_thread INNER JOIN fud21_msg ON fud21_thread.root_msg_id=fud21_msg.id WHERE forum_id=".$this->forum_id." AND fud21_msg.approved='Y'");
			$mc = q_singleval("SELECT SUM(replies) FROM fud21_thread INNER JOIN fud21_msg ON fud21_thread.root_msg_id=fud21_msg.id WHERE forum_id=".$this->forum_id." AND fud21_msg.approved='Y'");
			$mc += $tc;
			$lpi = q_singleval("SELECT MAX(last_post_id) FROM fud21_thread INNER JOIN fud21_msg ON fud21_thread.root_msg_id=fud21_msg.id WHERE forum_id=".$this->forum_id." AND fud21_msg.approved='Y'");
			q("UPDATE fud21_forum SET post_count=".intzero($mc).", last_post_id=".intzero($lpi).", thread_count=".intzero($tc)." WHERE id=".$this->forum_id);
		}	
		
		if( $rebuild_view ) rebuild_forum_view($this->forum_id);
	}
	
	function lock()
	{
		q("UPDATE fud21_thread SET locked='Y' WHERE id=".$this->id);
	}
	
	function unlock()
	{
		q("UPDATE fud21_thread SET locked='N' WHERE id=".$this->id);
	}
	
	function move($to_forum)
	{
		if ( !db_locked() ) {
			db_lock('fud21_thread_view+, fud21_thread+, fud21_forum+, fud21_msg+');
			$local_lock = 1;
		}
		$msg_count = q_singleval("SELECT count(*) FROM fud21_thread LEFT JOIN fud21_msg ON fud21_msg.thread_id=fud21_thread.id WHERE fud21_msg.approved='Y' AND fud21_thread.id=".$this->id);
		
		q("UPDATE fud21_thread SET forum_id=".$to_forum." WHERE id=".$this->id);
		q("UPDATE fud21_forum SET post_count=post_count-".$msg_count." WHERE id=".$this->forum_id);
		q("UPDATE fud21_forum SET thread_count=thread_count+1,post_count=post_count+".$msg_count." WHERE id=".$to_forum);
		$r=q("DELETE FROM fud21_thread WHERE forum_id=".$to_forum." AND root_msg_id=".$this->root_msg_id." AND moved_to=".$this->forum_id);
		if( $aff_rows=db_affected($r) ) q("UPDATE fud21_forum SET thread_count=thread_count-".$aff_rows." WHERE id=".$to_forum);
		q("UPDATE fud21_thread SET moved_to=".$to_forum." WHERE id!=".$this->id." AND root_msg_id=".$this->root_msg_id);
		
		q("INSERT INTO fud21_thread(
			forum_id,
			root_msg_id,
			last_post_date,
			last_post_id,
			moved_to
		)
		VALUES(
			".$this->forum_id.",
			".$this->root_msg_id.",
			".$this->last_post_date.",
			".$this->last_post_id.",
			".$to_forum."
		)");
		
		rebuild_forum_view($this->forum_id);
		rebuild_forum_view($to_forum);
		
		if ( !empty($local_lock) ) db_unlock();
	}
	
	function inc_post_count($val)
	{
		q("UPDATE fud21_thread SET replies=replies+".$val." WHERE id=".$this->id);
	}
	
	function inc_view_count()
	{
		q("UPDATE fud21_thread SET views=views+1 WHERE id=".$this->id);
	}
	
	function dec_view_count($val)
	{
		q("UPDATE fud21_thread SET views=views-1 WHERE id=".$this->id);
	}
	
	function get_notify_list($user_id)
	{
		$ctm = __request_timestamp__;
		$tm = $ctm-604800;
	
		$r = q("SELECT 
				fud21_users.id AS user_id,
				fud21_users.email,
				fud21_users.icq,
				fud21_read.last_view,
				fud21_read.id,
				fud21_users.notify_method 
			FROM 
				fud21_thread_notify
				INNER JOIN fud21_users 
					ON fud21_thread_notify.user_id=fud21_users.id 
				LEFT JOIN fud21_read 
					ON fud21_read.user_id=fud21_thread_notify.user_id 
					AND fud21_read.thread_id=fud21_thread_notify.thread_id 
			WHERE 
				( fud21_read.msg_id=".$this->last_post_id." OR fud21_read.last_view < ".$tm." )
				AND fud21_thread_notify.thread_id=".$this->id." 
				AND fud21_thread_notify.user_id!=".intzero($user_id));
		
		$p = forum_perm_array($this->forum_id);
		$to=NULL;
		while ( $obj = db_rowobj($r) ) {
			if ( !is_allowed($obj->user_id, $p) ) continue;
			
			$to[$obj->notify_method][] = ( $obj->notify_method == 'EMAIL' ) ? $obj->email : $obj->icq.'@pager.icq.com';
			if( $obj->last_view < $tm ) q("UPDATE fud21_read SET last_view=".$ctm." WHERE id=".$obj->id);
		}
		qf($r);
		
		return $to;
	}
	
	function adm_set_rating($value)
	{
		q("UPDATE fud21_thread SET rating=".intnull($value)." WHERE id=".$this->id);
	}

	function has_thread_vote($user_id, $thread_id='')
	{
		if ( !$thread_id ) $thread_id = $this->id;
		
		if( ($rating=q_singleval("SELECT rating FROM fud21_thread_rate_track WHERE thread_id=".$thread_id." AND user_id=".$user_id)) ) {
			return $rating;	
		}
		return -1;
	}
	
	function update_vote_count()
	{
		$rating = q_singleval("SELECT ROUND(AVG(rating)) FROM fud21_thread_rate_track WHERE thread_id=".$this->id);
		q("UPDATE fud21_thread SET rating=".$rating." WHERE id=".$this->id);
	}
	
	function vote_count($thread_id='')
	{
		if ( !$thread_id ) $thread_id = $this->id;
		
		return q_singleval("SELECT COUNT(*) FROM fud21_thread_rate_track WHERE thread_id=".$thread_id);
	}
	
	function register_thread_vote($user_id, $rating, $thread_id='')
	{
		if ( !$thread_id ) $thread_id = $this->id;
		
		if( !db_locked() ) {
			db_lock('fud21_thread_rate_track+, fud21_thread+');
			$local_lock = 1;
		}
		
		if( $this->has_thread_vote($user_id, $thread_id) != -1 ) {
			if ( $local_lock ) db_unlock();
			return;
		}	
		
		q("INSERT INTO fud21_thread_rate_track (
			thread_id,
			user_id,
			stamp,
			rating
			)
		VALUES(
			".$thread_id.",
			".$user_id.",
			".__request_timestamp__.",
			".$rating."
		)");
		
		$rating = q_singleval("SELECT ROUND(AVG(rating)) FROM fud21_thread_rate_track WHERE thread_id=".$thread_id);
		
		q("UPDATE fud21_thread SET rating=".$rating." WHERE id=".$thread_id);
		
		if ( $local_lock ) db_unlock();
	}
}

function rebuild_forum_view($forum_id, $page=0)
{
	if( !db_locked() ) {
	        db_lock('fud21_thread_view+, fud21_thread+, fud21_msg+, fud21_forum+');
		$local_lock=1;
	}
	
	$tm = __request_timestamp__;
	
	/* Remove expired moved thread pointers */
	$r=q("DELETE FROM fud21_thread WHERE forum_id=".$forum_id." AND last_post_date<".($tm-86400*$GLOBALS['MOVED_THR_PTR_EXPIRY'])." AND moved_to!=0");
	if( $aff_rows = db_affected($r) ) {
		q("UPDATE fud21_forum SET thread_count=thread_count-".$aff_rows." WHERE id=".$forum_id);
		$page = 0;
	}
	
	/* De-announce expired announcments and sticky messages */
	$r = q("SELECT fud21_thread.id FROM fud21_thread INNER JOIN fud21_msg ON fud21_thread.root_msg_id=fud21_msg.thread_id WHERE fud21_thread.forum_id=".$forum_id." AND is_sticky='Y' AND (fud21_msg.post_stamp+fud21_thread.orderexpiry)<".$tm);
	while( list($tid) = db_rowarr($r) ) 
		q("UPDATE fud21_thread SET ordertype='NONE', is_sticky='N' WHERE id=".$tid);
	qf($r);

	if ( __dbtype__ == 'pgsql' ) {
		$tmp_tbl_name = "fud21_ftvt_".get_random_value();
		q("CREATE TEMP TABLE ".$tmp_tbl_name." ( forum_id INT NOT NULL, page INT8 NOT NULL, thread_id INT NOT NULL, pos SERIAL, tmp INT )");
		
		if( $page ) {
			q("DELETE FROM fud21_thread_view WHERE forum_id=".$forum_id." AND page<".($page+1));
			q("INSERT INTO ".$tmp_tbl_name." (thread_id,forum_id,page,tmp) SELECT fud21_thread.id, fud21_thread.forum_id, 4294967294, CASE WHEN is_sticky='Y' AND (fud21_msg.post_stamp+fud21_thread.orderexpiry>".$tm." OR fud21_thread.orderexpiry=0) THEN 4294967294 ELSE fud21_thread.last_post_date END AS sort_order_fld  FROM fud21_thread INNER JOIN fud21_msg ON fud21_thread.root_msg_id=fud21_msg.id WHERE forum_id=".$forum_id." AND fud21_msg.approved='Y' ORDER BY sort_order_fld DESC, fud21_thread.last_post_id DESC LIMIT ".($GLOBALS['THREADS_PER_PAGE']*$page).", 0");
		}
		else {
			q("DELETE FROM fud21_thread_view WHERE forum_id=".$forum_id);
			q("INSERT INTO ".$tmp_tbl_name." (thread_id,forum_id,page,tmp) SELECT fud21_thread.id, fud21_thread.forum_id, 2147483647, CASE WHEN is_sticky='Y' AND (fud21_msg.post_stamp+fud21_thread.orderexpiry>".$tm." OR fud21_thread.orderexpiry=0) THEN 2147483647 ELSE fud21_thread.last_post_date END AS sort_order_fld  FROM fud21_thread INNER JOIN fud21_msg ON fud21_thread.root_msg_id=fud21_msg.id WHERE forum_id=".$forum_id." AND fud21_msg.approved='Y' ORDER BY sort_order_fld DESC, fud21_thread.last_post_id DESC");
		}
		
		q("INSERT INTO fud21_thread_view (thread_id,forum_id,page,pos) SELECT thread_id,forum_id,CEIL(pos/40.0),(pos-(CEIL(pos/40)-1)*40) FROM ".$tmp_tbl_name);
		q("DROP SEQUENCE ".$tmp_tbl_name."_pos_seq");
		q("DROP TABLE ".$tmp_tbl_name);
		return;
	}
	else if ( __dbtype__ == 'mysql' ) {
		if( $page ) {
			q("DELETE FROM fud21_thread_view WHERE forum_id=".$forum_id." AND page<".($page+1));
			q("INSERT INTO fud21_thread_view (thread_id,forum_id,page,tmp) SELECT fud21_thread.id, fud21_thread.forum_id, 4294967294, CASE WHEN is_sticky='Y' AND (fud21_msg.post_stamp+fud21_thread.orderexpiry>".$tm." OR fud21_thread.orderexpiry=0) THEN 4294967294 ELSE fud21_thread.last_post_date END AS sort_order_fld  FROM fud21_thread INNER JOIN fud21_msg ON fud21_thread.root_msg_id=fud21_msg.id WHERE forum_id=".$forum_id." AND fud21_msg.approved='Y' ORDER BY sort_order_fld DESC, fud21_thread.last_post_id DESC LIMIT 0, ".($GLOBALS['THREADS_PER_PAGE']*$page));
			q("UPDATE fud21_thread_view SET page=CEILING(pos/".$GLOBALS['THREADS_PER_PAGE']."), pos=pos-(CEILING(pos/".$GLOBALS['THREADS_PER_PAGE'].")-1)*".$GLOBALS['THREADS_PER_PAGE']." WHERE forum_id=".$forum_id." AND page=4294967294");			
		}
		else {
			q("DELETE FROM fud21_thread_view WHERE forum_id=".$forum_id);
			q("INSERT INTO fud21_thread_view (thread_id,forum_id,page,tmp) SELECT fud21_thread.id, fud21_thread.forum_id, 4294967294, CASE WHEN is_sticky='Y' AND (fud21_msg.post_stamp+fud21_thread.orderexpiry>".$tm." OR fud21_thread.orderexpiry=0) THEN 4294967294 ELSE fud21_thread.last_post_date END AS sort_order_fld  FROM fud21_thread INNER JOIN fud21_msg ON fud21_thread.root_msg_id=fud21_msg.id WHERE forum_id=".$forum_id." AND fud21_msg.approved='Y' ORDER BY sort_order_fld DESC, fud21_thread.last_post_id DESC");
			q("UPDATE fud21_thread_view SET page=CEILING(pos/".$GLOBALS['THREADS_PER_PAGE']."), pos=pos-(CEILING(pos/".$GLOBALS['THREADS_PER_PAGE'].")-1)*".$GLOBALS['THREADS_PER_PAGE']." WHERE forum_id=".$forum_id);			
		}
	}
	if( $local_lock ) db_unlock();
}class fud_forum
{
	var $id=NULL;
	var $cat_id=NULL;
	var $name=NULL;
	var $descr=NULL;
	var $passwd_posting=NULL;
	var $post_passwd=NULL;
	var $anon_forum=NULL;
	var $forum_icon=NULL;
	var $tag_style=NULL;
	var $last_post_id=NULL;
	
	var $allow_polls=NULL;
	var $date_created=NULL;
	var $thread_count=NULL;
	var $view_order=NULL;
	var $message_threshold=NULL;
	
	var $moderated=NULL;
	var $max_attach_size=NULL;
	var $max_file_attachments=NULL;
	
	var $forums=NULL;
	var $cur_frm=NULL;
	
	var $locked=NULL;
	
	
	function get($id)
	{
		qobj("SELECT * FROM fud21_forum WHERE fud21_forum.id=".$id, $this);
		if( empty($this->id) ) invl_inp_err();
			
		return $id;		
	}
	
	function is_moderator($user_id)
	{
		return q_singleval("SELECT id FROM fud21_mod WHERE user_id=".$user_id." AND forum_id=".$this->id);
	}
	
	function inc_reply_count($val)
	{
		q("UPDATE fud21_forum SET post_count=post_count+".$val." WHERE id=".$this->id);
	}
	
	function dec_reply_count($val)
	{
		q("UPDATE fud21_forum SET post_count=post_count-".$val." WHERE id=".$this->id);
	}
	
	function inc_thread_count($val)
	{
		q("UPDATE fud21_forum SET thread_count=thread_count+".$val." WHERE id=".$this->id);
	}
	
	function dec_thread_count($val)
	{
		q("UPDATE fud21_forum SET thread_count=thread_count-".$val." WHERE id=".$this->id);
	}
	
	function get_notify_list($user_id)
	{
		$r = q("SELECT 
				fud21_users.email, 
				fud21_users.icq, 
				fud21_users.notify_method 
			FROM 
				fud21_forum_notify 
				INNER JOIN fud21_users 
					ON fud21_forum_notify.user_id=fud21_users.id 
			WHERE 
				fud21_forum_notify.forum_id=".$this->id." 
				AND fud21_forum_notify.user_id!=".$user_id);
		
		$p = forum_perm_array($this->id);
		$to=NULL;
		while ( $obj = db_rowobj($r) ) {
			if ( !is_allowed($obj->user_id, $p) ) continue;
			
			$to[$obj->notify_method][] = ( $obj->notify_method == 'EMAIL' ) ? $obj->email : $obj->icq.'@pager.icq.com';
		}

		qf($r);
				
		return $to;
	}
	
}

if ( defined('admin_form') && !defined("_forum_adm_inc_") ) fud_use('forum_adm.inc');class fud_msg
{
	var $id=NULL;
	var $thread_id=NULL;
	var $poster_id=NULL;
	var $reply_to=NULL;
	var $ip_addr=NULL;
	var $host_name=NULL;
	var $post_stamp=NULL;
	var $subject=NULL;
	var $attach_cnt=NULL;
	var $poll_id=NULL;
	var $update_stamp=NULL;
	var $icon=NULL;
	var $approved=NULL;
	var $show_sig=NULL;
	var $updated_by=NULL;
	var $smiley_disabled=NULL;
	var $login=NULL;
	var $length=NULL;
	var $foff=NULL;
	var $file_id=NULL;
	var $file_id_preview=NULL;
	var $length_preview=NULL;
	var $offset_preview=NULL;
	
	var $body;
		
	function get_by_id($id)
	{
		qobj("SELECT fud21_msg.*,fud21_users.alias AS login FROM fud21_msg LEFT JOIN fud21_users ON fud21_msg.poster_id=fud21_users.id WHERE fud21_msg.id=".$id, $this);
		if( empty($this->id) ) error_dialog('Invalid Message', 'The message you are trying to view does not exist.', '', 'FATAL');
		
		$this->body = read_msg_body($this->foff,$this->length, $this->file_id);
		un_register_fps();
	}
	
	function get_thread($th_id)
	{
		qobj("SELECT fud21_msg.* FROM fud21_msg INNER JOIN fud21_thread ON fud21_thread.root_msg_id=fud21_msg.id WHERE fud21_thread.id=".$th_id, $this);
		
		
		$this->body = read_msg_body($this->foff,$this->length, $this->file_id);
		un_register_fps();
	}
}

if ( defined('msg_edit') && !defined("_imsg_edit_inc_") ) fud_use('imsg_edt.inc');	
	
	if ( $MEMBER_SEARCH_ENABLED != 'Y' ) {
		std_error('disabled');
		exit();
	}
	
	if ( !empty($js_redr) ) define('plain_form', 1);
	
	$TITLE_EXTRA = ': Find User';
	if ( isset($ses) ) $ses->update('Searching for users');
	if( _uid ) {
	if( $usr->is_mod != 'N' && $usr->is_mod ) {
		if( $approve_count = q_singleval("SELECT count(*) FROM 
					fud21_msg 
					INNER JOIN fud21_thread 
						ON fud21_msg.thread_id=fud21_thread.id 
					INNER JOIN fud21_forum 
						ON fud21_thread.forum_id=fud21_forum.id 
					INNER JOIN fud21_mod 
						ON fud21_forum.id=fud21_mod.forum_id 
						".($GLOBALS["usr"]->is_mod != 'A' ? "AND fud21_mod.user_id="._uid : '')."  
					WHERE 
						fud21_msg.approved='N' 
						AND fud21_forum.moderated='Y'") ) 
			$mod_que = '<a class="GenLink" href="http://thelocust.org/bored/index.php?t=modque&'._rsid.'">Moderation Queue</a> <span class="GenText" style="color: #ff0000">('.$approve_count.')</span>';
		
		if( $GLOBALS["usr"]->is_mod == 'A' ) {
			if( $avatar_count = q_singleval("SELECT count(*) FROM fud21_users WHERE avatar_approved='N'") ) 
				$custom_avatar_queue = '| <a class="GenLink" href="adm/admapprove_avatar.php?'._rsid.'">Custom Avatar Queue</a> <span class="GenText" style="color: #ff0000">('.$avatar_count.')</span>';
	
			if( $report_count = q_singleval("SELECT count(*) FROM fud21_msg_report") ) 
				$reported_msgs = '| <a class="GenLink" href="http://thelocust.org/bored/index.php?t=reported&'._rsid.'">Reported Messages</a> <span class="GenText" style="color: #ff0000">('.$report_count.')</span>';
				
			if( $thr_exchc = q_singleval("SELECT count(*) FROM fud21_thr_exchange") )
				$thr_exch = '| <a class="GenLink" href="http://thelocust.org/bored/index.php?t=thr_exch&'._rsid.'">Thread Exchange </a> <span class="GenText" style="color: #ff0000">('.$thr_exchc.')</span>';
		}	
		else {
			if( $report_count = q_singleval("SELECT count(*) FROM fud21_msg_report INNER JOIN fud21_msg ON fud21_msg_report.msg_id=fud21_msg.id INNER JOIN fud21_thread ON fud21_msg.thread_id=fud21_thread.id INNER JOIN fud21_mod ON fud21_thread.forum_id=fud21_mod.forum_id AND fud21_mod.user_id=".$GLOBALS["usr"]->id) )
				$reported_msgs = '| <a class="GenLink" href="http://thelocust.org/bored/index.php?t=reported&'._rsid.'">Reported Messages</a> <span class="GenText" style="color: #ff0000">('.$report_count.')</span>';
			
			if( $thr_exchc = q_singleval("SELECT count(*) FROM fud21_thr_exchange INNER JOIN fud21_mod ON fud21_mod.user_id=".$usr->id." AND fud21_thr_exchange.frm=fud21_mod.forum_id") ) 
				$thr_exch = '| <a class="GenLink" href="http://thelocust.org/bored/index.php?t=thr_exch&'._rsid.'">Thread Exchange </a> <span class="GenText" style="color: #ff0000">('.$thr_exchc.')</span>';
		}
	}
	if( $usr->is_mod=='A' || bq("SELECT id FROM fud21_group_members WHERE user_id="._uid." AND group_leader='Y' LIMIT 1") )
		$group_mgr = '| <a class="GenLink" href="http://thelocust.org/bored/index.php?t=groupmgr&'._rsid.'">Group(s) Manager</a>';
	
	if( $thr_exch || $group_mgr || $reported_msgs || $custom_avatar_queue || $mod_que ) $admin_cp = '<br><font class="GenText"><b>Admin :</b></font> '.$mod_que.' '.$reported_msgs.' '.$thr_exch.' '.$custom_avatar_queue.' '.$group_mgr;
}$adm_str = $rid = $pm = '';
	$ret_to = '&returnto='.urlencode(!empty($GLOBALS['returnto'])?urldecode($GLOBALS['returnto']):$GLOBALS['HTTP_SERVER_VARS']['REQUEST_URI']);

	if ( empty($GLOBALS['usr']) ) {
		$login_n_logout = '<td valign="middle"><a class="UserControlPanel" href="http://thelocust.org/bored/index.php?t=login&'._rsid.$ret_to.'"><img src="http://thelocust.org/bored/theme/default/images/top_login.gif" border=0 alt="Login"></a></td>
<td valign="middle"><a class="UserControlPanel" href="http://thelocust.org/bored/index.php?t=login&'._rsid.$ret_to.'">Login</a></td>';
		$register_n_profile = '<td valign="middle"><a class="UserControlPanel" href="http://thelocust.org/bored/index.php?t=register&'._rsid.'"><img src="http://thelocust.org/bored/theme/default/images/top_register.gif" border=0 alt="Register"></a></td>
<td valign="middle"><a class="UserControlPanel" href="http://thelocust.org/bored/index.php?t=register&'._rsid.'">Register</a></td>';
	}
	else {
		if( $GLOBALS['usr']->is_mod == 'A' ) $admin_control_panel = '<td>&nbsp;&nbsp;</td><td valign="middle"><a class="UserControlPanel" href="adm/admglobal.php?'._rsid.'"><img src="http://thelocust.org/bored/theme/default/images/top_admin.gif" border=0 alt="Admin Control Panel"></a></td>
<td valign="middle"><a class="UserControlPanel" href="adm/admglobal.php?'._rsid.'">Admin Control Panel</a></td>';
		$user_login = htmlspecialchars($usr->alias);
		$login_n_logout = '<td valign="middle"><a class="UserControlPanel" href="http://thelocust.org/bored/index.php?t=login&'._rsid.$ret_to.'&logout=1"><img src="http://thelocust.org/bored/theme/default/images/top_logout.gif" border=0 alt="Logout"></a></td>
<td valign="middle"><a class="UserControlPanel" href="http://thelocust.org/bored/index.php?t=login&'._rsid.$ret_to.'&logout=1">Logout [ '.$user_login.' ]</a></td>';
		$register_n_profile = '<td valign="middle"><a class="UserControlPanel" href="http://thelocust.org/bored/index.php?t=register&'._rsid.'"><img src="http://thelocust.org/bored/theme/default/images/top_profile.gif" border=0 title="Click here to access user control panel" alt="Profile"></a></td>
<td valign="middle"><a class="UserControlPanel" href="http://thelocust.org/bored/index.php?t=register&'._rsid.'"><acronym title="Click here to access user control panel">Profile</acronym></a></td>';
		$rid = $GLOBALS["usr"]->id;
		
		if ( $GLOBALS['PM_ENABLED']=='Y' ) {
			$c = q_singleval("SELECT count(*) FROM fud21_pmsg WHERE duser_id=".$GLOBALS["usr"]->id." AND folder_id='INBOX' AND read_stamp=0");
			$private_msg = ( $c ) ? '<td>&nbsp;&nbsp;</td>
<td valign="middle"><a href="http://thelocust.org/bored/index.php?t=pmsg&'._rsid.'" class="UserControlPanel"><img src="http://thelocust.org/bored/theme/default/images/top_pm.gif" border=0 alt="Private Messaging"></a></td>
<td><a href="http://thelocust.org/bored/index.php?t=pmsg&'._rsid.'" class="UserControlPanel">You have <span class="GenText" style="color: #ff0000">('.$c.')</span> unread private message(s)</a></td>
<td>&nbsp;&nbsp;</td>' : '<td>&nbsp;&nbsp;</td>
<td valign="middle"><a href="http://thelocust.org/bored/index.php?t=pmsg&'._rsid.'" class="UserControlPanel"><img src="http://thelocust.org/bored/theme/default/images/top_pm.gif" border=0 alt="Private Messaging"></a></td>
<td><a href="http://thelocust.org/bored/index.php?t=pmsg&'._rsid.'" class="UserControlPanel">Private Messaging</a></td>
<td>&nbsp;&nbsp;</td>';
		}
	}/* FILE START */	

	$usr_login = ( !empty($usr_login) ) ? trim(stripslashes($usr_login)) : '';
	$usr_email = ( !empty($usr_email) ) ? trim(stripslashes($usr_email)) : '';
	
	if ( empty($start) ) $start = 0;
	if ( empty($count) ) $count = $GLOBALS['MEMBERS_PER_PAGE'];
	
	if( !empty($pc) ) 
		$ord = "posted_msg_count DESC";
	else if( !empty($us) ) 
		$ord = "alias";
	else
		$ord = "id DESC";	
	
	$np = 1;
	if ( !empty($btn_submit) ) {
		if( __dbtype__ == 'pgsql' ) {
			$usr_login = str_replace('\\', '\\\\', $usr_login);
			$usr_email = str_replace('\\', '\\\\', $usr_email);
		}
	
		if ( $usr_login )
			$qry = "WHERE LOWER(alias) LIKE '".strtolower(addslashes($usr_login))."%'";
		else if ( $usr_email ) 
			$qry = "WHERE LOWER(email) LIKE '".strtolower(addslashes($usr_email))."%'";
		else 
			$qry = '';	
			
		if( __dbtype__ == 'pgsql' ) {
		        $usr_login = str_replace('\\\\', '\\', $usr_login);
			$usr_email = str_replace('\\\\', '\\', $usr_email);
		}	
			
		$user_login = htmlspecialchars($usr_login);
		$user_email = htmlspecialchars($usr_email);
			
		if ( $start || $count ) $lim = "LIMIT ".qry_limit($count, $start);
		
		$returnto = urlencode('http://thelocust.org/bored/index.php?t=finduser&btn_submit=Find&start='.$start.'&'._rsid.'&count='.$count);
		$res = q("SELECT * FROM fud21_users ".$qry." ORDER BY ".$ord." ".$lim);
		$find_user_data = '';
		if ( !db_count($res) ){
			$find_user_data = '<tr class="RowStyleA"><td colspan=4 width="100%" class="GenText">No Such User</td></tr>';
		}
		else {
			$np = 0;
			$i=0;
			while ( $obj = db_rowobj($res) ) {
				$pm_link = ( $GLOBALS['PM_ENABLED'] == 'Y' && isset($usr) ) ? '<a href="http://thelocust.org/bored/index.php?t=ppost&'._rsid.'&msg_to_list='.urlencode($obj->login).'" class="GenLink"><img src="http://thelocust.org/bored/theme/default/images/msg_pm.gif" border=0></a>' : '';
				$homepage_link = strlen($obj->home_page) ? '<a class="GenLink" href="'.$obj->home_page.'" target=_new><img src="http://thelocust.org/bored/theme/default/images/homepage.gif" border=0></a>' : '';
				$email_link = ($GLOBALS["ALLOW_EMAIL"]=='Y' && $obj->email_messages=='Y') ? '<a href="http://thelocust.org/bored/index.php?t=email&tx_name='.urlencode($obj->login).'&returnto='.$returnto.'&'._rsid.'" class="GenLink"><img src="http://thelocust.org/bored/theme/default/images/msg_email.gif" border=0></a>' : '';
				$class = $i%2?'RowStyleA':'RowStyleB';
				$find_user_data .= '<tr class="'.$class.'"><td nowrap class="GenText"><a class="GenLink" href="http://thelocust.org/bored/index.php?t=usrinfo&id='.$obj->id.'&'._rsid.'">'.htmlspecialchars($obj->alias).'</a></td><td align="center" nowrap>'.$obj->posted_msg_count.'</td><td class="DateText" nowrap>'.strftime("%a, %d %B %Y", $obj->join_date).'</td><td nowrap class="GenText"><a href="http://thelocust.org/bored/index.php?t=showposts&id='.$obj->id.'&'._rsid.'" class="GenLink"><img src="http://thelocust.org/bored/theme/default/images/show_posts.gif" border=0></a>
'.$email_link.'
'.$pm_link.'
'.$homepage_link.'</td></tr>';
				$i++;
			}
		}
		
		qf($res);
	}
	else 
		$user_login = $user_email = '';

	if ( empty($np) ) {
		$total = q_singleval("SELECT count(*) FROM fud21_users ".(isset($qry)?$qry:''));
		if ( $total && !empty($btn_submit) ) $pager = tmpl_create_pager($start, $count, $total, 'http://thelocust.org/bored/index.php?t=finduser&usr_login='.urlencode($usr_login).'&'._rsid.'&usr_email='.$usr_email.'&pc='.(empty($pc)?'':$pc).'&us='.(empty($us)?'':$us).'&btn_submit=Find&js_redr='.(empty($js_redr)?'':$js_redr).'&append='.(empty($append)?'':$append));
	}
	
	$page_gen_time = (db_getmicrotime() - $GLOBALS['PAGE_TIME']);
$q_time = query_count();
$ttl_time = total_time();

if ( isset($usr) && $usr->is_mod == 'A' )
	$page_stats = '<br><div align="left" class="SmallText">'.$q_time.' MySQL queries took '.$ttl_time.' seconds<br>Total time taken to generate the page: '.$page_gen_time.' seconds</div>';
else if ( $GLOBALS['PUBLIC_STATS'] == 'Y' ) 
	$page_stats = '<br><div align="left" class="SmallText">'.$q_time.' MySQL queries took '.$ttl_time.' seconds<br>Total time taken to generate the page: '.$page_gen_time.' seconds</div>';
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<title><?php echo $GLOBALS['FORUM_TITLE']; ?><?php echo $TITLE_EXTRA; ?></title>
<META HTTP-EQUIV="Content-Type" CONTENT="text/html; charset=ISO-8859-15">
<script language="javascript" src="lib.js"></script>
<link rel="StyleSheet" href="http://thelocust.org/bored/theme/default/forum.css" type="text/css">
</head>
<body topmargin="2" leftmargin="2" marginheight="2" marginwidth="2">
<table width="100%" border="0" cellspacing="3" cellpadding="5"><tr><td class="ForumBackground">
<table border=0 cellspacing=0 cellpadding=0 width="100%"><tr><td align="right">
<table cellspacing=3 cellpadding=0 border=0>
	<tr>
		<td valign="middle"><a class="UserControlPanel" href="http://thelocust.org/bored/index.php?t=help_index&<?php echo _rsid; ?>"><img src="http://thelocust.org/bored/theme/default/images/top_help.gif" border=0 alt="F.A.Q."></a></td>
		<td valign="middle"><a class="UserControlPanel" href="http://thelocust.org/bored/index.php?t=help_index&<?php echo _rsid; ?>">F.A.Q.</a></td>
		<td>&nbsp;&nbsp;</td>
		<?php echo $register_n_profile; ?>
		<td>&nbsp;&nbsp;</td>
		<?php echo $login_n_logout; ?>
		<td>&nbsp;&nbsp;</td>
		<td valign="middle"><a class="UserControlPanel" href="http://thelocust.org/bored/index.php?t=index&<?php echo _rsid; ?>"><img src="http://thelocust.org/bored/theme/default/images/top_home.gif" border=0 alt="Home"></a></td>
		<td valign="middle"><a class="UserControlPanel" href="http://thelocust.org/bored/index.php?t=index&<?php echo _rsid; ?>">Home</a></td>
	</tr>
</table>
<table cellspacing=3 cellpadding=0 border=0>	
	<tr>	
		<?php echo $private_msg; ?>
		<td valign="middle"><a class="UserControlPanel" href="http://thelocust.org/bored/index.php?t=finduser&btn_submit=Find&<?php echo _rsid; ?>"><img src="http://thelocust.org/bored/theme/default/images/top_members.gif" border=0 alt="Members"></a></td>
		<td valign="middle"><a class="UserControlPanel" href="http://thelocust.org/bored/index.php?t=finduser&btn_submit=Find&<?php echo _rsid; ?>">Members</a></td>
		<td>&nbsp;&nbsp;</td>
		<td valign="middle"><a class="UserControlPanel" href="http://thelocust.org/bored/index.php?t=search&<?php echo _rsid; ?>"><img src="http://thelocust.org/bored/theme/default/images/top_search.gif" border=0 alt="Search"></a></td>
		<td valign="middle"><a class="UserControlPanel" href="http://thelocust.org/bored/index.php?t=search&<?php echo _rsid; ?>">Search</a></td>
		<?php echo $admin_control_panel; ?>
	</tr>
</table></td></tr></table>
<br><?php echo $admin_cp; ?>
<table border="0" cellspacing="1" cellpadding="2" class="ContentTable">
<tr><th colspan=2>User Information</th></tr>
<form method="post" action="http://thelocust.org/bored/index.php?t=finduser"><?php echo _hs; ?>
<tr class="RowStyleA"><td class="GenText" nowrap>By Login:</td><td class="GenText" width="100%"><input type="text" name="usr_login" value="<?php echo $user_login; ?>"></td></tr>
<tr class="RowStyleB"><td class="GenText" nowrap>By Email:</td><td width="100%"><input type="text" name="usr_email" value="<?php echo $user_email; ?>"></td></tr>
<tr class="RowStyleA"><td class="GenText" align="right" colspan=2><input type="submit" class="button" name="btn_submit" value="Find"></td></tr>
</form>
</table>
<img src="blank.gif" height=2 width=1 border=0><br>
<table border="0" cellspacing="1" cellpadding="2" class="ContentTable">
<tr>
<th width="100%"><a class="th_lnk" href="http://thelocust.org/bored/index.php?t=finduser&usr_login=<?php echo urlencode($user_login); ?>&usr_email=<?php echo urlencode($usr_email); ?>&us=1&btn_submit=Find&<?php echo _rsid; ?>">User</a></th><th nowrap><a href="http://thelocust.org/bored/index.php?t=finduser&usr_login=<?php echo urlencode($usr_login); ?>&<?php echo _rsid; ?>&usr_email=<?php echo urlencode($usr_email); ?>&pc=1&btn_submit=Find" class="th_lnk">Post Count</a></th><th nowrap align="center"><a href="http://thelocust.org/bored/index.php?t=finduser&usr_login=<?php echo urlencode($usr_login); ?>&<?php echo _rsid; ?>&usr_email=<?php echo urlencode($usr_email); ?>&btn_submit=Find" class="th_lnk">Join Date</a></th><th align=middle>Action</th>
</tr>
<?php echo $find_user_data; ?>
</table>
<?php echo $pager; ?>
<br><table bgcolor="#000000" border=0 cellspacing=1 cellpadding=1 align="center"><tr class="RowStyleA"><td class="SmallText"><b>Current Time:</b> 
<?php echo strftime("%a %b %e %H:%M:%S %Z %Y", __request_timestamp__); ?>
</td></tr></table>
<?php echo $page_stats; ?>
</td></tr></table>
<table width="100%" border="0" cellspacing="3" cellpadding="5"><tr><td class="ForumBackground" align="center">
<b>.::</b> <a href="mailto:<?php echo $GLOBALS['ADMIN_EMAIL']; ?>">Contact</a> <b>::</b> <a href="http://thelocust.org/bored/index.php?t=index&<?php echo _rsid; ?>">Home</a> <b>::.</b>
<p>
<span class="SmallText">Powered by: FUDforum <?php echo $GLOBALS['FORUM_VERSION']; ?><br>Copyright &copy;2001,2002 <a href="http://fud.prohost.org/" class="GenLink">Advanced Internet Designs Inc.</a></span>
</td></tr></table>
</body>
</html>