<?php
/***************************************************************************
*   copyright            : (C) 2001,2002 Advanced Internet Designs Inc.
*   email                : forum@prohost.org
*
*   $Id: remail.php.t,v 1.4 2002/07/08 23:15:19 hackie Exp $
****************************************************************************
          
****************************************************************************
*
*	This program is free software; you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation; either version 2 of the License, or
*	(at your option) any later version.
*
***************************************************************************/

	include_once "GLOBALS.php";
	if ( !defined('__index_page_start__') ) exit('sorry, you can not access this page');$GLOBALS['__REVERSE_ARRAY__'] = array('&amp;'=>'&','&quot;'=>'"','&lt;'=>'<','&gt;'=>'>');

function reverse_FMT(&$data)
{
	$data = strtr($data, $GLOBALS['__REVERSE_ARRAY__']);
}

function FMT($val)
{
	return htmlspecialchars(stripslashes($val));
}function validate_email($email)
{
        return !preg_match('!([-_A-Za-z0-9\.]+)\@([-_A-Za-z0-9\.]+)\.([A-Za-z0-9]{2,4})$!', $email);
}
        
class fud_email_block
{
	var $id;
	var $type;
	var $string;
	
	var $e_list;
	
	function add($type, $string)
	{
		q("INSERT INTO fud21_email_block(type, string) VALUES('".$type."', '".$string."')");
	} 
	
	function sync($type, $string)
	{
		q("UPDATE fud21_email_block SET type='".$type."', string='".$string."' WHERE id=".$this->id);
	}
	
	function get($id)
	{
		$res = q("SELECT * FROM fud21_email_block WHERE id=".$id);
		if ( !is_result($res) ) exit("no such email block");
		
		$obj = db_singleobj($res);
		
		$this->id 	= $obj->id;
		$this->type	= $obj->type;
		$this->string	= $obj->string;
	}
	
	function delete()
	{
		q("DELETE FROM fud21_email_block WHERE id=".$this->id);
	}
	
	function getall()
	{
		$res = q("SELECT * FROM fud21_email_block ORDER BY id");
		
		unset($this->e_list);
		while ( $obj = db_rowobj($res) ) {
			$this->e_list[] = $obj;
		}
		if ( isset($this->e_list) ) reset($this->e_list);
		qf($res); 
	}
	
	function counte()
	{
		if ( !isset($this->e_list) ) return;
		return count($this->e_list);
	}
	
	function resete()
	{
		if ( !isset($this->e_list) ) return;
		reset($this->e_list);
	}
	
	function eache()
	{
		if ( !isset($this->e_list) ) return;
		$obj = current($this->e_list);
		if ( !isset($obj) ) return;
		next($this->e_list);
		
		return $obj;
	}
}

function is_email_blocked($addr)
{

	if ( bq("SELECT * FROM fud21_email_block WHERE string='".$addr."'") ) return 1;

	$r = q("SELECT * FROM fud21_email_block ORDER BY id");
	while ( $obj = db_rowobj($r) ) {
		if ( $obj->type == 'SIMPLE' ) {
			$reg = $obj->string;
			$reg = str_replace('.', '\.', $reg);
			$reg = str_replace('*', '.*?', $reg);			
			if ( preg_match("!".$reg."!i", $addr, $res) ) {
				return 1;
			}
		}
		else if ( $obj->type == 'REGEX' ) {
			$reg = $obj->string;
			if ( preg_match("!".$reg."!i", $addr, $res) ) {
				return 1;
			}	
		}
	}
	qf($r);
	
	return 0;
}

function send_email($from, $to, $subj, $body, $header='')
{
	if( empty($to) || !count($to) ) return;	
	$bcc='';
	
	if( is_array($to) ) {
		if( ($a = count($to)) > 1 ) {
			$bcc = "Bcc: ";
			for( $i=1; $i<$a; $i++ ) 
				$bcc .= $to[$i].', ';
				
			$bcc = substr($bcc,0,-2);	
		}		

		$to = $to[0];
	}
	
	mail($to, $subj, $body, "From: $from\r\nErrors-To: $from\r\nReturn-Path: $from\r\nX-Mailer: FUDforum v".$GLOBALS['FORUM_VERSION']."\r\n".$header.$bcc);
}

function send_notifications($to, $msg_id, $thr_subject, $poster_login, $id_type, $id, $frm_name='')
{
	$icq = str_replace("http://", "http'+'://'+'", $GLOBALS['WWW_ROOT']);
	$icq = str_replace("www.", "www'+'.", $icq);

	$goto_url['icq'] = "javascript:window.location='".$icq."index.php?t=rview&goto=".$msg_id."';";
	$goto_url['email'] = $GLOBALS['WWW_ROOT'].'index.php?t=rview&goto='.$msg_id;
	
	
	if ( $GLOBALS['NOTIFY_WITH_BODY'] == 'Y' ) {
		$r = q("SELECT 
			fud21_msg.*, 
			fud21_thread.locked,
			fud21_thread.forum_id,
			fud21_avatar.img AS avatar, 
			fud21_users.id AS user_id, 
			fud21_users.alias AS login, 
			fud21_users.display_email, 
			fud21_users.avatar_approved,
			fud21_users.avatar_loc,
			fud21_users.email, 
			fud21_users.posted_msg_count, 
			fud21_users.join_date, 
			fud21_users.location, 
			fud21_users.sig,
			fud21_users.icq,
			fud21_users.jabber,
			fud21_users.aim,
			fud21_users.msnm,
			fud21_users.invisible_mode,
			fud21_users.email_messages,
			fud21_users.last_visit AS time_sec,
			fud21_users.is_mod,
			fud21_users.yahoo,
			fud21_users.custom_status,
			fud21_level.name AS level_name,
			fud21_level.pri AS level_pri,
			fud21_level.img AS level_img
		FROM 
			fud21_msg 
			LEFT JOIN fud21_users 
				ON fud21_msg.poster_id=fud21_users.id 
			LEFT JOIN fud21_avatar 
				ON fud21_users.avatar=fud21_avatar.id 
			INNER JOIN fud21_thread
				ON fud21_msg.thread_id=fud21_thread.id	
			LEFT JOIN fud21_ses
				ON fud21_ses.user_id=fud21_msg.poster_id
			LEFT JOIN fud21_level
				ON fud21_users.level_id=fud21_level.id
		WHERE 
			fud21_msg.id=".$msg_id." AND fud21_msg.approved='Y'");
		
		$obj = db_singleobj($r);
		unset($obj->ip_addr);
		$headers  = "MIME-Version: 1.0\r\n";
		$split = get_random_value(128);
		$headers .= "Content-Type: multipart/alternative; boundary=\"------------$split\"\r\n";
		$boundry = "\r\n--------------$split\r\n";
		
		$plain_text = read_msg_body($obj->foff,$obj->length, $obj->file_id);
		$plain_text = $boundry."Content-Type: text/plain; charset=".$GLOBALS['CHARSET']."; format=flowed\r\nContent-Transfer-Encoding: 7bit\r\n\r\n".strip_tags($plain_text)."\r\n\r\nTo participate in the discussion, go here: ".$GLOBALS['WWW_ROOT'].'index.php?t=rview&th='.$id."&notify=1&opt=off\r\n";
		
		$mod = $GLOBALS['MOD'];
		$GLOBALS['MOD'] = 1;
		$GLOBALS['pl_view'] = $obj->poll_id;
		$body_email = tmpl_drawmsg($obj,NULL,NULL,'');
		$GLOBALS['MOD'] = $mod;
		
		$body_email = $boundry."Content-Type: text/html; charset=".$GLOBALS['CHARSET']."\r\nContent-Transfer-Encoding: 7bit\r\n\r\n".'<html>
<head>
<META HTTP-EQUIV="Content-Type" CONTENT="text/html; charset=ISO-8859-15">
<title>'.$GLOBALS['FORUM_TITLE'].$TITLE_EXTRA.'</title>
<BASE HREF="'.$GLOBALS['WWW_ROOT'].'">
<script language="JavaScript" src="lib.js"></script>
<link rel="StyleSheet" href="http://thelocust.org/bored/theme/default/forum.css" type="text/css">
</head>
<body topmargin="2" leftmargin="2" marginheight="2" marginwidth="2">
<table width="100%" border="0" cellspacing="3" cellpadding="5"><tr><td class="ForumBackground">
<table border="0" cellspacing="1" cellpadding="2" class="ContentTable">
<tr>
	<th width=1>Author</th>
	<th>Thread</th>
</tr>
'.$body_email.'
</table>
</td></tr></table></body></html>'."\r\n";
		$body_email = $plain_text.$body_email.substr($boundry, 0, -2)."--\r\n";
	}
	
	reverse_FMT($thr_subject);
	reverse_FMT($poster_login);
	
	if( $id_type == 'thr' ) {
		$subj = 'New reply to '.$thr_subject.' by '.$poster_login;
		
		if( !$body_email ) {
			$unsub_url['email'] = $GLOBALS['WWW_ROOT'].'index.php?t=rview&th='.$id.'&notify=1&opt=off';
			$body_email = 'To view unread replies goto '.$goto_url['email'].'

If you do not wish to receive further notifications about replies in this thread, please go here: '.$unsub_url['email'];
		}	
		
		$body_icq = 'To view unread replies goto
'.$goto_url['icq'].'

If you do not wish to receive further notifications about replies in this thread, please go here:
'.$unsub_url['icq'];
		$unsub_url['icq'] = "javascript:window.location='".$icq."index.php?t=rview&th=".$id."&notify=1&opt=off';";
	}
	else if ( $id_type == 'frm' ) {
		reverse_FMT($frm_name);
		
		$subj = 'New thread in forum '.$frm_name.' called '.$thr_subject.' by '.$poster_login;
		
		$unsub_url['icq'] = "javascript:window.location='".$icq."index.php?t=thread&unsub=1&frm_id=".$id."';";
		$body_icq = 'To view the thread goto:
'.$goto_url['icq'].'

To stop receiving notifications about new threads in this forum, please go here:
'.$unsub_url['icq'];
		
		if( !$body_email ) {
			$unsub_url['email'] = $GLOBALS['WWW_ROOT'].'index.php?t=thread&unsub=1&frm_id='.$id;
			$body_email = 'To view the thread goto:
'.$goto_url['email'].'

To stop receiving notifications about new threads in this forum, please go here: '.$unsub_url['email'];
		}	
	}	
	
	send_email($GLOBALS["FORUM_TITLE"].' <'.$GLOBALS['NOTIFY_FROM'].'>', $to['EMAIL'], $subj, $body_email, $headers);
	send_email($GLOBALS["FORUM_TITLE"].' <'.$GLOBALS['NOTIFY_FROM'].'>', $to['ICQ'], $subj, $body_icq);
}function fetch_vars($pref, &$obj, $arr)
{
	reset($obj);
	while ( list($k, $v) = each($obj) ) {
		if ( isset($arr[$pref.$k]) ) $obj->{$k} = $arr[$pref.$k];
	}
}
	
function export_vars($pref, &$obj)
{
	reset($obj);
	while ( list($k, $v) = each($obj) ) {
		if ( isset($obj->{$k}) ) $GLOBALS[$pref.$k] = $v;
	}
}

function empty_object(&$obj)
{
	reset($obj);
	while ( list($k, $v) = each($obj) ) $obj->{$k} = NULL;
}class fud_thread
{
	var $id=NULL;
	var $forum_id=NULL;
	var $root_msg_id=NULL;
	var $last_post_date=NULL;
	var $replies=NULL;
	var $views=NULL;
	var $rating=NULL;
	var $last_post_id=NULL;
	var $locked=NULL;
	var $is_sticky=NULL;
	var $ordertype=NULL;
	var $orderexpiry=NULL;
	
	var $subject=NULL;
	var $db_thread=NULL;
	
	function add($root, $forum_id, $locked=NULL, $is_sticky=NULL, $ordertype=NULL, $orderexpiry=NULL) 
	{
		$r = q("INSERT INTO 
			fud21_thread(
				forum_id, 
				root_msg_id, 
				last_post_date, 
				replies, 
				views, 
				rating, 
				last_post_id,
				locked, 
				is_sticky,
				ordertype,
				orderexpiry
			)
			VALUES
			(
				".$forum_id.",
				".$root.",
				".__request_timestamp__.",
				0,
				0,
				0,
				".$root.",
				'".yn($locked)."',
				'".yn($is_sticky)."',
				".ifnull($ordertype, "'NONE'").",
				".intzero($orderexpiry)."
			)");
		
		$this->id = db_lastid("fud21_thread", $r);
		
		return $this->id;
	}
	
	function sync()
	{
		list($old_sticky,$forum_id) = db_singlearr(q("SELECT is_sticky,forum_id FROM fud21_thread WHERE id=".$this->id));
	
		q("UPDATE fud21_thread SET 
			is_sticky='".yn($this->is_sticky)."',
			ordertype=".ifnull($this->ordertype, "'NONE'").",
			orderexpiry=".intnull($this->orderexpiry).",
			locked='".yn($this->locked)."'
		WHERE id=".$this->id);
		
		if( $old_sticky != yn($this->is_sticky) ) rebuild_forum_view($forum_id);
	}
	
	function get_by_id($id)
	{
		$result = qobj("SELECT 
				fud21_thread.*,
				fud21_msg.subject
			FROM 
				fud21_thread 
				LEFT JOIN fud21_msg 
					ON fud21_thread.root_msg_id=fud21_msg.id 
				LEFT JOIN fud21_forum 
					ON fud21_thread.forum_id=fud21_forum.id 
				LEFT JOIN fud21_cat 
					ON fud21_forum.cat_id=fud21_cat.id 
			WHERE 
				fud21_thread.id=".$id, $this);
		if ( empty($this->id) ) error_dialog('Invalid thread ID','You\'ve followed an invalid link, the thread you are trying to view does not exist.','', 'FATAL');
	}

	function delete($rebuild_view=TRUE)
	{
		$msg = new fud_msg_edit;
		qobj("SELECT * FROM fud21_msg WHERE id=".$this->root_msg_id, $msg);
		if( !empty($msg->id) )
			$msg->delete(FALSE);
		else {
			q("DELETE FROM fud21_thread WHERE id=".$this->id);
			$tc = q_singleval("SELECT count(*) FROM fud21_thread INNER JOIN fud21_msg ON fud21_thread.root_msg_id=fud21_msg.id WHERE forum_id=".$this->forum_id." AND fud21_msg.approved='Y'");
			$mc = q_singleval("SELECT SUM(replies) FROM fud21_thread INNER JOIN fud21_msg ON fud21_thread.root_msg_id=fud21_msg.id WHERE forum_id=".$this->forum_id." AND fud21_msg.approved='Y'");
			$mc += $tc;
			$lpi = q_singleval("SELECT MAX(last_post_id) FROM fud21_thread INNER JOIN fud21_msg ON fud21_thread.root_msg_id=fud21_msg.id WHERE forum_id=".$this->forum_id." AND fud21_msg.approved='Y'");
			q("UPDATE fud21_forum SET post_count=".intzero($mc).", last_post_id=".intzero($lpi).", thread_count=".intzero($tc)." WHERE id=".$this->forum_id);
		}	
		
		if( $rebuild_view ) rebuild_forum_view($this->forum_id);
	}
	
	function lock()
	{
		q("UPDATE fud21_thread SET locked='Y' WHERE id=".$this->id);
	}
	
	function unlock()
	{
		q("UPDATE fud21_thread SET locked='N' WHERE id=".$this->id);
	}
	
	function move($to_forum)
	{
		if ( !db_locked() ) {
			db_lock('fud21_thread_view+, fud21_thread+, fud21_forum+, fud21_msg+');
			$local_lock = 1;
		}
		$msg_count = q_singleval("SELECT count(*) FROM fud21_thread LEFT JOIN fud21_msg ON fud21_msg.thread_id=fud21_thread.id WHERE fud21_msg.approved='Y' AND fud21_thread.id=".$this->id);
		
		q("UPDATE fud21_thread SET forum_id=".$to_forum." WHERE id=".$this->id);
		q("UPDATE fud21_forum SET post_count=post_count-".$msg_count." WHERE id=".$this->forum_id);
		q("UPDATE fud21_forum SET thread_count=thread_count+1,post_count=post_count+".$msg_count." WHERE id=".$to_forum);
		$r=q("DELETE FROM fud21_thread WHERE forum_id=".$to_forum." AND root_msg_id=".$this->root_msg_id." AND moved_to=".$this->forum_id);
		if( $aff_rows=db_affected($r) ) q("UPDATE fud21_forum SET thread_count=thread_count-".$aff_rows." WHERE id=".$to_forum);
		q("UPDATE fud21_thread SET moved_to=".$to_forum." WHERE id!=".$this->id." AND root_msg_id=".$this->root_msg_id);
		
		q("INSERT INTO fud21_thread(
			forum_id,
			root_msg_id,
			last_post_date,
			last_post_id,
			moved_to
		)
		VALUES(
			".$this->forum_id.",
			".$this->root_msg_id.",
			".$this->last_post_date.",
			".$this->last_post_id.",
			".$to_forum."
		)");
		
		rebuild_forum_view($this->forum_id);
		rebuild_forum_view($to_forum);
		
		if ( !empty($local_lock) ) db_unlock();
	}
	
	function inc_post_count($val)
	{
		q("UPDATE fud21_thread SET replies=replies+".$val." WHERE id=".$this->id);
	}
	
	function inc_view_count()
	{
		q("UPDATE fud21_thread SET views=views+1 WHERE id=".$this->id);
	}
	
	function dec_view_count($val)
	{
		q("UPDATE fud21_thread SET views=views-1 WHERE id=".$this->id);
	}
	
	function get_notify_list($user_id)
	{
		$ctm = __request_timestamp__;
		$tm = $ctm-604800;
	
		$r = q("SELECT 
				fud21_users.id AS user_id,
				fud21_users.email,
				fud21_users.icq,
				fud21_read.last_view,
				fud21_read.id,
				fud21_users.notify_method 
			FROM 
				fud21_thread_notify
				INNER JOIN fud21_users 
					ON fud21_thread_notify.user_id=fud21_users.id 
				LEFT JOIN fud21_read 
					ON fud21_read.user_id=fud21_thread_notify.user_id 
					AND fud21_read.thread_id=fud21_thread_notify.thread_id 
			WHERE 
				( fud21_read.msg_id=".$this->last_post_id." OR fud21_read.last_view < ".$tm." )
				AND fud21_thread_notify.thread_id=".$this->id." 
				AND fud21_thread_notify.user_id!=".intzero($user_id));
		
		$p = forum_perm_array($this->forum_id);
		$to=NULL;
		while ( $obj = db_rowobj($r) ) {
			if ( !is_allowed($obj->user_id, $p) ) continue;
			
			$to[$obj->notify_method][] = ( $obj->notify_method == 'EMAIL' ) ? $obj->email : $obj->icq.'@pager.icq.com';
			if( $obj->last_view < $tm ) q("UPDATE fud21_read SET last_view=".$ctm." WHERE id=".$obj->id);
		}
		qf($r);
		
		return $to;
	}
	
	function adm_set_rating($value)
	{
		q("UPDATE fud21_thread SET rating=".intnull($value)." WHERE id=".$this->id);
	}

	function has_thread_vote($user_id, $thread_id='')
	{
		if ( !$thread_id ) $thread_id = $this->id;
		
		if( ($rating=q_singleval("SELECT rating FROM fud21_thread_rate_track WHERE thread_id=".$thread_id." AND user_id=".$user_id)) ) {
			return $rating;	
		}
		return -1;
	}
	
	function update_vote_count()
	{
		$rating = q_singleval("SELECT ROUND(AVG(rating)) FROM fud21_thread_rate_track WHERE thread_id=".$this->id);
		q("UPDATE fud21_thread SET rating=".$rating." WHERE id=".$this->id);
	}
	
	function vote_count($thread_id='')
	{
		if ( !$thread_id ) $thread_id = $this->id;
		
		return q_singleval("SELECT COUNT(*) FROM fud21_thread_rate_track WHERE thread_id=".$thread_id);
	}
	
	function register_thread_vote($user_id, $rating, $thread_id='')
	{
		if ( !$thread_id ) $thread_id = $this->id;
		
		if( !db_locked() ) {
			db_lock('fud21_thread_rate_track+, fud21_thread+');
			$local_lock = 1;
		}
		
		if( $this->has_thread_vote($user_id, $thread_id) != -1 ) {
			if ( $local_lock ) db_unlock();
			return;
		}	
		
		q("INSERT INTO fud21_thread_rate_track (
			thread_id,
			user_id,
			stamp,
			rating
			)
		VALUES(
			".$thread_id.",
			".$user_id.",
			".__request_timestamp__.",
			".$rating."
		)");
		
		$rating = q_singleval("SELECT ROUND(AVG(rating)) FROM fud21_thread_rate_track WHERE thread_id=".$thread_id);
		
		q("UPDATE fud21_thread SET rating=".$rating." WHERE id=".$thread_id);
		
		if ( $local_lock ) db_unlock();
	}
}

function rebuild_forum_view($forum_id, $page=0)
{
	if( !db_locked() ) {
	        db_lock('fud21_thread_view+, fud21_thread+, fud21_msg+, fud21_forum+');
		$local_lock=1;
	}
	
	$tm = __request_timestamp__;
	
	/* Remove expired moved thread pointers */
	$r=q("DELETE FROM fud21_thread WHERE forum_id=".$forum_id." AND last_post_date<".($tm-86400*$GLOBALS['MOVED_THR_PTR_EXPIRY'])." AND moved_to!=0");
	if( $aff_rows = db_affected($r) ) {
		q("UPDATE fud21_forum SET thread_count=thread_count-".$aff_rows." WHERE id=".$forum_id);
		$page = 0;
	}
	
	/* De-announce expired announcments and sticky messages */
	$r = q("SELECT fud21_thread.id FROM fud21_thread INNER JOIN fud21_msg ON fud21_thread.root_msg_id=fud21_msg.thread_id WHERE fud21_thread.forum_id=".$forum_id." AND is_sticky='Y' AND (fud21_msg.post_stamp+fud21_thread.orderexpiry)<".$tm);
	while( list($tid) = db_rowarr($r) ) 
		q("UPDATE fud21_thread SET ordertype='NONE', is_sticky='N' WHERE id=".$tid);
	qf($r);

	if ( __dbtype__ == 'pgsql' ) {
		$tmp_tbl_name = "fud21_ftvt_".get_random_value();
		q("CREATE TEMP TABLE ".$tmp_tbl_name." ( forum_id INT NOT NULL, page INT8 NOT NULL, thread_id INT NOT NULL, pos SERIAL, tmp INT )");
		
		if( $page ) {
			q("DELETE FROM fud21_thread_view WHERE forum_id=".$forum_id." AND page<".($page+1));
			q("INSERT INTO ".$tmp_tbl_name." (thread_id,forum_id,page,tmp) SELECT fud21_thread.id, fud21_thread.forum_id, 4294967294, CASE WHEN is_sticky='Y' AND (fud21_msg.post_stamp+fud21_thread.orderexpiry>".$tm." OR fud21_thread.orderexpiry=0) THEN 4294967294 ELSE fud21_thread.last_post_date END AS sort_order_fld  FROM fud21_thread INNER JOIN fud21_msg ON fud21_thread.root_msg_id=fud21_msg.id WHERE forum_id=".$forum_id." AND fud21_msg.approved='Y' ORDER BY sort_order_fld DESC, fud21_thread.last_post_id DESC LIMIT ".($GLOBALS['THREADS_PER_PAGE']*$page).", 0");
		}
		else {
			q("DELETE FROM fud21_thread_view WHERE forum_id=".$forum_id);
			q("INSERT INTO ".$tmp_tbl_name." (thread_id,forum_id,page,tmp) SELECT fud21_thread.id, fud21_thread.forum_id, 2147483647, CASE WHEN is_sticky='Y' AND (fud21_msg.post_stamp+fud21_thread.orderexpiry>".$tm." OR fud21_thread.orderexpiry=0) THEN 2147483647 ELSE fud21_thread.last_post_date END AS sort_order_fld  FROM fud21_thread INNER JOIN fud21_msg ON fud21_thread.root_msg_id=fud21_msg.id WHERE forum_id=".$forum_id." AND fud21_msg.approved='Y' ORDER BY sort_order_fld DESC, fud21_thread.last_post_id DESC");
		}
		
		q("INSERT INTO fud21_thread_view (thread_id,forum_id,page,pos) SELECT thread_id,forum_id,CEIL(pos/40.0),(pos-(CEIL(pos/40)-1)*40) FROM ".$tmp_tbl_name);
		q("DROP SEQUENCE ".$tmp_tbl_name."_pos_seq");
		q("DROP TABLE ".$tmp_tbl_name);
		return;
	}
	else if ( __dbtype__ == 'mysql' ) {
		if( $page ) {
			q("DELETE FROM fud21_thread_view WHERE forum_id=".$forum_id." AND page<".($page+1));
			q("INSERT INTO fud21_thread_view (thread_id,forum_id,page,tmp) SELECT fud21_thread.id, fud21_thread.forum_id, 4294967294, CASE WHEN is_sticky='Y' AND (fud21_msg.post_stamp+fud21_thread.orderexpiry>".$tm." OR fud21_thread.orderexpiry=0) THEN 4294967294 ELSE fud21_thread.last_post_date END AS sort_order_fld  FROM fud21_thread INNER JOIN fud21_msg ON fud21_thread.root_msg_id=fud21_msg.id WHERE forum_id=".$forum_id." AND fud21_msg.approved='Y' ORDER BY sort_order_fld DESC, fud21_thread.last_post_id DESC LIMIT 0, ".($GLOBALS['THREADS_PER_PAGE']*$page));
			q("UPDATE fud21_thread_view SET page=CEILING(pos/".$GLOBALS['THREADS_PER_PAGE']."), pos=pos-(CEILING(pos/".$GLOBALS['THREADS_PER_PAGE'].")-1)*".$GLOBALS['THREADS_PER_PAGE']." WHERE forum_id=".$forum_id." AND page=4294967294");			
		}
		else {
			q("DELETE FROM fud21_thread_view WHERE forum_id=".$forum_id);
			q("INSERT INTO fud21_thread_view (thread_id,forum_id,page,tmp) SELECT fud21_thread.id, fud21_thread.forum_id, 4294967294, CASE WHEN is_sticky='Y' AND (fud21_msg.post_stamp+fud21_thread.orderexpiry>".$tm." OR fud21_thread.orderexpiry=0) THEN 4294967294 ELSE fud21_thread.last_post_date END AS sort_order_fld  FROM fud21_thread INNER JOIN fud21_msg ON fud21_thread.root_msg_id=fud21_msg.id WHERE forum_id=".$forum_id." AND fud21_msg.approved='Y' ORDER BY sort_order_fld DESC, fud21_thread.last_post_id DESC");
			q("UPDATE fud21_thread_view SET page=CEILING(pos/".$GLOBALS['THREADS_PER_PAGE']."), pos=pos-(CEILING(pos/".$GLOBALS['THREADS_PER_PAGE'].")-1)*".$GLOBALS['THREADS_PER_PAGE']." WHERE forum_id=".$forum_id);			
		}
	}
	if( $local_lock ) db_unlock();
}function create_return()
{
	return '<input type="hidden" name="returnto" value="'.urldecode($GLOBALS['returnto']).'">';
}
        
function check_return()
{
        if ( empty($GLOBALS['returnto']) ) 
        	$GLOBALS['returnto']='index.php?'._rsid;
        else if ( !strstr($GLOBALS['returnto'], 'S=') ) {
        	if ( !strstr($GLOBALS['returnto'], '?') ) 
	         	$GLOBALS['returnto'] .= '?'._rsid;
	        else
	        	$GLOBALS['returnto'] .= '&'._rsid;
        }
        header("Location: ".$GLOBALS['returnto']);
	exit();
}define('_fileio_inc_', 1);


function register_fp($id)
{
	if( empty($GLOBALS['__MSG_FP__'][$id]) ) 
		$GLOBALS['__MSG_FP__'][$id] = fopen($GLOBALS["MSG_STORE_DIR"].'msg_'.$id, 'rb');
	
	return $GLOBALS['__MSG_FP__'][$id];
}

function un_register_fps()
{
	if( !@is_array($GLOBALS['__MSG_FP__']) ) return;
	
	reset($GLOBALS['__MSG_FP__']);
	while( list($k,$v) = each($GLOBALS['__MSG_FP__']) ) {
		if( @is_resource($v) ) fclose($v);
		$GLOBALS['__MSG_FP__'][$k] = NULL;
	}	
}

function read_msg_body($off, $len, $file_id)
{
	$fp = register_fp($file_id);
	fseek($fp, $off);
	return fread($fp, $len);
}$GLOBALS['__error__'] = 0;

function set_err($err, $msg)
{
	$GLOBALS['__err_msg__'][$err] = $msg;
	$GLOBALS['__error__'] = 1;
}

function is_post_error()
{
	return $GLOBALS['__error__'];
}

function get_err($err, $br=0)
{
	if( isset($err) && isset($GLOBALS['__err_msg__'][$err]) )
		return ($br?'<font class="ErrorText">'.$GLOBALS['__err_msg__'][$err].'</font><br>':'<br><font class="ErrorText">'.$GLOBALS['__err_msg__'][$err].'</font>');
}
		
function post_check_images()
{
	global $msg_body;
	
	if ( $GLOBALS['MAX_IMAGE_COUNT'] && $GLOBALS['MAX_IMAGE_COUNT'] < count_images($msg_body) ) {
		return -1;
	}
		
	return 0;
}

function check_post_form()
{
	global $msg_subject;
	
	if ( !strlen($msg_subject) ) {
		set_err('msg_subject', 'Subject required');
	}
	
	if ( post_check_images() ) {
		set_err('msg_body', 'Maximum '.$GLOBALS['MAX_IMAGE_COUNT'].' images are allowed per post, please decrease the number of images');
	}
	
	if ( isset($GLOBALS['ses']->at_name) && filter_ext($GLOBALS['ses']->at_name) ) {
		set_err('msg_file', 'This file type isn\'t allowed');
	}
	
	return $GLOBALS['__error__'];
} 

function check_ppost_form()
{
	global $msg_subject;
	
	if ( !strlen($msg_subject) ) {
		set_err('msg_subject', 'Subject required');
	}
	
	if ( post_check_images() ) {
		set_err('msg_body', 'Maximum '.$GLOBALS['MAX_IMAGE_COUNT'].' images are allowed per post, please decrease the number of images');
	}
	
	if ( isset($GLOBALS['ses']->at_name) && filter_ext($GLOBALS['ses']->at_name) ) {
		set_err('msg_file', 'This file type isn\'t allowed');
	}
	
	$GLOBALS['msg_to_list'] = trim($GLOBALS['msg_to_list']);
	$list = explode(";", $GLOBALS['msg_to_list']);
	while ( list(, $v) = each($list) ) {
		$v = trim($v);
		if( strlen($v) ) {
			$r = q("SELECT fud21_users.id,fud21_user_ignore.ignore_id FROM fud21_users LEFT JOIN fud21_user_ignore ON fud21_user_ignore.user_id=fud21_users.id AND fud21_user_ignore.ignore_id=".$GLOBALS["usr"]->id." WHERE fud21_users.alias='".addslashes($v)."'");	
			if( !is_result($r) ) {
				set_err('msg_to_list', 'There is no user named "'.htmlspecialchars($v).'" this forum');
				break;
			}
			else {
				$obj = db_singleobj($r);
				if( !empty($obj->ignore_id) ) {
					set_err('msg_to_list', 'You cannot send a private message to "'.htmlspecialchars($v).'", because this person is ignoring you.');
					break;
				}
				else 
					$GLOBALS['recv_user_id'][] = $obj->id;	
			}		
		}
	}
	
	if( empty($GLOBALS['msg_to_list']) ) set_err('msg_to_list', 'Cannot send a message, missing recipient');

	return $GLOBALS['__error__'];
} 

function check_femail_form()
{
	if( empty($GLOBALS["HTTP_POST_VARS"]["femail"]) || validate_email($GLOBALS["HTTP_POST_VARS"]["femail"]) ) {
		set_err('femail', 'Please enter a valid email address of your friend.');
	}
	
	if( empty($GLOBALS["HTTP_POST_VARS"]["subj"]) ) {
		set_err('subj', 'You cannot send an email without a subject.');
	}
	
	if( empty($GLOBALS["HTTP_POST_VARS"]["body"]) ) {
		set_err('body', 'You cannot send an email without the message body.');
	}

	return $GLOBALS['__error__'];
}

function count_images($text)
{
	$text = strtolower($text);
	$a = substr_count($text, '[img]');
	$b = substr_count($text, '[/img]');
	
	return ( ($a>$b)?$b:$a );
}function is_allowed_user()
{
	global $usr;
	
	if ( strtoupper($GLOBALS['COPPA']) == 'Y' && strtoupper($usr->coppa) == 'Y' )
		{ error_dialog('ERROR: Your account is not yet confirmed', 'We have not received a confirmation from your parent and/or legal guardian, which would allow you to post messages. If you lost your coppa form <a href="http://thelocust.org/bored/index.php?t=coppa_fax&'._rsid.'">click here</a> to get it', $returnto_d); exit(); }

	if ( $GLOBALS['EMAIL_CONFIRMATION'] == 'Y' && $usr->email_conf == 'N' ) 
		{ std_error('emailconf'); exit(); }	
			
	if ( $usr->blocked == 'Y' || is_email_blocked($usr->email) ) 
		{ error_dialog('ERROR: you aren\'t allowed to post', 'Your account has been blocked from posting', $returnto_d, 'FATAL'); exit(); }
}function alt_var()
{
	$key = func_get_arg(0);
	if ( empty($GLOBALS['_ALTERNATOR_'][$key]) || $GLOBALS['_ALTERNATOR_'][$key] == func_num_args() ) $GLOBALS['_ALTERNATOR_'][$key] = 1;
	return func_get_arg($GLOBALS['_ALTERNATOR_'][$key]++);
}function is_perms($user_id, $r_id, $perm, $r_type='forum')
{
	if( $GLOBALS['usr']->is_mod == 'A' ) return TRUE;
	if( __dbtype__ == 'pgsql' ) $perm = strtolower($perm);
	if( empty($user_id) ) $user_id = 0;

	if( @is_object($GLOBALS['__MEMPERM_CACHE'][$user_id][$r_id][$r_type]) ) 
		return ($GLOBALS['__MEMPERM_CACHE'][$user_id][$r_id][$r_type]->{'p_'.$perm}=='Y'?TRUE:FALSE);
	
	if ( empty($user_id) ) {
		$r = q("SELECT * FROM fud21_group_cache WHERE user_id=".$user_id." AND resource_type='".$r_type."' AND resource_id=".$r_id);
		if( !is_result($r) ) $r = q("SELECT * FROM fud21_groups WHERE id=1");
	}
	else {
		$r=q("SELECT * FROM fud21_group_cache WHERE user_id IN(".$user_id.",2147483647) AND resource_type='".$r_type."' AND resource_id=".$r_id." ORDER BY user_id LIMIT 1");
		if( !is_result($r) ) $r = q("SELECT * FROM fud21_groups WHERE id=2");
	}
	
	$GLOBALS['__MEMPERM_CACHE'][$user_id][$r_id][$r_type] = db_singleobj($r);
	return ($GLOBALS['__MEMPERM_CACHE'][$user_id][$r_id][$r_type]->{'p_'.$perm}=='Y'?TRUE:FALSE);
}

	if( !empty($done) ) check_return();
	
	if( empty($th) || !is_numeric($th) ) invl_inp_err();
	
	if( isset($usr) ) is_allowed_user();
	
	$thread = new fud_thread;
	$thread->get_by_id($th);

	if( !is_perms(_uid, $thread->forum_id, 'READ') ) {
		std_error('access');
		exit;	
	}

	if( empty($body) ) {
		$u = isset($usr) ? $usr->alias : $GLOBALS["ANON_NICK"];
		$rid = isset($usr) ? $usr->id : '';
		$bd = 'There is a web page on '.$GLOBALS['FORUM_TITLE'].' ( http://thelocust.org/bored/index.php?t=index ) that you may be interested in reading.
Here is the thread I thought you\'d be interested in, '.$thread->subject.' can be found here: http://thelocust.org/bored/index.php?t='.$GLOBALS['DEFAULT_THREAD_VIEW'].'&th='.$thread->id.'&'._rsid.'
From '.$u.'
';
	}	
	
	$adm_str = $rid = $pm = '';
	$ret_to = '&returnto='.urlencode(!empty($GLOBALS['returnto'])?urldecode($GLOBALS['returnto']):$GLOBALS['HTTP_SERVER_VARS']['REQUEST_URI']);

	if ( empty($GLOBALS['usr']) ) {
		$login_n_logout = '<td valign="middle"><a class="UserControlPanel" href="http://thelocust.org/bored/index.php?t=login&'._rsid.$ret_to.'"><img src="http://thelocust.org/bored/theme/default/images/top_login.gif" border=0 alt="Login"></a></td>
<td valign="middle"><a class="UserControlPanel" href="http://thelocust.org/bored/index.php?t=login&'._rsid.$ret_to.'">Login</a></td>';
		$register_n_profile = '<td valign="middle"><a class="UserControlPanel" href="http://thelocust.org/bored/index.php?t=register&'._rsid.'"><img src="http://thelocust.org/bored/theme/default/images/top_register.gif" border=0 alt="Register"></a></td>
<td valign="middle"><a class="UserControlPanel" href="http://thelocust.org/bored/index.php?t=register&'._rsid.'">Register</a></td>';
	}
	else {
		if( $GLOBALS['usr']->is_mod == 'A' ) $admin_control_panel = '<td>&nbsp;&nbsp;</td><td valign="middle"><a class="UserControlPanel" href="adm/admglobal.php?'._rsid.'"><img src="http://thelocust.org/bored/theme/default/images/top_admin.gif" border=0 alt="Admin Control Panel"></a></td>
<td valign="middle"><a class="UserControlPanel" href="adm/admglobal.php?'._rsid.'">Admin Control Panel</a></td>';
		$user_login = htmlspecialchars($usr->alias);
		$login_n_logout = '<td valign="middle"><a class="UserControlPanel" href="http://thelocust.org/bored/index.php?t=login&'._rsid.$ret_to.'&logout=1"><img src="http://thelocust.org/bored/theme/default/images/top_logout.gif" border=0 alt="Logout"></a></td>
<td valign="middle"><a class="UserControlPanel" href="http://thelocust.org/bored/index.php?t=login&'._rsid.$ret_to.'&logout=1">Logout [ '.$user_login.' ]</a></td>';
		$register_n_profile = '<td valign="middle"><a class="UserControlPanel" href="http://thelocust.org/bored/index.php?t=register&'._rsid.'"><img src="http://thelocust.org/bored/theme/default/images/top_profile.gif" border=0 title="Click here to access user control panel" alt="Profile"></a></td>
<td valign="middle"><a class="UserControlPanel" href="http://thelocust.org/bored/index.php?t=register&'._rsid.'"><acronym title="Click here to access user control panel">Profile</acronym></a></td>';
		$rid = $GLOBALS["usr"]->id;
		
		if ( $GLOBALS['PM_ENABLED']=='Y' ) {
			$c = q_singleval("SELECT count(*) FROM fud21_pmsg WHERE duser_id=".$GLOBALS["usr"]->id." AND folder_id='INBOX' AND read_stamp=0");
			$private_msg = ( $c ) ? '<td>&nbsp;&nbsp;</td>
<td valign="middle"><a href="http://thelocust.org/bored/index.php?t=pmsg&'._rsid.'" class="UserControlPanel"><img src="http://thelocust.org/bored/theme/default/images/top_pm.gif" border=0 alt="Private Messaging"></a></td>
<td><a href="http://thelocust.org/bored/index.php?t=pmsg&'._rsid.'" class="UserControlPanel">You have <span class="GenText" style="color: #ff0000">('.$c.')</span> unread private message(s)</a></td>
<td>&nbsp;&nbsp;</td>' : '<td>&nbsp;&nbsp;</td>
<td valign="middle"><a href="http://thelocust.org/bored/index.php?t=pmsg&'._rsid.'" class="UserControlPanel"><img src="http://thelocust.org/bored/theme/default/images/top_pm.gif" border=0 alt="Private Messaging"></a></td>
<td><a href="http://thelocust.org/bored/index.php?t=pmsg&'._rsid.'" class="UserControlPanel">Private Messaging</a></td>
<td>&nbsp;&nbsp;</td>';
		}
	}/* FILE START */
	if( !empty($GLOBALS["HTTP_POST_VARS"]["posted"]) && isset($usr) && !check_femail_form() ) {
		$to = empty($fname) ? $femail : $fname.' <'.$femail.'>';
		$from = $usr->alias. '<'.$usr->email.'>';
		send_email(stripslashes($from), stripslashes($to), stripslashes($subj), stripslashes($body));
	
		error_dialog('Email was sent', 'The email to your friend at '.$femail.' about the '.$thread->subject.' was successfully sent.', 'http://thelocust.org/bored/index.php?t='.d_thread_view.'&th='.$th.'&'._rsid);
		exit;
	}
	
	if( is_post_error() ) $error_data = '<h4 align="center"><font class="ErrorText">You have an error</font></h4>';
	
	$body = empty($body)?$bd:stripslashes($body);
	$body_error = get_err('body');
	if( isset($usr) ) {
		$femail_error = get_err('femail');
		$subject = empty($subj) ? $thread->subject:stripslashes($subj);
		$subject_error = get_err('subj');
		$form_data = '<tr class="'.alt_var('page_alt','RowStyleA','RowStyleB').'"><td class="GenText" nowrap>Your Name:</td><td width="100%">'.htmlspecialchars($usr->login).'</td></tr>
<tr class="'.alt_var('page_alt','RowStyleA','RowStyleB').'"><td class="GenText" nowrap>Your Email:</td><td width="100%">'.$usr->email.'</td></tr>
<tr class="'.alt_var('page_alt','RowStyleA','RowStyleB').'"><td class="GenText" nowrap>Friend\'s Name:</td><td width="100%"><input type="text" name="fname" value="'.stripslashes($fname).'"></td></tr>
<tr class="'.alt_var('page_alt','RowStyleA','RowStyleB').'"><td class="GenText" valign="top" nowrap><font class="SmallText">Friend\'s Email:<br><i>required</i></font></td><td valign="top"><input type="text" name="femail" value="'.stripslashes($femail).'">'.$femail_error.'</td></tr>
<tr class="'.alt_var('page_alt','RowStyleA','RowStyleB').'"><td class="GenText" valign="top" nowrap><font class="SmallText">Subject:<br><i>required</i></font></td><td nowrap valign="top"><input type="text" name="subj" value="'.$subject.'">'.$subject_error.'</td></tr>
<tr class="'.alt_var('page_alt','RowStyleA','RowStyleB').'"><td class="GenText" valign="top" nowrap>Message:<font class="SmallText"><br><i>required</i></font></td><td valign="top" nowrap><textarea name="body" rows="10" cols="50" wrap="PHYSICAL">'.$body.'</textarea>'.$body_error.'</td></tr>
<tr class="'.alt_var('page_alt','RowStyleA','RowStyleB').'"><td class="GenText" colspan=2 align="right"><input type="submit" class="button" name="submit" value="Send Email Now"></td></tr>';	
	}
	else {
		$form_data = '<tr class="'.alt_var('page_alt','RowStyleA','RowStyleB').'"><td class="GenText" valign="top">'.$remail_message.'<br><font class="SmallText">Copy this message into a mail client of your choice to send it to your friend(s).</font></td><td valign="top"><textarea name="body" rows="10" cols="70" wrap="PHYSICAL">'.$body.'</textarea></td></tr>
<tr class="'.alt_var('page_alt','RowStyleA','RowStyleB').'"><td class="GenText" colspan=2 align="right"><input type="submit" class="button" name="done" value="Done"></td></tr>';
	}
	$return_field = create_return();
	
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<title><?php echo $GLOBALS['FORUM_TITLE']; ?><?php echo $TITLE_EXTRA; ?></title>
<META HTTP-EQUIV="Content-Type" CONTENT="text/html; charset=ISO-8859-15">
<script language="javascript" src="lib.js"></script>
<link rel="StyleSheet" href="http://thelocust.org/bored/theme/default/forum.css" type="text/css">
</head>
<body topmargin="2" leftmargin="2" marginheight="2" marginwidth="2">
<table width="100%" border="0" cellspacing="3" cellpadding="5"><tr><td class="ForumBackground">
<table border=0 cellspacing=0 cellpadding=0 width="100%"><tr><td align="right">
<table cellspacing=3 cellpadding=0 border=0>
	<tr>
		<td valign="middle"><a class="UserControlPanel" href="http://thelocust.org/bored/index.php?t=help_index&<?php echo _rsid; ?>"><img src="http://thelocust.org/bored/theme/default/images/top_help.gif" border=0 alt="F.A.Q."></a></td>
		<td valign="middle"><a class="UserControlPanel" href="http://thelocust.org/bored/index.php?t=help_index&<?php echo _rsid; ?>">F.A.Q.</a></td>
		<td>&nbsp;&nbsp;</td>
		<?php echo $register_n_profile; ?>
		<td>&nbsp;&nbsp;</td>
		<?php echo $login_n_logout; ?>
		<td>&nbsp;&nbsp;</td>
		<td valign="middle"><a class="UserControlPanel" href="http://thelocust.org/bored/index.php?t=index&<?php echo _rsid; ?>"><img src="http://thelocust.org/bored/theme/default/images/top_home.gif" border=0 alt="Home"></a></td>
		<td valign="middle"><a class="UserControlPanel" href="http://thelocust.org/bored/index.php?t=index&<?php echo _rsid; ?>">Home</a></td>
	</tr>
</table>
<table cellspacing=3 cellpadding=0 border=0>	
	<tr>	
		<?php echo $private_msg; ?>
		<td valign="middle"><a class="UserControlPanel" href="http://thelocust.org/bored/index.php?t=finduser&btn_submit=Find&<?php echo _rsid; ?>"><img src="http://thelocust.org/bored/theme/default/images/top_members.gif" border=0 alt="Members"></a></td>
		<td valign="middle"><a class="UserControlPanel" href="http://thelocust.org/bored/index.php?t=finduser&btn_submit=Find&<?php echo _rsid; ?>">Members</a></td>
		<td>&nbsp;&nbsp;</td>
		<td valign="middle"><a class="UserControlPanel" href="http://thelocust.org/bored/index.php?t=search&<?php echo _rsid; ?>"><img src="http://thelocust.org/bored/theme/default/images/top_search.gif" border=0 alt="Search"></a></td>
		<td valign="middle"><a class="UserControlPanel" href="http://thelocust.org/bored/index.php?t=search&<?php echo _rsid; ?>">Search</a></td>
		<?php echo $admin_control_panel; ?>
	</tr>
</table></td></tr></table>
<div align=center>
<?php echo $remail_error; ?>
<table border="0" cellspacing="1" cellpadding="2" class="ContentTable">
<tr><th colspan=2>Email This Topic To A Friend</th></tr>
<form action="http://thelocust.org/bored/index.php?t=remail" name="remail" method="post"><input type="hidden" name="posted" value="1">
<?php echo $form_data; ?>
<?php echo _hs; ?>
<input type="hidden" name="th" value="<?php echo $th; ?>"></form>
</form>
</table>
</div>
<br><table bgcolor="#000000" border=0 cellspacing=1 cellpadding=1 align="center"><tr class="RowStyleA"><td class="SmallText"><b>Current Time:</b> 
<?php echo strftime("%a %b %e %H:%M:%S %Z %Y", __request_timestamp__); ?>
</td></tr></table>
</td></tr></table>
<table width="100%" border="0" cellspacing="3" cellpadding="5"><tr><td class="ForumBackground" align="center">
<b>.::</b> <a href="mailto:<?php echo $GLOBALS['ADMIN_EMAIL']; ?>">Contact</a> <b>::</b> <a href="http://thelocust.org/bored/index.php?t=index&<?php echo _rsid; ?>">Home</a> <b>::.</b>
<p>
<span class="SmallText">Powered by: FUDforum <?php echo $GLOBALS['FORUM_VERSION']; ?><br>Copyright &copy;2001,2002 <a href="http://fud.prohost.org/" class="GenLink">Advanced Internet Designs Inc.</a></span>
</td></tr></table>
</body>
</html>