<?php
/***************************************************************************
*   copyright            : (C) 2001,2002 Advanced Internet Designs Inc.
*   email                : forum@prohost.org
*
*   $Id: selmsg.php.t,v 1.6 2002/07/08 23:15:19 hackie Exp $
****************************************************************************
          
****************************************************************************
*
*	This program is free software; you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation; either version 2 of the License, or
*	(at your option) any later version.
*
***************************************************************************/

/*#? Message Display Page */
	include_once "GLOBALS.php";
	if ( !defined('__index_page_start__') ) exit('sorry, you can not access this page');function pager_replace(&$str, $s, $c)
{
	$str = str_replace('%s', $s, $str);
	$str = str_replace('%c', $c, $str);
}

function tmpl_create_pager($start, $count, $total, $arg, $suf='', $append=1, $js_pager=FALSE)
{
	if ( $total <= $count ) return;
	if ( !$count ) $count = $GLOBALS["POSTS_PER_PAGE"];
	
	$cur_pg = ceil($start/$count);
	$ttl_pg = ceil($total/$count);
	
	$page_pager_data='';
	
	if ( $start-$count > -1 ) {
		$page_start = $start-$count;
		if ( $append ) {
			$page_first_url = $arg.'&start=0&count='.$count.$suf;
			$page_prev_url = $arg.'&start='.$page_start.'&count='.$count.$suf;
		}
		else {
			$page_first_url = $arg;
			$page_prev_url = $arg;
			pager_replace($page_first_url, 0, $count);
			pager_replace($page_prev_url, $page_start, $count);
		}
		
		$page_pager_data .= (!$js_pager)?'&nbsp;<a href="'.$page_first_url.'" class="PagerLink">&laquo</a>&nbsp;&nbsp;<a href="'.$page_prev_url.'" class="PagerLink">&lt;</a>&nbsp;&nbsp;':'&nbsp;<a href="javascript://" onClick="'.$page_first_url.'" class="PagerLink">&laquo</a>&nbsp;&nbsp;<a href="'.$page_prev_url.'" class="PagerLink">&lt;</a>&nbsp;&nbsp;';
	}	

	$mid = ceil($GLOBALS["GENERAL_PAGER_COUNT"]/2);
	
	if( $ttl_pg > $GLOBALS["GENERAL_PAGER_COUNT"] ) {
		if( ($mid+$cur_pg)>=$ttl_pg ) {
			$end = $ttl_pg;
			$mid += ($mid+$cur_pg)-$ttl_pg;
			$st = $cur_pg-$mid;
		}
		else if( ($cur_pg-$mid)<=0 ) {
			$st = 0;				
			$mid += $mid-$cur_pg;
			$end = $mid+$cur_pg;
		}
		else {
			$st = $cur_pg-$mid;
			$end = $mid+$cur_pg;
		}
		
		if( $st < 0 ) $start = 0;
		if( $end > $ttl_pg ) $end = $ttl_pg;
	}
	else {
		$end = $ttl_pg;
		$st = 0;
	}
	
	
	while ( $st<$end ) {
		if( $st != $cur_pg ) {
			$page_start = $st*$count;
			$st++;
			if ( $append ) {
				$page_page_url = $arg.'&start='.$page_start.'&count='.$count.$suf;
			}
			else {
				$page_page_url = $arg;
				pager_replace($page_page_url, $page_start, $count);
			}
			$page_pager_data .= (!$js_pager)?'<a href="'.$page_page_url.'" class="PagerLink">'.$st.'</a>&nbsp;&nbsp;':'<a href="javascript://" onClick="'.$page_page_url.'" class="PagerLink">'.$st.'</a>&nbsp;&nbsp;';
		}
		else {
			$st++;
			$page_pager_data .= (!$js_pager)?''.$st.'&nbsp;&nbsp;':''.$st.'&nbsp;&nbsp;';
		}	
	}
	
	if ( !$js_pager )
		$page_pager_data = substr($page_pager_data,0,strlen('&nbsp;&nbsp;')*-1);
	else 
		$page_pager_data = substr($page_pager_data,0,strlen('&nbsp;&nbsp;')*-1);
		
	if ( ($start+$count)<$total ) { 
		$page_start = $start+$count;
		$page_start_2 = ($st-1)*$count;
		if ( $append ) {
			$page_next_url = $arg.'&start='.$page_start.'&count='.$count.$suf;
			$page_last_url = $arg.'&start='.$page_start_2.'&count='.$count.$suf;
		}
		else {
			$page_next_url = $arg;
			$page_last_url = $arg;
			pager_replace($page_next_url, $page_start, $count);
			pager_replace($page_last_url, $page_start_2, $count);
		}
		$page_pager_data .= (!$js_pager)?'&nbsp;&nbsp;<a href="'.$page_next_url.'" class="PagerLink">&gt;</a>&nbsp&nbsp;<a href="'.$page_last_url.'" class="PagerLink">&raquo;</a>':'&nbsp;&nbsp;<a href="javascript://" onClick="'.$page_next_url.'" class="PagerLink">&gt;</a>&nbsp&nbsp;<a href="'.$page_last_url.'" class="PagerLink">&raquo;</a>';
	}
	
	return (!$js_pager)?'<font class="SmallText"><b>Pages ('.$ttl_pg.'): 
['.$page_pager_data.']
</b></font>':'<font class="SmallText"><b>Pages ('.$ttl_pg.'): 
['.$page_pager_data.']
</b></font>';
}define('_fileio_inc_', 1);


function register_fp($id)
{
	if( empty($GLOBALS['__MSG_FP__'][$id]) ) 
		$GLOBALS['__MSG_FP__'][$id] = fopen($GLOBALS["MSG_STORE_DIR"].'msg_'.$id, 'rb');
	
	return $GLOBALS['__MSG_FP__'][$id];
}

function un_register_fps()
{
	if( !@is_array($GLOBALS['__MSG_FP__']) ) return;
	
	reset($GLOBALS['__MSG_FP__']);
	while( list($k,$v) = each($GLOBALS['__MSG_FP__']) ) {
		if( @is_resource($v) ) fclose($v);
		$GLOBALS['__MSG_FP__'][$k] = NULL;
	}	
}

function read_msg_body($off, $len, $file_id)
{
	$fp = register_fp($file_id);
	fseek($fp, $off);
	return fread($fp, $len);
}class fud_poll
{
	var $id;
	var $name=NULL;
	var $owner=NULL;
	var $creation_date=NULL;
	var $expiry_date=NULL;
	var $max_votes=NULL;
	
	function add()
	{
		if ( !db_locked() ) {
			$ll = 1;
			db_lock("fud21_poll+");
		}
		$r = q("INSERT INTO fud21_poll (
			name, 
			owner, 
			creation_date, 
			expiry_date,
			max_votes
			) 
			VALUES(
			'".$this->name."',
			".$this->owner.",
			".__request_timestamp__.",
			".intzero($this->expiry_date).",
			0
			)");
		$this->id = db_lastid("fud21_poll", $r);
		if ( $ll ) db_unlock();
		return $this->id;
	}
	
	function sync()
	{
		q("UPDATE fud21_poll SET 
			name='".$this->name."',
			expiry_date=".intzero($this->expiry_date).",
			max_votes=".intzero($this->max_votes)."
		WHERE id=".$this->id);
	}
	
	function get($id) 
	{
		qobj("SELECT * FROM fud21_poll WHERE id=".$id, $this);
	}
	
	function delete()
	{
		q("UPDATE fud21_msg SET poll_id=0 WHERE poll_id=".$this->id);
		q("DELETE FROM fud21_poll_opt WHERE poll_id=".$this->id);
		q("DELETE FROM fud21_poll_opt_track WHERE poll_id=".$this->id);
		q("DELETE FROM fud21_poll WHERE id=".$this->id);
	}
	
	function regvote($user_id)
	{
		q("INSERT INTO fud21_poll_opt_track(poll_id, user_id) VALUES(".$this->id.", ".$user_id.")");
	}
	
	function voted($user_id)
	{
		return q_singleval("SELECT id FROM fud21_poll_opt_track WHERE poll_id=".$this->id." AND user_id=".$user_id);
	}
}

class fud_poll_opt
{
	var $id=NULL;
	var $poll_id=NULL;
	var $name=NULL;
	var $count=NULL;
	
	var $all=NULL;
	var $all_c=NULL;
	
	function add()
	{
		if ( !db_locked() ) {
			$ll = 1;
			db_lock("fud21_poll_opt+");
		}
		$r = q("INSERT INTO fud21_poll_opt (poll_id, name, count) VALUES (".$this->poll_id.",'".$this->name."',".intzero($this->count).")");
		$this->id = db_lastid("fud21_poll_opt", $r);
		if ( $ll ) db_unlock();
		return $this->id;
	}
	
	function sync()
	{
		q("UPDATE fud21_poll_opt SET name='".$this->name."' WHERE id=".$this->id);
	}
	
	function get($id)
	{
		qobj("SELECT * FROM fud21_poll_opt WHERE id=".$id, $this);
	}
	
	function delete()
	{
		q("DELETE FROM fud21_poll_opt WHERE id=".$this->id);
	}
	
	function fetch_vars($array, $prefix)
	{
		$this->name = $array[$prefix.'name'];
	}
	
	function increase()
	{
		q("UPDATE fud21_poll_opt SET count=count+1 WHERE id=".$this->id);
	}
	
	function get_poll($pl_id) 
	{
		$res = q("SELECT * FROM fud21_poll_opt WHERE poll_id=".$pl_id." ORDER BY id");
		if ( !is_result($res) ) return;
		
		unset($this->all);
		$this->all_c = 0;
		while ( $obj=db_rowobj($res) ) {
			$this->all[] = $obj;
		}
		
		qf($res);
	}
	
	function reset_opt()
	{
		if ( isset($this->all) ) reset($this->all);
	}
	
	function count_opt()
	{
		if ( isset($this->all) ) return count($this->all);
		return;
	}
	
	function next_opt()
	{
		if ( $this->all_c > count($this->all) ) return;
		return ( isset($this->all[$this->all_c])?$this->all[$this->all_c++]:'');
	}
}function get_mime_by_ext($ext)
{
	return q_singleval("SELECT id FROM fud21_mime WHERE fl_ext='".$ext."'");
}function is_perms($user_id, $r_id, $perm, $r_type='forum')
{
	if( $GLOBALS['usr']->is_mod == 'A' ) return TRUE;
	if( __dbtype__ == 'pgsql' ) $perm = strtolower($perm);
	if( empty($user_id) ) $user_id = 0;

	if( @is_object($GLOBALS['__MEMPERM_CACHE'][$user_id][$r_id][$r_type]) ) 
		return ($GLOBALS['__MEMPERM_CACHE'][$user_id][$r_id][$r_type]->{'p_'.$perm}=='Y'?TRUE:FALSE);
	
	if ( empty($user_id) ) {
		$r = q("SELECT * FROM fud21_group_cache WHERE user_id=".$user_id." AND resource_type='".$r_type."' AND resource_id=".$r_id);
		if( !is_result($r) ) $r = q("SELECT * FROM fud21_groups WHERE id=1");
	}
	else {
		$r=q("SELECT * FROM fud21_group_cache WHERE user_id IN(".$user_id.",2147483647) AND resource_type='".$r_type."' AND resource_id=".$r_id." ORDER BY user_id LIMIT 1");
		if( !is_result($r) ) $r = q("SELECT * FROM fud21_groups WHERE id=2");
	}
	
	$GLOBALS['__MEMPERM_CACHE'][$user_id][$r_id][$r_type] = db_singleobj($r);
	return ($GLOBALS['__MEMPERM_CACHE'][$user_id][$r_id][$r_type]->{'p_'.$perm}=='Y'?TRUE:FALSE);
}function alt_var()
{
	$key = func_get_arg(0);
	if ( empty($GLOBALS['_ALTERNATOR_'][$key]) || $GLOBALS['_ALTERNATOR_'][$key] == func_num_args() ) $GLOBALS['_ALTERNATOR_'][$key] = 1;
	return func_get_arg($GLOBALS['_ALTERNATOR_'][$key]++);
}function build_ignore_list()
{
	$r = q("SELECT id,ignore_id FROM fud21_user_ignore WHERE user_id=".$GLOBALS["usr"]->id);
	while( list($id,$ignore_id) = db_rowarr($r) ) $GLOBALS['__IGNORE_LIST__'][$ignore_id] = $id;
	qf($r);
}

if( isset($GLOBALS['rev']) ) {
	$drawmsg_inc_tmp = explode(':', $GLOBALS['rev']);
	reset($drawmsg_inc_tmp);
	while ( list($k, $v) = each($drawmsg_inc_tmp) ) {
		if ( strlen($v) ) 
			$GLOBALS['__REVEALED_POSTS__'][$v] = 1;
	}
	unset($drawmsg_inc_tmp);
}	

if( isset($GLOBALS['reveal']) ) {
	$drawmsg_inc_tmp = explode(':', $GLOBALS['reveal']);
	reset($drawmsg_inc_tmp);
	while ( list($k, $v) = each($drawmsg_inc_tmp) ) {
		if ( strlen($v) ) 
			$GLOBALS['__REVEALED_USERS__'][$v] = 1;
	}
	unset($drawmsg_inc_tmp);
}	

function register_vote($opt)
{
	$poll = new fud_poll; 
	$poll_opt = new fud_poll_opt;
	$poll_opt->get($opt);
	$poll->get($poll_opt->poll_id);
	if ( !$poll->voted(_uid) ) {
		$poll_opt->increase();
		$poll->regvote(_uid);
	}	
}
/* determine the source form */
$GLOBALS['__DRAW_MSG_SCRIPT_NAME'] = basename($GLOBALS['HTTP_SERVER_VARS']['PATH_TRANSLATED']);

$GLOBALS['__MSG_COUNT__']=-1;

function tmpl_drawmsg(&$obj, $msg_count=NULL, $pager=NULL, $_rsid=_rsid)
{
	global $rev;
	global $reveal;
	global $count;
	global $start;

	if ( empty($obj->user_id) ) $obj->user_id=$obj->poster_id=0;

	if ( !empty($GLOBALS['DRAWMSG_OPTS']['NO_MSG_CONTROLS']) ) $hide_controls = 1;
	if( isset($GLOBALS['usr']) && !isset($GLOBALS['__IGNORE_LIST__']) ) build_ignore_list();
	$ret_n_sid = 'returnto='.urlencode($GLOBALS["HTTP_SERVER_VARS"]["REQUEST_URI"].'#msg_'.$obj->id).'&'.$_rsid;
	
	$GLOBALS['__MSG_COUNT__']++;
	
	if( $msg_count && empty($hide_controls) ) { 
		if( $GLOBALS['__MSG_COUNT__'] ) {
			$msg_num = $GLOBALS['__MSG_COUNT__']-1;
			$prev_message = '<a href="#msg_num_'.$msg_num.'" class="GenLink"><img title="Go to previous message" border=0 src="http://thelocust.org/bored/theme/default/images/up.gif"></a>';
		}
		else if ( $pager && $obj->id!=$obj->root_msg_id ) {
			$msg_start = $GLOBALS['start']-$GLOBALS['count'];
			$prev_message = '<a href="http://thelocust.org/bored/index.php?t=msg&'._rsid.'&prevloaded=1&th='.$obj->thread_id.'&start='.$msg_start.'&rev='.$rev.'&reveal='.$reveal.'&count='.$count.'" class="GenLink"><img border=0 src="http://thelocust.org/bored/theme/default/images/up.gif" border=0 title="Go to previous message"></a>';
		}	
			
		if( $GLOBALS['__MSG_COUNT__'] < $msg_count ) {
			$msg_num = $GLOBALS['__MSG_COUNT__']+1;
			$next_message = '<a href="#msg_num_'.$msg_num.'" class="GenLink"><img title="Go to next message" src="http://thelocust.org/bored/theme/default/images/down.gif" border=0></a>';
		}
		else if ( $pager && $obj->id!=$obj->last_post_id ) {
			$msg_start = $GLOBALS['start']+$GLOBALS['count'];
			$next_message = '<a href="http://thelocust.org/bored/index.php?t=msg&'._rsid.'&prevloaded=1&th='.$obj->thread_id.'&start='.$msg_start.'&rev='.$rev.'&reveal='.$reveal.'&count='.$count.'" class="GenLink"><img title="Go to previous message" border=0 src="http://thelocust.org/bored/theme/default/images/down.gif" border=0></a>';
		}			
	}	
	
	$msg_bg_color_alt = alt_var('draw_msg_clr_alt','RowStyleB','RowStyleA');
	
	if ( empty($obj->user_id) ) {
		$user_login = htmlspecialchars($GLOBALS['ANON_NICK']);
		$user_login_td = $user_login.' is ignored&nbsp;';
	}
	else {
		$user_login = htmlspecialchars($obj->login);
		$user_login_td = 'Post by <a href="http://thelocust.org/bored/index.php?t=usrinfo&'._rsid.'&id='.$obj->user_id.'" class="GenLink">'.$user_login.'</a> is ignored&nbsp;';
	}
	
	$link_args = '&mid='.$GLOBALS['mid'].'&'.$_rsid.'&frm_id='.$GLOBALS['frm_id'].'&th='.$GLOBALS['th'].'&start='.$GLOBALS['start'].'&count='.$GLOBALS['count'].'&unread='.$GLOBALS['unread'].'&reply_count='.$GLOBALS['reply_count'].'&date='.$GLOBALS['date'].'#msg_'.$obj->id;
	if ( !empty($GLOBALS['__IGNORE_LIST__'][$obj->poster_id]) && empty($GLOBALS['__REVEALED_POSTS__'][$obj->id]) && empty($GLOBALS['__REVEALED_USERS__'][$obj->poster_id]) ) {
		if ( empty($hide_controls) )	
			return '<tr class="'.$msg_bg_color_alt.'">
<td colspan=2>
<table border=0 width="100%" cellspacing=0 cellpadding=0>
<tr>
<td align="left" class="GenText">
<a name="msg_num_'.$GLOBALS['__MSG_COUNT__'].'"></a>
<a name="msg_'.$obj->id.'"></a>
'.$user_login_td.'
[<a href="'.$GLOBALS['__DRAW_MSG_SCRIPT_NAME'].'?reveal='.$reveal.'&rev='.$rev.':'.$obj->id.$link_args.'" class="GenLink">reveal post</a>]&nbsp;
[<a href="'.$GLOBALS['__DRAW_MSG_SCRIPT_NAME'].'?rev='.$rev.'&reveal='.$reveal.':'.$obj->poster_id.$link_args.'" class="GenLink">reveal all posts by '.$user_login.'</a>]&nbsp;
[<a href="http://thelocust.org/bored/index.php?t=ignore_list&del='.$GLOBALS['__IGNORE_LIST__'][$obj->poster_id].'&'.$ret_n_sid.'" class="GenLink">stop ignoring this user</a>]</td>
<td align="right">'.$prev_message.$next_message.'</td></tr>
</table></td>
</tr>';
		else
			return '<tr class="'.$msg_bg_color_alt.'">
<td colspan=2>
<table border=0 width="100%" cellspacing=0 cellpadding=0>
<tr>
<td align="left" class="GenText">
<a name="msg_num_'.$GLOBALS['__MSG_COUNT__'].'"></a>
<a name="msg_'.$obj->id.'"></a>
Post by '.$user_login.' is ignored&nbsp;
<td align="right"></td></tr>
</table></td>
</tr>';
	}

	if( !empty($obj->user_id) ) {
		$disable_avatar = ( $obj->level_pri == 'L' || (_uid && $GLOBALS["usr"]->show_avatars=='N') ) ? 1 : 0;
		
		if( ($GLOBALS['ONLINE_OFFLINE_STATUS'] == 'Y' && $obj->invisible_mode=='N' ) || $GLOBALS["usr"]->is_mod == 'A' ) 
			$online_indicator = (($obj->time_sec+$GLOBALS['LOGEDIN_TIMEOUT']*60) > __request_timestamp__) ? '<img src="http://thelocust.org/bored/theme/default/images/online.gif" border=0 title="'.$user_login.' is currently online">' : '<img src="http://thelocust.org/bored/theme/default/images/offline.gif" border=0 title="'.$user_login.'  is currently offline">';
		
		if ( !$disable_avatar ) {
			if( $obj->avatar ) 
				$avatar_img = 'images/avatars/'.$obj->avatar;
			else if ( $obj->avatar_approved == 'Y' ) 
				$avatar_img = ($obj->avatar_loc) ? $obj->avatar_loc : 'images/custom_avatars/'.$obj->user_id;
		
			$avatar = ($avatar_img) ? '<img src="'.$avatar_img.'" border=0>' : '';
		}
		
		$user_link = empty($hide_controls) ? '<a class="GenLink" href="http://thelocust.org/bored/index.php?t=usrinfo&id='.$obj->user_id.'&'._rsid.'">'.$user_login.'</a>' : $user_login;
		
		$user_posts = 'Posts: '.$obj->posted_msg_count.'<br>';
		$user_reg_date = 'Registered:<br><font class="DateText">'.strftime("%B %Y", $obj->join_date).'</font>';

		if ( !empty($obj->location) ) {
			$location = trim_show_len($obj->location, 'LOCATION');
			$location = 'Location: '.$location.'<br>';
		}
		else $location = '';

		$custom_tag = empty($obj->custom_status) ? '' : $obj->custom_status.'<br>';
	}
	else 
		$user_link = $user_login;
		
	if ( $GLOBALS["MOD"] || $GLOBALS["DISPLAY_IP"] == 'Y' ) $ip_address = 'IP: <a href="http://www.nic.com/cgi-bin/whois.cgi?query='.$obj->ip_addr.'" target="_blank">'.$obj->ip_addr.'</a><br>';

	if ( $GLOBALS['PUBLIC_RESOLVE_HOST'] == 'Y' && !empty($obj->host_name) ) {
		$host_name = wordwrap($obj->host_name,30,'<br>',1);
		$host_name = 'From:<br><font class="SmallText">'.$host_name.'</font><br>';
	}
	
	$msg_icon = empty($obj->icon) ? '' : '<img src="images/message_icons/'.$obj->icon.'" border=0>&nbsp;&nbsp;';
	
	$buddy_link=$ignore_link='';
	if ( isset($GLOBALS['usr']) && $GLOBALS['usr']->id != $obj->user_id && empty($hide_controls) ) {
		if ( $obj->user_id > 0 ) 
			$buddy_link = '<br>[<a href="http://thelocust.org/bored/index.php?t=buddy_list&'.$ret_n_sid.'&add='.$obj->user_id.'" class="GenLink">add to buddy list</a>]';
		else 
			$obj->user_id = 0;
		
		if ( $obj->is_mod != 'A' ) {
			if ( !empty($GLOBALS['__IGNORE_LIST__'][$obj->poster_id]) )
				$ignore_link = '<br>[<a href="http://thelocust.org/bored/index.php?t=ignore_list&'.$ret_n_sid.'&del='.$GLOBALS['__IGNORE_LIST__'][$obj->poster_id].'" class="GenLink">stop ignoring posts by this user</a>]';
			else 
				$ignore_link = '<br>[<a href="http://thelocust.org/bored/index.php?t=ignore_list&'.$ret_n_sid.'&add='.$obj->user_id.'" class="GenLink">ignore all posts by this user</a>]';
		}
	}
	
	if ( $obj->level_pri ) {
		if( !empty($obj->level_name) ) $level_name = '<font class="LevelText">'.$obj->level_name.'</font><br>';
		if( !empty($obj->level_img) && strtolower($obj->level_pri)!='a' ) $level_image = '<img src="images/'.$obj->level_img.'" border=0><br>';
	}	

	if ( empty($hide_controls) ) {
		/* determine IM status */
		if ( $obj->icq ) 	$im_icq =   '<a href="http://thelocust.org/bored/index.php?t=usrinfo&id='.$obj->poster_id.'&'._rsid.'#icq_msg"><img src="http://web.icq.com/whitepages/online?icq='.$obj->icq.'&amp;img=5" border=0></a>&nbsp;';
		if ( $obj->aim ) 	{ $im_aim = urlencode($obj->aim); $im_aim = '<a href="aim:goim?screenname='.$im_aim.'&message=Hi.+Are+you+there?"><img src="http://thelocust.org/bored/theme/default/images/aim.gif" border=0></a>&nbsp;'; }
		if ( $obj->yahoo ) 	{ $im_yahoo = urlencode($obj->yahoo); $im_yahoo = '<a target=_new href="http://edit.yahoo.com/config/send_webmesg?.target='.$im_yahoo.'&.src=pg"><img src="http://thelocust.org/bored/theme/default/images/yahoo.gif" border=0></a>&nbsp;'; }
		if ( $obj->msnm ) 	$im_msnm =  '<a href="mailto:'.$obj->msnm.'"><img src="http://thelocust.org/bored/theme/default/images/msnm.gif" border=0></a>';
		if ( $obj->jabber ) 	$im_jabber =  '<img src="http://thelocust.org/bored/theme/default/images/jabber.gif" title="'.$obj->jabber.'" alt="'.$obj->jabber.'" border=0>';
	}
	
	
	if( $obj->message_threshold && $obj->length_preview && empty($GLOBALS['__REVEALED_POSTS__'][$obj->id]) && $obj->length > $obj->message_threshold ) {
		$msg_body = read_msg_body($obj->offset_preview, $obj->length_preview, $obj->file_id_preview);
		$msg_body = $msg_body.'
<br>
<div align="center">[<a href="'.$GLOBALS['__DRAW_MSG_SCRIPT_NAME'].'?reveal='.$reveal.'&rev='.$rev.':'.$obj->id.$link_args.'" class="GenLink">Show the rest of the message</a>]</div>';
	}
	else if ( $obj->length ) {
		$msg_body = read_msg_body($obj->foff,$obj->length, $obj->file_id);
		$msg_body = $msg_body;
	}
	else
		$msg_body = 'No Message Body';
	
	if( !empty($GLOBALS['opt']) && $obj->locked != 'Y' ) {
		register_vote($GLOBALS['opt']);
		$GLOBALS['opt']=NULL;
	}	
	
	$__RESOURCE_ID = $obj->forum_id;
	if ( $obj->poll_id ) {
		$show_res=1;
		
		$poll_obj = db_singleobj(q("SELECT * FROM fud21_poll WHERE id=".$obj->poll_id));

		if( _uid && $GLOBALS["pl_view"] != $obj->poll_id && $obj->locked == 'N' && is_perms(_uid, $__RESOURCE_ID, 'VOTE') && !bq("SELECT id FROM fud21_poll_opt_track WHERE poll_id=".$poll_obj->id." AND user_id="._uid) ) $show_res=0;
		
		/* determine if poll is expired or reach max count */
			
		$res = q("SELECT * FROM fud21_poll_opt WHERE poll_id=".$poll_obj->id);
		$total_votes = q_singleval("SELECT sum(count) FROM fud21_poll_opt WHERE poll_id=".$poll_obj->id." GROUP BY poll_id");
		
		$i=0;
		if ( !$show_res && $poll_obj->max_votes && $total_votes >= $poll_obj->max_votes ) $show_res = 1;
		if ( !$show_res && $poll_obj->expiry_date && ($poll_obj->creation_date + $poll_obj->expiry_date) <= __request_timestamp__ ) $show_res = 1;
		
		$poll_data='';
		while ( $opt = db_rowobj($res) ) {
			$i++;
			if ( $show_res || !empty($hide_controls) ) {
				$length = ( $opt->count ) ? round($opt->count/$total_votes*100) : 0;
				$poll_data .= '<tr class="'.alt_var('msg_poll_alt_clr','RowStyleB','RowStyleA').'"><td>'.$i.'.</td><td>'.$opt->name.'</td><td><img src="http://thelocust.org/bored/theme/default/images/poll_pix.gif" height="10" width="'.$length.'"> '.$opt->count.' / '.$length.'%</td></tr>';
			}
			else 
				$poll_data .= '<tr class="'.alt_var('msg_poll_alt_clr','RowStyleB','RowStyleA').'"><td>'.$i.'.</td><td colspan=2><input type="radio" name="opt" value="'.$opt->id.'">&nbsp;&nbsp;'.$opt->name.'</td></tr>';
		}
			
		qf($res);
			
		if ( !$show_res && empty($hide_controls) ) {
			if( $total_votes ) $view_poll_results_button = '<input type="submit" class="button" name="pl_res" value="View Results">';
			$poll_buttons = '<tr class="'.alt_var('msg_poll_alt_clr','RowStyleB','RowStyleA').'"><td colspan=3 align="right"><input type="submit" class="button" name="pl_vote" value="Vote">&nbsp;'.$view_poll_results_button.'</td></tr>';
		}
		
		$poll = '<p>
<table border=0 cellspacing=1 cellpadding=2 class="PollTable">
<form action="'.$GLOBALS['HTTP_SERVER_VARS']['REQUEST_URI'].'" method="post">
<tr><th nowrap colspan=3>'.$poll_obj->name.'<img src="blank.gif" border=0 height=1 width=10><font size="-1">[ '.$total_votes.' vote(s) ]</font></th></tr>
'.$poll_data.'
'.$poll_buttons.'
<input type="hidden" name="pl_view" value="'.$poll_obj->id.'">'._hs.'<input type="hidden" name="pl_msg" value="'.$obj->id.'"></form></table><p>
'._hs; 
	}

	if ( $obj->attach_cnt ) {
		$a_result = q("SELECT fud21_attach.id,original_name,dlcount,icon FROM fud21_attach LEFT JOIN fud21_mime ON fud21_attach.mime_type=fud21_mime.id WHERE message_id=".$obj->id." AND private='N'");
		if ( db_count($a_result) ) {
			$drawmsg_file_attachments='';
			while ( $a_obj = db_rowobj($a_result) ) {
				if( file_exists($GLOBALS["FILE_STORE"].$a_obj->id.".atch") ) {
					$sz = filesize($GLOBALS["FILE_STORE"].$a_obj->id.".atch")/1024;
					$sz = $sz<1000 ? number_format($sz,2).'KB' : number_format($sz/1024,2).'MB';
					if( empty($a_obj->icon) ) $a_obj->icon = 'unknown.gif';
					$drawmsg_file_attachments .= '<tr>
<td valign=middle><a class="GenLink" href="http://thelocust.org/bored/index.php?t=getfile&id='.$a_obj->id.'&'._rsid.'"><img src="images/mime/'.$a_obj->icon.'" border=0></a></td>
<td><font class="GenText"><b>Attachment:</b></font> <a class="GenLink" href="http://thelocust.org/bored/index.php?t=getfile&id='.$a_obj->id.'&'._rsid.'">'.$a_obj->original_name.'</a><br>
<font class="SmallText">(Size: '.$sz.', Downloaded '.$a_obj->dlcount.' time(s))</font></td></tr>';	
				}					
			}
			$drawmsg_file_attachments = '<p>
<table border=0 cellspacing=0 cellpadding=2>
'.$drawmsg_file_attachments.'
</table>';
		}
		qf($a_result);	
	}
		
	if ( $obj->update_stamp ) {
		if( $obj->updated_by != $obj->poster_id && $GLOBALS['EDITED_BY_MOD'] == 'Y' ) 
			$modified_message = '<p>[Updated on: '.strftime("%a, %d %B %Y %H:%M", $obj->update_stamp).'] by Moderator';
		else if ( $obj->updated_by == $obj->poster_id && $GLOBALS['SHOW_EDITED_BY'] == 'Y' ) 
			$modified_message = '<p>[Updated on: '.strftime("%a, %d %B %Y %H:%M", $obj->update_stamp).']';
	}		
	
	if( empty($hide_controls) ) {
		if ( $GLOBALS["ALLOW_SIGS"] == 'Y' && $obj->show_sig == 'Y' && $GLOBALS["usr"]->show_sigs=='Y' && $obj->sig ) $signature = '<p><u>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</u><br>'.$obj->sig;
	
		$report_to_mod_link = '<div align="right"><font class="SmallText">[<a class="SmallText" href="http://thelocust.org/bored/index.php?t=report&msg_id='.$obj->id.'&'.$ret_n_sid.'">Report message to a moderator</a>]</font></div>';
	
		if( $obj->user_id ) {
			$user_profile = '<a class="GenLink" href="http://thelocust.org/bored/index.php?t=usrinfo&id='.$obj->user_id.'&'._rsid.'"><img src="http://thelocust.org/bored/theme/default/images/msg_about.gif" border=0></a>';
			$encoded_login = urlencode($obj->login);
			if( $GLOBALS["ALLOW_EMAIL"] == 'Y' && $obj->email_messages == 'Y' ) $email_link = '<a class="GenLink" href="http://thelocust.org/bored/index.php?t=email&tx_name='.$encoded_login.'&'.$ret_n_sid.'"><img src="http://thelocust.org/bored/theme/default/images/msg_email.gif" border=0></a>';
			if( $GLOBALS['PM_ENABLED']=='Y' ) $private_msg_link = '<a class="GenLink" href="http://thelocust.org/bored/index.php?t=ppost&msg_to_list='.$encoded_login.'&'.$ret_n_sid.'"><img title="Send a private message to this user" src="http://thelocust.org/bored/theme/default/images/msg_pm.gif" border=0></a>';
		}
		
		if( $msg_count && $pager && ($GLOBALS['__MSG_COUNT__']-1) == $msg_count && $obj->id!=$obj->last_post_id ) {
			$page_num = $start+$count;
			$next_page = '<a href="http://thelocust.org/bored/index.php?t=msg&'._rsid.'&prevloaded=1&th='.$obj->thread_id.'&start='.$page_num.'&rev='.$rev.'&reveal='.$reveal.'&count='.$count.'" class="GenLink">Next Page <img src="http://thelocust.org/bored/theme/default/images/goto.gif" border=0></a>';
		}
		else
			$next_page = '&nbsp;';
		
		if ( $GLOBALS["MOD"] || is_perms(_uid, $__RESOURCE_ID, 'DEL') ) $delete_link = '<a class="GenLink" href="http://thelocust.org/bored/index.php?t=mmod&del='.$obj->id.'&th='.$obj->thread_id.'&det_page='.$GLOBALS['__DRAW_MSG_SCRIPT_NAME'].'&'.$ret_n_sid.'"><img src="http://thelocust.org/bored/theme/default/images/msg_delete.gif" border=0></a>&nbsp;';
		if ( isset($GLOBALS["usr"]) && (_uid == $obj->poster_id || $GLOBALS["MOD"] || is_perms(_uid, $__RESOURCE_ID, 'EDIT')) ) {
			if ( $GLOBALS["MOD"] || is_perms(_uid, $__RESOURCE_ID, 'EDIT') || !$GLOBALS['EDIT_TIME_LIMIT'] || (__request_timestamp__-$obj->post_stamp < $GLOBALS['EDIT_TIME_LIMIT']*60) ) $edit_link = '<a class="GenLink" href="http://thelocust.org/bored/index.php?t=post&start='.$GLOBALS['start'].'&msg_id='.$obj->id.'&'.$ret_n_sid.'"><img src="http://thelocust.org/bored/theme/default/images/msg_edit.gif" border=0></a>&nbsp;&nbsp;&nbsp;&nbsp;';
		}
		
		if( $GLOBALS["MOD"] || $obj->locked=='N' ) {
			$reply_link = '<a class="GenLink" href="http://thelocust.org/bored/index.php?t=post&start='.$GLOBALS['start'].'&reply_to='.$obj->id.'&'.$ret_n_sid.'"><img src="http://thelocust.org/bored/theme/default/images/msg_reply.gif" border=0></a>&nbsp;';
			$quote_link = '<a class="GenLink" href="http://thelocust.org/bored/index.php?t=post&start='.$GLOBALS['start'].'&reply_to='.$obj->id.'&quote=true&'.$ret_n_sid.'"><img src="http://thelocust.org/bored/theme/default/images/msg_quote.gif" border=0></a>';
		}	
		
		$message_toolbar = '<tr class="MsgToolBar"><td colspan=2><table border=0 cellspacing=0 cellpadding=0 width="100%"><tr>
<td align="left" nowrap width="1%">
'.$user_profile.'&nbsp;'.$email_link.'&nbsp;'.$private_msg_link.'
</td>
<td align="center" class="GenText">'.$next_page.'</td>
<td align="right" nowrap width="1%">
'.$delete_link.$edit_link.$reply_link.$quote_link.'
</td></tr></table></td></tr>';
	}
	return '<tr>
<td class="'.$msg_bg_color_alt.'" valign=top nowrap>

<table cellspacing=0 cellpadding=0 border=0>
<tr>
	<td valign="middle">'.$online_indicator.'</td>
	<td valign="middle" class="GenText">'.$user_link.'<br>'.$level_name.$level_image.'</td>
</tr>
</table>

<font class="GenText">'.$avatar.'<p>
'.$custom_tag.'
'.$user_posts.'
'.$location.'
'.$ip_address.'
'.$host_name.'
'.$user_reg_date.'
'.$buddy_link.'
'.$ignore_link.'
</font><div align=center>
'.$im_icq.'
'.$im_aim.'
'.$im_yahoo.'
'.$im_msnm.'
'.$im_jabber.'
</div></td>
<td class="'.$msg_bg_color_alt.'" valign="top" width="100%">
<table valign="top" border=0 cellspacing=0 cellpadding=0 width="100%">
<tr>
	<td valign="top" align="left" class="MsgSubText">
		<a name="msg_num_'.$GLOBALS['__MSG_COUNT__'].'"></a>
		<a name="msg_'.$obj->id.'"></a>'.$msg_icon.$obj->subject.'
	</td>
	<td valign="top" align=right>
		<img src="http://thelocust.org/bored/theme/default/images/posticon.gif" border=0>
		<font class="DateText">'.strftime("%a, %d %B %Y %H:%M", $obj->post_stamp).'</font> 
		'.$prev_message.$next_message.'
	</td>
</tr>
<tr><td colspan=2 class="ContentTable"><img src="blank.gif" border=0></td></tr>
<tr class="'.$msg_bg_color_alt.'" valign="top">
	<td colspan=2 valign="top" height="100%"><font class="MsgBodyText">
	'.$poll.'
	'.$msg_body.'
	'.$drawmsg_file_attachments.'
	'.$modified_message.'
	'.$signature.'
	</font>
	'.$report_to_mod_link.'
	</td>
</tr>
</table>

</td>
</tr>
'.$message_toolbar;
}class fud_forum
{
	var $id=NULL;
	var $cat_id=NULL;
	var $name=NULL;
	var $descr=NULL;
	var $passwd_posting=NULL;
	var $post_passwd=NULL;
	var $anon_forum=NULL;
	var $forum_icon=NULL;
	var $tag_style=NULL;
	var $last_post_id=NULL;
	
	var $allow_polls=NULL;
	var $date_created=NULL;
	var $thread_count=NULL;
	var $view_order=NULL;
	var $message_threshold=NULL;
	
	var $moderated=NULL;
	var $max_attach_size=NULL;
	var $max_file_attachments=NULL;
	
	var $forums=NULL;
	var $cur_frm=NULL;
	
	var $locked=NULL;
	
	
	function get($id)
	{
		qobj("SELECT * FROM fud21_forum WHERE fud21_forum.id=".$id, $this);
		if( empty($this->id) ) invl_inp_err();
			
		return $id;		
	}
	
	function is_moderator($user_id)
	{
		return q_singleval("SELECT id FROM fud21_mod WHERE user_id=".$user_id." AND forum_id=".$this->id);
	}
	
	function inc_reply_count($val)
	{
		q("UPDATE fud21_forum SET post_count=post_count+".$val." WHERE id=".$this->id);
	}
	
	function dec_reply_count($val)
	{
		q("UPDATE fud21_forum SET post_count=post_count-".$val." WHERE id=".$this->id);
	}
	
	function inc_thread_count($val)
	{
		q("UPDATE fud21_forum SET thread_count=thread_count+".$val." WHERE id=".$this->id);
	}
	
	function dec_thread_count($val)
	{
		q("UPDATE fud21_forum SET thread_count=thread_count-".$val." WHERE id=".$this->id);
	}
	
	function get_notify_list($user_id)
	{
		$r = q("SELECT 
				fud21_users.email, 
				fud21_users.icq, 
				fud21_users.notify_method 
			FROM 
				fud21_forum_notify 
				INNER JOIN fud21_users 
					ON fud21_forum_notify.user_id=fud21_users.id 
			WHERE 
				fud21_forum_notify.forum_id=".$this->id." 
				AND fud21_forum_notify.user_id!=".$user_id);
		
		$p = forum_perm_array($this->id);
		$to=NULL;
		while ( $obj = db_rowobj($r) ) {
			if ( !is_allowed($obj->user_id, $p) ) continue;
			
			$to[$obj->notify_method][] = ( $obj->notify_method == 'EMAIL' ) ? $obj->email : $obj->icq.'@pager.icq.com';
		}

		qf($r);
				
		return $to;
	}
	
}

if ( defined('admin_form') && !defined("_forum_adm_inc_") ) fud_use('forum_adm.inc');class fud_cat
{
	var $id=NULL;
	var $name=NULL;
	var $description=NULL;
	var $allow_collapse=NULL;
	var $default_view=NULL;
	var $view_order=NULL;
	
	var $cat_list;
	var $cur_cat;

	function get_cat($id)
	{
		qobj("SELECT * FROM fud21_cat WHERE id=".$id, $this);
		return $this->id;
	}
}

if ( defined('admin_form') && !defined("_cat_adm_inc_") ) fud_use('cat_adm.inc');function fetch_vars($pref, &$obj, $arr)
{
	reset($obj);
	while ( list($k, $v) = each($obj) ) {
		if ( isset($arr[$pref.$k]) ) $obj->{$k} = $arr[$pref.$k];
	}
}
	
function export_vars($pref, &$obj)
{
	reset($obj);
	while ( list($k, $v) = each($obj) ) {
		if ( isset($obj->{$k}) ) $GLOBALS[$pref.$k] = $v;
	}
}

function empty_object(&$obj)
{
	reset($obj);
	while ( list($k, $v) = each($obj) ) $obj->{$k} = NULL;
}class fud_thread
{
	var $id=NULL;
	var $forum_id=NULL;
	var $root_msg_id=NULL;
	var $last_post_date=NULL;
	var $replies=NULL;
	var $views=NULL;
	var $rating=NULL;
	var $last_post_id=NULL;
	var $locked=NULL;
	var $is_sticky=NULL;
	var $ordertype=NULL;
	var $orderexpiry=NULL;
	
	var $subject=NULL;
	var $db_thread=NULL;
	
	function add($root, $forum_id, $locked=NULL, $is_sticky=NULL, $ordertype=NULL, $orderexpiry=NULL) 
	{
		$r = q("INSERT INTO 
			fud21_thread(
				forum_id, 
				root_msg_id, 
				last_post_date, 
				replies, 
				views, 
				rating, 
				last_post_id,
				locked, 
				is_sticky,
				ordertype,
				orderexpiry
			)
			VALUES
			(
				".$forum_id.",
				".$root.",
				".__request_timestamp__.",
				0,
				0,
				0,
				".$root.",
				'".yn($locked)."',
				'".yn($is_sticky)."',
				".ifnull($ordertype, "'NONE'").",
				".intzero($orderexpiry)."
			)");
		
		$this->id = db_lastid("fud21_thread", $r);
		
		return $this->id;
	}
	
	function sync()
	{
		list($old_sticky,$forum_id) = db_singlearr(q("SELECT is_sticky,forum_id FROM fud21_thread WHERE id=".$this->id));
	
		q("UPDATE fud21_thread SET 
			is_sticky='".yn($this->is_sticky)."',
			ordertype=".ifnull($this->ordertype, "'NONE'").",
			orderexpiry=".intnull($this->orderexpiry).",
			locked='".yn($this->locked)."'
		WHERE id=".$this->id);
		
		if( $old_sticky != yn($this->is_sticky) ) rebuild_forum_view($forum_id);
	}
	
	function get_by_id($id)
	{
		$result = qobj("SELECT 
				fud21_thread.*,
				fud21_msg.subject
			FROM 
				fud21_thread 
				LEFT JOIN fud21_msg 
					ON fud21_thread.root_msg_id=fud21_msg.id 
				LEFT JOIN fud21_forum 
					ON fud21_thread.forum_id=fud21_forum.id 
				LEFT JOIN fud21_cat 
					ON fud21_forum.cat_id=fud21_cat.id 
			WHERE 
				fud21_thread.id=".$id, $this);
		if ( empty($this->id) ) error_dialog('Invalid thread ID','You\'ve followed an invalid link, the thread you are trying to view does not exist.','', 'FATAL');
	}

	function delete($rebuild_view=TRUE)
	{
		$msg = new fud_msg_edit;
		qobj("SELECT * FROM fud21_msg WHERE id=".$this->root_msg_id, $msg);
		if( !empty($msg->id) )
			$msg->delete(FALSE);
		else {
			q("DELETE FROM fud21_thread WHERE id=".$this->id);
			$tc = q_singleval("SELECT count(*) FROM fud21_thread INNER JOIN fud21_msg ON fud21_thread.root_msg_id=fud21_msg.id WHERE forum_id=".$this->forum_id." AND fud21_msg.approved='Y'");
			$mc = q_singleval("SELECT SUM(replies) FROM fud21_thread INNER JOIN fud21_msg ON fud21_thread.root_msg_id=fud21_msg.id WHERE forum_id=".$this->forum_id." AND fud21_msg.approved='Y'");
			$mc += $tc;
			$lpi = q_singleval("SELECT MAX(last_post_id) FROM fud21_thread INNER JOIN fud21_msg ON fud21_thread.root_msg_id=fud21_msg.id WHERE forum_id=".$this->forum_id." AND fud21_msg.approved='Y'");
			q("UPDATE fud21_forum SET post_count=".intzero($mc).", last_post_id=".intzero($lpi).", thread_count=".intzero($tc)." WHERE id=".$this->forum_id);
		}	
		
		if( $rebuild_view ) rebuild_forum_view($this->forum_id);
	}
	
	function lock()
	{
		q("UPDATE fud21_thread SET locked='Y' WHERE id=".$this->id);
	}
	
	function unlock()
	{
		q("UPDATE fud21_thread SET locked='N' WHERE id=".$this->id);
	}
	
	function move($to_forum)
	{
		if ( !db_locked() ) {
			db_lock('fud21_thread_view+, fud21_thread+, fud21_forum+, fud21_msg+');
			$local_lock = 1;
		}
		$msg_count = q_singleval("SELECT count(*) FROM fud21_thread LEFT JOIN fud21_msg ON fud21_msg.thread_id=fud21_thread.id WHERE fud21_msg.approved='Y' AND fud21_thread.id=".$this->id);
		
		q("UPDATE fud21_thread SET forum_id=".$to_forum." WHERE id=".$this->id);
		q("UPDATE fud21_forum SET post_count=post_count-".$msg_count." WHERE id=".$this->forum_id);
		q("UPDATE fud21_forum SET thread_count=thread_count+1,post_count=post_count+".$msg_count." WHERE id=".$to_forum);
		$r=q("DELETE FROM fud21_thread WHERE forum_id=".$to_forum." AND root_msg_id=".$this->root_msg_id." AND moved_to=".$this->forum_id);
		if( $aff_rows=db_affected($r) ) q("UPDATE fud21_forum SET thread_count=thread_count-".$aff_rows." WHERE id=".$to_forum);
		q("UPDATE fud21_thread SET moved_to=".$to_forum." WHERE id!=".$this->id." AND root_msg_id=".$this->root_msg_id);
		
		q("INSERT INTO fud21_thread(
			forum_id,
			root_msg_id,
			last_post_date,
			last_post_id,
			moved_to
		)
		VALUES(
			".$this->forum_id.",
			".$this->root_msg_id.",
			".$this->last_post_date.",
			".$this->last_post_id.",
			".$to_forum."
		)");
		
		rebuild_forum_view($this->forum_id);
		rebuild_forum_view($to_forum);
		
		if ( !empty($local_lock) ) db_unlock();
	}
	
	function inc_post_count($val)
	{
		q("UPDATE fud21_thread SET replies=replies+".$val." WHERE id=".$this->id);
	}
	
	function inc_view_count()
	{
		q("UPDATE fud21_thread SET views=views+1 WHERE id=".$this->id);
	}
	
	function dec_view_count($val)
	{
		q("UPDATE fud21_thread SET views=views-1 WHERE id=".$this->id);
	}
	
	function get_notify_list($user_id)
	{
		$ctm = __request_timestamp__;
		$tm = $ctm-604800;
	
		$r = q("SELECT 
				fud21_users.id AS user_id,
				fud21_users.email,
				fud21_users.icq,
				fud21_read.last_view,
				fud21_read.id,
				fud21_users.notify_method 
			FROM 
				fud21_thread_notify
				INNER JOIN fud21_users 
					ON fud21_thread_notify.user_id=fud21_users.id 
				LEFT JOIN fud21_read 
					ON fud21_read.user_id=fud21_thread_notify.user_id 
					AND fud21_read.thread_id=fud21_thread_notify.thread_id 
			WHERE 
				( fud21_read.msg_id=".$this->last_post_id." OR fud21_read.last_view < ".$tm." )
				AND fud21_thread_notify.thread_id=".$this->id." 
				AND fud21_thread_notify.user_id!=".intzero($user_id));
		
		$p = forum_perm_array($this->forum_id);
		$to=NULL;
		while ( $obj = db_rowobj($r) ) {
			if ( !is_allowed($obj->user_id, $p) ) continue;
			
			$to[$obj->notify_method][] = ( $obj->notify_method == 'EMAIL' ) ? $obj->email : $obj->icq.'@pager.icq.com';
			if( $obj->last_view < $tm ) q("UPDATE fud21_read SET last_view=".$ctm." WHERE id=".$obj->id);
		}
		qf($r);
		
		return $to;
	}
	
	function adm_set_rating($value)
	{
		q("UPDATE fud21_thread SET rating=".intnull($value)." WHERE id=".$this->id);
	}

	function has_thread_vote($user_id, $thread_id='')
	{
		if ( !$thread_id ) $thread_id = $this->id;
		
		if( ($rating=q_singleval("SELECT rating FROM fud21_thread_rate_track WHERE thread_id=".$thread_id." AND user_id=".$user_id)) ) {
			return $rating;	
		}
		return -1;
	}
	
	function update_vote_count()
	{
		$rating = q_singleval("SELECT ROUND(AVG(rating)) FROM fud21_thread_rate_track WHERE thread_id=".$this->id);
		q("UPDATE fud21_thread SET rating=".$rating." WHERE id=".$this->id);
	}
	
	function vote_count($thread_id='')
	{
		if ( !$thread_id ) $thread_id = $this->id;
		
		return q_singleval("SELECT COUNT(*) FROM fud21_thread_rate_track WHERE thread_id=".$thread_id);
	}
	
	function register_thread_vote($user_id, $rating, $thread_id='')
	{
		if ( !$thread_id ) $thread_id = $this->id;
		
		if( !db_locked() ) {
			db_lock('fud21_thread_rate_track+, fud21_thread+');
			$local_lock = 1;
		}
		
		if( $this->has_thread_vote($user_id, $thread_id) != -1 ) {
			if ( $local_lock ) db_unlock();
			return;
		}	
		
		q("INSERT INTO fud21_thread_rate_track (
			thread_id,
			user_id,
			stamp,
			rating
			)
		VALUES(
			".$thread_id.",
			".$user_id.",
			".__request_timestamp__.",
			".$rating."
		)");
		
		$rating = q_singleval("SELECT ROUND(AVG(rating)) FROM fud21_thread_rate_track WHERE thread_id=".$thread_id);
		
		q("UPDATE fud21_thread SET rating=".$rating." WHERE id=".$thread_id);
		
		if ( $local_lock ) db_unlock();
	}
}

function rebuild_forum_view($forum_id, $page=0)
{
	if( !db_locked() ) {
	        db_lock('fud21_thread_view+, fud21_thread+, fud21_msg+, fud21_forum+');
		$local_lock=1;
	}
	
	$tm = __request_timestamp__;
	
	/* Remove expired moved thread pointers */
	$r=q("DELETE FROM fud21_thread WHERE forum_id=".$forum_id." AND last_post_date<".($tm-86400*$GLOBALS['MOVED_THR_PTR_EXPIRY'])." AND moved_to!=0");
	if( $aff_rows = db_affected($r) ) {
		q("UPDATE fud21_forum SET thread_count=thread_count-".$aff_rows." WHERE id=".$forum_id);
		$page = 0;
	}
	
	/* De-announce expired announcments and sticky messages */
	$r = q("SELECT fud21_thread.id FROM fud21_thread INNER JOIN fud21_msg ON fud21_thread.root_msg_id=fud21_msg.thread_id WHERE fud21_thread.forum_id=".$forum_id." AND is_sticky='Y' AND (fud21_msg.post_stamp+fud21_thread.orderexpiry)<".$tm);
	while( list($tid) = db_rowarr($r) ) 
		q("UPDATE fud21_thread SET ordertype='NONE', is_sticky='N' WHERE id=".$tid);
	qf($r);

	if ( __dbtype__ == 'pgsql' ) {
		$tmp_tbl_name = "fud21_ftvt_".get_random_value();
		q("CREATE TEMP TABLE ".$tmp_tbl_name." ( forum_id INT NOT NULL, page INT8 NOT NULL, thread_id INT NOT NULL, pos SERIAL, tmp INT )");
		
		if( $page ) {
			q("DELETE FROM fud21_thread_view WHERE forum_id=".$forum_id." AND page<".($page+1));
			q("INSERT INTO ".$tmp_tbl_name." (thread_id,forum_id,page,tmp) SELECT fud21_thread.id, fud21_thread.forum_id, 4294967294, CASE WHEN is_sticky='Y' AND (fud21_msg.post_stamp+fud21_thread.orderexpiry>".$tm." OR fud21_thread.orderexpiry=0) THEN 4294967294 ELSE fud21_thread.last_post_date END AS sort_order_fld  FROM fud21_thread INNER JOIN fud21_msg ON fud21_thread.root_msg_id=fud21_msg.id WHERE forum_id=".$forum_id." AND fud21_msg.approved='Y' ORDER BY sort_order_fld DESC, fud21_thread.last_post_id DESC LIMIT ".($GLOBALS['THREADS_PER_PAGE']*$page).", 0");
		}
		else {
			q("DELETE FROM fud21_thread_view WHERE forum_id=".$forum_id);
			q("INSERT INTO ".$tmp_tbl_name." (thread_id,forum_id,page,tmp) SELECT fud21_thread.id, fud21_thread.forum_id, 2147483647, CASE WHEN is_sticky='Y' AND (fud21_msg.post_stamp+fud21_thread.orderexpiry>".$tm." OR fud21_thread.orderexpiry=0) THEN 2147483647 ELSE fud21_thread.last_post_date END AS sort_order_fld  FROM fud21_thread INNER JOIN fud21_msg ON fud21_thread.root_msg_id=fud21_msg.id WHERE forum_id=".$forum_id." AND fud21_msg.approved='Y' ORDER BY sort_order_fld DESC, fud21_thread.last_post_id DESC");
		}
		
		q("INSERT INTO fud21_thread_view (thread_id,forum_id,page,pos) SELECT thread_id,forum_id,CEIL(pos/40.0),(pos-(CEIL(pos/40)-1)*40) FROM ".$tmp_tbl_name);
		q("DROP SEQUENCE ".$tmp_tbl_name."_pos_seq");
		q("DROP TABLE ".$tmp_tbl_name);
		return;
	}
	else if ( __dbtype__ == 'mysql' ) {
		if( $page ) {
			q("DELETE FROM fud21_thread_view WHERE forum_id=".$forum_id." AND page<".($page+1));
			q("INSERT INTO fud21_thread_view (thread_id,forum_id,page,tmp) SELECT fud21_thread.id, fud21_thread.forum_id, 4294967294, CASE WHEN is_sticky='Y' AND (fud21_msg.post_stamp+fud21_thread.orderexpiry>".$tm." OR fud21_thread.orderexpiry=0) THEN 4294967294 ELSE fud21_thread.last_post_date END AS sort_order_fld  FROM fud21_thread INNER JOIN fud21_msg ON fud21_thread.root_msg_id=fud21_msg.id WHERE forum_id=".$forum_id." AND fud21_msg.approved='Y' ORDER BY sort_order_fld DESC, fud21_thread.last_post_id DESC LIMIT 0, ".($GLOBALS['THREADS_PER_PAGE']*$page));
			q("UPDATE fud21_thread_view SET page=CEILING(pos/".$GLOBALS['THREADS_PER_PAGE']."), pos=pos-(CEILING(pos/".$GLOBALS['THREADS_PER_PAGE'].")-1)*".$GLOBALS['THREADS_PER_PAGE']." WHERE forum_id=".$forum_id." AND page=4294967294");			
		}
		else {
			q("DELETE FROM fud21_thread_view WHERE forum_id=".$forum_id);
			q("INSERT INTO fud21_thread_view (thread_id,forum_id,page,tmp) SELECT fud21_thread.id, fud21_thread.forum_id, 4294967294, CASE WHEN is_sticky='Y' AND (fud21_msg.post_stamp+fud21_thread.orderexpiry>".$tm." OR fud21_thread.orderexpiry=0) THEN 4294967294 ELSE fud21_thread.last_post_date END AS sort_order_fld  FROM fud21_thread INNER JOIN fud21_msg ON fud21_thread.root_msg_id=fud21_msg.id WHERE forum_id=".$forum_id." AND fud21_msg.approved='Y' ORDER BY sort_order_fld DESC, fud21_thread.last_post_id DESC");
			q("UPDATE fud21_thread_view SET page=CEILING(pos/".$GLOBALS['THREADS_PER_PAGE']."), pos=pos-(CEILING(pos/".$GLOBALS['THREADS_PER_PAGE'].")-1)*".$GLOBALS['THREADS_PER_PAGE']." WHERE forum_id=".$forum_id);			
		}
	}
	if( $local_lock ) db_unlock();
}class fud_msg
{
	var $id=NULL;
	var $thread_id=NULL;
	var $poster_id=NULL;
	var $reply_to=NULL;
	var $ip_addr=NULL;
	var $host_name=NULL;
	var $post_stamp=NULL;
	var $subject=NULL;
	var $attach_cnt=NULL;
	var $poll_id=NULL;
	var $update_stamp=NULL;
	var $icon=NULL;
	var $approved=NULL;
	var $show_sig=NULL;
	var $updated_by=NULL;
	var $smiley_disabled=NULL;
	var $login=NULL;
	var $length=NULL;
	var $foff=NULL;
	var $file_id=NULL;
	var $file_id_preview=NULL;
	var $length_preview=NULL;
	var $offset_preview=NULL;
	
	var $body;
		
	function get_by_id($id)
	{
		qobj("SELECT fud21_msg.*,fud21_users.alias AS login FROM fud21_msg LEFT JOIN fud21_users ON fud21_msg.poster_id=fud21_users.id WHERE fud21_msg.id=".$id, $this);
		if( empty($this->id) ) error_dialog('Invalid Message', 'The message you are trying to view does not exist.', '', 'FATAL');
		
		$this->body = read_msg_body($this->foff,$this->length, $this->file_id);
		un_register_fps();
	}
	
	function get_thread($th_id)
	{
		qobj("SELECT fud21_msg.* FROM fud21_msg INNER JOIN fud21_thread ON fud21_thread.root_msg_id=fud21_msg.id WHERE fud21_thread.id=".$th_id, $this);
		
		
		$this->body = read_msg_body($this->foff,$this->length, $this->file_id);
		un_register_fps();
	}
}

if ( defined('msg_edit') && !defined("_imsg_edit_inc_") ) fud_use('imsg_edt.inc');function get_all_perms($usr_id)
{
	$fl = '';

	if( empty($usr_id) ) {
		$r = q("SELECT resource_id FROM fud21_group_cache WHERE user_id=0 AND resource_type='forum' AND p_READ='Y' AND p_VISIBLE='Y'");
		while( list($resource_id) = db_rowarr($r) ) $fl .= $resource_id.',';		
	}
	else {
		$tmp_arr = array();
		$r = q("SELECT user_id,resource_id,p_read,p_visible FROM fud21_group_cache WHERE user_id IN(".$usr_id.",2147483647) AND resource_type='forum' ORDER BY user_id");
		while( $obj = db_rowobj($r) ) {
			if( $obj->p_read == 'Y' && $obj->p_read == 'Y' && ($obj->user_id == $usr_id || !isset($tmp_arr[$obj->resource_id])) ) 
				$fl .= $obj->resource_id.',';

			$tmp_arr[$obj->resource_id] = 1;	
		}		
	}
	qf($r);
	
	if( !empty($fl) ) $fl = substr($fl, 0, -1);
	
	return $fl;
}

function forum_perm_array($forum_id)
{
 	$r = q("SELECT p_READ AS p_read, user_id FROM fud21_group_cache WHERE resource_type='forum' AND resource_id=$forum_id AND user_id>0");
	while ( $obj = db_rowobj($r) ) $p[$obj->user_id] = $obj->p_read;
	qf($r);
	
	return $p;
}

function is_allowed($user_id, $p)
{
	if ( isset($p[$user_id]) && $p[$user_id] != 'Y' ) 
		return 0;
	else if ( $p[$user_id] != 'Y' && $p['2147483647'] == 'N' ) 
		return 0;
	
	return 1;
}
	
function ifstr($opt1, $opt2, $str)
{	
	return ( strlen($str) ) ? $opt1 : $opt2;
}
	
	if ( isset($ses) ) $ses->update('Browsing <a class="GenLink" href="http://thelocust.org/bored/index.php?t=selmsg&date=today&rid='.$usr->id.'">Today\'s Posts</a>');
	
	if ( !isset($usr) && empty($count) ) 
		$count = $POSTS_PER_PAGE;
	else if ( isset($usr) ) 
		$count = ($usr->posts_ppg)?$usr->posts_ppg:$GLOBALS['POSTS_PER_PAGE'];

	if ( !isset($start) ) $start = 0;
		
	if ( ((isset($reply_count)&&!strlen($reply_count))||!isset($reply_count)) && empty($date) && empty($unread) && empty($sub_forums) && empty($sub_threads) ) {
		$date = 'today';
	}	
	
	if( isset($unread) && !strlen($unread) ) $unread='';
	if( isset($reply_count) && !strlen($reply_count) ) $reply_count='';
	if( isset($date) && !strlen($date) ) $date = '';
	if( isset($unread_join) && !strlen($unread_join) ) $unread_join = '';
	if( isset($frm_id) && !strlen($frm_id) ) $frm_id='';
	if( isset($th) && !strlen($th) ) $th='';
	
	/* figure out the query */

	$tm = __request_timestamp__;
	$day = date('d', $tm);
	$month = date ('m', $tm);
	$year = date('Y', $tm);
	$tm_today_start = mktime(0, 0, 0, $month, $day, $year);
	$tm_today_end = mktime(24, 59, 59, $month, $day, $year);
	
	$reply_lmt=$thread_lmt=$forum_lmt='';
	
	if ( isset($frm_id) && strlen($frm_id) ) $forum_lmt = 'AND fud21_forum.id='.$frm_id.' ';
	if ( isset($th) && strlen($th) ) $thread_lmt = 'AND fud21_thread.id='.$th.' ';
	if ( isset($reply_count) && strlen($reply_count) ) $reply_lmt = ' AND fud21_thread.replies='.$reply_count.' ';
	
	$unread_where='';
	if ( isset($unread) && strlen($unread) && isset($usr) ) {
		$unread_join = 'LEFT JOIN fud21_read ON fud21_read.user_id='.$usr->id.' AND fud21_read.thread_id=fud21_msg.thread_id';
		
		if( isset($usr) && $usr->last_read ) 
			$unread_where = ' AND fud21_msg.post_stamp>'.$usr->last_read;
		$unread_where .= ' AND (fud21_read.msg_id<fud21_msg.id OR fud21_read.msg_id IS NULL)';
	}
	
	$date_limit = '';
	if ( isset($date) && $date=='today' ) {
		$date_limit = "
			AND fud21_msg.post_stamp>".$tm_today_start."
			AND fud21_msg.post_stamp<".$tm_today_end;
	}
	
	
	if ( isset($usr) ) {
		if ( !empty($sub_threads) ) {
			$sub_thread_join = 'INNER JOIN fud21_thread_notify
						ON fud21_thread_notify.thread_id=fud21_thread.id AND fud21_thread_notify.user_id='.$usr->id;
		}
		
		if ( !empty($sub_forums) ) {
			$sub_forum_join = 'INNER JOIN fud21_forum_notify
						ON fud21_forum_notify.forum_id=fud21_forum.id AND fud21_forum_notify.user_id='.$usr->id;
		}
	}
	
	if ( !empty($last_id) && !empty($mark_page_read) ) {
		$id_limit = ' AND fud21_msg.id<='.$last_id;
	}
	
	if( $usr->id_mod!='A' ) {
		$fids = get_all_perms(_uid);
		if( empty($fids) ) $fids = 0;
		$qry_limit = 'fud21_forum.id IN ('.$fids.') AND ';
	}
	else
		$qry_limit = '';		
		
	$total = q_singleval('SELECT
			count(*)
		FROM
			fud21_msg
			INNER JOIN fud21_thread
				ON fud21_msg.thread_id=fud21_thread.id
			INNER JOIN fud21_forum
				ON fud21_thread.forum_id=fud21_forum.id
			INNER JOIN fud21_cat
				ON fud21_forum.cat_id=fud21_cat.id
			'.$perms.'
			'.$sub_forum_join.'
			'.$sub_thread_join.'
			'.$unread_join.'
		WHERE
			'.$qry_limit.'
			fud21_msg.approved=\'Y\'
			'.$forum_lmt.'
			'.$thread_lmt.'
			'.$reply_lmt.'
			'.$unread_where.'
			'.$date_limit.'
			'.(isset($id_limit)?$id_limit:''));

	$rid = q('SELECT 
			fud21_msg.id 
		FROM
			fud21_msg
			INNER JOIN fud21_thread
				ON fud21_msg.thread_id=fud21_thread.id
			INNER JOIN fud21_forum
				ON fud21_thread.forum_id=fud21_forum.id
			INNER JOIN fud21_cat
				ON fud21_forum.cat_id=fud21_cat.id
			'.$sub_forum_join.'
			'.$sub_thread_join.'
			'.$unread_join.'
		WHERE
			'.$qry_limit.'
			fud21_msg.approved=\'Y\'
			'.$forum_lmt.'
			'.$thread_lmt.'
			'.$reply_lmt.'
			'.$unread_where.'
			'.$date_limit.'
			'.(isset($id_limit)?$id_limit:'').'
	ORDER BY 
		fud21_forum.last_post_id,
		fud21_thread.last_post_id, 
		fud21_msg.post_stamp
	LIMIT '.qry_limit($count, $start));
	
	
	if( db_count($rid) ) {
		$id_list='fud21_msg.id IN(';
		$m_count=0;
		while ( list($msgp_id) = db_rowarr($rid) ) { $id_list .= $msgp_id.','; $m_count++; }
		qf($rid);
		$id_list = substr($id_list, 0, -1).')';
	
		$r = q('SELECT 
			fud21_msg.*, 
			fud21_forum.id AS frm_id,
			fud21_forum.message_threshold,
			fud21_thread.last_post_id,
			fud21_thread.id AS th_id,
			fud21_thread.locked AS locked,
			fud21_thread.forum_id,
			fud21_thread.replies,
			fud21_users.id AS user_id, 
			fud21_users.alias AS login,
			fud21_users.display_email,
			fud21_users.custom_status,
			fud21_users.email, 
			fud21_users.posted_msg_count, 
			fud21_users.join_date, 
			fud21_users.location,
			fud21_users.avatar_approved,
			fud21_users.avatar_loc,
			fud21_users.sig,
			fud21_users.icq,
			fud21_users.jabber,
			fud21_users.aim,
			fud21_users.msnm,
			fud21_users.yahoo,
			fud21_users.email_messages,
			fud21_users.invisible_mode,
			fud21_users.is_mod,
			fud21_forum.name AS frm_name, 
			fud_msg_thread.subject AS thr_subject,
			fud21_avatar.img AS avatar,
			fud21_level.name AS level_name,
			fud21_level.pri AS level_pri,
			fud21_level.img AS level_img,
			fud21_ses.time_sec
		FROM
			fud21_msg 
			INNER JOIN fud21_thread 
				ON fud21_msg.thread_id=fud21_thread.id
			INNER JOIN fud21_forum 
				ON fud21_forum.id=fud21_thread.forum_id 
			INNER JOIN fud21_cat
				ON fud21_forum.cat_id=fud21_cat.id	
			INNER JOIN fud21_msg AS fud_msg_thread 
				ON fud_msg_thread.id=fud21_thread.root_msg_id 
			LEFT JOIN fud21_users 
				ON fud21_msg.poster_id=fud21_users.id 
			LEFT JOIN fud21_ses
				ON fud21_ses.user_id=fud21_msg.poster_id
			LEFT JOIN fud21_avatar
				ON fud21_users.avatar=fud21_avatar.id
			LEFT JOIN fud21_level
				ON fud21_users.level_id=fud21_level.id
			WHERE
				'.$id_list.' 
			ORDER BY fud21_forum.last_post_id,fud21_thread.last_post_id, fud21_msg.post_stamp');
	}
	else $r = $rid;	

	$url_param = _rsid.'&unread='.(isset($unread)?$unread:'').'&reply_count='.$reply_count.'&date='.(isset($date)?$date:'').'&frm_id='.(isset($frm_id)?$frm_id:'').'&th='.(isset($th)?$th:'').'&rand='.get_random_value();
	
	if ( !empty($mark_page_read) && isset($usr) ) {
		while ( $obj = db_rowobj($r) ) {
			if ( $dth_id != $obj->th_id ) { 
				if ( $dth_id && $msg_id ) $usr->register_thread_view($dth_id, $msg_id);
				if ( $p_frm_id ) $usr->register_forum_view($p_frm_id);
			}
			$dth_id = $obj->th_id;
			$msg_id = $obj->id;
			$p_frm_id = $obj->frm_id;
		}
		
		if ( $dth_id != $obj->th_id ) { 
			if ( $dth_id && $msg_id ) $usr->register_thread_view($dth_id, $msg_id);
			if ( $p_frm_id ) $usr->register_forum_view($p_frm_id);
		}
		
		header('Location: http://thelocust.org/bored/index.php?t=selmsg&'.$url_param.'rand='.get_random_value());
		exit();
	}
	$dth_id='';
	
	if( _uid ) {
	if( $usr->is_mod != 'N' && $usr->is_mod ) {
		if( $approve_count = q_singleval("SELECT count(*) FROM 
					fud21_msg 
					INNER JOIN fud21_thread 
						ON fud21_msg.thread_id=fud21_thread.id 
					INNER JOIN fud21_forum 
						ON fud21_thread.forum_id=fud21_forum.id 
					INNER JOIN fud21_mod 
						ON fud21_forum.id=fud21_mod.forum_id 
						".($GLOBALS["usr"]->is_mod != 'A' ? "AND fud21_mod.user_id="._uid : '')."  
					WHERE 
						fud21_msg.approved='N' 
						AND fud21_forum.moderated='Y'") ) 
			$mod_que = '<a class="GenLink" href="http://thelocust.org/bored/index.php?t=modque&'._rsid.'">Moderation Queue</a> <span class="GenText" style="color: #ff0000">('.$approve_count.')</span>';
		
		if( $GLOBALS["usr"]->is_mod == 'A' ) {
			if( $avatar_count = q_singleval("SELECT count(*) FROM fud21_users WHERE avatar_approved='N'") ) 
				$custom_avatar_queue = '| <a class="GenLink" href="adm/admapprove_avatar.php?'._rsid.'">Custom Avatar Queue</a> <span class="GenText" style="color: #ff0000">('.$avatar_count.')</span>';
	
			if( $report_count = q_singleval("SELECT count(*) FROM fud21_msg_report") ) 
				$reported_msgs = '| <a class="GenLink" href="http://thelocust.org/bored/index.php?t=reported&'._rsid.'">Reported Messages</a> <span class="GenText" style="color: #ff0000">('.$report_count.')</span>';
				
			if( $thr_exchc = q_singleval("SELECT count(*) FROM fud21_thr_exchange") )
				$thr_exch = '| <a class="GenLink" href="http://thelocust.org/bored/index.php?t=thr_exch&'._rsid.'">Thread Exchange </a> <span class="GenText" style="color: #ff0000">('.$thr_exchc.')</span>';
		}	
		else {
			if( $report_count = q_singleval("SELECT count(*) FROM fud21_msg_report INNER JOIN fud21_msg ON fud21_msg_report.msg_id=fud21_msg.id INNER JOIN fud21_thread ON fud21_msg.thread_id=fud21_thread.id INNER JOIN fud21_mod ON fud21_thread.forum_id=fud21_mod.forum_id AND fud21_mod.user_id=".$GLOBALS["usr"]->id) )
				$reported_msgs = '| <a class="GenLink" href="http://thelocust.org/bored/index.php?t=reported&'._rsid.'">Reported Messages</a> <span class="GenText" style="color: #ff0000">('.$report_count.')</span>';
			
			if( $thr_exchc = q_singleval("SELECT count(*) FROM fud21_thr_exchange INNER JOIN fud21_mod ON fud21_mod.user_id=".$usr->id." AND fud21_thr_exchange.frm=fud21_mod.forum_id") ) 
				$thr_exch = '| <a class="GenLink" href="http://thelocust.org/bored/index.php?t=thr_exch&'._rsid.'">Thread Exchange </a> <span class="GenText" style="color: #ff0000">('.$thr_exchc.')</span>';
		}
	}
	if( $usr->is_mod=='A' || bq("SELECT id FROM fud21_group_members WHERE user_id="._uid." AND group_leader='Y' LIMIT 1") )
		$group_mgr = '| <a class="GenLink" href="http://thelocust.org/bored/index.php?t=groupmgr&'._rsid.'">Group(s) Manager</a>';
	
	if( $thr_exch || $group_mgr || $reported_msgs || $custom_avatar_queue || $mod_que ) $admin_cp = '<br><font class="GenText"><b>Admin :</b></font> '.$mod_que.' '.$reported_msgs.' '.$thr_exch.' '.$custom_avatar_queue.' '.$group_mgr;
}$adm_str = $rid = $pm = '';
	$ret_to = '&returnto='.urlencode(!empty($GLOBALS['returnto'])?urldecode($GLOBALS['returnto']):$GLOBALS['HTTP_SERVER_VARS']['REQUEST_URI']);

	if ( empty($GLOBALS['usr']) ) {
		$login_n_logout = '<td valign="middle"><a class="UserControlPanel" href="http://thelocust.org/bored/index.php?t=login&'._rsid.$ret_to.'"><img src="http://thelocust.org/bored/theme/default/images/top_login.gif" border=0 alt="Login"></a></td>
<td valign="middle"><a class="UserControlPanel" href="http://thelocust.org/bored/index.php?t=login&'._rsid.$ret_to.'">Login</a></td>';
		$register_n_profile = '<td valign="middle"><a class="UserControlPanel" href="http://thelocust.org/bored/index.php?t=register&'._rsid.'"><img src="http://thelocust.org/bored/theme/default/images/top_register.gif" border=0 alt="Register"></a></td>
<td valign="middle"><a class="UserControlPanel" href="http://thelocust.org/bored/index.php?t=register&'._rsid.'">Register</a></td>';
	}
	else {
		if( $GLOBALS['usr']->is_mod == 'A' ) $admin_control_panel = '<td>&nbsp;&nbsp;</td><td valign="middle"><a class="UserControlPanel" href="adm/admglobal.php?'._rsid.'"><img src="http://thelocust.org/bored/theme/default/images/top_admin.gif" border=0 alt="Admin Control Panel"></a></td>
<td valign="middle"><a class="UserControlPanel" href="adm/admglobal.php?'._rsid.'">Admin Control Panel</a></td>';
		$user_login = htmlspecialchars($usr->alias);
		$login_n_logout = '<td valign="middle"><a class="UserControlPanel" href="http://thelocust.org/bored/index.php?t=login&'._rsid.$ret_to.'&logout=1"><img src="http://thelocust.org/bored/theme/default/images/top_logout.gif" border=0 alt="Logout"></a></td>
<td valign="middle"><a class="UserControlPanel" href="http://thelocust.org/bored/index.php?t=login&'._rsid.$ret_to.'&logout=1">Logout [ '.$user_login.' ]</a></td>';
		$register_n_profile = '<td valign="middle"><a class="UserControlPanel" href="http://thelocust.org/bored/index.php?t=register&'._rsid.'"><img src="http://thelocust.org/bored/theme/default/images/top_profile.gif" border=0 title="Click here to access user control panel" alt="Profile"></a></td>
<td valign="middle"><a class="UserControlPanel" href="http://thelocust.org/bored/index.php?t=register&'._rsid.'"><acronym title="Click here to access user control panel">Profile</acronym></a></td>';
		$rid = $GLOBALS["usr"]->id;
		
		if ( $GLOBALS['PM_ENABLED']=='Y' ) {
			$c = q_singleval("SELECT count(*) FROM fud21_pmsg WHERE duser_id=".$GLOBALS["usr"]->id." AND folder_id='INBOX' AND read_stamp=0");
			$private_msg = ( $c ) ? '<td>&nbsp;&nbsp;</td>
<td valign="middle"><a href="http://thelocust.org/bored/index.php?t=pmsg&'._rsid.'" class="UserControlPanel"><img src="http://thelocust.org/bored/theme/default/images/top_pm.gif" border=0 alt="Private Messaging"></a></td>
<td><a href="http://thelocust.org/bored/index.php?t=pmsg&'._rsid.'" class="UserControlPanel">You have <span class="GenText" style="color: #ff0000">('.$c.')</span> unread private message(s)</a></td>
<td>&nbsp;&nbsp;</td>' : '<td>&nbsp;&nbsp;</td>
<td valign="middle"><a href="http://thelocust.org/bored/index.php?t=pmsg&'._rsid.'" class="UserControlPanel"><img src="http://thelocust.org/bored/theme/default/images/top_pm.gif" border=0 alt="Private Messaging"></a></td>
<td><a href="http://thelocust.org/bored/index.php?t=pmsg&'._rsid.'" class="UserControlPanel">Private Messaging</a></td>
<td>&nbsp;&nbsp;</td>';
		}
	}/* FILE START */
	
	function valstat($a)
	{
		return ( ($a) ? '<font style="font-size: xx-small; font-weight: bold; text-decoration: none;">(<font color="red">ON</font>)</font>' : '<font style="font-size: xx-small; font-weight: bold; text-decoration: none;">(OFF)</font>');
	}

	if ( !empty($date) && $date == 'today' ) {
		$dt_opt = '';
		$s_today = valstat(1);
	}
	else {
		$dt_opt = 'today';
		$s_today = valstat(0);
	}

	if ( isset($reply_count) && strlen($reply_count) ) {
		$rp_opt = '';
		$s_unu = valstat(1);
	}
	else {
		$rp_opt = '0';
		$s_unu = valstat(0);
	}
	
	if ( isset($usr) ) {
		if ( !empty($unread) && strlen($unread) ) {
			$un_opt = '';
			$s_unread = valstat(1);
		}
		else {
			$un_opt = '1';
			$s_unread = valstat(0);
		}
		
		if ( !empty($sub_forums) && isset($usr) ) {
			$frm_opt = '';
			$s_subf = valstat(1);
		}
		else if ( isset($usr) ) {
			$frm_opt = '1';
			$s_subf = valstat(0);
		}
	
		if ( $sub_threads && isset($usr) ) {
			$th_opt = '';
			$s_subt = valstat(1);
		}
		else if ( isset($usr) ) {
			$th_opt = '1';
			$s_subt = valstat(0);
		}	
		
		$subscribed_thr = '&nbsp;| <a class="GenLink" href="http://thelocust.org/bored/index.php?t=selmsg&date='.$date.'&unread='.$unread.'&reply_count='.$reply_count.'&sub_forums='.$sub_forums.'&sub_threads='.$th_opt.'&'._rsid.'"><acronym title="Toggle the subscribed threads filter (will only show posts from the threads you are subscribed to)">Subscribed Threads '.$s_subt.'</acronym></a>';
		$subscribed_frm = '&nbsp;| <a class="GenLink" href="http://thelocust.org/bored/index.php?t=selmsg&date='.$date.'&unread='.$unread.'&reply_count='.$reply_count.'&sub_forums='.$frm_opt.'&sub_threads='.$sub_threads.'&'._rsid.'"><acronym title="Toggle the subscribed forums filter (will only show posts from the forums you are subscribed to)">Subscribed Forums '.$s_subf.'</acronym></a>';
		$unread_messages = '&nbsp;| <a class="GenLink" href="http://thelocust.org/bored/index.php?t=selmsg&date='.$date.'&unread='.$un_opt.'&reply_count='.$reply_count.'&sub_forums='.$sub_forums.'&sub_threads='.$sub_threads.'&'._rsid.'"><acronym title="Toggle unread message filter (will only show unread messages)">Unread Messages '.$s_unread.'</acronym></a>';
	}
	
	$todays_posts = '<a class="GenLink" href="http://thelocust.org/bored/index.php?t=selmsg&date='.$dt_opt.'&unread='.$unread.'&reply_count='.$reply_count.'&sub_forums='.$sub_forums.'&sub_threads='.$sub_threads.'&'._rsid.'"><acronym title="Toggle today\'s posts filter (will only show posts made today)">Today\'s Posts '.$s_today.'</acronym></a>';
	$unanswered = '&nbsp;| <a class="GenLink" href="http://thelocust.org/bored/index.php?t=selmsg&date='.$date.'&unread='.$unread.'&reply_count='.$rp_opt.'&sub_forums='.$sub_forums.'&sub_threads='.$sub_threads.'&'._rsid.'"><acronym title="Toggle the un-answered posts filter (will show only posts that have no replies)">Unanswered Posts '.$s_unu.'</acronym></a>';	

	if ( $unread && $total ) {
		$LAST_ID=NULL;
		while ( $obj = db_rowobj($r) ) {
			if ( $LAST_ID < $obj->id ) $LAST_ID = $obj->id;
		}
		db_seek($r, 0);
		$LAST_ID = 'last_id='.$LAST_ID;
		$more_unread_messages = '<div align="center" class="GenText">[<a href="http://thelocust.org/bored/index.php?t=selmsg&mark_page_read=1&'.$LAST_ID.'&'.$url_param.'" class="GenLink"><acronym title="Show more unread messages and mark the currently viewable messages read">more unread messages</acronym></a>]</div><img src="blank.gif" height=3 border=0>';
	}
	
	if ( ($m_count = db_count($r)) ) {
		$m_count--;
		$message_data='';
		while ( $obj = db_rowobj($r) ) {
			if ( $dfrm_id != $obj->frm_id ) { 
				if( isset($usr) ) {
					unset($frm);
					$frm = new fud_forum;
					$frm->id = $obj->frm_id;
					unset($MOD);
					if ( $frm->is_moderator($usr->id) || $usr->is_mod == 'A' ) $MOD = 1;
				}	
				$message_data .= '<tr><th colspan=2>Forum: <a class="th_lnk" href="http://thelocust.org/bored/index.php?t=thread&frm_id='.$obj->frm_id.'&'._rsid.'"><font style="font-size: 12px;">'.$obj->frm_name.'</font></a></th></tr>';
				$dfrm_id = $obj->frm_id; 
			}
			
			if ( $dth_id != $obj->th_id ) { 
				
				
				if( isset($usr) ) {
					unset($thread);
					$thread = new fud_thread;
					$thread->id = $obj->th_id;
					$thread->locked = $obj->locked;
					$thread->inc_view_count();
				}
				
				$message_data .= '<tr><th colspan=2>&nbsp;Thread: <a class="th_lnk" href="http://thelocust.org/bored/index.php?t='.d_thread_view.'&goto='.$obj->id.'&'._rsid.'">'.$obj->thr_subject.'</a></th></tr>';
				$dth_id = $obj->th_id; 
			}
			
			$GLOBALS["returnto"] = 'returnto='.urlencode($GLOBALS["HTTP_SERVER_VARS"]["REQUEST_URI"]);
			$o_start = $start;
			$start = $obj->replies-$GLOBALS['POSTS_PER_PAGE'];
			if( $start < 0 ) $start = 0;
			$message_data .= tmpl_drawmsg($obj, $m_count);
			$start = $o_start;
			$msg_id = $obj->id;
			$p_frm_id = $obj->frm_id;
		}
		un_register_fps();
	}
	else 
		$message_data = '<tr><th align=middle>No Posts</th></tr>';

	if( empty($unread) ) 
		$pager = tmpl_create_pager($start, $count, $total, 'http://thelocust.org/bored/index.php?t=selmsg&'."date=".$date."&unread=".$unread."&"._rsid."&frm_id=".$frm_id."&th=".$th."&reply_count=".$reply_count);
	else if ( $unread && $total ) {
		/* nop */
	}
	else if ( !(empty($unread) && empty($total)) && isset($usr) && empty($sub_threads) && empty($sub_forums) && empty($date) && $reply_count!=='0' ) 
		$usr->mark_all_read();

	$page_gen_time = (db_getmicrotime() - $GLOBALS['PAGE_TIME']);
$q_time = query_count();
$ttl_time = total_time();

if ( isset($usr) && $usr->is_mod == 'A' )
	$page_stats = '<br><div align="left" class="SmallText">'.$q_time.' MySQL queries took '.$ttl_time.' seconds<br>Total time taken to generate the page: '.$page_gen_time.' seconds</div>';
else if ( $GLOBALS['PUBLIC_STATS'] == 'Y' ) 
	$page_stats = '<br><div align="left" class="SmallText">'.$q_time.' MySQL queries took '.$ttl_time.' seconds<br>Total time taken to generate the page: '.$page_gen_time.' seconds</div>';
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<title><?php echo $GLOBALS['FORUM_TITLE']; ?><?php echo $TITLE_EXTRA; ?></title>
<META HTTP-EQUIV="Content-Type" CONTENT="text/html; charset=ISO-8859-15">
<script language="javascript" src="lib.js"></script>
<link rel="StyleSheet" href="http://thelocust.org/bored/theme/default/forum.css" type="text/css">
</head>
<body topmargin="2" leftmargin="2" marginheight="2" marginwidth="2">
<table width="100%" border="0" cellspacing="3" cellpadding="5"><tr><td class="ForumBackground">
<table border=0 cellspacing=0 cellpadding=0 width="100%"><tr><td align="right">
<table cellspacing=3 cellpadding=0 border=0>
	<tr>
		<td valign="middle"><a class="UserControlPanel" href="http://thelocust.org/bored/index.php?t=help_index&<?php echo _rsid; ?>"><img src="http://thelocust.org/bored/theme/default/images/top_help.gif" border=0 alt="F.A.Q."></a></td>
		<td valign="middle"><a class="UserControlPanel" href="http://thelocust.org/bored/index.php?t=help_index&<?php echo _rsid; ?>">F.A.Q.</a></td>
		<td>&nbsp;&nbsp;</td>
		<?php echo $register_n_profile; ?>
		<td>&nbsp;&nbsp;</td>
		<?php echo $login_n_logout; ?>
		<td>&nbsp;&nbsp;</td>
		<td valign="middle"><a class="UserControlPanel" href="http://thelocust.org/bored/index.php?t=index&<?php echo _rsid; ?>"><img src="http://thelocust.org/bored/theme/default/images/top_home.gif" border=0 alt="Home"></a></td>
		<td valign="middle"><a class="UserControlPanel" href="http://thelocust.org/bored/index.php?t=index&<?php echo _rsid; ?>">Home</a></td>
	</tr>
</table>
<table cellspacing=3 cellpadding=0 border=0>	
	<tr>	
		<?php echo $private_msg; ?>
		<td valign="middle"><a class="UserControlPanel" href="http://thelocust.org/bored/index.php?t=finduser&btn_submit=Find&<?php echo _rsid; ?>"><img src="http://thelocust.org/bored/theme/default/images/top_members.gif" border=0 alt="Members"></a></td>
		<td valign="middle"><a class="UserControlPanel" href="http://thelocust.org/bored/index.php?t=finduser&btn_submit=Find&<?php echo _rsid; ?>">Members</a></td>
		<td>&nbsp;&nbsp;</td>
		<td valign="middle"><a class="UserControlPanel" href="http://thelocust.org/bored/index.php?t=search&<?php echo _rsid; ?>"><img src="http://thelocust.org/bored/theme/default/images/top_search.gif" border=0 alt="Search"></a></td>
		<td valign="middle"><a class="UserControlPanel" href="http://thelocust.org/bored/index.php?t=search&<?php echo _rsid; ?>">Search</a></td>
		<?php echo $admin_control_panel; ?>
	</tr>
</table></td></tr></table>
<?php echo $todays_posts; ?><?php echo $unread_messages; ?><?php echo $subscribed_frm; ?><?php echo $subscribed_thr; ?><?php echo $unanswered; ?>
<br><?php echo $admin_cp; ?>
<br><img src="blank.gif" height=2 border=0><br>
<?php echo $more_unread_messages; ?>
<table border="0" cellspacing="1" cellpadding="2" class="ContentTable">
<?php echo $message_data; ?>
</table>
<?php echo $more_unread_messages; ?>
<?php echo $pager; ?>
<p>
<br><table bgcolor="#000000" border=0 cellspacing=1 cellpadding=1 align="center"><tr class="RowStyleA"><td class="SmallText"><b>Current Time:</b> 
<?php echo strftime("%a %b %e %H:%M:%S %Z %Y", __request_timestamp__); ?>
</td></tr></table>
<?php echo $page_stats; ?>
</td></tr></table>
<table width="100%" border="0" cellspacing="3" cellpadding="5"><tr><td class="ForumBackground" align="center">
<b>.::</b> <a href="mailto:<?php echo $GLOBALS['ADMIN_EMAIL']; ?>">Contact</a> <b>::</b> <a href="http://thelocust.org/bored/index.php?t=index&<?php echo _rsid; ?>">Home</a> <b>::.</b>
<p>
<span class="SmallText">Powered by: FUDforum <?php echo $GLOBALS['FORUM_VERSION']; ?><br>Copyright &copy;2001,2002 <a href="http://fud.prohost.org/" class="GenLink">Advanced Internet Designs Inc.</a></span>
</td></tr></table>
</body>
</html>