<?php
/***************************************************************************
*   copyright            : (C) 2001,2002 Advanced Internet Designs Inc.
*   email                : forum@prohost.org
*
*   $Id: thr_exch.php.t,v 1.4 2002/07/08 23:15:19 hackie Exp $
****************************************************************************
          
****************************************************************************
*
*	This program is free software; you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation; either version 2 of the License, or
*	(at your option) any later version.
*
***************************************************************************/

	include_once "GLOBALS.php";
	fud_use('thrx_adm.inc', TRUE);
	if ( !defined('__index_page_start__') ) exit('sorry, you can not access this page');$GLOBALS['__REVERSE_ARRAY__'] = array('&amp;'=>'&','&quot;'=>'"','&lt;'=>'<','&gt;'=>'>');

function reverse_FMT(&$data)
{
	$data = strtr($data, $GLOBALS['__REVERSE_ARRAY__']);
}

function FMT($val)
{
	return htmlspecialchars(stripslashes($val));
}function validate_email($email)
{
        return !preg_match('!([-_A-Za-z0-9\.]+)\@([-_A-Za-z0-9\.]+)\.([A-Za-z0-9]{2,4})$!', $email);
}
        
class fud_email_block
{
	var $id;
	var $type;
	var $string;
	
	var $e_list;
	
	function add($type, $string)
	{
		q("INSERT INTO fud21_email_block(type, string) VALUES('".$type."', '".$string."')");
	} 
	
	function sync($type, $string)
	{
		q("UPDATE fud21_email_block SET type='".$type."', string='".$string."' WHERE id=".$this->id);
	}
	
	function get($id)
	{
		$res = q("SELECT * FROM fud21_email_block WHERE id=".$id);
		if ( !is_result($res) ) exit("no such email block");
		
		$obj = db_singleobj($res);
		
		$this->id 	= $obj->id;
		$this->type	= $obj->type;
		$this->string	= $obj->string;
	}
	
	function delete()
	{
		q("DELETE FROM fud21_email_block WHERE id=".$this->id);
	}
	
	function getall()
	{
		$res = q("SELECT * FROM fud21_email_block ORDER BY id");
		
		unset($this->e_list);
		while ( $obj = db_rowobj($res) ) {
			$this->e_list[] = $obj;
		}
		if ( isset($this->e_list) ) reset($this->e_list);
		qf($res); 
	}
	
	function counte()
	{
		if ( !isset($this->e_list) ) return;
		return count($this->e_list);
	}
	
	function resete()
	{
		if ( !isset($this->e_list) ) return;
		reset($this->e_list);
	}
	
	function eache()
	{
		if ( !isset($this->e_list) ) return;
		$obj = current($this->e_list);
		if ( !isset($obj) ) return;
		next($this->e_list);
		
		return $obj;
	}
}

function is_email_blocked($addr)
{

	if ( bq("SELECT * FROM fud21_email_block WHERE string='".$addr."'") ) return 1;

	$r = q("SELECT * FROM fud21_email_block ORDER BY id");
	while ( $obj = db_rowobj($r) ) {
		if ( $obj->type == 'SIMPLE' ) {
			$reg = $obj->string;
			$reg = str_replace('.', '\.', $reg);
			$reg = str_replace('*', '.*?', $reg);			
			if ( preg_match("!".$reg."!i", $addr, $res) ) {
				return 1;
			}
		}
		else if ( $obj->type == 'REGEX' ) {
			$reg = $obj->string;
			if ( preg_match("!".$reg."!i", $addr, $res) ) {
				return 1;
			}	
		}
	}
	qf($r);
	
	return 0;
}

function send_email($from, $to, $subj, $body, $header='')
{
	if( empty($to) || !count($to) ) return;	
	$bcc='';
	
	if( is_array($to) ) {
		if( ($a = count($to)) > 1 ) {
			$bcc = "Bcc: ";
			for( $i=1; $i<$a; $i++ ) 
				$bcc .= $to[$i].', ';
				
			$bcc = substr($bcc,0,-2);	
		}		

		$to = $to[0];
	}
	
	mail($to, $subj, $body, "From: $from\r\nErrors-To: $from\r\nReturn-Path: $from\r\nX-Mailer: FUDforum v".$GLOBALS['FORUM_VERSION']."\r\n".$header.$bcc);
}

function send_notifications($to, $msg_id, $thr_subject, $poster_login, $id_type, $id, $frm_name='')
{
	$icq = str_replace("http://", "http'+'://'+'", $GLOBALS['WWW_ROOT']);
	$icq = str_replace("www.", "www'+'.", $icq);

	$goto_url['icq'] = "javascript:window.location='".$icq."index.php?t=rview&goto=".$msg_id."';";
	$goto_url['email'] = $GLOBALS['WWW_ROOT'].'index.php?t=rview&goto='.$msg_id;
	
	
	if ( $GLOBALS['NOTIFY_WITH_BODY'] == 'Y' ) {
		$r = q("SELECT 
			fud21_msg.*, 
			fud21_thread.locked,
			fud21_thread.forum_id,
			fud21_avatar.img AS avatar, 
			fud21_users.id AS user_id, 
			fud21_users.alias AS login, 
			fud21_users.display_email, 
			fud21_users.avatar_approved,
			fud21_users.avatar_loc,
			fud21_users.email, 
			fud21_users.posted_msg_count, 
			fud21_users.join_date, 
			fud21_users.location, 
			fud21_users.sig,
			fud21_users.icq,
			fud21_users.jabber,
			fud21_users.aim,
			fud21_users.msnm,
			fud21_users.invisible_mode,
			fud21_users.email_messages,
			fud21_users.last_visit AS time_sec,
			fud21_users.is_mod,
			fud21_users.yahoo,
			fud21_users.custom_status,
			fud21_level.name AS level_name,
			fud21_level.pri AS level_pri,
			fud21_level.img AS level_img
		FROM 
			fud21_msg 
			LEFT JOIN fud21_users 
				ON fud21_msg.poster_id=fud21_users.id 
			LEFT JOIN fud21_avatar 
				ON fud21_users.avatar=fud21_avatar.id 
			INNER JOIN fud21_thread
				ON fud21_msg.thread_id=fud21_thread.id	
			LEFT JOIN fud21_ses
				ON fud21_ses.user_id=fud21_msg.poster_id
			LEFT JOIN fud21_level
				ON fud21_users.level_id=fud21_level.id
		WHERE 
			fud21_msg.id=".$msg_id." AND fud21_msg.approved='Y'");
		
		$obj = db_singleobj($r);
		unset($obj->ip_addr);
		$headers  = "MIME-Version: 1.0\r\n";
		$split = get_random_value(128);
		$headers .= "Content-Type: multipart/alternative; boundary=\"------------$split\"\r\n";
		$boundry = "\r\n--------------$split\r\n";
		
		$plain_text = read_msg_body($obj->foff,$obj->length, $obj->file_id);
		$plain_text = $boundry."Content-Type: text/plain; charset=".$GLOBALS['CHARSET']."; format=flowed\r\nContent-Transfer-Encoding: 7bit\r\n\r\n".strip_tags($plain_text)."\r\n\r\nTo participate in the discussion, go here: ".$GLOBALS['WWW_ROOT'].'index.php?t=rview&th='.$id."&notify=1&opt=off\r\n";
		
		$mod = $GLOBALS['MOD'];
		$GLOBALS['MOD'] = 1;
		$GLOBALS['pl_view'] = $obj->poll_id;
		$body_email = tmpl_drawmsg($obj,NULL,NULL,'');
		$GLOBALS['MOD'] = $mod;
		
		$body_email = $boundry."Content-Type: text/html; charset=".$GLOBALS['CHARSET']."\r\nContent-Transfer-Encoding: 7bit\r\n\r\n".'<html>
<head>
<META HTTP-EQUIV="Content-Type" CONTENT="text/html; charset=ISO-8859-15">
<title>'.$GLOBALS['FORUM_TITLE'].$TITLE_EXTRA.'</title>
<BASE HREF="'.$GLOBALS['WWW_ROOT'].'">
<script language="JavaScript" src="lib.js"></script>
<link rel="StyleSheet" href="http://thelocust.org/bored/theme/default/forum.css" type="text/css">
</head>
<body topmargin="2" leftmargin="2" marginheight="2" marginwidth="2">
<table width="100%" border="0" cellspacing="3" cellpadding="5"><tr><td class="ForumBackground">
<table border="0" cellspacing="1" cellpadding="2" class="ContentTable">
<tr>
	<th width=1>Author</th>
	<th>Thread</th>
</tr>
'.$body_email.'
</table>
</td></tr></table></body></html>'."\r\n";
		$body_email = $plain_text.$body_email.substr($boundry, 0, -2)."--\r\n";
	}
	
	reverse_FMT($thr_subject);
	reverse_FMT($poster_login);
	
	if( $id_type == 'thr' ) {
		$subj = 'New reply to '.$thr_subject.' by '.$poster_login;
		
		if( !$body_email ) {
			$unsub_url['email'] = $GLOBALS['WWW_ROOT'].'index.php?t=rview&th='.$id.'&notify=1&opt=off';
			$body_email = 'To view unread replies goto '.$goto_url['email'].'

If you do not wish to receive further notifications about replies in this thread, please go here: '.$unsub_url['email'];
		}	
		
		$body_icq = 'To view unread replies goto
'.$goto_url['icq'].'

If you do not wish to receive further notifications about replies in this thread, please go here:
'.$unsub_url['icq'];
		$unsub_url['icq'] = "javascript:window.location='".$icq."index.php?t=rview&th=".$id."&notify=1&opt=off';";
	}
	else if ( $id_type == 'frm' ) {
		reverse_FMT($frm_name);
		
		$subj = 'New thread in forum '.$frm_name.' called '.$thr_subject.' by '.$poster_login;
		
		$unsub_url['icq'] = "javascript:window.location='".$icq."index.php?t=thread&unsub=1&frm_id=".$id."';";
		$body_icq = 'To view the thread goto:
'.$goto_url['icq'].'

To stop receiving notifications about new threads in this forum, please go here:
'.$unsub_url['icq'];
		
		if( !$body_email ) {
			$unsub_url['email'] = $GLOBALS['WWW_ROOT'].'index.php?t=thread&unsub=1&frm_id='.$id;
			$body_email = 'To view the thread goto:
'.$goto_url['email'].'

To stop receiving notifications about new threads in this forum, please go here: '.$unsub_url['email'];
		}	
	}	
	
	send_email($GLOBALS["FORUM_TITLE"].' <'.$GLOBALS['NOTIFY_FROM'].'>', $to['EMAIL'], $subj, $body_email, $headers);
	send_email($GLOBALS["FORUM_TITLE"].' <'.$GLOBALS['NOTIFY_FROM'].'>', $to['ICQ'], $subj, $body_icq);
}function fetch_vars($pref, &$obj, $arr)
{
	reset($obj);
	while ( list($k, $v) = each($obj) ) {
		if ( isset($arr[$pref.$k]) ) $obj->{$k} = $arr[$pref.$k];
	}
}
	
function export_vars($pref, &$obj)
{
	reset($obj);
	while ( list($k, $v) = each($obj) ) {
		if ( isset($obj->{$k}) ) $GLOBALS[$pref.$k] = $v;
	}
}

function empty_object(&$obj)
{
	reset($obj);
	while ( list($k, $v) = each($obj) ) $obj->{$k} = NULL;
}function get_mime_by_ext($ext)
{
	return q_singleval("SELECT id FROM fud21_mime WHERE fl_ext='".$ext."'");
}class fud_attach
{
	var $id=NULL;
	var $proto=NULL;
	var $location=NULL;
	var $original_name=NULL;
	var $owner=NULL;
	var $private=NULL;
	var $message_id=NULL;
	var $dlcount=NULL;
	var $mime_type=NULL;
	
	var $a_list;
	
	function add($owner, $message_id, $original_name, $cur_location, $private='')
	{
		$proto = proto($cur_location);
		
		$ext = substr($original_name, strrpos($original_name, '.')+1);
		if( !($mime_id = get_mime_by_ext($ext)) ) $mime_id = 0;
		
		$r=q("INSERT INTO fud21_attach (proto, location, original_name, message_id, owner, private, mime_type) VALUES('".$proto."', 'none://unset', '".$original_name."', ".intzero($message_id).", ".intzero($owner).", '".yn($private)."', ".$mime_id.")");
		$id = db_lastid("fud21_attach", $r);
		$this->message_id=$message_id;
		if ( $proto == 'LOCAL' ) {
			$loc = safe_attachment_copy($cur_location, $id);
		}
		else $loc = $cur_location;
		
		if ( $private == 'Y' ) 
			$tbl = 'fud21_pmsg';
		else
			$tbl = 'fud21_msg';
		
		q("UPDATE fud21_attach SET location='".addslashes($loc)."' WHERE id=".$id);
		if ( $message_id ) {
			qobj("SELECT count(*) AS a_count FROM fud21_attach WHERE message_id=".$message_id, $cObj);
			q("UPDATE ".$tbl." SET attach_cnt=".$cObj->a_count." WHERE id=".$this->message_id);
		}
		
		return $id;
	}
		
	function get($id,$private='')
	{
		$obj = qobj("SELECT * FROM fud21_attach WHERE id=".$id." AND private='".yn($private)."'", $this);
	}
	
	function replace($original_name, $cur_location)
	{
		$proto = proto($cur_location);
		$ext = substr($original_name, strrpos($original_name, '.')+1);
		if( !($mime_id = get_mime_by_ext($ext)) ) $mime_id = 0;
		
		q("UPDATE fud21_attach SET mime_type=".$mime_id.", proto='".$proto."', original_name='".$original_name."', location='".$cur_location."' WHERE id=".$this->id);
		if ( $proto == 'LOCAL' ) {
			$loc = $GLOBALS['FILE_STORE'].$this->id.'.atch';
			if ( file_exists($loc) ) unlink($loc);
			safe_attachment_copy($cur_location, $id);
		}
	}
	
	function delete()
	{
		if( !db_locked() ) {
			$ll = 1;
			db_lock('fud21_attach+');
		}	
		$r = q("SELECT location FROM fud21_attach WHERE id=".$this->id);
		if( db_count($r) ) {
			list($loc) = db_rowarr($r);
			if( file_exists($loc) ) 
				unlink($loc);
		}
		qf($r);
		q("DELETE FROM fud21_attach WHERE id=".$this->id);
		if( $ll ) db_unlock();
	}
	
	function inc_dl_count()
	{
		q("UPDATE fud21_attach SET dlcount=dlcount+1 WHERE id=".$this->id);
	}
	
}

function proto($file)
{
	if ( start_match($file, 'http://') ) 	return "REMOTE";
	if ( start_match($file, 'ftp://') ) 	return "REMOTE";
	
	return "LOCAL";
}

function start_match($haystack, $needle)
{
	if ( strtolower(substr($haystack, 0, strlen($needle))) == strtolower($needle) ) return strlen($needle);
	return 0;
}

function safe_attachment_copy($source, $id)
{
	$loc = $GLOBALS['FILE_STORE'].$id.'.atch';	
	if ( file_exists($loc) ) {
		unlink($loc);
		std_out('"'.$loc.'" already exists, but shouldn\'t (old file unlinked), check security', 'ERR');
	}
	
	if( !@copy($source, $loc) ) {
		std_out('unable to create source file ('.$loc.') check permissions on ('.$GLOBALS['FILE_STORE'].'), we suggest 1777', 'ERR');
	}
	@chmod($loc, 0600);
	
	return $loc;
}function get_host($ip)
{
	if( empty($ip) ) return;

	$name = gethostbyaddr($ip);
	if( $name != $ip ) {
		if ( count(explode('.', $name)) > 2 ) 
			$name = substr($name, strpos($name, '.'));
	}		
	else
		$name = NULL;		

	return $name;
}class fud_pmsg
{
	var $id='';
	var $to_list='';
	var $ouser_id='';
	var $duser_id='';
	var $pdest='';
	var $ip_addr='';
	var $host_name='';
	var $post_stamp='';
	
	var $icon='';
	var $mailed='';

	var $folder_id='';

	var $subject='';
	var $attach_cnt='';
	var $smiley_disabled='';
	var $show_sig='';
	var $track='';
	var $length='';
	var $foff='';
	var $login='';
	var $ref_msg_id='';	
	var $body;
	
	function add($track='')
	{
		if ( !db_locked() ) {
			$ll = 1;
			db_lock("fud21_pmsg+");
		}
	
		$this->post_stamp = __request_timestamp__;
		$this->ip_addr = $GLOBALS['HTTP_SERVER_VARS']['REMOTE_ADDR'];
	
		if ( $GLOBALS['PUBLIC_RESOLVE_HOST'] == 'Y' ) $this->host_name = get_host($this->ip_addr);
		
		if( empty($this->mailed) ) $this->mailed = ( $this->folder_id=='SENT' ) ? 'Y' : 'N';
		
		$r = q("INSERT INTO fud21_pmsg (
			ouser_id,
			duser_id,
			pdest,
			to_list,
			ip_addr,
			host_name,
			post_stamp,
			icon,
			mailed,
			folder_id,
			subject,
			attach_cnt,
			smiley_disabled,
			show_sig,
			track,
			read_stamp,
			ref_msg_id
			)
			VALUES(
				".$this->ouser_id.",
				".$this->ouser_id.",
				".INTZERO($GLOBALS['recv_user_id'][0]).",
				".strnull($this->to_list).",
				".ifnull($this->ip_addr, "'0.0.0.0'").",
				".strnull($this->host_name).",
				".$this->post_stamp.",
				".strnull($this->icon).",
				'".yn($this->mailed)."',
				'DRAFT',
				'".$this->subject."',
				".intzero($this->attach_cnt).",
				'".yn($this->smiley_disabled)."',
				'".yn($this->show_sig)."',
				'".yn($this->track)."',
				".$this->post_stamp.",
				".strnull($this->ref_msg_id)."
			)");
			
		$this->id = db_lastid("fud21_pmsg", $r);
			
		list($this->foff, $this->length) = write_pmsg_body($this->body);
		
		q("UPDATE fud21_pmsg SET foff=".$this->foff.", length=".$this->length.", folder_id='".$this->folder_id."' WHERE id=".$this->id);
		
		if( $this->folder_id == 'SENT' && empty($track) ) $this->send_pmsg();
		if ( $ll ) db_unlock();
	}
	
	function send_pmsg()
	{
		while( list(, $v) = each($GLOBALS['recv_user_id']) ) {
			$r = q("INSERT INTO 
			fud21_pmsg 
			(
				to_list,
				ouser_id,
				ip_addr,
				host_name,
				post_stamp,
				icon,
				mailed,
				folder_id,
				subject,
				attach_cnt,
				show_sig,
				smiley_disabled,
				track,
				foff,
				length,
				duser_id,
				ref_msg_id
			)
			VALUES
			(
				".strnull($this->to_list).",
				".$this->ouser_id.",
				".ifnull($this->ip_addr, "'0.0.0.0'").",
				".strnull($this->host_name).",
				".$this->post_stamp.",
				".strnull($this->icon).",
				'Y',
				'INBOX',
				'".$this->subject."',
				".intzero($this->attach_cnt).",
				'".yn($this->show_sig)."',
				'".yn($this->smiley_disabled)."',
				'".yn($this->track)."',
				".$this->foff.",
				".$this->length.",
				".$v.",
				".strnull($this->ref_msg_id)."
			)
			");
			$GLOBALS["send_to_array"][] = array($v, db_lastid("fud21_pmsg", $r));
		}	
	}
	
	function move_folder($folder_id)
	{
		if( empty($folder_id) ) return;
		q("UPDATE fud21_pmsg SET folder_id='".$folder_id."' WHERE duser_id="._uid." AND id=".$this->id);
		$this->mark_read();
	}
	
	function sync()
	{
		list($this->foff, $this->length) = write_pmsg_body($this->body);
		
		$this->post_stamp = __request_timestamp__;
		$this->ip_addr = $GLOBALS['HTTP_SERVER_VARS']['REMOTE_ADDR'];
		
		if ( $GLOBALS['PUBLIC_RESOLVE_HOST'] == 'Y' ) $this->host_name = get_host($this->ip_addr);
		
		$this->mailed = ( $this->folder_id=='SENT' ) ? 'Y' : 'N';
		
		q("UPDATE fud21_pmsg 
			SET
				to_list=".strnull($this->to_list).",
				icon=".strnull($this->icon).",
				ouser_id=".$this->ouser_id.",
				duser_id=".$this->ouser_id.",
				post_stamp=".$this->post_stamp.",
				subject='".$this->subject."',
				ip_addr='".$this->ip_addr."',
				host_name='".$this->host_name."',
				mailed='".yn($this->mailed)."',
				attach_cnt=".intzero($this->attach_cnt).",
				show_sig='".yn($this->show_sig)."',
				smiley_disabled='".yn($this->smiley_disabled)."',
				track='".yn($this->track)."',
				folder_id='".$this->folder_id."',
				foff=".$this->foff.",
				length=".$this->length."
			WHERE
				id=".$this->id);
				
		if( $this->folder_id == 'SENT' ) $this->send_pmsg();		
	}
	
	function del_pmsg($fldr_id='')
	{
		if( empty($fldr_id) ) {
			$fldr_id = q_singleval("SELECT folder_id FROM fud21_pmsg WHERE duser_id="._uid." AND id=".$this->id);
			$this->mark_read();
		}	
		if( empty($fldr_id) ) return;
			
		if( $fldr_id != 'TRASH' ) 
			$this->move_folder('TRASH');				
		else {
			$this->get($this->id, 1);
			
			q("DELETE FROM fud21_pmsg WHERE duser_id="._uid." AND id=".$this->id);
			if ( $this->attach_cnt ) {
				$res = q("SELECT location FROM fud21_attach WHERE message_id=".$this->id." AND private='Y'");
				if( db_count($res) ) {
					while ( list($loc) = db_rowarr($res) ) {
						if( file_exists($loc) ) unlink($loc);				
					}
				}
				qf($res);
				q("DELETE FROM fud21_attach WHERE message_id=".$this->id." AND private='Y'");
			}
		}	
	}
	
	function get($id, $re='')
	{
		qobj("SELECT fud21_pmsg.*,fud21_users.alias AS login FROM fud21_pmsg LEFT JOIN fud21_users ON fud21_pmsg.ouser_id=fud21_users.id WHERE fud21_pmsg.duser_id="._uid." AND fud21_pmsg.id=".$id, $this);
		if( !empty($this->id) && empty($re) ) 
			$this->body = read_pmsg_body($this->foff, $this->length);
	}
	
	function send_notify_msg()
	{
		$track_msg = new fud_pmsg;
		$track_msg->ouser_id = $track_msg->duser_id = $this->ouser_id;
		$track_msg->ip_addr = $track_msg->host_name = NULL;
		$track_msg->post_stamp = __request_timestamp__;
		$track_msg->mailed='Y';
		$track_msg->folder_id='INBOX';
		$track_msg->track='N';
		$this->subject = addslashes($this->subject);
		$track_msg->subject = 'Read Notification For: '.$this->subject;
		$track_msg->body = 'Hello,<br>'.$GLOBALS["usr"]->login.' has read your private message, "'.$this->subject.'", on '.strftime("%a, %d %B %Y %H:%M", $track_msg->post_stamp).'<br>';
		$track_msg->add(1);
		$this->mark_notify();	
	}

	function mark_read()
	{
		q("UPDATE fud21_pmsg SET read_stamp=".__request_timestamp__." WHERE id=".$this->id);
	}
	
	function mark_notify()
	{
		q("UPDATE fud21_pmsg SET track='SENT' WHERE id=".$this->id);
	}
}

function set_nrf($nrf, $id)
{
	q("UPDATE fud21_pmsg SET nrf_status='".$nrf."' WHERE id=".$id);		
}	

function write_pmsg_body($text)
{
	$fp = fopen($GLOBALS['MSG_STORE_DIR'].'private', 'ab');
	
	if( !($s = ftell($fp)) ) $s = __ffilesize($fp);

	fwrite($fp, $text);
	fflush($fp);
	$len = (ftell($fp)-$s);
	fclose($fp);
	
	if( !$s ) chmod($GLOBALS['MSG_STORE_DIR'].'private', 0600);
	
	return array($s,$len);
}

function read_pmsg_body($offset, $length)
{
	if( empty($length) ) return;
	
	$fp = fopen($GLOBALS['MSG_STORE_DIR'].'private', 'rb');
	
	fseek($fp, $offset, SEEK_SET);
	$str = fread($fp, $length);
	
	fclose($fp);
	
	return $str;
}function send_status_update($dusr, $title, $msg)
{
	if( $GLOBALS['PM_ENABLED']=='Y' ) {
		if( defined('no_inline') ) fud_use('private.inc');
		$GLOBALS['recv_user_id'][] = $dusr->id;
		$pmsg = new fud_pmsg;
		$pmsg->to_list = addslashes($dusr->login);
		$pmsg->ouser_id = $GLOBALS['usr']->id;
		$pmsg->post_stamp = __request_timestamp__;
		$pmsg->subject = addslashes($title);
		list($pmsg->foff, $pmsg->length) = write_pmsg_body(nl2br($msg));
		$pmsg->send_pmsg();	
	}
	else {
		if( defined('no_inline') ) fud_use('iemail.inc');
		send_email($GLOBALS['NOTIFY_FROM'], $dusr->email, $title, $msg);
	}
}class fud_forum
{
	var $id=NULL;
	var $cat_id=NULL;
	var $name=NULL;
	var $descr=NULL;
	var $passwd_posting=NULL;
	var $post_passwd=NULL;
	var $anon_forum=NULL;
	var $forum_icon=NULL;
	var $tag_style=NULL;
	var $last_post_id=NULL;
	
	var $allow_polls=NULL;
	var $date_created=NULL;
	var $thread_count=NULL;
	var $view_order=NULL;
	var $message_threshold=NULL;
	
	var $moderated=NULL;
	var $max_attach_size=NULL;
	var $max_file_attachments=NULL;
	
	var $forums=NULL;
	var $cur_frm=NULL;
	
	var $locked=NULL;
	
	
	function get($id)
	{
		qobj("SELECT * FROM fud21_forum WHERE fud21_forum.id=".$id, $this);
		if( empty($this->id) ) invl_inp_err();
			
		return $id;		
	}
	
	function is_moderator($user_id)
	{
		return q_singleval("SELECT id FROM fud21_mod WHERE user_id=".$user_id." AND forum_id=".$this->id);
	}
	
	function inc_reply_count($val)
	{
		q("UPDATE fud21_forum SET post_count=post_count+".$val." WHERE id=".$this->id);
	}
	
	function dec_reply_count($val)
	{
		q("UPDATE fud21_forum SET post_count=post_count-".$val." WHERE id=".$this->id);
	}
	
	function inc_thread_count($val)
	{
		q("UPDATE fud21_forum SET thread_count=thread_count+".$val." WHERE id=".$this->id);
	}
	
	function dec_thread_count($val)
	{
		q("UPDATE fud21_forum SET thread_count=thread_count-".$val." WHERE id=".$this->id);
	}
	
	function get_notify_list($user_id)
	{
		$r = q("SELECT 
				fud21_users.email, 
				fud21_users.icq, 
				fud21_users.notify_method 
			FROM 
				fud21_forum_notify 
				INNER JOIN fud21_users 
					ON fud21_forum_notify.user_id=fud21_users.id 
			WHERE 
				fud21_forum_notify.forum_id=".$this->id." 
				AND fud21_forum_notify.user_id!=".$user_id);
		
		$p = forum_perm_array($this->id);
		$to=NULL;
		while ( $obj = db_rowobj($r) ) {
			if ( !is_allowed($obj->user_id, $p) ) continue;
			
			$to[$obj->notify_method][] = ( $obj->notify_method == 'EMAIL' ) ? $obj->email : $obj->icq.'@pager.icq.com';
		}

		qf($r);
				
		return $to;
	}
	
}

if ( defined('admin_form') && !defined("_forum_adm_inc_") ) fud_use('forum_adm.inc');class fud_thread
{
	var $id=NULL;
	var $forum_id=NULL;
	var $root_msg_id=NULL;
	var $last_post_date=NULL;
	var $replies=NULL;
	var $views=NULL;
	var $rating=NULL;
	var $last_post_id=NULL;
	var $locked=NULL;
	var $is_sticky=NULL;
	var $ordertype=NULL;
	var $orderexpiry=NULL;
	
	var $subject=NULL;
	var $db_thread=NULL;
	
	function add($root, $forum_id, $locked=NULL, $is_sticky=NULL, $ordertype=NULL, $orderexpiry=NULL) 
	{
		$r = q("INSERT INTO 
			fud21_thread(
				forum_id, 
				root_msg_id, 
				last_post_date, 
				replies, 
				views, 
				rating, 
				last_post_id,
				locked, 
				is_sticky,
				ordertype,
				orderexpiry
			)
			VALUES
			(
				".$forum_id.",
				".$root.",
				".__request_timestamp__.",
				0,
				0,
				0,
				".$root.",
				'".yn($locked)."',
				'".yn($is_sticky)."',
				".ifnull($ordertype, "'NONE'").",
				".intzero($orderexpiry)."
			)");
		
		$this->id = db_lastid("fud21_thread", $r);
		
		return $this->id;
	}
	
	function sync()
	{
		list($old_sticky,$forum_id) = db_singlearr(q("SELECT is_sticky,forum_id FROM fud21_thread WHERE id=".$this->id));
	
		q("UPDATE fud21_thread SET 
			is_sticky='".yn($this->is_sticky)."',
			ordertype=".ifnull($this->ordertype, "'NONE'").",
			orderexpiry=".intnull($this->orderexpiry).",
			locked='".yn($this->locked)."'
		WHERE id=".$this->id);
		
		if( $old_sticky != yn($this->is_sticky) ) rebuild_forum_view($forum_id);
	}
	
	function get_by_id($id)
	{
		$result = qobj("SELECT 
				fud21_thread.*,
				fud21_msg.subject
			FROM 
				fud21_thread 
				LEFT JOIN fud21_msg 
					ON fud21_thread.root_msg_id=fud21_msg.id 
				LEFT JOIN fud21_forum 
					ON fud21_thread.forum_id=fud21_forum.id 
				LEFT JOIN fud21_cat 
					ON fud21_forum.cat_id=fud21_cat.id 
			WHERE 
				fud21_thread.id=".$id, $this);
		if ( empty($this->id) ) error_dialog('Invalid thread ID','You\'ve followed an invalid link, the thread you are trying to view does not exist.','', 'FATAL');
	}

	function delete($rebuild_view=TRUE)
	{
		$msg = new fud_msg_edit;
		qobj("SELECT * FROM fud21_msg WHERE id=".$this->root_msg_id, $msg);
		if( !empty($msg->id) )
			$msg->delete(FALSE);
		else {
			q("DELETE FROM fud21_thread WHERE id=".$this->id);
			$tc = q_singleval("SELECT count(*) FROM fud21_thread INNER JOIN fud21_msg ON fud21_thread.root_msg_id=fud21_msg.id WHERE forum_id=".$this->forum_id." AND fud21_msg.approved='Y'");
			$mc = q_singleval("SELECT SUM(replies) FROM fud21_thread INNER JOIN fud21_msg ON fud21_thread.root_msg_id=fud21_msg.id WHERE forum_id=".$this->forum_id." AND fud21_msg.approved='Y'");
			$mc += $tc;
			$lpi = q_singleval("SELECT MAX(last_post_id) FROM fud21_thread INNER JOIN fud21_msg ON fud21_thread.root_msg_id=fud21_msg.id WHERE forum_id=".$this->forum_id." AND fud21_msg.approved='Y'");
			q("UPDATE fud21_forum SET post_count=".intzero($mc).", last_post_id=".intzero($lpi).", thread_count=".intzero($tc)." WHERE id=".$this->forum_id);
		}	
		
		if( $rebuild_view ) rebuild_forum_view($this->forum_id);
	}
	
	function lock()
	{
		q("UPDATE fud21_thread SET locked='Y' WHERE id=".$this->id);
	}
	
	function unlock()
	{
		q("UPDATE fud21_thread SET locked='N' WHERE id=".$this->id);
	}
	
	function move($to_forum)
	{
		if ( !db_locked() ) {
			db_lock('fud21_thread_view+, fud21_thread+, fud21_forum+, fud21_msg+');
			$local_lock = 1;
		}
		$msg_count = q_singleval("SELECT count(*) FROM fud21_thread LEFT JOIN fud21_msg ON fud21_msg.thread_id=fud21_thread.id WHERE fud21_msg.approved='Y' AND fud21_thread.id=".$this->id);
		
		q("UPDATE fud21_thread SET forum_id=".$to_forum." WHERE id=".$this->id);
		q("UPDATE fud21_forum SET post_count=post_count-".$msg_count." WHERE id=".$this->forum_id);
		q("UPDATE fud21_forum SET thread_count=thread_count+1,post_count=post_count+".$msg_count." WHERE id=".$to_forum);
		$r=q("DELETE FROM fud21_thread WHERE forum_id=".$to_forum." AND root_msg_id=".$this->root_msg_id." AND moved_to=".$this->forum_id);
		if( $aff_rows=db_affected($r) ) q("UPDATE fud21_forum SET thread_count=thread_count-".$aff_rows." WHERE id=".$to_forum);
		q("UPDATE fud21_thread SET moved_to=".$to_forum." WHERE id!=".$this->id." AND root_msg_id=".$this->root_msg_id);
		
		q("INSERT INTO fud21_thread(
			forum_id,
			root_msg_id,
			last_post_date,
			last_post_id,
			moved_to
		)
		VALUES(
			".$this->forum_id.",
			".$this->root_msg_id.",
			".$this->last_post_date.",
			".$this->last_post_id.",
			".$to_forum."
		)");
		
		rebuild_forum_view($this->forum_id);
		rebuild_forum_view($to_forum);
		
		if ( !empty($local_lock) ) db_unlock();
	}
	
	function inc_post_count($val)
	{
		q("UPDATE fud21_thread SET replies=replies+".$val." WHERE id=".$this->id);
	}
	
	function inc_view_count()
	{
		q("UPDATE fud21_thread SET views=views+1 WHERE id=".$this->id);
	}
	
	function dec_view_count($val)
	{
		q("UPDATE fud21_thread SET views=views-1 WHERE id=".$this->id);
	}
	
	function get_notify_list($user_id)
	{
		$ctm = __request_timestamp__;
		$tm = $ctm-604800;
	
		$r = q("SELECT 
				fud21_users.id AS user_id,
				fud21_users.email,
				fud21_users.icq,
				fud21_read.last_view,
				fud21_read.id,
				fud21_users.notify_method 
			FROM 
				fud21_thread_notify
				INNER JOIN fud21_users 
					ON fud21_thread_notify.user_id=fud21_users.id 
				LEFT JOIN fud21_read 
					ON fud21_read.user_id=fud21_thread_notify.user_id 
					AND fud21_read.thread_id=fud21_thread_notify.thread_id 
			WHERE 
				( fud21_read.msg_id=".$this->last_post_id." OR fud21_read.last_view < ".$tm." )
				AND fud21_thread_notify.thread_id=".$this->id." 
				AND fud21_thread_notify.user_id!=".intzero($user_id));
		
		$p = forum_perm_array($this->forum_id);
		$to=NULL;
		while ( $obj = db_rowobj($r) ) {
			if ( !is_allowed($obj->user_id, $p) ) continue;
			
			$to[$obj->notify_method][] = ( $obj->notify_method == 'EMAIL' ) ? $obj->email : $obj->icq.'@pager.icq.com';
			if( $obj->last_view < $tm ) q("UPDATE fud21_read SET last_view=".$ctm." WHERE id=".$obj->id);
		}
		qf($r);
		
		return $to;
	}
	
	function adm_set_rating($value)
	{
		q("UPDATE fud21_thread SET rating=".intnull($value)." WHERE id=".$this->id);
	}

	function has_thread_vote($user_id, $thread_id='')
	{
		if ( !$thread_id ) $thread_id = $this->id;
		
		if( ($rating=q_singleval("SELECT rating FROM fud21_thread_rate_track WHERE thread_id=".$thread_id." AND user_id=".$user_id)) ) {
			return $rating;	
		}
		return -1;
	}
	
	function update_vote_count()
	{
		$rating = q_singleval("SELECT ROUND(AVG(rating)) FROM fud21_thread_rate_track WHERE thread_id=".$this->id);
		q("UPDATE fud21_thread SET rating=".$rating." WHERE id=".$this->id);
	}
	
	function vote_count($thread_id='')
	{
		if ( !$thread_id ) $thread_id = $this->id;
		
		return q_singleval("SELECT COUNT(*) FROM fud21_thread_rate_track WHERE thread_id=".$thread_id);
	}
	
	function register_thread_vote($user_id, $rating, $thread_id='')
	{
		if ( !$thread_id ) $thread_id = $this->id;
		
		if( !db_locked() ) {
			db_lock('fud21_thread_rate_track+, fud21_thread+');
			$local_lock = 1;
		}
		
		if( $this->has_thread_vote($user_id, $thread_id) != -1 ) {
			if ( $local_lock ) db_unlock();
			return;
		}	
		
		q("INSERT INTO fud21_thread_rate_track (
			thread_id,
			user_id,
			stamp,
			rating
			)
		VALUES(
			".$thread_id.",
			".$user_id.",
			".__request_timestamp__.",
			".$rating."
		)");
		
		$rating = q_singleval("SELECT ROUND(AVG(rating)) FROM fud21_thread_rate_track WHERE thread_id=".$thread_id);
		
		q("UPDATE fud21_thread SET rating=".$rating." WHERE id=".$thread_id);
		
		if ( $local_lock ) db_unlock();
	}
}

function rebuild_forum_view($forum_id, $page=0)
{
	if( !db_locked() ) {
	        db_lock('fud21_thread_view+, fud21_thread+, fud21_msg+, fud21_forum+');
		$local_lock=1;
	}
	
	$tm = __request_timestamp__;
	
	/* Remove expired moved thread pointers */
	$r=q("DELETE FROM fud21_thread WHERE forum_id=".$forum_id." AND last_post_date<".($tm-86400*$GLOBALS['MOVED_THR_PTR_EXPIRY'])." AND moved_to!=0");
	if( $aff_rows = db_affected($r) ) {
		q("UPDATE fud21_forum SET thread_count=thread_count-".$aff_rows." WHERE id=".$forum_id);
		$page = 0;
	}
	
	/* De-announce expired announcments and sticky messages */
	$r = q("SELECT fud21_thread.id FROM fud21_thread INNER JOIN fud21_msg ON fud21_thread.root_msg_id=fud21_msg.thread_id WHERE fud21_thread.forum_id=".$forum_id." AND is_sticky='Y' AND (fud21_msg.post_stamp+fud21_thread.orderexpiry)<".$tm);
	while( list($tid) = db_rowarr($r) ) 
		q("UPDATE fud21_thread SET ordertype='NONE', is_sticky='N' WHERE id=".$tid);
	qf($r);

	if ( __dbtype__ == 'pgsql' ) {
		$tmp_tbl_name = "fud21_ftvt_".get_random_value();
		q("CREATE TEMP TABLE ".$tmp_tbl_name." ( forum_id INT NOT NULL, page INT8 NOT NULL, thread_id INT NOT NULL, pos SERIAL, tmp INT )");
		
		if( $page ) {
			q("DELETE FROM fud21_thread_view WHERE forum_id=".$forum_id." AND page<".($page+1));
			q("INSERT INTO ".$tmp_tbl_name." (thread_id,forum_id,page,tmp) SELECT fud21_thread.id, fud21_thread.forum_id, 4294967294, CASE WHEN is_sticky='Y' AND (fud21_msg.post_stamp+fud21_thread.orderexpiry>".$tm." OR fud21_thread.orderexpiry=0) THEN 4294967294 ELSE fud21_thread.last_post_date END AS sort_order_fld  FROM fud21_thread INNER JOIN fud21_msg ON fud21_thread.root_msg_id=fud21_msg.id WHERE forum_id=".$forum_id." AND fud21_msg.approved='Y' ORDER BY sort_order_fld DESC, fud21_thread.last_post_id DESC LIMIT ".($GLOBALS['THREADS_PER_PAGE']*$page).", 0");
		}
		else {
			q("DELETE FROM fud21_thread_view WHERE forum_id=".$forum_id);
			q("INSERT INTO ".$tmp_tbl_name." (thread_id,forum_id,page,tmp) SELECT fud21_thread.id, fud21_thread.forum_id, 2147483647, CASE WHEN is_sticky='Y' AND (fud21_msg.post_stamp+fud21_thread.orderexpiry>".$tm." OR fud21_thread.orderexpiry=0) THEN 2147483647 ELSE fud21_thread.last_post_date END AS sort_order_fld  FROM fud21_thread INNER JOIN fud21_msg ON fud21_thread.root_msg_id=fud21_msg.id WHERE forum_id=".$forum_id." AND fud21_msg.approved='Y' ORDER BY sort_order_fld DESC, fud21_thread.last_post_id DESC");
		}
		
		q("INSERT INTO fud21_thread_view (thread_id,forum_id,page,pos) SELECT thread_id,forum_id,CEIL(pos/40.0),(pos-(CEIL(pos/40)-1)*40) FROM ".$tmp_tbl_name);
		q("DROP SEQUENCE ".$tmp_tbl_name."_pos_seq");
		q("DROP TABLE ".$tmp_tbl_name);
		return;
	}
	else if ( __dbtype__ == 'mysql' ) {
		if( $page ) {
			q("DELETE FROM fud21_thread_view WHERE forum_id=".$forum_id." AND page<".($page+1));
			q("INSERT INTO fud21_thread_view (thread_id,forum_id,page,tmp) SELECT fud21_thread.id, fud21_thread.forum_id, 4294967294, CASE WHEN is_sticky='Y' AND (fud21_msg.post_stamp+fud21_thread.orderexpiry>".$tm." OR fud21_thread.orderexpiry=0) THEN 4294967294 ELSE fud21_thread.last_post_date END AS sort_order_fld  FROM fud21_thread INNER JOIN fud21_msg ON fud21_thread.root_msg_id=fud21_msg.id WHERE forum_id=".$forum_id." AND fud21_msg.approved='Y' ORDER BY sort_order_fld DESC, fud21_thread.last_post_id DESC LIMIT 0, ".($GLOBALS['THREADS_PER_PAGE']*$page));
			q("UPDATE fud21_thread_view SET page=CEILING(pos/".$GLOBALS['THREADS_PER_PAGE']."), pos=pos-(CEILING(pos/".$GLOBALS['THREADS_PER_PAGE'].")-1)*".$GLOBALS['THREADS_PER_PAGE']." WHERE forum_id=".$forum_id." AND page=4294967294");			
		}
		else {
			q("DELETE FROM fud21_thread_view WHERE forum_id=".$forum_id);
			q("INSERT INTO fud21_thread_view (thread_id,forum_id,page,tmp) SELECT fud21_thread.id, fud21_thread.forum_id, 4294967294, CASE WHEN is_sticky='Y' AND (fud21_msg.post_stamp+fud21_thread.orderexpiry>".$tm." OR fud21_thread.orderexpiry=0) THEN 4294967294 ELSE fud21_thread.last_post_date END AS sort_order_fld  FROM fud21_thread INNER JOIN fud21_msg ON fud21_thread.root_msg_id=fud21_msg.id WHERE forum_id=".$forum_id." AND fud21_msg.approved='Y' ORDER BY sort_order_fld DESC, fud21_thread.last_post_id DESC");
			q("UPDATE fud21_thread_view SET page=CEILING(pos/".$GLOBALS['THREADS_PER_PAGE']."), pos=pos-(CEILING(pos/".$GLOBALS['THREADS_PER_PAGE'].")-1)*".$GLOBALS['THREADS_PER_PAGE']." WHERE forum_id=".$forum_id);			
		}
	}
	if( $local_lock ) db_unlock();
}function logaction($user_id, $res, $res_id=0, $action=NULL)
{
	q("INSERT INTO fud21_action_log(logtime, logaction, user_id, a_res, a_res_id)
		VALUES(".__request_timestamp__.", '$action', $user_id, '$res', $res_id)");
}

function clear_action_log()
{
	q("DELETE FROM fud21_action_log");
}function is_perms($user_id, $r_id, $perm, $r_type='forum')
{
	if( $GLOBALS['usr']->is_mod == 'A' ) return TRUE;
	if( __dbtype__ == 'pgsql' ) $perm = strtolower($perm);
	if( empty($user_id) ) $user_id = 0;

	if( @is_object($GLOBALS['__MEMPERM_CACHE'][$user_id][$r_id][$r_type]) ) 
		return ($GLOBALS['__MEMPERM_CACHE'][$user_id][$r_id][$r_type]->{'p_'.$perm}=='Y'?TRUE:FALSE);
	
	if ( empty($user_id) ) {
		$r = q("SELECT * FROM fud21_group_cache WHERE user_id=".$user_id." AND resource_type='".$r_type."' AND resource_id=".$r_id);
		if( !is_result($r) ) $r = q("SELECT * FROM fud21_groups WHERE id=1");
	}
	else {
		$r=q("SELECT * FROM fud21_group_cache WHERE user_id IN(".$user_id.",2147483647) AND resource_type='".$r_type."' AND resource_id=".$r_id." ORDER BY user_id LIMIT 1");
		if( !is_result($r) ) $r = q("SELECT * FROM fud21_groups WHERE id=2");
	}
	
	$GLOBALS['__MEMPERM_CACHE'][$user_id][$r_id][$r_type] = db_singleobj($r);
	return ($GLOBALS['__MEMPERM_CACHE'][$user_id][$r_id][$r_type]->{'p_'.$perm}=='Y'?TRUE:FALSE);
}
	
	/* Verify that the user has the right to approve the thread */
	if( !empty($appr) || !empty($decl) ) {
		$thrx = new fud_thr_exchange;
		$thrx->get(($appr?$appr:$decl));
	
		if( !bq("SELECT id FROM fud21_mod WHERE user_id=".$usr->id." AND forum_id=".$thrx->frm) && !is_perms(_uid, $thrx->frm, 'MOVE') && $usr->is_mod!='A' ) $appr = $decl = NULL;
	}

	if( !empty($appr) ) {
		$thr = new fud_thread;
		$frm_src = new fud_forum;
		$frm_dst = new fud_forum;
		
		db_lock('fud21_mod+, fud21_cat+, fud21_thread_view+, fud21_thread+, fud21_forum+, fud21_msg+');
		
		$thr->get_by_id($thrx->th);
		
		
		$frm_src->get(q_singleval("SELECT forum_id FROM fud21_thread WHERE id=".$thrx->th));
		$frm_dst->get($thrx->frm);
		
		$thr->move($thrx->frm);
		
		if ( $frm_src->last_post_id == $thr->last_post_id ) {
			$mid = intzero(q_singleval("SELECT MAX(fud21_msg.id) FROM fud21_thread INNER JOIN fud21_msg ON fud21_thread.last_post_id=fud21_msg.id WHERE forum_id=".$frm_src->id." AND moved_to=0 AND approved='Y'"));
			q("UPDATE fud21_forum SET last_post_id=".$mid." WHERE id=".$frm_src->id);
		}
		
		if( $frm_dst->last_post_id < $thr->last_post_id ) q("UPDATE fud21_forum SET last_post_id=".$thr->last_post_id." WHERE id=".$frm_dst->id);
		
		db_unlock();
		
		$thrx->delete();
		logaction($usr->id, 'THRXAPPROVE', $thr->id);
		
		header("Location: http://thelocust.org/bored/index.php?t=thr_exch&"._rsid);
		exit;
	}
	else if( !empty($decl) ) {
		$thr_name = q_singleval("SELECT subject FROM fud21_thread INNER JOIN fud21_msg ON fud21_thread.root_msg_id=fud21_msg.id WHERE fud21_thread.id=".$thrx->th);
			
		$frm = new fud_forum;
		$frm->get($thrx->frm);
	
		if( isset($reason) ) {
			$dusr = new fud_user;
			$dusr->get_user_by_id($thrx->req_by);
			
			send_status_update($dusr, 'Moving of thread '.$thr_name.' into forum '.$frm->name.' was declined.', stripslashes($reason));
			$thrx->delete();
			
			header("Location: http://thelocust.org/bored/index.php?t=thr_exch&"._rsid);
			exit;
		}
		else {
			$thr_exch_data = '<form method="post" action="http://thelocust.org/bored/index.php?t=thr_exch" name="thr_exch">
'._hs.'<input type="hidden" name="decl" value="'.$decl.'">
<tr><td class="RowStyleC">Reason for declining thread <b>'.$thr_name.'</b> into forum <b>'.$frm->name.'</b><br><textarea name="reason" cols=60 rows=10></textarea><br><input type="submit" class="button" name="btn_submit" value="Submit"></td><tr>
</form>';
		}
		
		logaction($usr->id, 'THRXDECLINE', $thrx->th);
	}
	
	if( _uid ) {
	if( $usr->is_mod != 'N' && $usr->is_mod ) {
		if( $approve_count = q_singleval("SELECT count(*) FROM 
					fud21_msg 
					INNER JOIN fud21_thread 
						ON fud21_msg.thread_id=fud21_thread.id 
					INNER JOIN fud21_forum 
						ON fud21_thread.forum_id=fud21_forum.id 
					INNER JOIN fud21_mod 
						ON fud21_forum.id=fud21_mod.forum_id 
						".($GLOBALS["usr"]->is_mod != 'A' ? "AND fud21_mod.user_id="._uid : '')."  
					WHERE 
						fud21_msg.approved='N' 
						AND fud21_forum.moderated='Y'") ) 
			$mod_que = '<a class="GenLink" href="http://thelocust.org/bored/index.php?t=modque&'._rsid.'">Moderation Queue</a> <span class="GenText" style="color: #ff0000">('.$approve_count.')</span>';
		
		if( $GLOBALS["usr"]->is_mod == 'A' ) {
			if( $avatar_count = q_singleval("SELECT count(*) FROM fud21_users WHERE avatar_approved='N'") ) 
				$custom_avatar_queue = '| <a class="GenLink" href="adm/admapprove_avatar.php?'._rsid.'">Custom Avatar Queue</a> <span class="GenText" style="color: #ff0000">('.$avatar_count.')</span>';
	
			if( $report_count = q_singleval("SELECT count(*) FROM fud21_msg_report") ) 
				$reported_msgs = '| <a class="GenLink" href="http://thelocust.org/bored/index.php?t=reported&'._rsid.'">Reported Messages</a> <span class="GenText" style="color: #ff0000">('.$report_count.')</span>';
				
			if( $thr_exchc = q_singleval("SELECT count(*) FROM fud21_thr_exchange") )
				$thr_exch = '| <a class="GenLink" href="http://thelocust.org/bored/index.php?t=thr_exch&'._rsid.'">Thread Exchange </a> <span class="GenText" style="color: #ff0000">('.$thr_exchc.')</span>';
		}	
		else {
			if( $report_count = q_singleval("SELECT count(*) FROM fud21_msg_report INNER JOIN fud21_msg ON fud21_msg_report.msg_id=fud21_msg.id INNER JOIN fud21_thread ON fud21_msg.thread_id=fud21_thread.id INNER JOIN fud21_mod ON fud21_thread.forum_id=fud21_mod.forum_id AND fud21_mod.user_id=".$GLOBALS["usr"]->id) )
				$reported_msgs = '| <a class="GenLink" href="http://thelocust.org/bored/index.php?t=reported&'._rsid.'">Reported Messages</a> <span class="GenText" style="color: #ff0000">('.$report_count.')</span>';
			
			if( $thr_exchc = q_singleval("SELECT count(*) FROM fud21_thr_exchange INNER JOIN fud21_mod ON fud21_mod.user_id=".$usr->id." AND fud21_thr_exchange.frm=fud21_mod.forum_id") ) 
				$thr_exch = '| <a class="GenLink" href="http://thelocust.org/bored/index.php?t=thr_exch&'._rsid.'">Thread Exchange </a> <span class="GenText" style="color: #ff0000">('.$thr_exchc.')</span>';
		}
	}
	if( $usr->is_mod=='A' || bq("SELECT id FROM fud21_group_members WHERE user_id="._uid." AND group_leader='Y' LIMIT 1") )
		$group_mgr = '| <a class="GenLink" href="http://thelocust.org/bored/index.php?t=groupmgr&'._rsid.'">Group(s) Manager</a>';
	
	if( $thr_exch || $group_mgr || $reported_msgs || $custom_avatar_queue || $mod_que ) $admin_cp = '<br><font class="GenText"><b>Admin :</b></font> '.$mod_que.' '.$reported_msgs.' '.$thr_exch.' '.$custom_avatar_queue.' '.$group_mgr;
}$adm_str = $rid = $pm = '';
	$ret_to = '&returnto='.urlencode(!empty($GLOBALS['returnto'])?urldecode($GLOBALS['returnto']):$GLOBALS['HTTP_SERVER_VARS']['REQUEST_URI']);

	if ( empty($GLOBALS['usr']) ) {
		$login_n_logout = '<td valign="middle"><a class="UserControlPanel" href="http://thelocust.org/bored/index.php?t=login&'._rsid.$ret_to.'"><img src="http://thelocust.org/bored/theme/default/images/top_login.gif" border=0 alt="Login"></a></td>
<td valign="middle"><a class="UserControlPanel" href="http://thelocust.org/bored/index.php?t=login&'._rsid.$ret_to.'">Login</a></td>';
		$register_n_profile = '<td valign="middle"><a class="UserControlPanel" href="http://thelocust.org/bored/index.php?t=register&'._rsid.'"><img src="http://thelocust.org/bored/theme/default/images/top_register.gif" border=0 alt="Register"></a></td>
<td valign="middle"><a class="UserControlPanel" href="http://thelocust.org/bored/index.php?t=register&'._rsid.'">Register</a></td>';
	}
	else {
		if( $GLOBALS['usr']->is_mod == 'A' ) $admin_control_panel = '<td>&nbsp;&nbsp;</td><td valign="middle"><a class="UserControlPanel" href="adm/admglobal.php?'._rsid.'"><img src="http://thelocust.org/bored/theme/default/images/top_admin.gif" border=0 alt="Admin Control Panel"></a></td>
<td valign="middle"><a class="UserControlPanel" href="adm/admglobal.php?'._rsid.'">Admin Control Panel</a></td>';
		$user_login = htmlspecialchars($usr->alias);
		$login_n_logout = '<td valign="middle"><a class="UserControlPanel" href="http://thelocust.org/bored/index.php?t=login&'._rsid.$ret_to.'&logout=1"><img src="http://thelocust.org/bored/theme/default/images/top_logout.gif" border=0 alt="Logout"></a></td>
<td valign="middle"><a class="UserControlPanel" href="http://thelocust.org/bored/index.php?t=login&'._rsid.$ret_to.'&logout=1">Logout [ '.$user_login.' ]</a></td>';
		$register_n_profile = '<td valign="middle"><a class="UserControlPanel" href="http://thelocust.org/bored/index.php?t=register&'._rsid.'"><img src="http://thelocust.org/bored/theme/default/images/top_profile.gif" border=0 title="Click here to access user control panel" alt="Profile"></a></td>
<td valign="middle"><a class="UserControlPanel" href="http://thelocust.org/bored/index.php?t=register&'._rsid.'"><acronym title="Click here to access user control panel">Profile</acronym></a></td>';
		$rid = $GLOBALS["usr"]->id;
		
		if ( $GLOBALS['PM_ENABLED']=='Y' ) {
			$c = q_singleval("SELECT count(*) FROM fud21_pmsg WHERE duser_id=".$GLOBALS["usr"]->id." AND folder_id='INBOX' AND read_stamp=0");
			$private_msg = ( $c ) ? '<td>&nbsp;&nbsp;</td>
<td valign="middle"><a href="http://thelocust.org/bored/index.php?t=pmsg&'._rsid.'" class="UserControlPanel"><img src="http://thelocust.org/bored/theme/default/images/top_pm.gif" border=0 alt="Private Messaging"></a></td>
<td><a href="http://thelocust.org/bored/index.php?t=pmsg&'._rsid.'" class="UserControlPanel">You have <span class="GenText" style="color: #ff0000">('.$c.')</span> unread private message(s)</a></td>
<td>&nbsp;&nbsp;</td>' : '<td>&nbsp;&nbsp;</td>
<td valign="middle"><a href="http://thelocust.org/bored/index.php?t=pmsg&'._rsid.'" class="UserControlPanel"><img src="http://thelocust.org/bored/theme/default/images/top_pm.gif" border=0 alt="Private Messaging"></a></td>
<td><a href="http://thelocust.org/bored/index.php?t=pmsg&'._rsid.'" class="UserControlPanel">Private Messaging</a></td>
<td>&nbsp;&nbsp;</td>';
		}
	}/* FILE START */
	
	if( empty($decl) ) {
		if( $usr->is_mod != 'A' ) $limit = 'INNER JOIN fud21_mod ON fud21_mod.user_id='.$usr->id.' AND fud21_thr_exchange.frm=fud21_mod.forum_id ';
		
		$r = q("SELECT 
				fud21_thr_exchange.*,
				fud21_msg.subject,
				fud21_forum.name,
				fud_forum2.name AS name2,
				fud21_users.alias AS login
			 FROM 
			 	fud21_thr_exchange 
			 	".$limit."
			 INNER JOIN fud21_thread
			 	ON fud21_thr_exchange.th=fud21_thread.id
			 INNER JOIN fud21_msg
			 	ON fud21_thread.root_msg_id=fud21_msg.id
			 INNER JOIN fud21_forum
			 	ON fud21_thread.forum_id=fud21_forum.id
			 INNER JOIN fud21_forum AS fud_forum2
		 		ON fud21_thr_exchange.frm=fud_forum2.id	
			 INNER JOIN fud21_users
			 	ON fud21_thr_exchange.req_by=fud21_users.id");
		if( db_count($r) ) {
			$thr_exch_data = '';
			while( $obj = db_rowobj($r) ) $thr_exch_data .= '<tr><td>
<table border=0 cellspacing=0 cellpadding=3 width="100%">
	<tr class="RowStyleB">
		<td align=left nowrap valign=top>
			<font class="SmallText"><b>Thread move requested by:</b> <a class="GenLink" href="http://thelocust.org/bored/index.php?t=usrinfo&id='.$obj->req_by.'&'._rsid.'">'.htmlspecialchars($obj->login).'</a><br></font>
		</td>
		<td align=center width="100%" valign=top>
			<font class="SmallText">
			<b>Reason for thread move:</b><br>
			<table border=1 cellspacing=1 cellpadding=0><tr><td align=left>&nbsp;'.$obj->reason_msg.' &nbsp;</td></tr></table>
			</font>
		</td>
	</tr>
	<tr class="RowStyleC">
		<td colspan=2>
			<table border=0 cellspacing=0 cellpadding=3 width="100%">
			<tr>
				<td align="left"><font size="-1"><b>Original Forum:</b> '.$obj->name.'<br><b>Destination Forum:</b> '.$obj->name2.'<br><b>Thread:</b> <a href="http://thelocust.org/bored/index.php?t=msg&'._rsid.'&th='.$obj->th.'">'.$obj->subject.'</a></font></td>
				<td align="right">[<a class="GenLink" href="http://thelocust.org/bored/index.php?t=thr_exch&appr='.$obj->id.'&'._rsid.'">accept thread</a>]&nbsp;&nbsp;[<a class="GenLink" href="http://thelocust.org/bored/index.php?t=thr_exch&decl='.$obj->id.'&'._rsid.'">decline thread</a>]</td>
			</tr>
			</table>
		</td>
	</tr>		
</table>
</td></tr>';
		}
		else
			$thr_exch_data = '<tr><td class="RowStyleA" align="center">No threads waiting approval.</td></tr>';
			
		qf($r);	
	}		
	$page_gen_time = (db_getmicrotime() - $GLOBALS['PAGE_TIME']);
$q_time = query_count();
$ttl_time = total_time();

if ( isset($usr) && $usr->is_mod == 'A' )
	$page_stats = '<br><div align="left" class="SmallText">'.$q_time.' MySQL queries took '.$ttl_time.' seconds<br>Total time taken to generate the page: '.$page_gen_time.' seconds</div>';
else if ( $GLOBALS['PUBLIC_STATS'] == 'Y' ) 
	$page_stats = '<br><div align="left" class="SmallText">'.$q_time.' MySQL queries took '.$ttl_time.' seconds<br>Total time taken to generate the page: '.$page_gen_time.' seconds</div>';
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<title><?php echo $GLOBALS['FORUM_TITLE']; ?><?php echo $TITLE_EXTRA; ?></title>
<META HTTP-EQUIV="Content-Type" CONTENT="text/html; charset=ISO-8859-15">
<script language="javascript" src="lib.js"></script>
<link rel="StyleSheet" href="http://thelocust.org/bored/theme/default/forum.css" type="text/css">
</head>
<body topmargin="2" leftmargin="2" marginheight="2" marginwidth="2">
<table width="100%" border="0" cellspacing="3" cellpadding="5"><tr><td class="ForumBackground">
<table border=0 cellspacing=0 cellpadding=0 width="100%"><tr><td align="right">
<table cellspacing=3 cellpadding=0 border=0>
	<tr>
		<td valign="middle"><a class="UserControlPanel" href="http://thelocust.org/bored/index.php?t=help_index&<?php echo _rsid; ?>"><img src="http://thelocust.org/bored/theme/default/images/top_help.gif" border=0 alt="F.A.Q."></a></td>
		<td valign="middle"><a class="UserControlPanel" href="http://thelocust.org/bored/index.php?t=help_index&<?php echo _rsid; ?>">F.A.Q.</a></td>
		<td>&nbsp;&nbsp;</td>
		<?php echo $register_n_profile; ?>
		<td>&nbsp;&nbsp;</td>
		<?php echo $login_n_logout; ?>
		<td>&nbsp;&nbsp;</td>
		<td valign="middle"><a class="UserControlPanel" href="http://thelocust.org/bored/index.php?t=index&<?php echo _rsid; ?>"><img src="http://thelocust.org/bored/theme/default/images/top_home.gif" border=0 alt="Home"></a></td>
		<td valign="middle"><a class="UserControlPanel" href="http://thelocust.org/bored/index.php?t=index&<?php echo _rsid; ?>">Home</a></td>
	</tr>
</table>
<table cellspacing=3 cellpadding=0 border=0>	
	<tr>	
		<?php echo $private_msg; ?>
		<td valign="middle"><a class="UserControlPanel" href="http://thelocust.org/bored/index.php?t=finduser&btn_submit=Find&<?php echo _rsid; ?>"><img src="http://thelocust.org/bored/theme/default/images/top_members.gif" border=0 alt="Members"></a></td>
		<td valign="middle"><a class="UserControlPanel" href="http://thelocust.org/bored/index.php?t=finduser&btn_submit=Find&<?php echo _rsid; ?>">Members</a></td>
		<td>&nbsp;&nbsp;</td>
		<td valign="middle"><a class="UserControlPanel" href="http://thelocust.org/bored/index.php?t=search&<?php echo _rsid; ?>"><img src="http://thelocust.org/bored/theme/default/images/top_search.gif" border=0 alt="Search"></a></td>
		<td valign="middle"><a class="UserControlPanel" href="http://thelocust.org/bored/index.php?t=search&<?php echo _rsid; ?>">Search</a></td>
		<?php echo $admin_control_panel; ?>
	</tr>
</table></td></tr></table>
<br><?php echo $admin_cp; ?>
<table border="0" cellspacing="0" cellpadding="0" class="ContentTable">
<tr><th>Thread Exchange </th></tr>
<?php echo $thr_exch_data; ?>
</table>
<br><table bgcolor="#000000" border=0 cellspacing=1 cellpadding=1 align="center"><tr class="RowStyleA"><td class="SmallText"><b>Current Time:</b> 
<?php echo strftime("%a %b %e %H:%M:%S %Z %Y", __request_timestamp__); ?>
</td></tr></table>
<?php echo $page_stats; ?>
</td></tr></table>
<table width="100%" border="0" cellspacing="3" cellpadding="5"><tr><td class="ForumBackground" align="center">
<b>.::</b> <a href="mailto:<?php echo $GLOBALS['ADMIN_EMAIL']; ?>">Contact</a> <b>::</b> <a href="http://thelocust.org/bored/index.php?t=index&<?php echo _rsid; ?>">Home</a> <b>::.</b>
<p>
<span class="SmallText">Powered by: FUDforum <?php echo $GLOBALS['FORUM_VERSION']; ?><br>Copyright &copy;2001,2002 <a href="http://fud.prohost.org/" class="GenLink">Advanced Internet Designs Inc.</a></span>
</td></tr></table>
</body>
</html>